/***********************************************************************
*
* ļ        DataManager.h
* ģĿģʵƽ̨޹عڴ
* ߼ڣ  wang_jin 2008-05-18
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef DataManager_H
#define DataManager_H

#include "MemoryManager.h"
#include "GDLock/GDLock.h"

#include <assert.h>
#ifdef _WIN32
#	include <windows.h>
#else
#endif

// ڴ:ڲݴȡ
class CSharedDataManager
{
	// Ϣʹýṹ
	typedef struct infoblock
	{
		union
		{
			int nWriteHead;
			int nReadTail;
		};
		union
		{
			int nWriteTail;
			int nReadHead;
		};
		int nFillFull;
		int nMaxSize;
	}	INFOBLOCK;
	INFOBLOCK* m_pBlock;
	// ̬ڴʹýṹ
	typedef struct iteminfo
	{
		int nPrevFreeItem;
		int nNextFreeItem;
	}	ITEMINFO;
	typedef struct headinfo
	{
		int rootItem;
		int lastFreeItem;
	}	ITEMHEAD;
	ITEMHEAD* m_pHeadInfo;

public:
	CSharedDataManager();
	~CSharedDataManager();

public:
	long CreateMemory( long nKey, long nTotalSize, long nSize = 0 );	// 
	long CreateMemory( const char* sKey, long nTotalSize, long nSize = 0 );
	long ReleaseMemory();							// ͷ
	bool IsOwner() { return m_bOwner; }

public:
	// ռ䲻ʱԶռ
	long SetData( void* pBuf, long nSize );			// 
	long GetData( void* pBuf, long& nSize );		// ȡ
public:
	// ռ䲻ʱؿռ䲻
	long PutBlock( void* pMsg, int nSize );		// Ϣ
	long GetBlock( void* pMsg, int& nSize );	// ȡϢ
public:
	// ռ䲻㣬һ
	void* GetRoot();
	void* New();									// ̬
	void Delete( void* pBuf );						// ̬ͷ
	int GetOffset( void* pBuf );					// Чڴַתƫ
	void* GetRealAddress( int nOffset );            // ƫתЧڴַ

private:
	CSharedMemoryManager m_smMgr;
	SharedMemoryData* m_pSMData;
	bool m_bOwner;
	long m_nKey;
	char m_sKey[GD_MAX_PATH];

};


//
// inline
//
inline int CSharedDataManager::GetOffset( void* pBuf )
{
    if( pBuf )
    {
	    return ( (char*)pBuf - (char*)m_pSMData );
    }

    return 0;
}

inline void* CSharedDataManager::GetRealAddress( int nOffset )
{
    if( nOffset )
    {
	    return (void*) ( (char*)m_pSMData + nOffset );
    }

    return NULL;
}

#endif

