/******************************************************************************
*
* ļ              FileTree.cpp
* ģĿģ      ļʵ
* ߼ڣ        liu_yfeng
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
******************************************************************************/

#pragma warning( disable: 4786 )


#include "FileOpt/FileTree.h"

#ifdef WIN32
#	include "FileTree_WIN32.cpp"
#	include <windows.h>
#	include <assert.h>
#else
#	include "FileTree_UNIX.cpp"
#	include <string.h>
#	include <dirent.h>
#	include <sys/types.h>
#	include <sys/stat.h>
#	include <unistd.h>
#	include <assert.h>
#endif


CFileTree::CFileTree( const string& path ) : CFileTreeImpl( path )
{
}


CFileTree::~CFileTree()
{
}


GDInt64 CFileTree::calcTree( PPATHNODE node )
{
	assert( node );

	GDInt64 nSize = 0;

	// ǰĿ¼ļ(s)С
	PFILENODE file = node->list;
	while ( file )
	{
		nSize += file->size_Size;
		file = file->link;
	}

	// ǰĿ¼Ŀ¼(s)С
	PPATHNODE path = node->son;
	if ( path )
	{
		nSize += calcTree( path );
	}

	// ǰĿ¼ֵĿ¼(s)С
	path = node->bro;
	while ( path )
	{
		nSize += calcTree( path );
		path = path->bro;
	}

	return nSize;
}


PPATHNODE CFileTree::freeTree( PPATHNODE node )
{
	if ( !node ) return NULL;
	
	// ͷļ
	if ( node->list )
	{
		PFILENODE list = node->list;
		do
		{
			node->list = list->link;
			delete []list->szName;
			list->szName = NULL;
			delete list;
			list = NULL;
		} while ( ( list = node->list ) );
	}
	
	// ӽݹͷűѭͷ
	PPATHNODE son = node->son;
	while ( son )
	{
		PPATHNODE tmp = son->son;
		son->son = NULL; // ֹٴεݹ
		freeTree( son );
		son = tmp;
	}
	
	// ֵܽݹͷűѭͷ by wang_jin at 2008-12-13 for ƶAIXɨ1500ͬĿ¼
	PPATHNODE bro = node->bro;
	while ( bro )
	{
		PPATHNODE tmp = bro->bro;
		bro->bro = NULL; // ֹٴεݹ
		freeTree( bro );
		bro = tmp;
	}
	
	// ͷԼ
	if ( node->szName )
	{
		delete[] node->szName;
		node->szName = NULL;
	}
	delete node;
	node = NULL;
	
	return node;
}
