/***********************************************************************
*
* ļ        GDChecker.cpp
* ģĿģļ֤
* ߼ڣ  wang_jin 2008-05-10
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning ( disable : 4251 4786 )

#include "SQLValidator.h"

#include "Common/DateTime.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/ThreadData.h"
#include "GDChecker/GDChecker.h"

#define KEY_SEM_TRACELOG_SQL 0x8765432b

CGDChecker* CGDChecker::m_GDChecker = NULL;


CGDChecker::CGDChecker()
:m_bInitialized( false )
,m_pValidator(new CSQLValidator)
{
	SetAppName( "filter" );
}

CGDChecker::~CGDChecker()
{
}

bool CGDChecker::Initialize()
{
	CGDTrace trace( LOG_L6, "CGDChecker:Initialize()" );

	if ( !m_pValidator->Initialize() )
	{
		if ( m_bFirst ) // ״ʧܼ¼־
		{
			CGDLog::WriteErrLog( "1083:CGDChecker:Check()-Initialize() failed" ); // ʼʧ
			m_bFirst = false;
		}
		return trace.SetRetResult( true ); // ˴:trueʾûվʣfalseʾֹ
	}
	else
	{
		m_bInitialized = true;
		CGDLog::WriteSysLog( "2042:CGDChecker:Initialize() OK" );
		return trace.SetRetResult( true );
	}
}

bool CGDChecker::UnInitialize()
{
	CGDTrace trace( LOG_L6, "CGDChecker:UnInitialize()" );
	bool bRet = m_pValidator->UnInitialize();
	return trace.SetRetResult( bRet );
}

const char* CGDChecker::GetErrCode()
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "sql", true ); // ߳

	CGDTrace trace( LOG_L6, "CGDChecker:GetErrCode()" );
	// ʼ
	try
	{
		if ( ! m_bInitialized )
		{
			if ( Initialize() )
			{
				m_bInitialized = true;
			}
		}
		return m_pValidator->GetErrCode();
	}
	catch (...)
	{
	}
	return NULL;
}

const char* CGDChecker::GetErrPage()
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "sql", true ); // ߳

	CGDTrace trace( LOG_L6, "CGDChecker:GetErrCode()" );
	// ʼ
	try
	{
		if ( ! m_bInitialized )
		{
			if ( Initialize() )
			{
				m_bInitialized = true;
			}
		}
		return m_pValidator->GetErrPage();
	}
	catch (...)
	{
	}
	return NULL;
}

const char* CGDChecker::GetErrMessage()
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "sql", true ); // ߳

	CGDTrace trace( LOG_L6, "CGDChecker:GetErrCode()" );
	// ʼ
	try
	{
		if ( ! m_bInitialized )
		{
			if ( Initialize() )
			{
				m_bInitialized = true;
			}
		}
		return m_pValidator->GetErrMessage();
	}
	catch (...)
	{
	}
	return NULL;
}

bool CGDChecker::Check( char cType, const char* sHost, const char* method, const char* url, char* pQueryString )
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "sql", true ); // ߳

	CGDTrace trace( LOG_L6, "CGDChecker:Check(%c,%s,%s,%s,%s)", cType, sHost, method, url, pQueryString );

#ifndef NDEBUG
	try
#endif
	{
		// ʼ
		if ( ! m_bInitialized )
		{
			if ( Initialize() )
			{
				m_bInitialized = true;
			}
		}

		bool bRet = m_pValidator->Check( cType, sHost, method, url, pQueryString );
		return trace.SetRetResult( bRet );
	}
#ifndef NDEBUG
	catch ( ... )
	{
		CGDLog::WriteErrLog( "1084:CGDChecker:Check(%s) catch(...)", pQueryString );
		return trace.SetRetResult( false );
	}
#endif
}


// ´빩C

bool Check( char cType, const char* sHost, const char* method, const char* url, char* pQueryString )
{
	static CGDChecker* checker = CGDChecker::Instance();

	return checker->Check( cType, sHost, method, url, pQueryString );
}

// add by liu_yfeng 2009-03-31
const char* GetInfor( const char* type )
{
	static CGDChecker* checker = CGDChecker::Instance();
	if ( NULL != type && '\0' != *type && NULL != checker )
	{
		if ( 0 == strcmp( type, Infor_Type_Err_Code ) )
		{
			return checker->GetErrCode();
		}
		else if ( 0 == strcmp( type, Infor_Type_Err_Page ) )
		{
			return checker->GetErrPage();
		}
		else if ( 0 == strcmp( type, Infor_Type_Err_Message ) )
		{
			return checker->GetErrMessage();
		}
		else
		{
			return NULL;
		}
	}
	else
	{
		return NULL;
	}
}


#ifdef WIN32
char* Unicode2Ansi(const unsigned short unicode, char* ansi, const unsigned int n)
{
    WideCharToMultiByte(
        CP_ACP, 
        0, 
        &unicode, 
        -1, 
        ansi, 
        n, 
        NULL, 
        NULL);
    
    return ansi;
}

bool ConvertUTF8ToANSI( const char* sUtf, char* sAnsi )
{
	CGDTrace trace( LOG_L6, "ConvertUTF8ToANSI()" );
	int utfLen = 0;
	unsigned short chUNICODE = 0;
	char chANSI[3] = { 0 };
	int i, n;
	
	utfLen = strlen(sUtf);
	for (i = 0, n = 0; i < utfLen; )
	{
		// Converts UTF-8 to ANSI
		if ((sUtf[i] & 0xf0) == 0xe0)
		{
			/* UgTF-8 to UNICODE(big endian):
			*                           [0]      [1]       [2]
			* UTF-8(3 bytes)	     1110aaaa 10BBBBcc 10DDDDDD
			* UNICODE(little endian) ccDDDDDD aaaaBBBB
			*/
			( (char *) &chUNICODE)[0] = 
				((sUtf[i + 1] & 0x03) << 6) | (sUtf[i + 2] & 0x3f);
			( (char *) &chUNICODE)[1] = 
				(sUtf[i] << 4) | ((sUtf[i+1] >> 2) & 0x0f);
			
			// UNICODE to ANSI;
			Unicode2Ansi(chUNICODE, chANSI, sizeof(chANSI));
			
			sAnsi[n] = chANSI[0];
			sAnsi[n + 1] = chANSI[1];
            
			i += 3;
			n += 2;
		}
		else if ((sUtf[i] & 0xe0) == 0xc0)
		{
			/*
			* UTF-8                    110xxxyy 10zzzzzz
			* UNICODE(littel endian)   yyzzzzzz 00000xxx 
			*/
			( (char *) &chUNICODE)[0] = 
				(sUtf[i] << 6) | (sUtf[i+1] & 0x3f);
			( (char *) &chUNICODE)[1] = 
				((sUtf[i] >> 2) & 0x07);
			
			// UNICODE to ANSI;
			Unicode2Ansi(chUNICODE, chANSI, sizeof(chANSI));
			
			sAnsi[n] = chANSI[0];
			sAnsi[n+1] = chANSI[1];
            
			i += 2;
			n += 2;
		}
		else if ((sUtf[i] & 0x80) == 0)
		{ 
			/*
			* UTF-8        0xxxxxxx
			* ANSI         0xxxxxxx
			*/
			sAnsi[n++] = sUtf[i++];
		}
		else
		{
			return trace.SetRetResult( false );
		}
	}

	return trace.SetRetResult( true );
}

#endif
