/***********************************************************************
*
* ļ        GDLock.cpp
* ģĿģʵ߳дӦĻ
* ߼ڣ  wang_jin 2008-05-05
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning(disable:4786)

#include "gd3_define/gd3_errcode.h"
#include "Common/Common.h"
#include "Common/DateTime.h"
#include "GDLock/GDLock.h"

#ifdef _WIN32
#	include "GDLockWin32.cpp"
#	include <time.h> // for _strdate & _strtime 
#else
#	include "GDLockLinux.cpp"
#	include <stdarg.h>
#endif


CThreadLock::CThreadLock( CThreadMutex& mutex )
:m_mutex(mutex)
{
	m_mutex.Lock();
}

CThreadLock::~CThreadLock()
{
	m_mutex.Unlock();
}


CProcessLock::CProcessLock( CProcessMutex& mutex, unsigned int ms )
:m_mutex(mutex)
{
	do
	{
		m_bLocked = m_mutex.Lock( ms );
		if ( ! m_bLocked )
		{
			CDateTime::Sleep(1);
		}

	} while ( ! m_bLocked );
}

CProcessLock::~CProcessLock()
{
	if ( m_bLocked )
	{
		m_mutex.Unlock();
		m_bLocked = false;
	}
}


CProcessRWLock::CProcessRWLock( CProcessRWMutex& mutex, enumLockMode lockMode, unsigned int ms )
:m_mutex(mutex)
{
	m_bLocked = ( NO_ERROR == m_mutex.Lock( lockMode, ms ) );
}

CProcessRWLock::~CProcessRWLock()
{
	if ( m_bLocked )
	{
		m_mutex.Unlock();
		m_bLocked = false;
	}
}
