/***********************************************************************
*
* ļ        GDVerifier.cpp
* ģĿģʵֻڹļ֤
* ߼ڣ  wang_jin 2008-05-05
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning( disable : 4786 )

#include "Validator.h"

#include "Base/MonitorDef.h"
#include "Common/GDString.h"
#include "Common/GDFile.h"
#include "FileOpt/FileOpt.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/ThreadData.h"
#include "GDVerifier/GDVerifier.h"
 
#ifdef WIN32
#	include <sys/stat.h>
#	include <assert.h>
#else
#	include <sys/stat.h>
#	include <signal.h>
#	include <unistd.h>
#	include <sys/socket.h>
#	include <netinet/in.h>
#	include <arpa/inet.h>
#	include <netdb.h>
#	include <iconv.h>
#endif

#include <stdarg.h>
#include <time.h>
#include <list>
#include <algorithm> // for transform

#define KEY_SEM_TRACELOG_TAM 0x8765432a

#ifndef NOT_USE_STD_LIB
	using namespace std;
#endif

CVerifier* CVerifier::m_GDVerifier = NULL;


CVerifier::CVerifier()
:m_bFirst( true )
,m_bInitialized( false )
,m_pValidator( new CValidator )
{
	SetAppName( "filter" ); // 
}

CVerifier::~CVerifier()
{
	if ( m_pValidator )
		delete m_pValidator;
}

bool CVerifier::Initialize()
{
	return m_pValidator->Initialize();
}

bool CVerifier::Uninitialize()
{
	return m_pValidator->Uninitialize();
}

void TmpLog2( const char *fmt, ... )
{
	char tmplog_path[512] = {0};
	FILE *tmp_logfile = NULL;
#ifndef WIN32
	sprintf( tmplog_path, "/tmp/VerifyResult2.log");
#else
	sprintf( tmplog_path, "C:\\tmp\\VerifyResult2.log");
#endif
	tmp_logfile = CGDFile::open(tmplog_path, "a+");
	
	if( tmp_logfile )
	{
		char time_string[ 32 ] = {0};
		time_t nowtime = time( NULL );

		va_list args;
		va_start( args, fmt );

		// Format is month day hour:minute:second (24 time) 
		strftime( time_string, 32, "%b %d %H:%M:%S", localtime(&nowtime) );
#ifdef WIN32
		fprintf( tmp_logfile, "%s [%d] - ", time_string, GetCurrentThreadId() );
#else
		fprintf( tmp_logfile, "%s [%u] - ", time_string, pthread_self() );
#endif
		vfprintf( tmp_logfile, fmt, args );
		
		fprintf( tmp_logfile, "\012" ); // \n

		fflush(tmp_logfile);
		
		va_end(args);
		
		CGDFile::close(tmp_logfile);
		tmp_logfile = NULL; 
	}
}

const char* CVerifier::GetErrCode()
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "tam", true ); // ߳

	return m_pValidator->m_sErrCode.c_str();
}

const char* CVerifier::GetErrPage()
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "tam", true ); // ߳

	return m_pValidator->m_sErrPage.c_str();
}

const char* CVerifier::GetErrMessage()
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "tam", true ); // ߳

	// ʼ
	try
	{
		if ( ! m_bInitialized )
		{
			if ( ! Initialize() ) // ʼʧ
			{
				return "UNKNOWN";
			}
			m_bInitialized = true;
		}
	}
	catch ( ... ) // ʱ쳣ɳ򱨴
	{
		return "UNKNOWN";
	}
	
	return m_pValidator->m_sErrMessge.c_str();
}


int CVerifier::Verify( int nType, const char* sFilePath, const char* sRootPath )
{
	CThreadData threadData; // ֲԱ߳̽ʱͨɾ߳ݶ
	CThreadData::SetCurrentThreadLogFile( "tam", true ); // ߳
	
	CGDTrace trace( LOG_L6, "CVerifier:Verify(%c,%s,%s)", nType, sFilePath, sRootPath );

#ifndef NDEBUG
	try
#endif
	{
		// ʼ
		if ( ! m_bInitialized )
		{
			CGDTrace::GDTrace( LOG_WAR, "CVerifier:Verify Init(%c,%s,%s)", nType, sFilePath, sRootPath );
			if ( ! Initialize() ) // ʼʧ
			{
				if ( m_bFirst ) // ״ʧܼ¼־ 
				{
					CGDLog::WriteErrLog( "1111:CVerifier:Verify()-Init() false" ); // ʼʧ
					m_bFirst = false;
				}
				return trace.SetRetValue( 0 ); // 0:ʼʧ;ʾ
			}

			CGDLog::WriteSysLog( "2046:CVerifier:Verify(%c,%s,%s)-Initialize() OK", nType, sFilePath, sRootPath );

			m_bInitialized = true;
		}

		// Ŀ¼ָ
		char sFile[ GD_MAX_PATH ] = {0};
		char sRoot[ GD_MAX_PATH ] = {0};
		strcpy( sFile, sFilePath );
		strcpy( sRoot, sRootPath );
		int nLen = strlen( sFile );
		int i = 0;
		for ( i = 0; i<nLen; i++ ) { if ( sFile[i] == '\\' || sFile[i] == '/' )	{ sFile[i] = C_PATHLASH; } }
		nLen = strlen( sRoot );
		for ( i = 0; i<nLen; i++ ) { if ( sRoot[i] == '\\' || sRoot[i] == '/' ) { sRoot[i] = C_PATHLASH; } }

		int nRet = m_pValidator->Verify( nType, sFile, sRoot );
		return trace.SetRetValue( nRet );
	}
#ifndef NDEBUG
	catch ( ... ) // ʱ쳣ɳ򱨴
	{
		CGDLog::WriteErrLog( "1112:CVerifier:Verify(%s) catch(...)", sFilePath );
		return 500;
	}
#endif
}

// ´빩C

int Verify( int nType, const char* sFilePath, const char* sRootPath )
{	
	static CVerifier* verifier = CVerifier::Instance();
	return verifier->Verify( nType, sFilePath, sRootPath );
}

const char* GetInformation( const char* type )
{
	static CVerifier* verifier = CVerifier::Instance();
	return verifier->GetErrMessage();
}

#ifdef WIN32
char* Unicode2Ansi(const unsigned short unicode, char* ansi, const unsigned int n)
{
    WideCharToMultiByte(
        CP_ACP, 
        0, 
        &unicode, 
        -1, 
        ansi, 
        n, 
        NULL, 
        NULL);
    
    return ansi;
}
bool ConvertUTF8ToANSI( const char* sUtf, char* sAnsi )
{
	int utfLen = 0;
	unsigned short chUNICODE = 0;
	char chANSI[3] = { 0 };
	int i, n;
	
	utfLen = strlen(sUtf);
	for (i = 0, n = 0; i < utfLen; )
	{
		// Converts UTF-8 to ANSI
		if ((sUtf[i] & 0xf0) == 0xe0)
		{
			/* UgTF-8 to UNICODE(big endian):
			*                           [0]      [1]       [2]
			* UTF-8(3 bytes)	     1110aaaa 10BBBBcc 10DDDDDD
			* UNICODE(little endian) ccDDDDDD aaaaBBBB
			*/
			( (char *) &chUNICODE)[0] = 
				((sUtf[i + 1] & 0x03) << 6) | (sUtf[i + 2] & 0x3f);
			( (char *) &chUNICODE)[1] = 
				(sUtf[i] << 4) | ((sUtf[i+1] >> 2) & 0x0f);
			
			// UNICODE to ANSI;
			Unicode2Ansi(chUNICODE, chANSI, sizeof(chANSI));
			
			sAnsi[n] = chANSI[0];
			sAnsi[n + 1] = chANSI[1];
            
			i += 3;
			n += 2;
		}
		else if ((sUtf[i] & 0xe0) == 0xc0)
		{
			/*
			* UTF-8                    110xxxyy 10zzzzzz
			* UNICODE(littel endian)   yyzzzzzz 00000xxx 
			*/
			( (char *) &chUNICODE)[0] = 
				(sUtf[i] << 6) | (sUtf[i+1] & 0x3f);
			( (char *) &chUNICODE)[1] = 
				((sUtf[i] >> 2) & 0x07);
			
			// UNICODE to ANSI;
			Unicode2Ansi(chUNICODE, chANSI, sizeof(chANSI));
			
			sAnsi[n] = chANSI[0];
			sAnsi[n+1] = chANSI[1];
            
			i += 2;
			n += 2;
		}
		else if ((sUtf[i] & 0x80) == 0)
		{ 
			/*
			* UTF-8        0xxxxxxx
			* ANSI         0xxxxxxx
			*/
			sAnsi[n++] = sUtf[i++];
		}
		else
		{
			return false;
		}
	}

	return true;
}
#else
// ת:һֱתΪһֱ
int code_convert( char * from_charset, char * to_charset, char * inbuf, size_t inlen, char * outbuf, size_t outlen )
{
	iconv_t cd;
	int rc;
#ifdef Solaris
	const char **pin = (const char**)&inbuf;
#else
	char **pin = (char**)&inbuf;
#endif
	char **pout = &outbuf;
	
	cd = iconv_open(to_charset,from_charset);
	if (cd==0) return -1;
	memset(outbuf,0,outlen);
	if (iconv(cd,pin,&inlen,pout,&outlen)==-1) return -1;
	iconv_close(cd);
	return 0;
}
//UNICODEתΪGB2312
char* Unicode2Ansi(unsigned short unicode, char* outbuf, unsigned int inlen, unsigned int outlen = 520)
{
	char * inbuf = (char *)&unicode;
	code_convert("utf-8","gb2312",inbuf,inlen,outbuf,outlen);
	return outbuf;
}
//GB2312תΪUNICODE
char* Ansi2Unicode(char* inbuf, char * outbuf, unsigned int outlen)
{
	code_convert("gb2312","utf-8",inbuf,strlen(inbuf),outbuf,outlen);
	return outbuf;
}

bool ConvertUTF8ToANSI( const char* sUtf, char* sAnsi )
{
	int utfLen = 0;
	char chUNICODE[3] = { 0 };
	char chANSI[3] = { 0 };
	char * pUnicode = chUNICODE;
	char * pAnsi = chANSI;
	int i, n;

	iconv_t cd;
	int rc;
	
	cd = iconv_open("gb2312","utf-8");
	if (cd==0) return false;
	
	utfLen = strlen(sUtf);
	for (i = 0, n = 0; i < utfLen; )
	{
		// Converts UTF-8 to ANSI
		if ((sUtf[i] & 0xf0) == 0xe0)
		{
			/* UgTF-8 to UNICODE(big endian):
			*                           [0]      [1]       [2]
			* UTF-8(3 bytes)	     1110aaaa 10BBBBcc 10DDDDDD
			* UNICODE(little endian) ccDDDDDD aaaaBBBB
			*/
			( (char *) &chUNICODE)[0] = 
				((sUtf[i + 1] & 0x03) << 6) | (sUtf[i + 2] & 0x3f);
			( (char *) &chUNICODE)[1] = 
				(sUtf[i] << 4) | ((sUtf[i+1] >> 2) & 0x0f);
			
			// UNICODE to ANSI;
			{
#ifdef Solaris
				const char **pin = (const char**)&pUnicode;
#else
				char **pin = (char**)&pUnicode;
#endif
				char **pout = (char**)&pAnsi;
				size_t inlen = 2;
				size_t outlen = 2;
				if (iconv(cd,pin,&inlen,pout,&outlen)==-1)
				{
					return -1;
				}
			}
		
			sAnsi[n] = chANSI[0];
			sAnsi[n + 1] = chANSI[1];
            
			i += 3;
			n += 2;
		}
		else if ((sUtf[i] & 0xe0) == 0xc0)
		{
			/*
			* UTF-8                    110xxxyy 10zzzzzz
			* UNICODE(littel endian)   yyzzzzzz 00000xxx 
			*/
			( (char *) &chUNICODE)[0] = 
				(sUtf[i] << 6) | (sUtf[i+1] & 0x3f);
			( (char *) &chUNICODE)[1] = 
				((sUtf[i] >> 2) & 0x07);
			
			// UNICODE to ANSI;
			{
#ifdef Solaris
				const char **pin = (const char**)&pUnicode;
#else
				char **pin = (char**)&pUnicode;
#endif
				char **pout = (char**)&pAnsi;
				size_t inlen = 2;
				size_t outlen = 2;
				if (iconv(cd,pin,&inlen,pout,&outlen)==-1)
				{
					return -1;
				}
			}
			
			sAnsi[n] = chANSI[0];
			sAnsi[n+1] = chANSI[1];
            
			i += 2;
			n += 2;
		}
		else if ((sUtf[i] & 0x80) == 0)
		{ 
			/*
			* UTF-8        0xxxxxxx
			* ANSI         0xxxxxxx
			*/
			sAnsi[n++] = sUtf[i++];
		}
		else
		{
			return false;
		}
	}

	iconv_close(cd);

	return true;
}
#endif
