// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TestRunLog.h"

#include "MainFrm.h"
#include "RunLogView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_MESSAGE(WM_USER_DATA, OnUserData)
	ON_WM_CREATE()
	ON_COMMAND(IDM_EDIT_CLEAN, OnEditClean)
	ON_COMMAND(IDM_VIEW_FONT, OnViewFont)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

CFont fonts[2][4];

const short MA_PORT = 7379;
const short SA_PORT = 7380;

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// 
	LOGFONT lf = {0};
	lf.lfCharSet = 134;
	lf.lfHeight = 10;

	fonts[0][0].CreateFontIndirect( &lf );
	fonts[0][1].CreateFontIndirect( &lf );
	fonts[0][2].CreateFontIndirect( &lf );
	fonts[0][3].CreateFontIndirect( &lf );
	fonts[1][0].CreateFontIndirect( &lf );
	fonts[1][1].CreateFontIndirect( &lf );
	fonts[1][2].CreateFontIndirect( &lf );
	fonts[1][3].CreateFontIndirect( &lf );


	if ( m_sock10002.Init( "127.0.0.1", MA_PORT ) )
	{
		AfxMessageBox( "ʼ׽ʧ" );
		return -1;
	}
	m_sock10002.m_hMainWnd = this->m_hWnd;

	if ( m_sock10003.Init( "127.0.0.1", SA_PORT ) )
	{
		AfxMessageBox( "ʼ׽ʧ" );
		return -1;
	}
	m_sock10003.m_hMainWnd = this->m_hWnd;

	return 0;
}

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	//ͼֳһа
	VERIFY(m_wndSplitter.CreateStatic(this,2,4));
	m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(0,2,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(0,3,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(1,0,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(1,1,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(1,2,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);
	m_wndSplitter.CreateView(1,3,RUNTIME_CLASS(CRunLogView),CSize(0,0),pContext);

	m_wndSplitter.SetRowInfo(0,320,0);	// и
	m_wndSplitter.SetRowInfo(1,320,0);	// и

	m_wndSplitter.SetColumnInfo(0,400,0);	// п
	m_wndSplitter.SetColumnInfo(1,400,0);	// п
	m_wndSplitter.SetColumnInfo(2,110,0);	// п
	m_wndSplitter.SetColumnInfo(3,100,0);	// п

	return TRUE;
	return m_wndSplitter.Create(this,
		2, 2,               // TODO: adjust the number of rows, columns
		CSize(10, 10),      // TODO: adjust the minimum pane size
		pContext);
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style = WS_OVERLAPPED | WS_CAPTION | FWS_ADDTOTITLE
		| WS_THICKFRAME | WS_SYSMENU | WS_MINIMIZEBOX | WS_MAXIMIZEBOX | WS_MAXIMIZE;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


BOOL CMainFrame::DestroyWindow() 
{
	// TODO: Add your specialized code here and/or call the base class
	m_sock10002.Close();
	m_sock10003.Close();

	return CFrameWnd::DestroyWindow();
}

DWORD line[2][4] = {0};

HRESULT CMainFrame::OnUserData(WPARAM wParam, LPARAM lParam)
{
	int nPort = (int)wParam;
	char* pBuf = (char*)lParam;
	if ( nPort == MA_PORT ) nPort = 0;
	else if ( nPort == SA_PORT ) nPort = 1;
	else return 0;

	int no, nLen;
	sscanf( pBuf, "%04x%04x", &no, &nLen );
	strcat( pBuf, "\r\n" );

	if ( no < 0 || no > 3 )
	{
		CString text;
		text.Format("no bad[%s]", pBuf);
		SetWindowText(text);
		return 0;
	}
#if 0
	CRunLogView* pView = (CRunLogView*)m_wndSplitter.GetPane(nPort,no);
	pView->GetEditCtrl().SetSel( 0, 0 );
	char sLine[8] = {0};
	sprintf( sLine, "%4d ", ++ line[nPort][no] );
	pView->GetEditCtrl().ReplaceSel( sLine );
	pView->GetEditCtrl().SetSel( 5, 5 );
	pView->GetEditCtrl().ReplaceSel( pBuf+9 );
#elif 0
	CRunLogView* pView = (CRunLogView*)m_wndSplitter.GetPane(nPort,no);
	int nLength = pView->GetEditCtrl().SendMessage(WM_GETTEXTLENGTH);
	pView->GetEditCtrl().SetSel( nLength, nLength );
	char sLine[8] = {0};
	sprintf( sLine, "%4d ", ++ line[nPort][no] );
	CString tmp = sLine;
	tmp += pBuf + 9;
	pView->GetEditCtrl().ReplaceSel( tmp );
#else
	CRunLogView* pView = (CRunLogView*)m_wndSplitter.GetPane(nPort,no);
	pView->GetEditCtrl().SetWindowText( pBuf + 9 );
#endif

	return 0;
}

void CMainFrame::OnEditClean() 
{
	// б
	BYTE keyState = 0;
	if ( GetAsyncKeyState( VK_CONTROL ) < 0 || GetAsyncKeyState( VK_MENU ) < 0 )
	{
		((CEditView*)m_wndSplitter.GetPane(0,0))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(0,0))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(0,1))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(0,1))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(0,2))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(0,2))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(0,3))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(0,3))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(1,0))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(1,0))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(1,1))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(1,1))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(1,2))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(1,2))->GetEditCtrl().Clear();
		((CEditView*)m_wndSplitter.GetPane(1,3))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetPane(1,3))->GetEditCtrl().Clear();

		line[0][0] = 0;
		line[0][1] = 0;
		line[0][2] = 0;
		line[0][3] = 0;
		line[1][0] = 0;
		line[1][1] = 0;
		line[1][2] = 0;
		line[1][3] = 0;
	}
	else
	{
		int nRow;
		int nCol;
		((CEditView*)m_wndSplitter.GetActivePane( &nRow, &nCol ))->GetEditCtrl().SetSel(0,-1);
		((CEditView*)m_wndSplitter.GetActivePane( &nRow, &nCol ))->GetEditCtrl().Clear();
		line[nRow][nCol] = 0;
	}
}

DWORD color[2][4] = {0};

void CMainFrame::OnViewFont() 
{
	// 
	if ( GetAsyncKeyState( VK_CONTROL ) < 0 || GetAsyncKeyState( VK_MENU ) < 0 )
	{
		int nRow;
		int nCol;
		m_wndSplitter.GetActivePane( &nRow, &nCol );

		LOGFONT logFont;
		fonts[nRow][nCol].GetLogFont( &logFont );
		CFontDialog dlg;
		dlg.m_cf.lpLogFont = &logFont;
		dlg.m_cf.rgbColors = color[nRow][nCol];
		//dlg.m_cf.Flags = CF_INITTOLOGFONTSTRUCT;
		if ( dlg.DoModal() == IDCANCEL )
		{
			return ;
		}
		LOGFONT lf;  
		dlg.GetCurrentFont( &lf );

		// 
		fonts[0][0].DeleteObject();
		fonts[0][1].DeleteObject();
		fonts[0][2].DeleteObject();
		fonts[0][3].DeleteObject();
		fonts[1][0].DeleteObject();
		fonts[1][1].DeleteObject();
		fonts[1][2].DeleteObject();
		fonts[1][3].DeleteObject();

		fonts[0][0].CreateFontIndirect( &lf );
		fonts[0][1].CreateFontIndirect( &lf );
		fonts[0][2].CreateFontIndirect( &lf );
		fonts[0][3].CreateFontIndirect( &lf );
		fonts[1][0].CreateFontIndirect( &lf );
		fonts[1][1].CreateFontIndirect( &lf );
		fonts[1][2].CreateFontIndirect( &lf );
		fonts[1][3].CreateFontIndirect( &lf );

		((CEditView*)m_wndSplitter.GetPane(0,0))->SetFont( &fonts[0][0] );
		((CEditView*)m_wndSplitter.GetPane(0,1))->SetFont( &fonts[0][1] );
		((CEditView*)m_wndSplitter.GetPane(0,2))->SetFont( &fonts[0][2] );
		((CEditView*)m_wndSplitter.GetPane(0,3))->SetFont( &fonts[0][3] );
		((CEditView*)m_wndSplitter.GetPane(1,0))->SetFont( &fonts[1][0] );
		((CEditView*)m_wndSplitter.GetPane(1,1))->SetFont( &fonts[1][1] );
		((CEditView*)m_wndSplitter.GetPane(1,2))->SetFont( &fonts[1][2] );
		((CEditView*)m_wndSplitter.GetPane(1,3))->SetFont( &fonts[1][3] );

		// ɫ
		color[0][0] = dlg.GetColor();
		color[0][1] = dlg.GetColor();
		color[0][2] = dlg.GetColor();
		color[0][3] = dlg.GetColor();
		color[1][0] = dlg.GetColor();
		color[1][1] = dlg.GetColor();
		color[1][2] = dlg.GetColor();
		color[1][3] = dlg.GetColor();

		((CEditView*)m_wndSplitter.GetPane(0,0))->GetDC()->SetTextColor( color[0][0] );
		((CEditView*)m_wndSplitter.GetPane(0,1))->GetDC()->SetTextColor( color[0][1] );
		((CEditView*)m_wndSplitter.GetPane(0,2))->GetDC()->SetTextColor( color[0][2] );
		((CEditView*)m_wndSplitter.GetPane(0,3))->GetDC()->SetTextColor( color[0][3] );
		((CEditView*)m_wndSplitter.GetPane(1,0))->GetDC()->SetTextColor( color[1][0] );
		((CEditView*)m_wndSplitter.GetPane(1,1))->GetDC()->SetTextColor( color[1][1] );
		((CEditView*)m_wndSplitter.GetPane(1,2))->GetDC()->SetTextColor( color[1][2] );
		((CEditView*)m_wndSplitter.GetPane(1,3))->GetDC()->SetTextColor( color[1][3] );
	}
	else
	{
		int nRow;
		int nCol;
		m_wndSplitter.GetActivePane( &nRow, &nCol );

		LOGFONT logFont;
		fonts[nRow][nCol].GetLogFont( &logFont );
		CFontDialog dlg;
		dlg.m_cf.lpLogFont = &logFont;
		dlg.m_cf.rgbColors = color[nRow][nCol];
		//dlg.m_cf.Flags = CF_INITTOLOGFONTSTRUCT;
		if ( dlg.DoModal() == IDCANCEL )
		{
			return ;
		}
		LOGFONT lf;  
		dlg.GetCurrentFont( &lf );

		// 
		fonts[nRow][nCol].DeleteObject();
		fonts[nRow][nCol].CreateFontIndirect( &lf );
		((CEditView*)m_wndSplitter.GetPane(nRow,nCol))->SetFont( &fonts[nRow][nCol] );

		// ɫ
		color[nRow][nCol] = dlg.GetColor();
		((CEditView*)m_wndSplitter.GetPane(nRow,nCol))->GetDC()->SetTextColor( color[nRow][nCol] );
	}
}
