/***********************************************************************
*
* ļ SharedMemory_Win32.cpp
* ģĿģʵWindows¹ڴ
* ߼ڣ wang_jin 2008-05-18
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ 
*
***********************************************************************/

#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"

#include <stdio.h> // for sprintf

const char* const InforGuardSharedMemory = "InforGuardSharedMemory";


CSharedMemoryManager::CSharedMemoryManager()
{
	m_hFileMap = INVALID_HANDLE_VALUE;
	m_pMapView = NULL;
	m_pSMData = NULL;
}

CSharedMemoryManager::~CSharedMemoryManager()
{
}


class CShareRestrictedSD
{
public:
	CShareRestrictedSD();
	virtual ~CShareRestrictedSD();
	SECURITY_ATTRIBUTES* GetSA();
protected:
	PVOID ptr;
	SECURITY_ATTRIBUTES sa;
	SECURITY_DESCRIPTOR sd;
};

//һãôjiangsheng
//һһûУҲ֪ߡ
PVOID BuildRestrictedSD(PSECURITY_DESCRIPTOR pSD)
 {
	DWORD dwAclLength;
	PSID psidEveryone = NULL;
	PACL pDACL = NULL;
	BOOL bResult = FALSE;
	PACCESS_ALLOWED_ACE pACE = NULL;
	SID_IDENTIFIER_AUTHORITY siaWorld = SECURITY_WORLD_SID_AUTHORITY ;
	
	SECURITY_INFORMATION si = DACL_SECURITY_INFORMATION;
	
	__try {
		// initialize the security descriptor
		if (!InitializeSecurityDescriptor(pSD,
			SECURITY_DESCRIPTOR_REVISION)) {
			GDPrint("InitializeSecurityDescriptor() failed with error %d\n",
				GetLastError());
			__leave;
		}
		// obtain a sid for the Authenticated Users Group
		if (!AllocateAndInitializeSid(&siaWorld, 1,
			SECURITY_WORLD_RID, 0, 0, 0, 0, 0, 0, 0,
			&psidEveryone)) {
			GDPrint("AllocateAndInitializeSid() failed with error %d\n",
				GetLastError());
			__leave;
		}
		// NOTE:
		//
		// The Authenticated Users group includes all user accounts that
		// have been successfully authenticated by the system. If access
		// must be restricted to a specific user or group other than
		// Authenticated Users, the SID can be constructed using the
		// LookupAccountSid() API based on a user or group name.
		// calculate the DACL length
		dwAclLength = sizeof(ACL)
			// add space for Authenticated Users group ACE
			+ sizeof(ACCESS_ALLOWED_ACE) - sizeof(DWORD)
			+ GetLengthSid(psidEveryone);
		// allocate memory for the DACL
		pDACL = (PACL) HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY,
			dwAclLength);
		if (!pDACL) {
			GDPrint("HeapAlloc() failed with error %d\n", GetLastError());
			__leave;
		}
		// initialize the DACL
		if (!InitializeAcl(pDACL, dwAclLength, ACL_REVISION)) {
			GDPrint("InitializeAcl() failed with error %d\n",
				GetLastError());
			__leave;
		}
		
		// add the Authenticated Users group ACE to the DACL with
		// GENERIC_READ, GENERIC_WRITE, and GENERIC_EXECUTE access
		if (!AddAccessAllowedAce(pDACL, ACL_REVISION,
			GENERIC_ALL,
			psidEveryone)) {
			GDPrint("AddAccessAllowedAce() failed with error %d\n",
				GetLastError());
			__leave;
		}
		// set the DACL in the security descriptor
		if (!SetSecurityDescriptorDacl(pSD, TRUE, pDACL, FALSE)) {
			GDPrint("SetSecurityDescriptorDacl() failed with error %d\n",
				GetLastError());
			__leave;
		}
		bResult = TRUE;
		
	} __finally {
		if (psidEveryone) FreeSid(psidEveryone);
	}
	if (bResult == FALSE) {
		if (pDACL) HeapFree(GetProcessHeap(), 0, pDACL);
		pDACL = NULL;
	}
	return (PVOID) pDACL;
}

// The following function frees memory allocated in the
// BuildRestrictedSD() function
VOID FreeRestrictedSD(PVOID ptr) {
	if (ptr) HeapFree(GetProcessHeap(), 0, ptr);
	return;
}

CShareRestrictedSD::CShareRestrictedSD()
{
	ptr=NULL;
	sa.nLength = sizeof(sa);
	sa.lpSecurityDescriptor = &sd;
	sa.bInheritHandle = FALSE;
	// build a restricted security descriptor
	ptr = BuildRestrictedSD(&sd);
	if (!ptr) {
		CGDLog::WriteErrLog( "1108:BuildRestrictedSD() failed" );
	}
}

CShareRestrictedSD::~CShareRestrictedSD()
{
	if(ptr){
		FreeRestrictedSD(ptr);
	}
}

SECURITY_ATTRIBUTES* CShareRestrictedSD::GetSA()
{
	CGDTrace trace( LOG_L6, "CShareRestrictedSD:GetSA()" );
	if(ptr){
		return &sa;
	}
	else
		return NULL;
}

//ʼ:ȡùڴ
long CSharedMemoryManager::CreateMemory(  long nKey, long nMaxSize, bool* pbOwner )
{
	CGDTrace trace( LOG_L6, "CSharedMemoryManager:CreateMemory(%x,%d)",nKey,nMaxSize);
	
	sprintf( m_sInforGuardSharedMemoryId, "%s%x", InforGuardSharedMemory, nKey );

	return trace.SetRetValue( CreateMemory(m_sInforGuardSharedMemoryId,nMaxSize,pbOwner) );
} 

long CSharedMemoryManager::CreateMemory(  const char* sKey, long nMaxSize, bool* pbOwner )
{
	CGDTrace trace( LOG_L6, "CSharedMemoryManager:CreateMemory(%s,%d)",sKey,nMaxSize);
	
	DWORD dwErr = 0;
	bool bOwner = false;
	m_nMaxSize = nMaxSize;
	strcpy(m_sInforGuardSharedMemoryId,sKey);
	
	if ( INVALID_HANDLE_VALUE == m_hFileMap )
	{
		// ԴMAPļ
		m_hFileMap = OpenFileMapping(
			FILE_MAP_ALL_ACCESS,
			FALSE,
			TEXT(m_sInforGuardSharedMemoryId));
		
		if ( NULL == m_hFileMap )
		{ 
			dwErr = GetLastError();
			if ( ERROR_ALREADY_EXISTS != dwErr )
			{ 
				CShareRestrictedSD ShareRestrictedSD;
				// MAPļ
				m_hFileMap = CreateFileMapping(
					INVALID_HANDLE_VALUE,
					ShareRestrictedSD.GetSA(),
					PAGE_READWRITE,
					0,
					1024*m_nMaxSize,
					TEXT(m_sInforGuardSharedMemoryId)
					);
				
				if ( NULL == m_hFileMap )
				{ 
					dwErr = GetLastError();
					if ( ERROR_ALREADY_EXISTS != dwErr )
					{ 
						GDETrace( "ڴʧ[%d][%s]", dwErr, GetErrText(dwErr) );
						return trace.SetRetValue( dwErr );
					}
					else
					{ 
						// ѾڣֻҪӳ
					}
				}
				bOwner = true;
			}
			else
			{
				GDETrace( "ڴʧ[%d][%s]", dwErr, GetErrText(dwErr) );
				return trace.SetRetValue( dwErr );
			}
		}
	}
	
	if ( pbOwner ) *pbOwner = bOwner;
	
	// ӳMAPͼ
	m_pMapView = MapViewOfFile( m_hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0 ); 
	if ( NULL == m_pMapView )
	{
		dwErr = GetLastError();
		return trace.SetRetValue( dwErr );
	}
	
	m_pSMData = (SharedMemoryData*)m_pMapView;
	
	// ӳɹ
	if ( bOwner ) // ˭˭ʼ
	{
		// 洢ڴСϢ
		m_pSMData->nSize = 1024*m_nMaxSize - sizeof(SharedMemoryData);
		m_pSMData->nOffset = sizeof(SharedMemoryData); // ¼Եַ
	}
	
	return trace.SetRetValue( 0 );
} 


// ()
long CSharedMemoryManager::CreateMemory( long nMaxSize )
{
	CGDTrace trace( LOG_L6, "CSharedMemoryManager:CreateMemory(%d)", nMaxSize );
	long nRet = CreateMemory( m_nSharedMemoryKey, nMaxSize );
	return trace.SetRetValue( nRet );
}

long CSharedMemoryManager::ReleaseMemory()
{
	// CGDTrace trace( LOG_L6,  "CSharedMemoryManager:ReleaseMemory()" );	// by liu_yfeng
	/*ûŪףϴִʱᵼTomcatӦ÷޷˳*/
	/*by wang_jin at 2008-8-11*/
	
	if ( m_pMapView )
	{
		UnmapViewOfFile( m_pMapView );
	}
	if ( INVALID_HANDLE_VALUE != m_hFileMap )
	{
		//CloseHandle( m_hFileMap );	// delete by liu_yfeng 2009-01-05
		//m_hFileMap = INVALID_HANDLE_VALUE;
	}
	return 0;
	// return trace.SetRetValue( 0 );
}
