/******************************************************************************
*
* ļ              SocketServer.cpp
* ģĿģ      ࣬׽ʵֿƽ̨ͨѶ
* ߼ڣ        wang_jin 2007-12-15
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
******************************************************************************/

#include "SocketServer.h"

#include <process.h>
#include <assert.h>


SOCKBUFF SockBuff[ MAXSOCKBUFFCOUNT ] = {0};

CSocketServer::CSocketServer()
{
	m_sock = 0; 
	m_bWorkOn = m_bStopFlag = false;
}

CSocketServer::CSocketServer( short nPort )
{
	m_sock = 0; 
	m_bWorkOn = m_bStopFlag = false;

	Init( NULL, nPort );
}

CSocketServer::~CSocketServer()
{
	Close(); 
}

int CSocketServer::Close()
{
	int nRet = 0; 
	
	if ( m_sock > 0 )
	{
#ifdef WIN32
		nRet = closesocket( m_sock ); 
#else
		nRet = close( m_sock ); 
#endif
		m_sock = 0; 
	}
	
	return nRet; 
}

int CSocketServer::Stop()
{
	printf( "CSocketServer:Stop() ...\n" );
	
	if ( m_bWorkOn )
	{
		if ( ! m_bStopFlag )
		{
			m_bStopFlag = true;
			
			do
			{
				Sleep( 50 );
			} while ( m_bWorkOn );
		}
	}
	
	Close();
	
	printf( "CSocketServer Stoped.\n" );
	
	return 0;
}

int CSocketServer::Init( const char* sIp, int nPort )
{
	if ( sIp )
	{
		m_sIp = sIp;
	}
	m_nPort = nPort;
	
#ifdef WIN32
	m_hThread = (HANDLE)_beginthreadex( 
		NULL, 
		0, 
		SocketServerThread, 
		this, 
		0, 
		&m_nThreadId );
	
	if ( 0 == m_hThread )
	{
		return GetLastError();
	}
#else
	m_nThreadId = pthread_create( &m_hThread,
		NULL,
		SocketServerThread,
		(void*)this );
	
	if ( m_nThreadId )
	{
		return GetLastError();
	}
	else
	{
		printf( "pthread_create() Error=[%d] [%s]\n", GetLastError(), GetErrText(GetLastError()) );
	}
#endif
	
	return 0; 
}

int CSocketServer::Send( const char* sData, int nLen )
{
	int nRet = 0; 
	int nCnt = 0; 
	
	// ֱͣȫִͣ
	while ( nCnt < nLen )
	{
		nRet = send( m_sock, sData + nCnt, nLen - nCnt, 0 ); 
		if ( SOCKET_ERROR == nRet )
		{
			nRet = GetLastError();
			return nRet; 
		}
		else if ( nRet > 0 )
		{
			nCnt += nRet; 
		}
	}
	
	return 0; 
}

int CSocketServer::DealWithDataFromSocketClient( char* sRecvData, int nRecvDataLen, SOCKET sock )
{
	const int HEADLEN = 8;
	int nOffset = 0;
	
	// ѭ
	do
	{
		if ( nOffset + HEADLEN > nRecvDataLen )
		{
			return nOffset; // (ǰ)ݰͷȲ
		}
		
		int nSize = -1;
		sscanf( sRecvData + nOffset, "%08d", &nSize );
		if ( nSize < 0 || nSize > 1024 )
		{
			// !
			return nRecvDataLen; // 
		}

		if ( nOffset + HEADLEN + nSize > nRecvDataLen )
		{
			return nOffset; // (ǰ)ݳȲ
		}
		
#ifdef WIN32
		struct sockaddr_in rAddr = {0}; 
		struct sockaddr_in lAddr = {0}; 
		int addrlen = sizeof( rAddr );
		getpeername( sock,(struct sockaddr*)&rAddr,&addrlen);
		addrlen = ::htons( rAddr.sin_port );
		addrlen = sizeof( lAddr );
		getsockname( sock,(struct sockaddr*)&lAddr,&addrlen);
		addrlen = ::htons( lAddr.sin_port );
		if ( m_hMainWnd )
		{
			char* p = new char[ nSize + 1 + 2 + 17 ]; // \r\n [192.168.123.321]
			memcpy( p, sRecvData + nOffset + HEADLEN, nSize );
			p[ nSize ] = '\0';
			sprintf( p + strlen(p), "[%d.%d.%d.%d]", (unsigned char)rAddr.sin_addr.S_un.S_un_b.s_b1, (unsigned char)rAddr.sin_addr.S_un.S_un_b.s_b2, (unsigned char)rAddr.sin_addr.S_un.S_un_b.s_b3, (unsigned char)rAddr.sin_addr.S_un.S_un_b.s_b4 );
			long nRet = ::SendMessage( m_hMainWnd, WM_USER_DATA, addrlen, (LPARAM)p );
			delete []p;
		}
#else
#error No Win32 and No Code.
#endif

		nOffset += HEADLEN + nSize;
	} while( nOffset + HEADLEN <= nRecvDataLen );
	
	return nOffset; // ִ
}

int GnSocketStatus = 0; 

UINT WINAPI CSocketServer::SocketServerThread(void* param)
{
	int nRet; 
	int sock; 
	int count; 
	int svrsock, newsock, minsock, maxsock; 
	bool bStateOK; 
	struct sockaddr_in addr; 
	struct fd_set main_set, sub_set; 
	struct timeval timeout; 
	unsigned long on = 1;
	
	CSocketServer* pSock = (CSocketServer*)param; 
	
	pSock->m_bWorkOn = true;
	pSock->m_bStopFlag = false;
	while ( ! pSock->m_bStopFlag )
	{
		bStateOK = true;
		
		svrsock = socket( AF_INET, SOCK_STREAM, 0 ); 
		if ( svrsock < 0 )
		{
			nRet = GetLastError();
			return nRet; 
		}
		nRet = setsockopt( svrsock, SOL_SOCKET, SO_REUSEADDR, (char*)&on, sizeof(on) ); 
		if ( nRet < 0 )
		{
			nRet = GetLastError(); 
			closesocket( svrsock ); 
			return nRet; 
		}
		nRet = ioctlsocket( svrsock, FIONBIO, &on ); 
		if ( nRet < 0 )
		{
			nRet = GetLastError(); 
			closesocket( svrsock ); 
			return nRet; 
		}
		// 
		memset(&addr, 0, sizeof(addr)); 
		addr.sin_family = AF_INET; 
		addr.sin_addr.s_addr = htonl(INADDR_ANY); 
		addr.sin_port = htons( pSock->m_nPort ); 
		nRet = bind( svrsock, (struct sockaddr*)&addr, sizeof(addr) ); 
		if ( nRet < 0 )
		{
			nRet = GetLastError(); 
			closesocket( svrsock ); 
			return nRet; 
		}
		nRet = listen( svrsock, 32 ); 
		if ( nRet < 0 )
		{
			nRet = GetLastError(); 
			closesocket( svrsock ); 
			return nRet; 
		}
		
		minsock = maxsock = svrsock; 
		timeout.tv_sec = 1; 
		timeout.tv_usec = 0; 
		// 
		FD_ZERO( &main_set ); 
		FD_SET( svrsock, &main_set ); 
		
		printf( "SocketServer Started at [%s][%d]...\n", pSock->m_sIp.c_str(), pSock->m_nPort ); 
		while ( ! pSock->m_bStopFlag && bStateOK )
		{
			// Ⲣ¼
			memcpy( &sub_set, &main_set, sizeof(main_set) ); 
			nRet = select( maxsock + 1, &sub_set, NULL, NULL, &timeout ); 
			if ( nRet < 0 )
			{
				// ͨѶʧ
				nRet = GetLastError(); 
				printf( "****ͨѶʧ[%d][%s]****\n", nRet, "" ); // GetErrText(nRet) );
				bStateOK = false;
				break; 
			}
			if ( 0 == nRet )
			{
				// SELECTʱУ⴦
				continue; 
			}
			count = nRet; 
			// countҪ׽֣һ
			for ( sock = minsock; sock <= maxsock && count > 0; sock++ )
			{
				if ( ! FD_ISSET( sock, &sub_set ) ) continue; 
				count--; 
				if ( sock == svrsock) // ׽֡¼
				{
					do
					{
						newsock = accept( svrsock, NULL, NULL); // ڷظֵʱʾʧ(0Ҳǳɹ)
						if ( newsock < 0 )
						{
							// ʧ
							nRet = GetLastError(); 
#ifdef WIN32
							if ( WSAEWOULDBLOCK != nRet )
#else
							if ( EWOULDBLOCK != nRet )
#endif
							{
								printf( "****ʧ[%d][%s]****\n", nRet, "" ); // GetErrText(nRet) );
								bStateOK = false;
							}
							break;
						}
						// ѰҿԴ
						for ( int i = 0; i < MAXSOCKBUFFCOUNT; i++ )
						{
							if ( 0 == SockBuff[i].sock )
							{
								SockBuff[i].sock = newsock; 
								SockBuff[i].nOffset = 0;
								
								FD_SET( newsock, &main_set ); 
								if ( newsock < minsock )
									minsock = newsock; 
								if ( maxsock < newsock )
									maxsock = newsock; 
								break; 
							}
						}
						if ( i == MAXSOCKBUFFCOUNT )
						{
							closesocket( newsock ); // Դ
							printf( "Դ[%d]\n", MAXSOCKBUFFCOUNT ); 
						}
					} while( newsock != SOCKET_ERROR );
				}
				else // Ǽ׽֡ݶд
				{
					// ѰҴ
					for( int i = 0; i < MAXSOCKBUFFCOUNT; i ++ )
					{
						if ( SockBuff[i].sock == sock ) // ҵ
						{
							// 
							nRet = recv(
								sock, 
								SockBuff[i].chrRBuf + SockBuff[i].nOffset, 
								sizeof(SockBuff[i].chrRBuf) - SockBuff[i].nOffset, 
								0 ); 
							
							if ( nRet > 0 ) // 
							{
								SockBuff[i].nOffset += nRet; 
								SockBuff[i].chrRBuf[ SockBuff[i].nOffset ] = '\0';
								// ݴݴ
								int nDoneDataLen = pSock->DealWithDataFromSocketClient( SockBuff[i].chrRBuf, SockBuff[i].nOffset, sock ); 
								if ( nDoneDataLen > 0 )
								{
									assert( nDoneDataLen <= SockBuff[i].nOffset ); 
									if ( nDoneDataLen < SockBuff[i].nOffset )
									{
										memcpy( SockBuff[i].chrRBuf, SockBuff[i].chrRBuf + nDoneDataLen, SockBuff[i].nOffset - nDoneDataLen ); 
									}
									SockBuff[i].nOffset -= nDoneDataLen; 
									//SockBuff[i].chrRBuf[ SockBuff[i].nOffset ] = '\0'; // 
								}
								else if ( nDoneDataLen < 0 )
								{
									// ӦҪϿ
									nRet = SOCKET_ERROR;
								}
							}
							
							// ͨѶӦϿӻӦϿӣϿ
							if ( ( SOCKET_ERROR == nRet ) // Error occurs.
								|| ( 0 == nRet ) ) // The connection has been gracefully closed.
							{
								// Ͽ
								closesocket( sock ); 
								FD_CLR( sock, &main_set ); 
								SockBuff[i].sock = 0;
								if ( sock == minsock ) while ( FD_ISSET(minsock, &main_set) == FALSE ) minsock += 1; 
								if ( sock == maxsock ) while ( FD_ISSET(maxsock, &main_set) == FALSE ) maxsock -= 1; 
							}
							break; 
						}// if
					}// for
				}// else
			}// for
		}
		
		if ( minsock <= maxsock )
			for( sock = minsock; sock <= maxsock; sock++ )
			{
				if ( FD_ISSET( sock, &main_set ) )
				{
					closesocket( sock ); 
					FD_CLR( sock, &main_set ); 
				}
			}
			
		closesocket( svrsock ); 
		svrsock = 0; 
	}
	
	pSock->m_bWorkOn = false;
	printf( "߳˳\n"); 
	
	return 0; 
}
