// UrlParse.h

#ifndef URLPARSE_H
#define URLPARSE_H

#pragma warning(disable:4251)
#pragma warning(disable:4786)

#include <string>
#include <vector>

#ifndef NOT_USE_STD_LIB
	using namespace std;
#endif

#ifdef WIN32
	#ifdef URLPARSE_EXPORTS
		#define URLPARSE_API __declspec(dllexport)
	#else
		#define URLPARSE_API __declspec(dllimport)
	#endif
#endif

#ifndef URLPARSE_API
	#define URLPARSE_API
#endif


class URLPARSE_API CUrlParse
{
public:
	static const char* PATHSLASH;
	static const char* PATHREVERSESLASH;

	enum PageType
	{
		NIL_PAGE = 0,
		ASP_PAGE = 1,
		JSP_PAGE = 2,
		PHP_PAGE = 4,
		SHTML_PAGE = 5,
		ASP_AND_PHP_PAGE = 6
		
	};

	enum FileAttr
	{
		FILEATTR_EXCEPT = 0,
		FILEATTR_FILE = 1,
		FILEATTR_DIR = 2
	};

	// ĬֹؼֵĴСдң򻯴
	CUrlParse(const char* sFilePath, const char* sRootPath, PageType pageType, bool bToLower = false);
	~CUrlParse();

public:
	// 
	void Parse();
	// ؽincludeļб
	vector<string>& GetFileList() { return _filelist; }

protected:
	FileAttr GetFileType(const char* strFilePath);
	void InitPath();
	string GetParentPath(const string& fileName);

	void ParseAspInclude(const char* fileName);
	void ParseJspInclude(const char* fileName);
	void ParsePhpInclude(const char* fileName);
	void ParseSHtmlInclude(const char* fileName);

protected:
	string _filePath;
	string _rootPath;
	PageType _pageType;
	vector<string> _filelist;
	// ɨǰתСд(ĬΪfalse)
	bool _bToLower;
};


#endif
