#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

static char *t_pzftp = NULL;    /* ZFTPƽַ̨ */

typedef struct  s_monfilter     /* عṹ */
{
    uid_t   iUid;               /* ûID */
    char    szFilDesc[65];      /*  */
    char    szFilNo[65];        /* ɼ */
    int     bWarn;              /* Ƿ澯 */
    int     bStat;              /* ״̬Ƿ */
} MONFILTER;

/**************************************
 ƥȡ״̬
 ֵ  1 ƥ  0 ƥ
 **************************************/
static int f_filter(MONFILTER *pFilter, char *pstat)
{
    if( pFilter->iUid && (pFilter->iUid != GC_getuid(t_pzftp, u_pruns->pslot)) ) return(0);

    /*  */
    if( pFilter->szFilDesc[0] && strstr(u_pcfgs->desc, pFilter->szFilDesc) == NULL ) return(0);

    /* Ź */
    if( pFilter->szFilNo[0] && strstr(u_pcfgs->no, pFilter->szFilNo) == NULL ) return(0);

    /* 澯 */
    if( pFilter->bWarn >= 0 )
    {
        if( u_pcfgs->warn_mode[WF_ALL] == '1' )
        {
            if( pFilter->bWarn == 1 ) return(0);
        }
        else
        {
            if( pFilter->bWarn == 0 ) return(0);
        }
    }

    /* ״̬ */
    switch( GC_getstat(t_pzftp, u_pruns->pslot) )
    {
    case ST_RELEASED:                   /* ͷ */
        return(0);

    case ST_STOPPING:                   /* ֹͣ */
    case ST_STOPPED:                    /* Ϊֹ */
        strcpy(pstat, "Ϊֹ");
        break;

    default:
        if( u_pruns->errtime || u_pruns->noftime )
            strcpy(pstat, "");
        else
            strcpy(pstat, "");
    }

    /* ״̬ */
    if( pFilter->bStat >= 0 )
    {
        if( strcmp(pstat, "") == 0 )
        {
            if( pFilter->bStat == 1 ) return(0);
        }
        else
        {
            if( pFilter->bStat == 0 ) return(0);
        }
    }

    return(1);
}

int f_mon(void)
{
    time_t tNow;

    int   i, k, b,
          leftn,                /* ʣļĿ */

          startno = 1,          /* ʼ */
          num = 1,              /* ʾĿ */
          endno,                /*  */
          totalnum = 1,         /* ܼĿ */
          iSlot;

    char *p,
          pstat[10],            /* ״̬ */
          tmstr[10],            /* ϴβɼʱ */
          errtm[10],            /* ʱ */
          warnnot[3],           /* Ƿ澯 */
          nofmsg[64],           /* ļϢ */
          desc[65];

    static char buf1[1024];

    MONFILTER   sFilter;        /* ṹ */

    t_pzftp = f_conn_zshm(u_cportkey, 0);

    if( t_pzftp == NULL )
    {
        GC_sendecode(E_NOTRUN);
        return(0);
    }

    memset(&sFilter, 0, sizeof(sFilter));
    sFilter.bWarn = -1;
    sFilter.bStat = -1;

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        switch( u_TAGs[i].tag )
        {
        case TAG_MONSTARTSEQ:   /* ʼ */

            startno = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;

        case TAG_MONSHOWROWS:   /* ʾĿ */

            num = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;

        case TAG_DESCRIPTION:   /* Ϣ */

            strcpy(sFilter.szFilDesc, u_TAGs[i].pv);
            break;

        case TAG_NO:            /* ɼŹ */

            strcpy(sFilter.szFilNo, u_TAGs[i].pv);
            break;

        case TAG_MONWARNNOT:    /* 澯 */

            sFilter.bWarn = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;

        case TAG_MONSTATOK:     /* ״̬ */

            sFilter.bStat = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;
        }
    }
    endno = startno + num;

z_logv(g_logfile, "start=%d, num=%d, desc=%s, no=%s, warn=%d, status=%d",
    startno, num, sFilter.szFilDesc, sFilter.szFilNo, sFilter.bWarn, sFilter.bStat);

    /* ûID */
    sFilter.iUid = atoi(u_pkthead.uid);

    /* ͳƷĿܼĿ */
    num = 0;
    totalnum = 0;

    for( i = 0, u_pruns = u_runs, u_pcfgs = u_cfgs; i < MAXN_Z; u_pcfgs++, u_pruns++, i++ )
    {
        if( u_pcfgs->no[0] == 0 ) continue;
        totalnum ++;

        if( f_filter(&sFilter, pstat) == 0 ) continue;
        num ++;
    }

    /* ܼĿ */
    sprintf(buf1, "%d", totalnum);
    GC_setpheadn(buf1, 5);

    /* 澯ʱ */
    iSlot = f_wtmslot(sFilter.iUid, 0);

    if( iSlot < 0 )
        buf1[0] = 0;
    else
        snprintf(buf1, sizeof(buf1), "%ld", (long)(u_wtms[iSlot].tWarnTime));
    GC_setpheadn(buf1, 4);

    p = u_cinfo;
    *p = 0;

    /* Ŀ */
    sprintf(p, "%-10d", num);
    p += 10;
    *p = 0;

    /* ǰʱ */
    tNow = time( (time_t *) 0 );

    for( i = 0, k = 1, u_pruns = u_runs, u_pcfgs = u_cfgs; i < MAXN_Z; u_pcfgs++, u_pruns++, i++ )
    {
        if( k >= endno ) break;

        if( u_pcfgs->no[0] == 0 ) continue;
        if( f_filter(&sFilter, pstat) == 0 ) continue;

        if( k++ < startno ) continue;

        /* Ϣ */
        b = z_chi_nohalf(u_pcfgs->desc, 64);
        strncpy(desc, u_pcfgs->desc, b);
        desc[b] = 0;

        /* ϴβɼʱ */
        tmstr[0] = 0;
        if( u_pruns->endtime ) z_get_dt(tmstr, 8, "t", u_pruns->endtime);

        /* ʣļĿ */
        leftn = u_pruns->leftfiles > 9999 ? 9999 : u_pruns->leftfiles;

        strcpy(warnnot, u_pcfgs->warn_mode[WF_ALL] == '1' ? "" : "");

        if( u_pruns->errtime ) z_get_dt(errtm, 8, "t", u_pruns->errtime);
        else errtm[0] = 0;

        if( u_pruns->noftime ) sprintf(nofmsg, " ļ %ld", (long)(tNow - u_pruns->endtime));
        else nofmsg[0] = 0;

        sprintf(buf1, "%s+%s+%s+%s+%s+%d+%s+%s+%s+%s+%s%s+%d\n",
            u_pruns->uname, desc, u_pcfgs->no, warnnot, pstat,
            leftn, tmstr, u_pruns->currfile, u_pruns->hdftime,
            errtm, u_pruns->errmsg, nofmsg, u_pcfgs->seq_ctrl);

        strcpy(p, buf1);
        p += strlen(buf1);
        *p = 0;
    }

    /* Ͽӹڴṹ */
    f_disconn_zshm();

    /* Ӧ */
    GC_setpheadn(g_okcode, 3);
    GC_sendtext(u_cinfo);

    return(0);
}
