/********
 ־ѯ
 ********/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/stat.h>
#include "gcps.h"
#include "z.h"
#include "zagent.h"
#include "zvar.h"

#define   QRY_LOGN      9       /* ļĿǰļܵ.bakļ */
#define   LEN_CPTIME    19      /* ʱȽϳ */
#define   DFL_YEAR     "2008"   /* ȱʡ */

/* ־ļϢ */
typedef struct s_loginfo
{
        int      no;                            /*  */
        time_t   stamp;                         /* ʱ */
} LOGFINFO;

/* ѯ */
typedef struct s_qryfilter
{
        char     file[256];                     /* ļȫ· */
        char     begtime[20];                   /* ʼ */
        char     endtime[20];                   /*  */
        char     include[129];                  /*  */
        char     exclude[129];                  /*  */
} QRYFILTER;

static LOGFINFO  t_sloginfo[QRY_LOGN];
static QRYFILTER t_filter;

/* ־ļʱ */
int f_logsort(char *pbase);

/**********************
 ѯļ
 ֵ  0 
           1 
 **********************/
int f_qryone(char **pOut);

/* ѯ־ */
int f_qrynid(int iLogType, char *pDir);

int f_logqry(void)
{
    int   b, i,
          iLogType = -1,            /* ־ͣ0ƽ̨־ 1澯־ 2־ 3ܸ澯 */
          iFtpOut = -1;             /* ѯFTP Ϣ */

    char *pBody,
          szNo[17],                 /* ɼ */
          szBelong[21],             /* ֹ˾ */

          szBase[256],
          szDir[256],
          szTmp[64];

    szNo[0] = 0;
    szBelong[0] = 0;

    memset(&t_filter, 0, sizeof(t_filter));

    for( i = 0; i < MAXN_TAG; i++ )
    {
        if( u_TAGs[i].tag == 0 ) break;

        switch( u_TAGs[i].tag )
        {
        case TAG_BELONG:            /* ֹ˾ */

            strcpy(szBelong, u_TAGs[i].pv);
            break;

        case TAG_NO:                /* ɼ */

            strcpy(szNo, u_TAGs[i].pv);
            break;

        case TAG_SEQMIN:            /* ʼʱ䣬TAG */

            if( u_TAGs[i].bSet == 1 ) strcpy(t_filter.begtime, u_TAGs[i].pv);
            break;

        case TAG_SEQMAX:            /* ʱ䣬TAG */

            if( u_TAGs[i].bSet == 1 ) strcpy(t_filter.endtime, u_TAGs[i].pv);
            break;

        case TAG_HOSTIP_PAIR:       /* ʼʱ()TAG */

            if( u_TAGs[i].bSet == 1 ) strcpy(t_filter.begtime, u_TAGs[i].pv);
            break;

        case TAG_USER_PAIR:         /* ʱ()TAG */

            if( u_TAGs[i].bSet == 1 ) strcpy(t_filter.endtime, u_TAGs[i].pv);
            break;

        case TAG_SOURCE_PATH:       /* TAG */

            strcpy(t_filter.include, u_TAGs[i].pv);
            break;

        case TAG_SOURCE_BACKUP_PATH:/* TAG */

            strcpy(t_filter.exclude, u_TAGs[i].pv);
            break;

        case TAG_MONWARNNOT:        /* ѯFTP TAG */

            iFtpOut = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;

        case TAG_MONSTATOK:         /* ־ͣTAG */

            iLogType = (int) strtol(u_TAGs[i].pv, (char **)NULL, 10);
            break;
        }
    }

    if( t_filter.begtime[0] == 0 || t_filter.endtime[0] == 0 )
    {
        GC_sendecode(E_NOTMATCH);
        return(1);
    }

    /* Ϊʱ */
    if( strlen(t_filter.begtime) == LEN_CPTIME - 5 )
    {
        sprintf(szTmp, "%s/%s", DFL_YEAR, t_filter.begtime);
        strcpy(t_filter.begtime, szTmp);

        sprintf(szTmp, "%s/%s", DFL_YEAR, t_filter.endtime);
        strcpy(t_filter.endtime, szTmp);
    }

    /* ȡ־Ŀ¼ */
    switch( iLogType )
    {
    case LT_SINGLE:         /* ɼ־ */
        b = z_readini(CITYS_CFG, SEG_DIRLOG, szBelong, szDir, sizeof(szDir) - 1, 0);
        break;

    case LT_NIDNORM:        /* ־ */
    case LT_NIDWARN:
        b = z_getkeyv(u_szPlatCfg, "DIRNID", szDir, sizeof(szDir) - 1);
        break;

    default:                /* ƽ̨ */
        b = z_readini(CITYS_CFG, SEG_PLATFORM, "DIRLOG", szDir, sizeof(szDir) - 1, 0);
    }

    if( b )
    {
        GC_sendecode(E_LOGONDENY);
        return(1);
    }

    pBody = u_cinfo;
    *pBody = 0;

    /* ־ */
    if( iLogType == LT_NIDNORM || iLogType == LT_NIDWARN )
    {
        f_qrynid(iLogType, szDir);
        return(0);
    }

    /* ־ļ */
    switch( iLogType )
    {
    case LT_PLAT:           /* ƽ̨־ */
        snprintf(szBase, sizeof(szBase), "%s/%s", szDir, LOGRPLAT);
        break;

    case LT_PLATWARN:       /* ƽ̨澯־ */
        snprintf(szBase, sizeof(szBase), "%s/%s%s", szDir, LOGPREFIX, LOGPSMON);
        break;

    default:                /* ɼ־ */
        if( iFtpOut > 0 )   /* FTP  */
            snprintf(szBase, sizeof(szBase), "%s/%s%s%s", szDir, OUTPREFIX, szNo, OUTSUFFIX);
        else
            snprintf(szBase, sizeof(szBase), "%s/%s%s", szDir, LOGPREFIX, szNo);

        break;
    }
z_logv(g_logfile, "iLogType=%d, iFtpOut=%d, szBase=%s", iLogType, iFtpOut, szBase);

    /* ־ļʱ */
    f_logsort(szBase);

    /* ѯ־Ϣ */
    for( i = 0; i < QRY_LOGN; i++ )
    {
        switch( t_sloginfo[i].no )
        {
        case -1:

            strcpy(t_filter.file, szBase);
            break;

        case -2:

            snprintf(t_filter.file, sizeof(t_filter.file), "%s.bak", szBase);
            break;

        default:

            snprintf(t_filter.file, sizeof(t_filter.file), "%s.%d", szBase, t_sloginfo[i].no);
            break;
        }

        z_get_dt(szTmp, 19, "l", t_sloginfo[i].stamp);
        if( strcmp(szTmp, t_filter.begtime) < 0 ) continue;

        if( f_qryone(&pBody) ) break;
    }

    GC_setpheadn(g_okcode, 3);
    GC_sendtext(u_cinfo);

    return(b);
}

int f_morepkt(char *pCmd)
{
    FILE *fp;

    int   iLen;
    char *pBody, szMore[8] = {0};

    static char szBuf[1024];

    /* ִнűȡ */
    if( (fp = popen(pCmd, "r")) == NULL ) return(0);

    szMore[0] = '1';
    pBody = u_cinfo;
    *pBody = 0;

    while( ! feof(fp) )
    {
        if( fgets(szBuf, sizeof(szBuf), fp) == NULL ) break;

        if( t_filter.include[0] && strstr(szBuf, t_filter.include) == NULL ) continue;
        if( t_filter.exclude[0] && strstr(szBuf, t_filter.exclude) ) continue;

        iLen = strlen(szBuf);

        /* Ϣ֤ */
        if( pBody - u_cinfo + iLen >= sizeof(u_cinfo) - 1 )
        {
            GC_setpheadn(szMore, 5);
            GC_setpheadn(g_okcode, 3);
            GC_sendtext(u_cinfo);

            pBody = u_cinfo;
            *pBody = 0;
        }

        strcpy(pBody, szBuf);
        pBody += iLen;
        *pBody = 0;
    }
    pclose(fp);

    szMore[0] = '0';
    GC_setpheadn(szMore, 5);
    GC_setpheadn(g_okcode, 3);
    GC_sendtext(u_cinfo);

    return(0);
}

/************
 ѯ־
 ************/
int f_qrynid(int iLogType, char *pDir)
{
    int   b;
    char  szDir[256], szName[64], szShell[64],
          szBegTime[16], szEndTime[16];

    static char szBuf[1024];

    /* ʼʱ䡢ʱ */
    sprintf(szBegTime, "%.4s%.2s%.2s%.2s%.2s%.2s",
        t_filter.begtime, t_filter.begtime + 5, t_filter.begtime + 8,
        t_filter.begtime + 11, t_filter.begtime + 14, t_filter.begtime + 17);

    sprintf(szEndTime, "%.4s%.2s%.2s%.2s%.2s%.2s",
        t_filter.endtime, t_filter.endtime + 5, t_filter.endtime + 8,
        t_filter.endtime + 11, t_filter.endtime + 14, t_filter.endtime + 17);

    /* ˽ű */
    if( iLogType == LT_NIDNORM )
        strcpy(szName, "NIDNORM_SHELL");
    else
        strcpy(szName, "NIDWARN_SHELL");

    if( z_getkeyv(u_szPlatCfg, szName, szShell, sizeof(szShell) - 1) )
    {
        z_logv(g_logfile, "no %s", szName);
        GC_sendecode(E_FILE);
        return(0);
    }

    if( z_readini(CITYS_CFG, SEG_PLATFORM, "DIRPLUGIN", szDir, sizeof(szDir) - 1, 0) )
    {
        z_logv(g_logfile, "no DIRPLUGIN");
        GC_sendecode(E_FILE);
        return(0);
    }

    /* DeviceID */
    b = f_seekTAG(TAG_FILE_ANALYZER);

    sprintf(szBuf, "%s/%s %s %s %s", szDir, szShell, szBegTime, szEndTime, u_TAGs[b].pv);

    return( f_morepkt(szBuf) );
}

/**********************
 ѯļ
 ֵ  0 
           1 
 **********************/
int f_qryone(char **pOut)
{
    FILE *fp;

    int   b = 0, iLen;
    char *pLoc, szTmp[64];

    static char szBuf[1024];

    if( (fp = fopen(t_filter.file, "r")) == NULL ) return(0);

    while( ! feof(fp) )
    {
        if( fgets(szBuf, sizeof(szBuf), fp) == NULL ) break;

        if( szBuf[0] == '[' )
        {
            /* ȷļеʱ䳤 */
            if( (pLoc = strchr(szBuf, ']')) == NULL )
                iLen = 0;
            else
                iLen = pLoc - szBuf;

            if( iLen == LEN_CPTIME - 5 + 1 )
            {
                sprintf(szTmp, "%s/%.*s", DFL_YEAR, LEN_CPTIME - 5, szBuf + 1);
            }
            else if( iLen == LEN_CPTIME + 1 )
            {
                strncpy(szTmp, szBuf + 1, LEN_CPTIME);
            }
            else
            {
                continue;
            }

            if( strncmp(szTmp, t_filter.begtime, LEN_CPTIME) < 0 ) continue;
            else if( strncmp(szTmp, t_filter.endtime, LEN_CPTIME) > 0 )
            {
                b = 1;
                break;
            }
        }

        if( t_filter.include[0] && strstr(szBuf, t_filter.include) == NULL ) continue;
        if( t_filter.exclude[0] && strstr(szBuf, t_filter.exclude) ) continue;

        iLen = strlen(szBuf);

        /* Ϣ֤ */
        if( *pOut - u_cinfo + iLen >= sizeof(u_cinfo) - 1 )
        {
            b = 1;
            break;
        }

        strcpy(*pOut, szBuf);
        (*pOut) += iLen;
        *(*pOut) = 0;
    }
    fclose(fp);

    return(b);
}

/*  */
int f_compstamp(const void *a, const void *b)
{
    if( ((LOGFINFO *)a)->stamp < ((LOGFINFO *)b)->stamp ) return(-1);
    else if( ((LOGFINFO *)a)->stamp < ((LOGFINFO *)b)->stamp ) return(0);
    else return(1);
}

/* ־ļʱ */
int f_logsort(char *pbase)
{
    int  i;
    char szFile[256];

    struct stat st;

    for( i = 0; i < QRY_LOGN; i++ )
    {
        switch( i )
        {
        case 0:

            strcpy(szFile, pbase);
            t_sloginfo[i].no = -1;
            break;

        case 1:

            snprintf(szFile, sizeof(szFile), "%s.bak", pbase);
            t_sloginfo[i].no = -2;
            break;

        default:

            snprintf(szFile, sizeof(szFile), "%s.%d", pbase, i - 2);
            t_sloginfo[i].no = i - 2;
            break;
        }

        if( stat(szFile, &st) < 0 )
            t_sloginfo[i].stamp = -1;
        else
            t_sloginfo[i].stamp = st.st_mtime;
    }

    qsort(t_sloginfo, QRY_LOGN, sizeof(LOGFINFO), f_compstamp);

    return(0);
}

/* ѯϵͳϢ */
int f_sysinfo(void)
{
    int    i;
    char  *pBody, szShell[64], szDir[256];

    static char szBuf[1024];

    pBody = u_cinfo;
    *pBody = 0;

    /* ˽ű */
    if( z_getkeyv(u_szPlatCfg, "SYSINFO_SHELL", szShell, sizeof(szShell) - 1) )
    {
        z_logv(g_logfile, "no SYSINFO_SHELL");
        return(0);
    }

    if( z_readini(CITYS_CFG, SEG_PLATFORM, "DIRPLUGIN", szDir, sizeof(szDir) - 1, 0) )
    {
        z_logv(g_logfile, "no DIRPLUGIN");
        GC_sendecode(E_FILE);
        return(0);
    }

    /* ѯ */
    i = f_seekTAG(TAG_GATHER_MODE);

    sprintf(szBuf, "%s/%s %s", szDir, szShell, u_TAGs[i].pv);

    return( f_morepkt(szBuf) );
}

