//
// DateTimeFormat.cpp
//


#include "Groundwork/DateTimeFormat.h"


namespace InforGuard {
namespace Groundwork {


const string DateTimeFormat::ISO8601_FORMAT  = "%Y-%m-%dT%H:%M:%S%z";
const string DateTimeFormat::RFC822_FORMAT   = "%w, %e %b %y %H:%M:%S %Z";
const string DateTimeFormat::RFC1123_FORMAT  = "%w, %e %b %Y %H:%M:%S %Z";
const string DateTimeFormat::HTTP_FORMAT     = "%w, %d %b %Y %H:%M:%S %Z";
const string DateTimeFormat::RFC850_FORMAT   = "%W, %e-%b-%y %H:%M:%S %Z";
const string DateTimeFormat::RFC1036_FORMAT  = "%W, %e %b %y %H:%M:%S %Z";
const string DateTimeFormat::ASCTIME_FORMAT  = "%w %b %f %H:%M:%S %Y";
const string DateTimeFormat::SORTABLE_FORMAT = "%Y-%m-%d %H:%M:%S";


const string DateTimeFormat::WEEKDAY_NAMES[] =
{
	"Sunday",
	"Monday",
	"Tuesday",
	"Wednesday",
	"Thursday",
	"Friday",
	"Saturday"
};


const string DateTimeFormat::MONTH_NAMES[] =
{
	"January",
	"February",
	"March",
	"April",
	"May",
	"June",
	"July",
	"August",
	"September",
	"October",
	"November",
	"December"
};


} // namespace Groundwork
}	// namespace InforGuard
