/***********************************************************************
*
* ļ        DBTree.cpp
* ģĿģݹ
* ߼ڣ  liu_yfeng 2008-06-21
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "Common/GDString.h"
#include "Common/GDFile.h"
#include "GDLog/GDTrace.h"
#include "DBTree.h"
#include "PathNodeList.h"
#include <assert.h>


CDBTree::CDBTree( PDBPATHNODE pDBRoot ) : m_pDBRoot( pDBRoot )
{
}

CDBTree::~CDBTree()
{
}


// ӽ㼰ݣǽṹ壩޸
long CDBTree::SetData( const char* pathName, const char* waterMark )
{
	//trace log
	CGDTrace trace( LOG_L6, "CDBTree:SetData(%s)", pathName);

	if ( NULL == pathName || '\0' == *pathName || NULL == waterMark )
	{
		return trace.SetRetValue( 1 );	// ļ
	}

	CPathNodeList pathList( pathName );
	
	PDBPATHNODE pFather = m_pDBRoot; // ֱָָӵַ
	PDBPATHNODE pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ

	while( true )
	{
		const char* pNodeName = pathList.GetNextNodeName();

		if ( !pathList.IsEmpty() )	// Ŀ¼
		{
			if ( pChild != NULL )
			{
				CGDTrace::GDTrace(LOG_L9, "CDBTree::SetData GetRealAddress is Not NULL");

				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
				{
					pFather = pChild;
					pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
					continue;
				}
				else	// ͬĿ¼в
				{
					bool isAdd = true;
					while ( pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
						if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
						{
							pFather = pChild;
							pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
							isAdd = false;
							break;
						}
					}
					
					if ( !isAdd )
					{
						continue;
					}
					// 
					PDBPATHNODE pBro = (PDBPATHNODE) CDBMemory::GetSharedMemory()->New(); // ֱӵַ
					
					if ( NULL == pBro )
					{
						return trace.SetRetValue(2);	// ڴľ
					}
					memset( pBro, 0, sizeof(DBPATHNODE) );

					if ( strlen( pNodeName ) >= PATH_NAME_LEN )
					{
						strncpy( pBro->name, pNodeName, PATH_NAME_LEN - 1 );
						pBro->name[PATH_NAME_LEN - 1] = '\0';
					}
					else
					{
						strcpy( pBro->name, pNodeName );
					}
					pBro->createTime = time( NULL );

					pChild->bro = CDBMemory::GetSharedMemory()->GetOffset( pBro ); // 洢Եַ

					pFather = pBro; // ֱӵַ
					pChild = NULL;
					m_bUpdated = true;
				}
			}
			else
			{
				//CGDTrace::GDTrace(LOG_DBG, "CDBTree:SetData GetRealAddress is NULL");

				// 
				PDBPATHNODE pSon = (PDBPATHNODE) CDBMemory::GetSharedMemory()->New(); // ֱӵַ

				if ( NULL ==pSon )
				{
					return trace.SetRetValue(2);	// ڴľ
				}
				memset( pSon, 0, sizeof(DBPATHNODE) );

				if ( strlen( pNodeName ) >= PATH_NAME_LEN )
				{
					strncpy( pSon->name, pNodeName, PATH_NAME_LEN - 1 );
					pSon->name[PATH_NAME_LEN - 1] = '\0';
				}
				else
				{
					strcpy( pSon->name, pNodeName );
				}
				pSon->createTime = time( NULL );
				pFather->son = CDBMemory::GetSharedMemory()->GetOffset( pSon ); // 洢Եַ

				pFather = pSon; // ֱӵַ
				pChild = NULL;
				m_bUpdated = true;
			}
		}
		else	// һļ,waterMarkΪNULL˵ļ,Ϊ""˵ǿļ
		{
			if ( waterMark && *waterMark )	// ļ
			{
				PDBFILENODE pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->fileList ); // ֮ǰתֱӵַ
				while ( NULL != pflCur )
				{
					if ( 0 == CGDString::StringCompare( pflCur->name, pNodeName ) )	// ޸
					{
						strcpy( pflCur->waterMark, waterMark );
						// pflCur->lastModifyTime = time( NULL );		// ռʹ
						return trace.SetRetValue(0);
					}

					if ( NULL != pflCur->next )
					{
						pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
					}
					else
					{
						break;
					}
				}

				// 
				PDBFILENODE paddFile = (PDBFILENODE) CDBMemory::GetSharedMemory()->New(); // ֱӵַ

				if ( NULL == paddFile )
				{
					return trace.SetRetValue(2);	// ڴľ
				}
				memset( paddFile, 0, sizeof(DBFILENODE) );
				if ( strlen( pNodeName ) >= FILE_NAME_LEN )
				{
					strncpy( paddFile->name, pNodeName, FILE_NAME_LEN - 1 );
					paddFile->name[FILE_NAME_LEN - 1] = '\0';
				}
				else
				{
					strcpy( paddFile->name, pNodeName );
				}
				strcpy( paddFile->waterMark, waterMark );
				paddFile->lastModifyTime = time( NULL );
				if ( NULL != pflCur )
				{
					pflCur->next = CDBMemory::GetSharedMemory()->GetOffset( paddFile ); // 洢Եַ
				}
				else
				{
					pFather->fileList = CDBMemory::GetSharedMemory()->GetOffset( paddFile ); // 洢Եַ
				}
				m_bUpdated = true;
			}
			else	// Ŀ¼
			{
				pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
				while ( NULL != pChild )
				{
					if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )
					{
						return trace.SetRetValue(0);
					}

					if ( NULL != pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
					}
					else
					{
						break;
					}
				}

				// 
				PDBPATHNODE addPath = (PDBPATHNODE) CDBMemory::GetSharedMemory()->New(); // ֱӵַ
				if ( NULL == addPath )
				{
					return trace.SetRetValue(2);	// ڴľ
				}
				memset( addPath, 0, sizeof(DBPATHNODE) );
				if ( strlen( pNodeName ) >= PATH_NAME_LEN )
				{
					strncpy( addPath->name, pNodeName, PATH_NAME_LEN - 1 );
					addPath->name[PATH_NAME_LEN - 1] = '\0';
				}
				else
				{
					strcpy( addPath->name, pNodeName );
				}
				addPath->createTime = time( NULL );

				if ( NULL != pChild )
				{
					pChild->bro = CDBMemory::GetSharedMemory()->GetOffset( addPath ); // 洢Եַ
				}
				else
				{
					pFather->son = CDBMemory::GetSharedMemory()->GetOffset( addPath ); // 洢Եַ
				}
				m_bUpdated = true;
			}
			return trace.SetRetValue(0);
		}
	}
}

// ҽ㲢ݣ򷵻ʧ
long CDBTree::GetData( const char* pathName, char* waterMark )
{
	//trace log
	CGDTrace trace( LOG_L6, "CDBTree:GetData(%s,%s)", pathName, waterMark );

	if ( NULL == pathName || '\0' == *pathName || NULL == waterMark )
	{
		CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData Data Is NULL");

		return trace.SetRetValue( -1 );	// ļ
	}

	CPathNodeList pathList( pathName );
	
	PDBPATHNODE pFather = m_pDBRoot; // ֱָָӵַ
	PDBPATHNODE pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
	if( !pChild )
	{
		CGDTrace::GDTrace(LOG_DBG, "CDBTree:GetData CDBMemory:GetSharedMemory(%x,%d) Is NULL", pFather, pFather->son );

		return trace.SetRetValue( -2 ); // ڴΪ
	}

	while( !pathList.IsEmpty() )
	{
		const char* pNodeName = pathList.GetNextNodeName();
		if( !pNodeName )
		{
			CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData from [%s] GetNextNodeName NULL", pathName);
			break;
		}

		if ( !pathList.IsEmpty() )	// Ŀ¼
		{
			CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData [%s] Have NextNode; CurNode[%s]", 
					pathName, pNodeName);

			if ( pChild != NULL )
			{
			//	CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData Compare [%s][%s] In Child", pChild->name, pNodeName);

				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
				{

					pFather = pChild;
					pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
					continue;
				}
				else	// ͬĿ¼в
				{
					bool isFind = false;
					while ( pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
					//	CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData Compare [%s][%s] In Brother", pChild->name, pNodeName);

						if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
						{
							pFather = pChild;
							pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
							isFind = true;
							break;
						}
					}
					
					if ( isFind )
					{
						continue;
					}
				}
			}
			
			CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData [%s] Path Not Match when travel", pathName);

			sprintf( waterMark, "%d", pathList.GetCurrentPathLen() );

			return trace.SetRetValue( 50505 ); // ûҵĿ¼
			// ûҵĿ¼Ǳɾķ by wang_jin at 2009-02-28
			
		}
		else	// һļҲĿ¼
		{
			CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData [%s] Have Not NextNode; CurNode[%s]", 
					pathName, pNodeName);

			// ļ
			PDBFILENODE pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->fileList ); // ֮ǰתֱӵַ
			while ( NULL != pflCur )
			{
				if ( 0 == CGDString::StringCompare( pflCur->name, pNodeName ) )	// ޸
				{
					strcpy( waterMark, pflCur->waterMark );
					return trace.SetRetValue( 0 ); // ļɹ
				}

				pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
			}

			// ļҲĿ¼
			pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
			while ( NULL != pChild )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )
				{
					strcpy( waterMark, "" );
					return trace.SetRetValue( 0 ); // Ŀ¼ɹ
				}

				pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
			}

			CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData [%s] Path Not Match at last", pathName);

			return trace.SetRetValue( 40404 ); // 40404 ʾûˮӡ
		}
	}

	CGDTrace::GDTrace(LOG_DBG, "CDBTree::GetData [%s] Path Is NULL", pathName);

	return trace.SetRetValue( -4 ); // δ
}


// ɾ㼰(пɾļҲĿ¼)
bool CDBTree::RemoveData( const char* pathName )
{
	CGDTrace trace( LOG_L6, "CDBTree:RemoveData(%s)", pathName );

	if ( NULL == pathName || '\0' == *pathName )
	{
		return trace.SetRetResult( false );	// ļ
	}

	CPathNodeList pathList( pathName );
	
	PDBPATHNODE pFather = m_pDBRoot; // ֱָָӵַ
	// һд쳣ɾʱm_pDBRootЧָԱ by wang_jin at 2008-10-06
	PDBPATHNODE pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
	if( !pChild )
	{
		CGDTrace::GDTrace(LOG_DBG, "CDBTree:RemoveData CDBMemory:GetSharedMemory Is NULL");
	}

	while( true )
	{
		const char* pNodeName = pathList.GetNextNodeName();

		if ( !pathList.IsEmpty() )	// Ŀ¼
		{
			if ( pChild != NULL )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
				{
					pFather = pChild;
					pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
					continue;
				}
				else	// ͬĿ¼в
				{
					bool isFind = false;
					while ( pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
						if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
						{
							pFather = pChild;
							pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
							isFind = true;
							break;
						}
					}
					
					if ( isFind )
					{
						continue;
					}
				}
			}
			
			return trace.SetRetResult( true );
		}
		else	// һļҲĿ¼
		{
			// ļ
			PDBFILENODE pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->fileList ); // ֮ǰתֱӵַ
			PDBFILENODE pflCurPre = NULL;
			while ( NULL != pflCur )
			{
				if ( 0 == CGDString::StringCompare( pflCur->name, pNodeName ) )	// ޸
				{
					PDBFILENODE pflNext = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
//					delete pflCur;
					CDBMemory::GetSharedMemory()->Delete( pflCur ); // ֱӵַ
					pflCur = NULL;
					if ( NULL == pflCurPre )
					{
						pFather->fileList = CDBMemory::GetSharedMemory()->GetOffset( pflNext ); // 洢Եַ
					}
					else
					{
						pflCurPre->next = CDBMemory::GetSharedMemory()->GetOffset( pflNext ); // 洢Եַ
					}
					m_bUpdated = true;
					return trace.SetRetResult( true );
				}

				pflCurPre = pflCur;
				pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
			}

			// ļҲĿ¼
			pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
			PDBPATHNODE pCurDir = NULL;
			while ( NULL != pChild )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )
				{
					if ( NULL == pCurDir )
					{
						pFather->son = pChild->bro;
						ReleaseTree( (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->son ) ); // ֮ǰתֱӵַ
						pChild->son = NULL; //?û
//						delete pChild;
						CDBMemory::GetSharedMemory()->Delete( pChild );
						pChild = NULL;
						m_bUpdated = true;
						return trace.SetRetResult( true );
					}
					else
					{
						pCurDir->bro = pChild->bro;
						ReleaseTree( (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->son ) ); // ֮ǰתֱӵַ
						pChild->son = NULL;
//						delete pChild;
						CDBMemory::GetSharedMemory()->Delete( pChild );
						pChild = NULL;
						m_bUpdated = true;
						return trace.SetRetResult( true );
					}
				}

				pCurDir = pChild;
				pChild =  (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
			}

			return trace.SetRetResult( true );
		}
	}
}


// (пļҲĿ¼)
bool CDBTree::RenameNode( const char* pathName, const char* newName )
{
	CGDTrace trace( LOG_L6, "CDBTree:RenameNode(%s,%s)", pathName, newName );

	if ( NULL == pathName || '\0' == *pathName )
	{
		return trace.SetRetResult(false );	// ļ
	}

	CPathNodeList pathList( pathName );
	
	PDBPATHNODE pFather = m_pDBRoot; // ֱָָӵַ
	PDBPATHNODE pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
	while( true )
	{
		const char* pNodeName = pathList.GetNextNodeName();

		if ( !pathList.IsEmpty() )	// Ŀ¼
		{
			if ( pChild != NULL )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
				{
					pFather = pChild;
					pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
					continue;
				}
				else	// ͬĿ¼в
				{
					bool isFind = false;
					while ( pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
						if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
						{
							pFather = pChild;
							pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
							isFind = true;
							break;
						}
					}
					
					if ( isFind )
					{
						continue;
					}
				}
			}
			
			return trace.SetRetResult( false );
		}
		else	// һļҲĿ¼
		{
			// ļ
			PDBFILENODE pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->fileList ); // ֮ǰתֱӵַ
			while ( NULL != pflCur )
			{
				if ( 0 == CGDString::StringCompare( pflCur->name, pNodeName ) )	// ޸
				{
					memset( pflCur->name, 0, sizeof(pflCur->name) );
					if ( strlen( pNodeName ) >= FILE_NAME_LEN )
					{
						strncpy( pflCur->name, pNodeName, FILE_NAME_LEN - 1 );
						pflCur->name[FILE_NAME_LEN - 1] = '\0';
					}
					else
					{
						strcpy( pflCur->name, newName );
					}
					pflCur->lastModifyTime = time( NULL );
					m_bUpdated = true;
					return trace.SetRetResult( true );
				}

				pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
			}

			// ļҲĿ¼
			pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
			while ( NULL != pChild )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )
				{
					memset( pChild->name, 0, sizeof(pChild->name) );
					if ( strlen( pNodeName ) >= PATH_NAME_LEN )
					{
						strncpy( pChild->name, pNodeName, PATH_NAME_LEN - 1 );
						pChild->name[PATH_NAME_LEN - 1] = '\0';
					}
					else
					{
						strcpy( pChild->name, newName );
					}
					pChild->createTime = time( NULL );
					m_bUpdated = true;
					return trace.SetRetResult( true );
				}

				pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
			}

			return trace.SetRetResult( false );
		}
	}
}


// ͷ
void CDBTree::ReleaseTree( PDBPATHNODE pNode )
{
	//trace log
	CGDTrace trace( LOG_L6, "CDBTree:ReleaseTree()" );

	if ( NULL == pNode ) return;

	PDBPATHNODE pCur = pNode;
	CSharedMemory* shm = CDBMemory::GetSharedMemory();

	while ( NULL != pCur )
	{
		// ļ
		PDBFILENODE pflCur = (PDBFILENODE) ( shm->GetRealAddress( pCur->fileList ) ); // ֮ǰתֱӵַ
		while ( NULL != pflCur )
		{
			PDBFILENODE pflCurNext = (PDBFILENODE) shm->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
//			delete pflCur;
			CDBMemory::GetSharedMemory()->Delete( pflCur );
			pflCur = pflCurNext;
		}
		pCur->fileList = NULL;

		// ɾĿ¼c
		if ( NULL != pCur->son )
		{
			ReleaseTree( (PDBPATHNODE) shm->GetRealAddress( pCur->son ) );
			pCur->son = NULL;
		}

		// ɾͬĿ¼
		PDBPATHNODE pCurNext = (PDBPATHNODE) shm->GetRealAddress( pCur->bro ); // ֮ǰתֱӵַ
//		delete pCur;
		CDBMemory::GetSharedMemory()->Delete( pCur );
		pCur = pCurNext;
	}
	//(*pNode) = NULL;
}

// չʾݷ
void CDBTree::ShowData(PDBPATHNODE pPath, SHOWDBFUNC showDBFunc, const string& rootPath)
{
	CGDTrace trace( LOG_L6, "CDBTree:ShowData(%s)", rootPath.c_str());
	if ( ! pPath )
	{
		return;
	}

	string path;

	if (rootPath.empty())
		path = pPath->name;
	else
		path = rootPath + "\\" + pPath->name;

	(*showDBFunc)(path.c_str(), "");
/*
	// ļ
	PDBFILENODE pCurFile = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pPath->fileList ); // ֮ǰתֱӵַ
	while ( NULL != pCurFile )
	{
		string realPath = path + "\\" + pCurFile->name;
		(*showDBFunc)(realPath.c_str(), pCurFile->waterMark);
		
		pCurFile = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pCurFile->next ); // ֮ǰתֱӵַ
	}
*/
	if (pPath->son)
	{
		ShowData(
			(PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pPath->son ), 
			showDBFunc, path);
	}

	if (pPath->bro)
	{
		ShowData(
			(PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pPath->bro ), 
			showDBFunc, rootPath);
	}
}


// ָĿ¼㣬ʾһ
bool CDBTree::ShowDirData( const char* pathName, SHOWDBFUNC showDBFunc )
{
	CGDTrace trace( LOG_L6, "CDBTree:ShowDirData(%s)", pathName);

	if ( NULL == pathName || '\0' == *pathName )
	{
		return trace.SetRetResult( false );	// ļ
	}

	CPathNodeList pathList( pathName );
	
	PDBPATHNODE pFather = m_pDBRoot; // ֱָָӵַ
	PDBPATHNODE pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ

	if ( 0 == strcmp( pathName, "ROOT" ) )	//ȡһĿ¼
	{
		// ȡĿ¼
		PDBPATHNODE pChildDir = pChild;
		while ( NULL != pChildDir )
		{
			(*showDBFunc)(pChildDir->name, "");
			pChildDir = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChildDir->bro ); // ֮ǰתֱӵַ
		}
		return trace.SetRetResult( true );
	}

	while( !pathList.IsEmpty() )
	{
		const char* pNodeName = pathList.GetNextNodeName();
		if( !pNodeName )
		{
			break;
		}

		if ( !pathList.IsEmpty() )	// Ŀ¼
		{
			if ( pChild != NULL )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
				{
					pFather = pChild;
					pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
					continue;
				}
				else	// ͬĿ¼в
				{
					bool isFind = false;
					while ( pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
						if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
						{
							pFather = pChild;
							pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
							isFind = true;
							break;
						}
					}
					
					if ( isFind )
					{
						continue;
					}
				}
			}
			
			return trace.SetRetResult( false );
		}
		else	// һĿ¼
		{
			pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
			while ( NULL != pChild )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )
				{
					// ȡĿ¼
					PDBPATHNODE pChildDir = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->son ); // ֮ǰתֱӵַ
					while ( NULL != pChildDir )
					{
						(*showDBFunc)(pChildDir->name, "");
						pChildDir = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChildDir->bro ); // ֮ǰתֱӵַ
					}

					// ȡļ
					PDBFILENODE pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->fileList ); // ֮ǰתֱӵַ
					while ( NULL != pflCur )
					{
						(*showDBFunc)(pflCur->name, pflCur->waterMark);
						pflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pflCur->next ); // ֮ǰתֱӵַ
					}

					return trace.SetRetResult( true );
				}

				pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
			}

			return trace.SetRetResult( false );
		}
	}

	return trace.SetRetResult( false );
}


// ˮӡĿ¼
const void* CDBTree::GetDirTree( const char* pathName )
{
	if ( NULL == pathName || '\0' == *pathName )
	{
		return NULL;	// ļ
	}

	CPathNodeList pathList( pathName );
	
	PDBPATHNODE pFather = m_pDBRoot; // ֱָָӵַ
	PDBPATHNODE pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ

	while( true )
	{
		const char* pNodeName = pathList.GetNextNodeName();

		if ( !pathList.IsEmpty() )	// Ŀ¼
		{
			if ( pChild != NULL )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
				{
					pFather = pChild;
					pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
					continue;
				}
				else	// ͬĿ¼в
				{
					bool isFind = false;
					while ( pChild->bro )
					{
						pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
						if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )	// ǰĿ¼ǸĿ¼
						{
							pFather = pChild;
							pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
							isFind = true;
							break;
						}
					}
					
					if ( isFind )
					{
						continue;
					}
				}
			}
			
			return NULL;
		}
		else	// һļҲĿ¼
		{
			// ֻĿ¼
			pChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pFather->son ); // ֮ǰתֱӵַ
			PDBPATHNODE pCurDir = NULL;
			while ( NULL != pChild )
			{
				if ( 0 == CGDString::StringCompare( pChild->name, pNodeName ) )
				{
					// 
					PPATHNODE temp = ( PPATHNODE ) CreateDirTree( pChild );
					if ( temp )
					{
						delete [] temp->szName;
						temp->szName=new char[strlen(pathName)+1];
						strcpy(temp->szName,pathName);
					}
					return temp;
				}

				pCurDir = pChild;
				pChild =  (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pChild->bro ); // ֮ǰתֱӵַ
			}

			return NULL;
		}
	}

	return NULL;
}


void CDBTree::CopyFileList( PDBFILENODE pSrcflCur, PPATHNODE pDstNode )
{
	while ( NULL != pSrcflCur )
	{
		// ļ
		PFILENODE pDstFile=new FILENODE;
		pDstFile->szName=new char[strlen(pSrcflCur->name)+1];
		strcpy(pDstFile->szName,pSrcflCur->name);
		pDstFile->size_Size = 0;
		pDstFile->time_LastWriteTime = pSrcflCur->lastModifyTime;
		
		if(!pDstNode->list)
		{
			pDstFile->link=NULL;
			pDstNode->list=pDstFile;
		}
		else
		{
			PFILENODE pDstList=pDstNode->list;
			PFILENODE pDstLink=pDstList->link;
			if(strcmp(pDstFile->szName,pDstList->szName)>0)
			{
				pDstFile->link=pDstNode->list;
				pDstNode->list=pDstFile;
			}
			else
			{
				while(pDstLink)
				{
					if(strcmp(pDstFile->szName,pDstLink->szName)>0)
						break;
					pDstList=pDstLink;
					pDstLink=pDstList->link;
				}
				pDstFile->link=pDstList->link;
				pDstList->link=pDstFile;
			}
		}
		pSrcflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcflCur->next ); // ֮ǰתֱӵַ
	}
}


const void* CDBTree::CreateDirTree( const PDBPATHNODE pSrcNode )
{
	CGDTrace trace( LOG_L6, "CDBTree:CreateDirTree()" );
	if ( NULL == pSrcNode )
	{
		return NULL;
	}

	// 
	PPATHNODE pDstNode = new PATHNODE;
	memset(pDstNode,0,sizeof(PATHNODE));
	int nLen = strlen( pSrcNode->name );
	pDstNode->szName=new char[nLen+1];
	memcpy( pDstNode->szName, pSrcNode->name, nLen );
	pDstNode->szName[nLen]=0;
	pDstNode->time_createTime = pSrcNode->createTime;

	// ȱĿ¼µļ
	PDBFILENODE pSrcflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcNode->fileList ); // ֮ǰתֱӵַ
	CopyFileList( pSrcflCur, pDstNode );

	// ݹ鴦Ŀ¼
	PDBPATHNODE pSrcChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcNode->son ); // ֮ǰתֱӵַ
	if ( NULL != pSrcChild )
	{
		pDstNode->son = (PPATHNODE) CreateDirTree( pSrcChild );
	}
	
	// ѭͬĿ¼
	PDBPATHNODE pSrcBro = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcNode->bro ); // ֮ǰתֱӵַ
	while ( NULL != pSrcBro )
	{
		PPATHNODE pDstBro = new PATHNODE;
		memset(pDstBro,0,sizeof(PATHNODE));
		int nBroLen = strlen( pSrcBro->name );
		pDstBro->szName=new char[nBroLen+1];
		memcpy( pDstBro->szName, pSrcBro->name, nBroLen );
		pDstBro->szName[nBroLen]=0;
		pDstBro->time_createTime = pSrcBro->createTime;

		PDBFILENODE pSrcBroflCur = (PDBFILENODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcBro->fileList ); // ֮ǰתֱӵַ
		CopyFileList( pSrcBroflCur, pDstBro );

		pSrcChild = (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcBro->son ); // ֮ǰתֱӵַ
		if ( NULL != pSrcChild )
		{
			pDstBro->son = (PPATHNODE) CreateDirTree( pSrcChild );
		}

		// 
		PPATHNODE pPreNode = NULL;
		PPATHNODE pTmpNode = pDstNode;
		while ( pTmpNode )
		{
			if ( strcmp( pTmpNode->szName, pDstBro->szName ) < 0 )
			{
				break;
			}
			pPreNode = pTmpNode;
			pTmpNode = pTmpNode->bro;
		}
		if ( pPreNode )
		{
			// ǰλò
			pDstBro->bro = pPreNode->bro;
			pPreNode->bro = pDstBro;
		}
		else
		{
			pDstBro->bro = pDstNode;
			pDstNode = pDstBro;
		}

		pSrcBro =  (PDBPATHNODE) CDBMemory::GetSharedMemory()->GetRealAddress( pSrcBro->bro ); // ֮ǰתֱӵַ
	}
	
	return pDstNode;
}


// ͷṹ
void* CDBTree::FreeDirTree( void* tree )
{
	if ( !tree ) return NULL;
	
	PPATHNODE pTree = ( PPATHNODE ) tree;
	// ͷļ
	if ( pTree->list )
	{
		PFILENODE list = pTree->list;
		do
		{
			pTree->list = list->link;
			delete []list->szName;
			list->szName = NULL;
			delete list;
			list = NULL;
		} while ( ( list = pTree->list ) );
	}
	
	// ӽݹͷűѭͷ
	PPATHNODE son = pTree->son;
	while ( son )
	{
		PPATHNODE tmp = son->son;
		son->son = NULL; // ֹٴεݹ
		FreeDirTree( son );
		son = tmp;
	}
	
	// ֵܽݹͷűѭͷ by wang_jin at 2008-12-13 for ƶAIXɨ1500ͬĿ¼
	PPATHNODE bro = pTree->bro;
	while ( bro )
	{
		PPATHNODE tmp = bro->bro;
		bro->bro = NULL; // ֹٴεݹ
		FreeDirTree( bro );
		bro = tmp;
	}
	
	// ͷԼ
	if ( pTree->szName )
	{
		delete[] pTree->szName;
		pTree->szName = NULL;
	}
	delete pTree;
	pTree = NULL;
	
	return NULL;
}


bool CDBTree::IsUpdated()
{
	return m_bUpdated;
}

void CDBTree::SetUpdatedFalse()
{
	m_bUpdated = false;
}

