//
// Directory_UNIX.cpp
//


#include "Groundwork/Directory_UNIX.h"
#include <string.h>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <assert.h>


namespace InforGuard {
namespace Groundwork {


DirectoryImpl::DirectoryImpl( const string& path ): _path( path )
{
}


DirectoryImpl::~DirectoryImpl()
{
}


bool DirectoryImpl::isExistImpl()
{
	// ֯Ŀ¼
	char szNodePath[PATH_MAX] = {0};
	sprintf( szNodePath, "%s%c", _path.c_str(), C_PATHLASH );
	
	// Ŀ¼
	DIR * dp = NULL;
	struct dirent * dirp = NULL;
	dp = opendir( szNodePath );
	if( dp == NULL )
	{
		return false;
	}
	dirp = readdir(dp);
	if( dirp == NULL )
	{
		return false;
	}
	return true;
}


PPATHNODE DirectoryImpl::getTreeImpl( PPATHNODE node )
{
	char szTempPath[PATH_MAX] = {0};

	if(_path.empty()) return NULL;

	strcpy( szTempPath, _path.c_str() );
	if(szTempPath[strlen(szTempPath)-1]==C_PATHLASH)
	{
		szTempPath[strlen(szTempPath)-1]=0;
	}
	node = createTree( "", szTempPath, NULL );
	return node;
}


PPATHNODE DirectoryImpl::createTree( char* szRoot, char* szPath, PPATHNODE dad )
{
	// ֯Ŀ¼
	char szNodePath[PATH_MAX] = {0};
	if(NULL==dad)
		sprintf(szNodePath,"%s%c",szPath,C_PATHLASH);
	else
		sprintf(szNodePath,"%s%c%s%c",szRoot,C_PATHLASH,szPath,C_PATHLASH);

	// Ŀ¼
	DIR * dp = NULL;
	struct dirent * dirp = NULL;
	dp = opendir(szNodePath);
	if( dp == NULL ) return NULL;
	dirp = readdir(dp);
	if( dirp == NULL ) return NULL;
	szNodePath[strlen(szNodePath)-1]=0;

	// 
	PPATHNODE root=new PATHNODE;
	memset(root,0,sizeof(PATHNODE));
	int nLen=strlen(szPath);
	root->szName=new char[nLen+1];
	memcpy(root->szName,szPath,nLen);
	root->szName[nLen]=0;
	
	// ӽ
	char cFileName[128]={0};
	int nStep=0;
	do
	{
		//ЧĿ¼ͽݹ
		struct stat statbuf;
		memset(&statbuf, 0, sizeof(statbuf));
		char strCur[PATH_MAX] = {0};
		sprintf(strCur, "%s/%s", szNodePath, dirp->d_name);

		if( lstat(strCur, &statbuf) )
		{
			break;
		}
		
		if ( S_ISDIR(statbuf.st_mode) )
		{
			strcpy(cFileName,dirp->d_name);

			if( strcmp(cFileName,".") && strcmp(cFileName,"..") )
			{
				//gd3_cmptree_scan_set_path(cFileName);
				//gd3_cmptree_scan_set_totalnum(false);
				PPATHNODE node=NULL;
				switch(nStep)
				{
				case 0:
					// һӽ
					nStep++;
					node=createTree(szNodePath,cFileName,root);
					root->son=node;
					break;
				case 1:
					// ڶӽ
					nStep++;
					node=createTree(szNodePath,cFileName,root);
					if(strcmp(node->szName,root->son->szName)>0)
					{	// ǰ
						node->bro=root->son;
						root->son=node;
					}
					else
					{
						root->son->bro=node;
					}
					break;
				default:
					// ӽ
					node=createTree(szNodePath,cFileName,root);
					if(node)
					{
						if(strcmp(node->szName,root->son->szName)>0)
						{
							node->bro=root->son;
							root->son=node;
						}
						else if(strcmp(node->szName,root->son->bro->szName)>0)
						{
							node->bro=root->son->bro;
							root->son->bro=node;
						}
						else
						{
							PPATHNODE prev=root->son;
							PPATHNODE next=prev->bro;
							while(next->bro)
							{
								if(strcmp(node->szName,next->bro->szName)>0)
									break;
								prev=next;
								next=prev->bro;
							}
							node->bro=next->bro;
							next->bro=node;
						}
					}//if
				}//switch
			}//ifĿ¼Ч
		}//ifĿ¼
		else
		{
			strcpy(cFileName,dirp->d_name);
			//gd3_cmptree_scan_set_path(cFileName);
			//gd3_cmptree_scan_set_totalnum(true);
			// ļ
			PFILENODE file=new FILENODE;
			file->szName=new char[strlen(cFileName)+1];
			strcpy(file->szName,cFileName);
			file->size_Size = statbuf.st_size;
			file->time_LastWriteTime = statbuf.st_mtime;

			// 

			if(!root->list)
			{
				file->link=NULL;
				root->list=file;
			}
			else
			{
				PFILENODE list=root->list;
				PFILENODE link=list->link;
				if(strcmp(file->szName,list->szName)>0)
				{
					file->link=root->list;
					root->list=file;
				}
				else
				{
					while(link)
					{
						if(strcmp(file->szName,link->szName)>0)
							break;
						list=link;
						link=list->link;
					}
					file->link=list->link;
					list->link=file;
				}
			}
		}

	} while( (dirp=readdir(dp)) );
	closedir(dp);

	return root;
}


} // namespace Groundwork
}	// namespace InforGuard
