//
// Directory_WIN32.cpp
//


#include "Groundwork/Directory_WIN32.h"
#include "Groundwork/Groundwork.h"
#include <windows.h>
#include <assert.h>


namespace InforGuard {
namespace Groundwork {


DirectoryImpl::DirectoryImpl( const string& path ) : _path ( path )
{
}


DirectoryImpl::~DirectoryImpl()
{
}


bool DirectoryImpl::isExistImpl()
{
	char szNodePath[MAX_PATH] = {0};
	sprintf( szNodePath, "%s%c", _path.c_str(), C_PATHLASH );
	strcat( szNodePath, "*" );
	WIN32_FIND_DATA fd={0};
	HANDLE hFind=FindFirstFile(szNodePath,&fd);
	if((HANDLE)-1==hFind)
	{
		return false;
	}
	else
	{
		return true;
	}
}


PPATHNODE DirectoryImpl::getTreeImpl( PPATHNODE node )
{
	char szTempPath[MAX_PATH] = {0};

	if(_path.empty()) NULL;

	strcpy( szTempPath, _path.c_str() );
	if(szTempPath[strlen(szTempPath)-1]== C_PATHLASH )
	{
		szTempPath[strlen(szTempPath)-1]=0;
	}
	node = createTree( "", szTempPath, NULL );
	return node;
}


PPATHNODE DirectoryImpl::createTree( char* szRoot, char* szPath, PPATHNODE dad )
{
	// ֯Ŀ¼
	char szNodePath[MAX_PATH] = {0};
	if(NULL==dad)
		sprintf(szNodePath,"%s%c",szPath, C_PATHLASH );
	else
		sprintf(szNodePath,"%s%c%s%c",szRoot, C_PATHLASH,szPath, C_PATHLASH );
	strcat(szNodePath,"*");


	// Ŀ¼
	WIN32_FIND_DATA fd={0};
	HANDLE hFind=FindFirstFile(szNodePath,&fd);
	if((HANDLE)-1==hFind) return NULL;
	szNodePath[strlen(szNodePath)-2]=0;

	// 
	PPATHNODE root=new PATHNODE;
	memset(root,0,sizeof(PATHNODE));
	int nLen=strlen(szPath);
	root->szName=new char[nLen+1];
	memcpy(root->szName,szPath,nLen);
	root->szName[nLen]=0;
	
	// ӽ
	char cFileName[128]={0};
	int nStep=0;
	do
	{
		//ЧĿ¼ͽݹ
		if( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
		{
			strcpy(cFileName,fd.cFileName);

			if( strcmp(cFileName,".") && strcmp(cFileName,"..") )
			{
				PPATHNODE node=NULL;
				switch(nStep)
				{
				case 0:
					// һӽ
					nStep++;
					node=createTree(szNodePath,cFileName,root);
					root->son=node;
					break;
				case 1:
					// ڶӽ
					nStep++;
					node=createTree(szNodePath,cFileName,root);
					if(strcmp(node->szName,root->son->szName)>0)
					{	// ǰ
						node->bro=root->son;
						root->son=node;
					}
					else
					{
						root->son->bro=node;
					}
					break;
				default:
					// ӽ
					node=createTree(szNodePath,cFileName,root);
					if(node)
					{
						if(strcmp(node->szName,root->son->szName)>0)
						{
							node->bro=root->son;
							root->son=node;
						}
						else if(strcmp(node->szName,root->son->bro->szName)>0)
						{
							node->bro=root->son->bro;
							root->son->bro=node;
						}
						else
						{
							PPATHNODE prev=root->son;
							PPATHNODE next=prev->bro;
							while(next->bro)
							{
								if(strcmp(node->szName,next->bro->szName)>0)
									break;
								prev=next;
								next=prev->bro;
							}
							node->bro=next->bro;
							next->bro=node;
						}
					}//if
				}//switch
			}//ifĿ¼Ч
		}//ifĿ¼
		else
		{
			strcpy(cFileName,fd.cFileName);

			// ļ
			PFILENODE file=new FILENODE;
			file->szName=new char[strlen(cFileName)+1];
			strcpy(file->szName,cFileName);
			file->size_Size = fd.nFileSizeHigh << 32;
			file->size_Size += fd.nFileSizeLow;
			ULONGLONG ll = *((ULONGLONG*)&fd.ftLastWriteTime);
			file->time_LastWriteTime = (time_t)( ( ll - 0x19DB1DED53E8000 ) / 10000000 );
		
			// 

			if(!root->list)
			{
				file->link=NULL;
				root->list=file;
			}
			else
			{
				PFILENODE list=root->list;
				PFILENODE link=list->link;
				if(strcmp(file->szName,list->szName)>0)
				{
					file->link=root->list;
					root->list=file;
				}
				else
				{
					while(link)
					{
						if(strcmp(file->szName,link->szName)>0)
							break;
						list=link;
						link=list->link;
					}
					file->link=list->link;
					list->link=file;
				}
			}
		}
	} while( FindNextFile(hFind,&fd) );
	FindClose(hFind);

	return root;
}


} // namespace Groundwork
}	// namespace InforGuard
