/******************************
 Ӧĺͻ˵
 ******************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include "es_gvdef.h"
#include "es_fdecl.h"
#include "uap_api.h"
#include "gcps.h"
#include "z.h"

static ESINFO   g_sEs[N_ELIST];     // ӦϢб
static ESINFO   g_sEsRep[N_ELIST];  // ӦӦϢб
static char     g_szError[2048];    // Ϣ

// ׼޸
int DB_prepare_update(int *nCode);

// ѯӦ״̬
int DB_qry_esstat(const ESINFO *pEs, ESINFO *pEsOut, int nVol, int *nCode);

// 첽޸Ӧ״̬
int DB_update_esstat(const char *pSeq, int iResult, int *nCode);

/***************************************
 ֪ͨĴ
 ڲESINFO *     --  ֪ͨϢ
           int          --  ϢṹĿ
           char *       --  Ϣ
 ֵ  -1ʧ   0첽  1ɹ
 ***************************************/
int EsNotifyDone(const ESINFO *pEs, int N, char *pNote)
{
    int  r;
    char szBuf[64];

    sprintf(szBuf, "%d,%d,%d", pEs->iCrmState, pEs->iBossState, pEs->iResState);
    r = CUapApi::setUrge(pEs->iRegion, pEs->cChannel, szBuf, pEs->cStateTime);

    switch( r )
    {
    case -1:
        strcpy(pNote, "ipc failed");
        break;
    case 0:
        strcpy(pNote, "no record in memory");
        r = -1;
        break;
    case 1:
        strcpy(pNote, "ok");
        break;
    }

    return r;
}

// ̳ʼ
int GC_appinit(const char *slot)
{
    int b;
    void u_set_outsys(int nOut);

    // ȡļ
    EsReadCfg(g_cfgfile, &g_sCfg);

    u_set_outsys(0);
    CUapApi::setIPCKey(g_sCfg.kUapKey);

    if( g_sCfg.szTns[0] == 0 )
    {
        z_logv(g_logfile, "no definition %s", SG_DBINFO);
        return(-1);
    }

    // ¼ݿ
    if( DB_conndb(g_sCfg.szTns, g_sCfg.nEncry, &b) < 0 )
    {
        z_logv(g_logfile, "connect to oracle failed %d", b);
        return(-1);
    }

    // ׼޸
    if( DB_prepare_update(&b) < 0 )
    {
        z_logv(g_logfile, "prepare update failed %d", b);
        return(-1);
    }

    return(0);
}

// 
int GC_dispense(const char *slot)
{
    int  i, N, b;

    int  u_query(int),              // ѯ
         u_feedback(int),           // ״̬֪ͨ첽Ӧ
         u_notify(int);             // ״̬֪ͨ

    static struct code_func         // ṹ
    {
        const char  *code;          // ״
        int        (*func)(int);    // 
    } funcs[] =
    {
        {TC_FEEDBACK,   u_feedback},
        {TC_QUERY,      u_query},
        {TC_NOTIFY,     u_notify}
    };

    b = 0;
    N = sizeof(funcs) / sizeof(struct code_func);

    z_logv(g_logfile, "%s", g_reqinfo);

    g_szError[0] = 0;
    b = ParseEsXml(g_reqinfo, g_sEs, N_ELIST, g_szError);
    z_logv(g_logfile, "b=%d, szTCode=%s, szError=%s", b, g_sEs[0].cOpCode, g_szError);

    // ҵ룬ӦĴ
    if( b > 0 )
    {
        for( i = 0; i < N; i++ )
        {
            if( strcmp(g_sEs[0].cOpCode, funcs[i].code) == 0 )
            {
                b = (int) (funcs[i].func)(b);
                break;
            }
        }
    }

    return(b);
}

// ״̬֪ͨ
int u_notify(int N)
{
    int  i, b;

    char szSeq[33],
         szNote[256],
         szXmlReq[1024];

    z_logv(g_logfile, "region=%d, channel=%s, crm=%d, boss=%d, res=%d",
        g_sEs[0].iRegion, g_sEs[0].cChannel,
        g_sEs[0].iCrmState, g_sEs[0].iBossState, g_sEs[0].iResState);

    // ֪ͨĲ
    b = EsNotifyDone(g_sEs, N, szNote);

    // ׼Ӧ
    for( i = 0; i < N; i++ )
    {
        // ˮ
        strcpy(szSeq, g_sEs[i].cSeqNumber);

        // ʼ
        InitEs(g_sEs);
        strcpy(g_sEs[i].cOpCode, TC_NOTIFY_RESP);
        g_sEs[i].iEslists = 1;

        // ˮ
        strcpy(g_sEs[i].cSeqNumber, szSeq);

        strcpy(g_sEs[i].cNote, szNote);
        z_get_dt(g_sEs[i].cDoneTime, 14, "f", 0);

        // ͬ־Ӧ
        g_sEs[i].iSyncFlag = 1;
        g_sEs[i].iResult = 0;

        if( b == 0 )        // 첽
        {
            g_sEs[i].iSyncFlag = 0;
        }
        else if( b != 1 )   // ʧ
        {
            g_sEs[i].iResult = 1;
        }
    }

    // 챨
    g_szError[0] = 0;
    b = MakeEsXml(g_sEs, N, szXmlReq, g_szError);
    z_logv(g_logfile, "MakeESXml b=%d, [%s], [%s]", b, szXmlReq, g_szError);

    // ͱ
    GC_http_resp(szXmlReq);

    return(0);
}

// ״̬ѯ
int u_query(int N)
{
    int   i, b,
          nRows,
          nUse,             // ʹÿռ
          nLeft;            // ʣռ

    char *pXmlReq;

    // ʼ
    for( i = 0; i < N_ELIST; i++ )
    {
        InitEs(g_sEsRep + i);
        g_sEsRep[i].iEslists = 1;
        g_sEsRep[i].iChannel = 1;

        strcpy(g_sEsRep[i].cOpCode, TC_QUERY_RESP);
    }

    // 
    for( i = 0, nUse = 0, nLeft = N_ELIST; i < N && nLeft > 0; i++ )
    {
        b = 0;
        if( (nRows = DB_qry_esstat(g_sEs + i, g_sEsRep + nUse, nLeft, &b)) < 0 )
        {
            z_logv(g_logfile, "query failed %d", b);
            return(-1);
        }

        nUse  += nRows;
        nLeft -= nRows;
    }

    // ڴ
    pXmlReq = (char *) malloc(1024 * nUse);

    if( pXmlReq == NULL )
    {
        z_logv(g_logfile, "malloc failed");
        return(-1);
    }

    memset(pXmlReq, 0, 1024 * nUse);

    // 챨
    g_szError[0] = 0;
    b = MakeEsXml(g_sEsRep, nUse, pXmlReq, g_szError);
    z_logv(g_logfile, "MakeESXml b=%d, [%s], [%s]", b, pXmlReq, g_szError);

    // ͱ
    GC_http_resp(pXmlReq);

    free(pXmlReq);
    return(0);
}

// 첽
int u_feedback(int N)
{
    int  i, b;
    char szXmlReq[2048];

    // Ӧ״̬
    for( i = 0; i < N; i++ )
    {
        b = 0;
        if( DB_update_esstat(g_sEs[i].cSeqNumber, g_sEs[i].iResult, &b) < 0 )
        {
            z_logv(g_logfile, "update esstat failed %d", b);
            return(-1);
        }
    }

    // ʼ
    InitEs(g_sEs);

    strcpy(g_sEs[0].cOpCode, TC_FEEDBACK_RESP);
    g_sEs[0].iAck = 0;

    // 챨
    g_szError[0] = 0;
    b = MakeEsXml(g_sEs, 1, szXmlReq, g_szError);
    z_logv(g_logfile, "MakeESXml b=%d, [%s], [%s]", b, szXmlReq, g_szError);

    // ͱ
    GC_http_resp(szXmlReq);

    return(0);
}

