/***********************************************************************
*
* ļ				FileDriver.h
* ģĿģ		ļӿʵ
* ߼ڣ		liu_yfeng 2008-06-19
* 汾				1.0
* ȨϢ			CVICSE Middleware
* ļ¼  
*
***********************************************************************/


#include "Driver.h"
#include "Service.h"
#include "SystemInfor.h"

#include "Common/ConvertString.h"
#include "Common/ParamList.h"
#include "Driver/Ioctlcmd.h"
#include "FileDriver/FileDriver.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"

#include <winioctl.h>


const char * GDFileDriverName = "GuardFileDriver";


CFileDriver::CFileDriver( const char * sDriverFileName ):
	CMonitorInterface("FileDriver", DRIVER)
{
	
	CGDTrace trace( LOG_L6, "CFileDriver:CFileDriver()");

	m_IsWatched = false;
	m_Service = new CService();
	memset( m_DriveList, 0, sizeof(m_DriveList) );

	// жϲϵͳ͡λCPUȷص
	if ( NULL != sDriverFileName && *sDriverFileName != '\0' )
	{
		m_DriverName = sDriverFileName;
	}
	else
	{
		m_DriverName = GetDriverName();
	}

	if ( !m_DriverName.empty() )
	{
		TCHAR szCurPath[MAX_PATH] = {0};  
		memset(szCurPath,   0,   MAX_PATH);  
		GetModuleFileName( NULL, szCurPath, sizeof(szCurPath)/sizeof(TCHAR) );
		m_DriverPath = szCurPath;
		m_LoadProcessName = szCurPath;
		std::string::size_type cur = m_DriverPath.find_last_of( '\\' );
		if ( cur != std::string::npos )
		{
			m_DriverPath = m_DriverPath.substr( 0, cur );
			m_LoadProcessName = m_LoadProcessName.substr( cur + 1 );
		}

		m_DriverPathName = m_DriverPath + "\\" + m_DriverName + ".sys";
	}
}


CFileDriver::~CFileDriver()
{
	if ( NULL != m_Service )
	{
		delete m_Service;
		m_Service = NULL;
	}
}


bool CFileDriver::Initialize( const char * pParam )
{
	CGDTrace trace( LOG_L6, "CFileDriver:Initialize(%s)", pParam);

	if ( !m_DriverPathName.empty() )
	{
		for ( int i=0; i<3; i++ )	// 
		{
			if ( InitDriver( pParam ) )
			{
				return trace.SetRetResult( true );
			}
			else
			{
				Uninitialize();
			}
		}
	}

	CGDLog::WriteErrLog( "1057:ʧܣPath=%s", m_DriverPathName.c_str() );
	return trace.SetRetResult( false );
}


bool CFileDriver::Uninitialize()
{
	CGDTrace trace( LOG_L6, "CFileDriver:Uninitialize()" );

	SetWatched( false );

	if ( !m_Service->ClearDisk() )
	{
		return trace.SetRetResult( false );
	}

	if ( m_Service->Close() )
	{
		return CDriver::RemoveDriver( GDFileDriverName );
	}
	return trace.SetRetResult( false );
}


bool CFileDriver::InitDriver( const char * pParam )
{
	CGDTrace trace( LOG_L6, "CFileDriver:InitDriver(%s)", pParam);

	bool bResult = true;

	if ( NULL != pParam )
	{
		CParamList paramList( pParam, ";" );
		m_SuperProcess = paramList.GetStringValue( "superprocess" );
	}
	else
	{
		return trace.SetRetResult( false );
	}

	if ( !m_SuperProcess.empty() )
	{
		if ( m_SuperProcess[0] != '|' )
		{
			m_SuperProcess = "|" + m_SuperProcess;
		}

		int len = m_SuperProcess.length();
		if ( m_SuperProcess[len-1] != '|' )
		{
			m_SuperProcess = m_SuperProcess + "|";
		}
	}

	if ( !m_LoadProcessName.empty() )
	{
		std::string sExeName = "|" + m_DriverPath + "\\" + m_LoadProcessName + "|";
		if ( std::string::npos == m_SuperProcess.find( sExeName.c_str() ) )
		{
			m_SuperProcess = sExeName + m_SuperProcess;
		}
	}

	if ( !m_Service->Create( GDFileDriverName ) )
	{
		bResult = CDriver::InstallDriver( GDFileDriverName, m_DriverPathName.c_str() );

		if (!bResult)
		{
			return trace.SetRetResult( false );
		}

		bResult = CDriver::StartDriver( GDFileDriverName );

		if (!bResult)
		{
			return trace.SetRetResult( false );
		}

		if ( !m_Service->Create( GDFileDriverName ) )
		{
			return trace.SetRetResult( false );
		}
    }

	if ( !m_Service->ClearEvent() )
	{
		return trace.SetRetResult( false );
	}

	// Ȩ
	bResult = m_Service->SetSuperProcess( m_SuperProcess.c_str(), m_SuperProcess.length() + 1 );
	return trace.SetRetResult( bResult );
}


bool CFileDriver::WatchDirectory( CMonitorInformation& moniInfo )
{
	CGDTrace trace( LOG_L6, "CFileDriver:WatchDirectory(%s)", moniInfo.m_monitorPath.c_str() );

	bool bResult = true;
	if ( m_paths.empty() )
	{
		bResult = SetWatched( true );
	}

	if ( !bResult )
	{
		return trace.SetRetResult( false );
	}

	// ȷÿĿ¼"\\"βΪʲô(by wang_jin at 2008-8-17)
	if ( moniInfo.m_monitorPath.length() > 2 )
	{
		if ( moniInfo.m_monitorPath.at( moniInfo.m_monitorPath.length() -1 ) != '\\' )
		{
			moniInfo.m_monitorPath = moniInfo.m_monitorPath + '\\';
		}
	}
	vector<string>::iterator it1;
	for ( it1 = moniInfo.m_excludePath.begin(); it1 != moniInfo.m_excludePath.end(); it1 ++ )
	{
		if ( (*it1).length() > 2 )
		{
			if ( (*it1).at( (*it1).length() - 1 ) != '\\' )
			{
				(*it1) = (*it1) + '\\';
			}
		}
	}

	list<CMonitorInformation>::iterator it;
	for ( it = m_paths.begin(); it != m_paths.end(); ++it )
	{
		if ( ( *it ).m_monitorPath.compare( moniInfo.m_monitorPath.c_str() ) == 0 )
		{
			m_paths.erase( it );
			break;
		}
	}
	m_paths.push_back( moniInfo );

	// ȡ
	bool isHookDisk[26] = {false};
	for ( it = m_paths.begin(); it != m_paths.end(); ++it )
	{
		if ( it->m_monitorPath.size() >= 2 )
		{
			char disk = it->m_monitorPath.at(0);
			if ( 'c' <= disk && disk <= 'z' )
			{
				disk = disk - 'c';
			}
			else if ( 'C' <= disk && disk <= 'Z' )
			{
				disk = disk - 'C';
			}
			else
			{
				break;
			}
			isHookDisk[disk] = true;
		}
	}
	int n = 0;
	for ( int i = 0; i < 26; i++ )
	{
		if ( isHookDisk[i] )
		{
			m_DriveList[n++] = i + 'C';
		}
	}

	// ò
	bResult = SetMonitorInfor();

	return trace.SetRetResult( bResult );
}


bool CFileDriver::SetMonitorInfor()
{
	CGDTrace trace( LOG_L6, "CFileDriver:SetMonitorInfor()" );

	m_Service->HookDrives( m_DriveList );

	// ַ
	std::string strPathInfo = "";

	list<CMonitorInformation>::iterator it0;
	for ( it0 = m_paths.begin(); it0 != m_paths.end(); ++it0 )
	{
		strPathInfo += PATH_START;
		
		// Ŀ¼
		strPathInfo += (*it0).m_monitorPath;
		strPathInfo += TYPE_SEPCHARE;

		// ųĿ¼б
		vector<string>::iterator it1;
		if ( !(*it0).m_excludePath.empty() )
		{
			strPathInfo += MLEMENT_SEPCHARE;
			for ( it1 = (*it0).m_excludePath.begin(); it1 != (*it0).m_excludePath.end(); ++it1  )
			{
				if ( !(*it1).empty() )
				{
					strPathInfo += (*it1).c_str();
					strPathInfo += MLEMENT_SEPCHARE;
				}
			}
		}
		strPathInfo += TYPE_SEPCHARE;

		// ųļб
		if ( !(*it0).m_excludeFile.empty() )
		{
			strPathInfo += MLEMENT_SEPCHARE;
			for ( it1 = (*it0).m_excludeFile.begin(); it1 != (*it0).m_excludeFile.end(); ++it1  )
			{
				// ųĿ¼
				if ( !(*it1).empty() )
				{
					strPathInfo += (*it1).c_str();
					strPathInfo += MLEMENT_SEPCHARE;
				}
			}
		}
		strPathInfo += TYPE_SEPCHARE;

		// ų
		if ( !(*it0).m_excludeType.empty() )
		{
			strPathInfo += MLEMENT_SEPCHARE;
			for ( it1 = (*it0).m_excludeType.begin(); it1 != (*it0).m_excludeType.end(); ++it1  )
			{
				if ( !(*it1).empty() )
				{
					strPathInfo += (*it1).c_str();
					strPathInfo += MLEMENT_SEPCHARE;
				}
			}
		}
		strPathInfo += TYPE_SEPCHARE;

		// ģų
		if ( !(*it0).m_excludeBlur.empty() )
		{
			strPathInfo += MLEMENT_SEPCHARE;
			for ( it1 = (*it0).m_excludeBlur.begin(); it1 != (*it0).m_excludeBlur.end(); ++it1  )
			{
				if ( !(*it1).empty() )
				{
					strPathInfo += (*it1).c_str();
					strPathInfo += MLEMENT_SEPCHARE;
				}
			}
		}
		strPathInfo += TYPE_SEPCHARE;

		// ų¼
		// |ų½¼|ųɾ¼|ų޸¼|ų¼|
		strPathInfo += MLEMENT_SEPCHARE;
		strPathInfo += (*it0).m_excludeCreateEvent == 0 ? "0" : "1";
		strPathInfo += MLEMENT_SEPCHARE;
		strPathInfo += (*it0).m_excludeDeleteEvent == 0 ? "0" : "1";
		strPathInfo += MLEMENT_SEPCHARE;
		strPathInfo += (*it0).m_excludeChangeEvent == 0 ? "0" : "1";
		strPathInfo += MLEMENT_SEPCHARE;
		strPathInfo += (*it0).m_excludeRenameEvent == 0 ? "0" : "1";
		strPathInfo += MLEMENT_SEPCHARE;
		strPathInfo += TYPE_SEPCHARE;

		//strPathInfo += PATH_FLAG;
	}
	strPathInfo += ALL_END;

	bool bRet = m_Service->SetPolicy( strPathInfo.c_str(), strPathInfo.length() );
	return trace.SetRetResult( bRet ); 
}


bool CFileDriver::UnwatchDirectory( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CFileDriver:UnwatchDirectory(%s)",sDirId );
	
	bool isRet = false;
	list<CMonitorInformation>::iterator it;
	for ( it = m_paths.begin(); it != m_paths.end(); ++it )
	{
		string tmp = sDirId;
		tmp += "\\";
		if ( ( *it ).m_monitorPath.compare( tmp ) == 0 )
		{
			m_paths.erase( it );
			break;
		}
	}
	
	if ( m_paths.empty() )
	{
		isRet = SetWatched( false );
	}
	else
	{
		isRet = SetMonitorInfor();
	}
	return trace.SetRetResult( isRet );
}


bool CFileDriver::SetWatched( bool isWatched )
{
	CGDTrace trace( LOG_L6, "CFileDriver:SetWatched()" );
	bool bResult = false;
	if ( isWatched )
	{
		bResult = m_Service->StartFilter();
		if ( bResult )
		{
			m_IsWatched = true;
		}
	}
	else
	{
		bResult = m_Service->StopFilter();
		if ( bResult )
		{
			m_IsWatched = false;
		}
	}
	return trace.SetRetResult( bResult );
}


bool CFileDriver::IsWatched( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CFileDriver:IsWatched(%s)",sDirId );
	
	list<CMonitorInformation>::iterator it;
	for ( it = m_paths.begin(); it != m_paths.end(); ++it )
	{
		string tmp = sDirId;
		tmp += "\\";
		if ( ( *it ).m_monitorPath.compare( tmp ) == 0 )
		{
			return trace.SetRetResult( true );
		}
	}
	return trace.SetRetResult( false );
}

bool CFileDriver::IsWatchedByWebsiteId( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CFileDriver:IsWatchedByWebsiteId(%s)",sDirId );
	
	list<CMonitorInformation>::iterator it;
	for ( it = m_paths.begin(); it != m_paths.end(); ++it )
	{
		string tmp = sDirId;
		tmp += "\\";
		if ( ( *it ).m_monitorPath.compare( tmp ) == 0 )
		{
			return trace.SetRetResult( true );
		}
	}
	return trace.SetRetResult( false );
}

bool CFileDriver::ReadEvent( EVENT_S& event )
{
	//CGDTrace trace( LOG_L6, "CFileDriver:ReadEvent(%s)",toString(event).c_str() ); // 򵥰װǸ־

	bool success = false;
	
	success = m_Service->GetBlockEvent( event );

	if (success)
	{
	}

	return success;
}

const char * CFileDriver::GetDriverName()
{
	CGDTrace trace( LOG_L6, "CFileDriver:GetDriverName()" );
	CSystemInfor sysInfor;
	switch( sysInfor.GetOsType() )
	{
	case CSystemInfor::OS_WIN2003:
		{
			if ( sysInfor.IsWin64() )
			{
				switch ( sysInfor.GetCpuType() )
				{
				case CSystemInfor::CPU_INTEL:
					return "GuardFileDriver03-IA64";
				case CSystemInfor::CPU_AMD:
					return "GuardFileDriver03-AMD64";
				}
			}
			else
			{
				return trace.SetRetText( "GuardFileDriver03" );
			}
		}
		break;

	case CSystemInfor::OS_WIN2008:
		{
			if ( sysInfor.IsWin64() )
			{
				switch ( sysInfor.GetCpuType() )
				{
				case CSystemInfor::CPU_INTEL:
					return "GuardFileDriver08-IA64";
				case CSystemInfor::CPU_AMD:
					return trace.SetRetText( "GuardFileDriver08-AMD64" );
				}
			}
			else
			{
				return trace.SetRetText( "GuardFileDriver08" );
			}
		}
		break;
	}
	return trace.SetRetText( "" );
}
