/***********************************************************************
 *
 * ļ        FileRule.cpp
 * ģĿģʵļųжϴ
 * ߼ڣ  wang_jin 2008-05-09
 * 汾          1.0
 * ȨϢ      CVICSE Middleware
 * ļ¼  
 *
 ***********************************************************************/

#pragma warning(disable:4786)


#include "FileRule.h"

#include "Base/MonitorDef.h"
#include "Common/GDString.h"
#include "FileOpt/FileOpt.h"
#include "FileExclude/FileExclude.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"

#ifdef _WIN32
#	include <windows.h>
#endif
#include <assert.h>


CFileRule::CFileRule()
{
}

CFileRule::~CFileRule()
{
}

bool CFileRule::SetRules( const CMonitorInformation& moniInfo )
{
		CGDTrace trace( LOG_L6, "CFileRule:SetRules()" );
		Clone( moniInfo );
		return trace.SetRetResult( true );
}

bool CFileRule::GetRules( CMonitorInformation& moniInfo )
{
		CGDTrace trace( LOG_L6, "CFileRule:GetRules()" );
		unClone( moniInfo );
		return trace.SetRetResult( true );
}

bool CFileRule::IsSubPath( const char* path, const char* subPath )
{
		CGDTrace trace( LOG_L6, "CFileRule:IsSubPath(%s,%s)", path, subPath );

		if ( !path || !(*path) || !subPath || !(*subPath) )
		{
				return trace.SetRetResult( false );
		}

		char ch1, ch2;
		for ( int i=0; ; i++ )
		{
				if ( !path[i] && !subPath[i] )
				{
						// ͬ
						trace.SetRetResult( true );
						return  true; // Ŀ¼δ?
				}

				if ( path[i] && !subPath[i] )
				{
						// ǰ
						trace.SetRetResult( false );
						return false;
				}

				ch1 = path[i];
				ch2 = subPath[i];

				if ( 'A' <= ch1 && ch1 <= 'Z' ) ch1 += 'a'-'A';
				if ( 'A' <= ch2 && ch2 <= 'Z' ) ch2 += 'a'-'A';

				if ( ch1 != ch2 )
				{
						if ( 0 == ch1 && C_PATHLASH == ch2 )
						{
								trace.SetRetResult( true );
								return true;
						}
						trace.SetRetResult( false );
						return false;
				}
		}

		assert( false ); // ᵽ!

		trace.SetRetResult( false );
		return false;
}

bool CFileRule::IsEqual( const char* sub, const char* str )
{
		CGDTrace trace( LOG_L6, "CFileRule:IsEqual(%s,%s)", sub, str );
		assert( sub && *sub && str && *str );

		char ch1, ch2;
		for ( int i=0; ; i++ )
		{
				if ( !sub[i] && !str[i] )
				{
						// ͬ
						return trace.SetRetResult( true ); // Ŀ¼δ?
				}

				if ( !sub[i] || !str[i] )
				{
						return trace.SetRetResult( false );
				}

				ch1 = sub[i];
				ch2 = str[i];

				if ( 'A' <= ch1 && ch1 <= 'Z' ) ch1 += 'a'-'A';
				if ( 'A' <= ch2 && ch2 <= 'Z' ) ch2 += 'a'-'A';

				if ( ch1 != ch2 )
				{
						return trace.SetRetResult( false );
				}
		}

		assert( false ); // ᵽ!

		return trace.SetRetResult( false );
}

bool CFileRule::IsExcludeFile( const char* file, int nFileType )
{
	CGDTrace trace( LOG_L6, "CFileRule:IsExcludeFile(%s,%d)", file, nFileType );
	vector< string >::iterator iter;

	// ȡļ
	char name[ GD_MAX_PATH ] = {0};
	char ext[ GD_MAX_PATH ] = {0};
	int i = 0;
	int len = strlen( file );
	for ( i=len-1; i>0; i-- )
	{
#ifdef _WIN32
		if ( file[i] == '\\' )
#else
		if ( file[i] == '/' )
#endif
		{
			strcpy( name, file + i + 1 );
			break;
		}
	}

	// ųĿ¼
	for ( iter = m_excludePath.begin(); iter != m_excludePath.end(); ++iter )
	{
		CGDTrace::GDTrace( LOG_L9, "CFileRule:IsExclude()-path [%s][%s]", (*iter).c_str(), file );

		//add   here  zhangquan 2008-10-7
		if ( (*iter).find('*') != string::npos ) 
		{   //ﺬ*
			if (CGDString::MatchWithPattern( (*iter).c_str(), file ) )
			{
				return trace.SetRetResult( true );
			}
		} 
		else 
		{
			if ( IsSubPath( (*iter).c_str(), file ) )
			{
				return trace.SetRetResult( true );  // ų
			}
		}

	}

	// жϵĿ¼ļ
	try
	{
		bool bFolder;
		if ( CFileOpt::IsExist(file, &bFolder) )
		{
			if ( bFolder )
			{
				// ΪĿ¼򲻱ؼж
				return trace.SetRetResult( false );
			}
		}
	}
	catch ( CExceptionError & ex )
	{
		//ex.AddErrText( "CFileRule:IsExcludeFile(%s)", file );
		// ޷ʣų
		//CGDLog::WriteErrLog("1058:޷ų(%s)\n%s", file, ex.GetErrText().c_str() );
		//return true;
	}
	// ļ

	// ųļ
	for ( iter=m_excludeFile.begin(); iter!=m_excludeFile.end(); ++iter )
	{
		CGDTrace::GDTrace( LOG_INF, "CFileRule:IsExclude()-file [%s][%s]", (*iter).c_str(), file );

		//add   here  zhangquan 2008-10-7
		if ( (*iter).find('*') != string::npos ) 
		{
			if ( !CFileOpt::IsDirectory( file ) )
			{
				if ( CGDString::MatchWithPattern( (*iter).c_str(), file ) )
				{
					return trace.SetRetResult( true );
				}
			}			
		} 
		else 
		{
			if ( IsEqual( (*iter).c_str(), file ) )
			{
				return trace.SetRetResult( true ); // ų
			}
		}
	}

	// ȡļ
	for ( i=len-1; i>0; i-- )
	{
		if ( file[i] == '.' )
		{
			strcpy( ext, file + i + 1 );
			break;
		}
	}
	for ( iter=m_excludeType.begin(); iter!=m_excludeType.end(); ++iter )
	{
		if ( IsEqual( (*iter).c_str(), ext ) )
		{
			return trace.SetRetResult( true ); // ų
		}
	}

	// ģƥ
	for ( iter=m_excludeBlur.begin(); iter!=m_excludeBlur.end(); ++iter )
	{			
		if ( CGDString::MatchWithPattern( (*iter).c_str(), name ) )
		{
			return trace.SetRetResult( true ); // ų
		}
	}

	return trace.SetRetResult( false );
}

bool CFileRule::IsExcludeEvent( eventType type, const char* file )
{
		CGDTrace trace( LOG_L6, "CFileRule:IsExcludeEvent(%d,%s)", type, file );
//		if ( ! IsSubPath( m_monitorPath.c_str(), file ) )
		if ( memcmp(m_monitorPath.c_str(), file, m_monitorPath.size()) != 0 )
		{
				// ڼ֮
				return trace.SetRetResult( true );
		}

		if ( IsExcludeEventType( type ) )
		{
				// ų¼
				return trace.SetRetResult( true );
		}

		if ( IsExcludeFile( file ) )
		{
				// ųļ
				return trace.SetRetResult( true );
		}

		return trace.SetRetResult( false );
}

bool CFileRule::IsExcludeEventType( eventType nEventType )
{
		CGDTrace trace( LOG_L6, "CFileRule:IsExcludeEventType(%d)", nEventType );
		switch ( nEventType & 0x0f )
		{
				case MONITOR_EVENT_CREATE:
						if ( m_excludeCreateEvent )
						{
								return trace.SetRetResult( true );
						}
						break;
				case MONITOR_EVENT_DELETE:
						if ( m_excludeDeleteEvent )
						{
								return trace.SetRetResult( true );
						}
						break;
				case MONITOR_EVENT_CHANGE:
						if ( m_excludeChangeEvent )
						{
								return trace.SetRetResult( true );
						}
						break;
				case MONITOR_EVENT_RENAME:
						if ( m_excludeRenameEvent )
						{
								return trace.SetRetResult( true );
						}
						break;
		}

		return trace.SetRetResult( false );
}
