// IISOptTest.cpp : Defines the entry point for the console application.
//
#include <comdef.h>
#include <initguid.h>
#include <objbase.h>
#include <iads.h>
#include <adshlp.h>
#include "GetIISDefaultdoc/GetIISDefaultdoc.h"

#include <iostream>

bool GetSiteDefaultDoc(BSTR& aDpath, string& sDirPath, string& sDefaultDoc)
{
	HRESULT hr;
	IADs *pSite = NULL;
	bool bSuccess = false;

	hr = ADsGetObject(aDpath, IID_IADs, (void**)&pSite);
	if ( SUCCEEDED(hr) )
	{
		//Virtual Directory*****************
		char sPath[256] = "";
		_bstr_t bText = aDpath;
		char* lpszText = bText;
		
		sprintf(sPath, "%s/ROOT", lpszText);

		IADs *pVDir;
		BSTR bstrPath = _bstr_t(sPath); 
		hr = ADsGetObject(bstrPath,IID_IADs, (void**)&pVDir);
		if ( SUCCEEDED(hr) )
		{
			_variant_t var;

			pVDir->Get(L"Path",&var);
			bText = var.bstrVal;
			lpszText = bText;
			sDirPath = lpszText;
			
			pVDir->Get(L"DefaultDoc",&var);
			bText = var.bstrVal;
			lpszText = bText;
			sDefaultDoc = lpszText;
			
			//**************
			VariantClear(&var);
			pVDir->Release();
			pVDir = NULL;

			bSuccess = true;
		}

		SysFreeString(bstrPath);

		pSite->Release();
		pSite = NULL;
	}

	return bSuccess;
}

long GetDefaultDoc(vector<string>& vDirPath, vector<string>& vDefaultDoc)
{
	HRESULT hr;
	IADs *pADs = NULL;
	
	hr = CoInitialize( NULL );
	if ( FAILED( hr ) )
	{
		printf( "CoInitialize failed. Error 0x%0x\n", hr );
		return -1;
	}

	IADsContainer *pServer = NULL;

	hr = ADsGetObject(L"IIS://localhost/w3svc",IID_IADsContainer, (void**)&pServer);
	if (!SUCCEEDED(hr))
	{
		printf("Error Connecting to IIS!\n\nIs IIS Installed?\nIs IIS running?");
		return -1;
	}

	IEnumVARIANT *pEnum = NULL;
	hr = ADsBuildEnumerator(pServer, &pEnum );
	if (SUCCEEDED(hr))
	{
		_variant_t vSite;
		ULONG lFetch;
		IADs *pSite=NULL;

		while(SUCCEEDED(ADsEnumerateNext( pEnum, 1, &vSite, &lFetch )) && lFetch == 1)
		{
			int item = 0;
			IDispatch *pDisp;
			pDisp = V_DISPATCH(&vSite);
			hr = pDisp->QueryInterface(IID_IADs, (void**) &pSite);
			if (SUCCEEDED(hr))
			{
				BSTR bstrClass;

				pSite->get_Class(&bstrClass);

				_bstr_t bText = bstrClass;
				char* lpszText = bText;

				if(strcmp(lpszText,"IIsWebServer")==0)
				{
					_variant_t	var;
					BSTR aDpath;
					
					pSite->get_ADsPath(&aDpath);
					//pSite->get_Name(&tSite.name);
					//pSite->Get(L"ServerComment",&var);
					//tSite.comment = var.bstrVal;
					//pSite->Get(L"ServerState",&var);
					//tSite.state = var.lVal;
					//pSite->Get(L"ServerBindings",&var);

					string sDirPath;
					string sDefaultDoc;

					if (GetSiteDefaultDoc(aDpath, sDirPath, sDefaultDoc))
					{
						vDirPath.push_back(sDirPath);
						vDirPath.push_back(sDefaultDoc);
						cout << sDirPath << "|" << sDefaultDoc << endl;
					}

					VariantClear(&vSite);
					SysFreeString(aDpath);
				}

				SysFreeString(bstrClass);

				pSite->Release();
				pSite = NULL;
				VariantClear(&vSite);
			}
		}
	}
	else
	{
		printf("Error enumerating sites!");
	}

	if (pEnum)
	{
		ADsFreeEnumerator(pEnum);
	}

	pServer->Release();
	pServer = NULL;

	CoUninitialize();
	return hr;
}

