

#ifndef __GIO_COROUTINE_H__
#define __GIO_COROUTINE_H__

#include <gio/gio.h>
#include "coroutine.h"

G_BEGIN_DECLS

typedef struct _GCoroutine GCoroutine;

struct _GCoroutine
{
    struct coroutine coroutine;
    guint wait_id;
    guint condition_id;
};


typedef gboolean (*GConditionWaitFunc)(gpointer);

typedef void (*GSignalEmitMainFunc)(GObject *object, int signum, gpointer params);

GCoroutine*  g_coroutine_self           (void);
void         g_coroutine_wakeup         (GCoroutine *coroutine);
GIOCondition g_coroutine_socket_wait    (GCoroutine *coroutine,
                                         GSocket *sock, GIOCondition cond);
gboolean     g_coroutine_condition_wait (GCoroutine *coroutine,
                                         GConditionWaitFunc func, gpointer data);
void         g_coroutine_condition_cancel(GCoroutine *coroutine);

void         g_coroutine_signal_emit (gpointer instance, guint signal_id,
                                      GQuark detail, ...);

void         g_coroutine_object_notify(GObject *object, const gchar *property_name);

G_END_DECLS

#endif 

