/************
 ýṹ
 ************/
#ifndef _UAP_STRU_H
#define _UAP_STRU_H

#include <sys/types.h>
#include <sys/time.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <netinet/in.h>

#define   N_CUTOVER     32              /* ϢĿ */
#define   N_URGE        2048            /* ӦĿ */
#define   N_NODE        512             /* ӵĿ */
#define   N_PROT        256             /* ЭĿ */
#define   N_IPA         4096            /* IP֤Ŀ */
#define   N_USRA        1024            /* û֤Ŀ */
#define   N_BUSI        8192            /* ҵĿ */
#define   N_FLOW        8192            /* űĿ */
#define   N_H3          32768           /* ŶĿ */
#define   N_RCODE       8192            /* Ŀ */
#define   N_PMAP        16384           /* ƷIDӳĿ(˫) */
#define   N_SCRIPT      16384000        /* ű󳤶 */

#define   N_BATROWS     1024            /* ݿȡĿ */

#define   TL_TAG        16              /* TLV TAG ĳ */
#define   TL_LEN        8               /* TLV LEN ĳ */

#define   T_DBTMOUT     60              /* ȱʡݿʱʱ䣬 */
#define   C_NODATA      1403            /* ʱ SQLCODE */
#define   D_EXPTIME    "3000"           /* ĬʧЧʱ䣬 */

                                        /* ùؼ */
#define   SG_CUTOVER   "[CUTOVER]"      /* Ӷ */
#define   SG_UAPKEY    "UAPIPCKEY"      /* IPCֵ */
#define   SG_DBINFO    "DBINFO"         /* ݿϢ */
#define   SG_ENCRY     "ENCRYPTION"     /* ϢǷ */
#define   SG_PROLIST   "PROTOID_LIST"   /* ϽЭIDб */
#define   SG_DBTMOUT   "DB_TIMEOUT"     /* ݿʱʱ */
#define   SG_UAPEXE    "UAPEXE"         /* UAP ִг */
#define   SG_UAPCFG    "UAPCFG"         /* UAP ļ */
#define   SG_HOSTID    "[HOSTID]"       /* ʶ */
#define   SG_ESURL     "ESURL"          /* ӦURL */

#define   N_SEM         2               /* źŵĿ */

enum                                    /* źŵƶ */
{
    SN_REFRESH      = 0,                /* ˢµ */
    SN_READ         = 1                 /*  */
};

enum                                    /*  */
{
    R_GLOB          = 'G',              /* ȫ */
    R_NODE          = 'N',              /* ӵ */
    R_PROT          = 'P',              /* Э */
    R_IPA           = 'I',              /* IP֤ */
    R_USRA          = 'U',              /* û֤ */
    R_BUSI          = 'B',              /* ҵ */
    R_FLOW          = 'F',              /* ű */
    R_H3            = 'H',              /* Ŷ */
    R_RCODE         = 'C',              /*  */
    R_PMAP          = 'M',              /* ƷIDӳ */
    R_CUTOVER       = 'O',              /*  */
    R_URGE          = 'E'               /* Ӧ */
};

enum                                    /* Ŷ */
{
    RN_GLOB         = -1,               /* ȫ */
    RN_NODE,                            /* ӵ */
    RN_PROT,                            /* Э */
    RN_IPA,                             /* IP֤ */
    RN_USRA,                            /* û֤ */
    RN_BUSI,                            /* ҵ */
    RN_FLOW,                            /* ű */
    RN_H3,                              /* Ŷ */
    RN_RCODE,                           /*  */
    RN_PMAP,                            /* ƷIDӳ */
    RN_CUTOVER,                         /*  */
    RN_URGE                             /* Ӧ */
};

enum                                    /* ٽ붨 */
{
    X_OUT = 0,                          /* 뿪 */
    X_IN = 1                            /*  */
};

typedef union u_semun                   /* źŵȡֵ */
{
    int              val;
    struct semid_ds *buf;
    unsigned short  *array;
} USEMUN;

typedef struct  s_uap_cutover           /* иϢ */
{
    int             nRegion;            /*  */
    unsigned char   cCutOver;           /* ǷѸ */
} UAP_CUTOVER;

typedef struct  s_uap_urge              /* ӦϢ */
{
    int             nRegion;            /*  */
    char            szChanID[33];       /* ID */
    signed char     cECrm;              /* CRM Ӧ״̬ */
    signed char     cEBoss;             /* BOSSӦ״̬ */
    signed char     cERes;              /* ԴӦ״̬ */
    char            szETime[15];        /* Ӧʱ */
    signed char     cMsgBlock;          /* ǷϢ */
    char            szRepMsg[257];      /* ʱӦϢ */
} UAP_URGE;

typedef struct  s_uap_node              /* ӵṹ */
{
    char            szNodeID[33];       /* ӵID */
    char            szProtID[65];       /* ЭID */
    char            szDefChanID[33];    /* ȱʡID */
    signed char     cAuthMode;          /* ֤ʽ */
    signed char     cRouteBy;           /* ת */
    char            szRouteTag[65];     /* תֶ */
    char            szRouteScript[513]; /* תű */
    char            szEffTime[15];      /* Чʱ */
    char            szExpTime[15];      /* ʧЧʱ */

    unsigned char   cLogLevel;          /* ־ */
    int             nProtOffset;        /* Эƫ */
                                        /* ӵͳϢԤ */
} UAP_NODE;

typedef struct  s_uap_prot              /* Эṹ */
{
    char            szProtID[65];       /* ЭID */
    char            szQHeadID[65];      /* ͷID */
    char            szPHeadID[65];      /* ӦͷID */
    char            szEffTime[15];      /* Чʱ */
    char            szExpTime[15];      /* ʧЧʱ */
    signed char     cProtType;          /* Э */
    unsigned char   cEncMode;           /* ܷʽ */
    char            szEncKey[49];       /* Կ */
    int             nQHOffset;          /* ͷڽűƫ */
    int             nPHOffset;          /* Ӧͷڽűƫ */
} UAP_PROT;

typedef struct  s_uap_ipauth            /* IP֤ṹ */
{
    char            szNodeID[33];       /* ӵID */
    char            szIP[33];           /* IPַ */
    char            szEffTime[15];      /* IPЧʱ */
    char            szExpTime[15];      /* IPʧЧʱ */
} UAP_IPAUTH;

typedef struct  s_uap_userauth          /* û֤ṹ */
{
    char            szNodeID[33];       /* ӵID */
    char            szUser[65];         /* û */
    char            szPass[65];         /*  */
    signed char     cEncryMode;         /* ܷʽ */
    char            szEncryKey[33];     /* Կ */
    char            szEffTime[15];      /* ûЧʱ */
    char            szExpTime[15];      /* ûʧЧʱ */
} UAP_USERAUTH;

typedef struct  s_uap_busi              /* ҵṹ */
{
    char            szBusiID[65];       /* ҵID */
    char            szBusiType[33];     /* ҵ */
    char            szChanID[33];       /* ID */
    char            szProtID[65];       /* ЭID */
    char            szFlowID[65];       /* űID */
    char            szEffTime[15];      /* Чʱ */
    char            szExpTime[15];      /* ʧЧʱ */

    signed char     cUrgencyUse;        /* ӦǷ */
    unsigned char   cLogLevel;          /* ־ */
    int             nTimeout;           /* ʱʱ */
    int             nFlowOffset;        /* űƫ */
                                        /* ҵͳϢԤ */
} UAP_BUSI;

typedef struct  s_uap_flow              /* űṹ */
{
    char            szFlowID[65];       /* űID */
    int             nTotalLen;          /* ű */
    int             nOffset;            /* űƫ */
} UAP_FLOW;

typedef struct  s_uap_h3                /* Ŷνṹ */
{
    char            szBegH3[26];
    char            szEndH3[26];
    int             nRegion;
} UAP_H3;

typedef struct  s_uap_rcode             /* ṹ */
{
    char            szChanID[33];       /* ID */
    char            szBusiID[65];       /* ҵID */
    char            szFromCode[17];     /* Դ */
    char            szToCode[17];       /* Ŀ귵 */
    char            szRetMsg[257];      /* Ϣ */
    char            szClass[17];        /*  */
} UAP_RCODE;

typedef struct  s_uap_pmap              /* Ʒսṹ */
{
    int             nRegion;
    char            szOldPID[33];       /* ɲƷID */
    char            szProdID[33];       /* ²ƷID */
    char            szProdType[33];     /* Ʒ */
    char            szBizCode[33];      /* BizCode */
    unsigned char   cOperType;          /* ҵ */
} UAP_PMAP;

typedef struct  s_uap_ginf              /* ڴȫϢ */
{
    int             nValid[16];         /* װر־ */
    int             nMemSize;           /* ڴС */
    time_t          tCreatTime;         /* ʱ */
    uid_t           nUserID;            /* ID */
    char            szUserName[16];     /*  */
    int             nSemID;             /* źŵƱʶ */
    unsigned char   cUrgePlat;          /* ǷȫӦ */

    int             nNode;              /* ӵṹǰĿ */
    int             nProt;              /* ЭṹǰĿ */
    int             nIP;                /* IPṹǰĿ */
    int             nUser;              /* ûṹǰĿ */
    int             nBusi;              /* ҵṹǰĿ */
    int             nFlow;              /* űṹǰĿ */
    int             nFlowLen;           /* űǰ */
    int             nH3;                /* ŶνṹǰĿ */
    int             nRCode;             /* 뵱ǰĿ */
    int             nRCode1;            /* ȱʡʱǰĿ */
    int             nRCode2;            /* ȱʡҵʱǰĿ */
    int             nPMap;              /* ƷIDӳ䵱ǰĿ */
    int             nCutOver;           /* ϢǰĿ */
    int             nUrge;              /* ӦϢǰĿ */

    UAP_CUTOVER     sCutOver[N_CUTOVER];/* Ϣ */
    UAP_URGE        sUrge   [N_URGE];   /* ӦϢ */
    UAP_NODE        sNode   [N_NODE];   /* ӵϢ */
    UAP_PROT        sProt   [N_PROT];   /* ЭϢ */
    UAP_IPAUTH      sIP     [N_IPA];    /* IPϢ */
    UAP_USERAUTH    sUser   [N_USRA];   /* ûϢ */
    UAP_BUSI        sBusi   [N_BUSI];   /* ҵϢ */
    UAP_FLOW        sFlow   [N_FLOW];   /* űϢ */
    UAP_H3          sH3     [N_H3];     /* ŶϢ */
    UAP_RCODE       sRCode  [N_RCODE];  /* Ϣ */
    UAP_PMAP        sPMap   [N_PMAP];   /* ƷӳϢ */

    char            szFlow  [N_SCRIPT]; /* ̽ű */
} UAP_GINF;

#endif
