/************
 UAP ײ㺯
 ************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "uap_gvdef.h"
#include "uap_tag.h"
#include "uap_api.h"
#include "gcps.h"
#include "z.h"

static    char        *t_shmhead = NULL;    /* ڴַ */
static    int          t_shmid   = -1;      /* ڴ */
static    int          t_semid   = -1;      /* źŵ */
static    int          t_outsys  = 1;       /* Χϵͳֻʽڴ */

/****************
 Χϵͳ־
 ****************/
void u_set_outsys(int nOut)
{
    t_outsys = nOut;
}

/******************************
 ڴ桢źŵ
 ֵ  -1ʧ  0ɹ
 ******************************/
int u_clean_ipc(void)
{
    if( t_shmid >= 0 && shmctl(t_shmid, IPC_RMID, 0) < 0 ) return(-1);
    //if( t_semid >= 0 && semctl(t_semid, 0, IPC_RMID, 0) < 0 ) return(-1);

    return(0);
}

/************************************
 װظϢ
 ڲconst char *   -- ļ
           UAP_CUTOVER *  -- 
           int *          -- ¼Ŀ
 ֵ  -1ʧ  0ɹ  1
 ************************************/
int u_load_cutover(const char *pFile, UAP_CUTOVER *pCut, int *nRows)
{
    FILE *fp = NULL;

    int   i, b;

    char *p,
          szBuf[64],
          szSepStr[2],      // ָ
          szRegion[8],      // 
          szValue[16];      // ״̬

    // иϢ
    szSepStr[0] = SM_KEYVALUE;
    szSepStr[1] = 0;

    for( i = 0; ; )
    {
        b = z_scanseg(&fp, pFile, SG_CUTOVER, szBuf, sizeof(szBuf));

        if( b < 0 ) return(-1);
        else if( b == 0 ) break;

        z_atrim(szBuf);

        if( szBuf[0] )
        {
            // 
            if( i >= N_CUTOVER )
            {
                if( fp ) fclose(fp);
                return(1);
            }

            p = szBuf;
            z_get_fieldv(&p, szRegion, NULL, sizeof(szRegion) - 1, szSepStr);
            z_get_fieldv(&p, szValue, NULL, sizeof(szValue) - 1, szSepStr);

            pCut[i].nRegion = (int) strtol(szRegion, (char **)NULL, 10);
            pCut[i].cCutOver = (unsigned char) strtol(szValue, (char **)NULL, 10);
            i++;
        }
    }

    // ¼Ŀ
    if( nRows ) *nRows = i;

    return(0);
}

/***************************************
 ڴ桢źŵ
 ڲkey_t        --  KEY ֵ
           const char * --  ļ
           int          --  ڴ泤
 ֵ  -1ʧ  0ɹ
 ***************************************/
int u_init_ipc(key_t aKey, const char *pFile, int aLen)
{
    int   b, nRows;

    char *p;

    USEMUN un;
    unsigned short usa[N_SEM] = {0};

    un.array = usa;

    // 
    if( pFile == NULL || *pFile == 0 ) return(-1);

    /* źŵ */
    if( (t_semid = semget(aKey, N_SEM, IPC_CREAT | 0666)) < 0 ) return(-1);

    /* ֵ */
    if( semctl(t_semid, 0, SETALL, un) < 0 ) return(-1);

    /* ڴ */
    if( (t_shmid = shmget(aKey, aLen, IPC_CREAT | 0666)) < 0 ) return(-1);

    /*  */
    if( (t_shmhead = (char *) shmat(t_shmid, 0, 0)) == (char *) -1 ) return(-1);

    /* ʼڴ */
    memset(t_shmhead, 0, aLen);

    // ڴָ붨λ
    u_pGInf = (UAP_GINF *)t_shmhead;

    // ȫϢֵ
    u_pGInf->nMemSize   = aLen;
    u_pGInf->tCreatTime = time(0);
    u_pGInf->nUserID    = geteuid();
    u_pGInf->nSemID     = t_semid;

    // û
    if( (p = getenv("LOGNAME")) )
        strncpy(u_pGInf->szUserName, p, sizeof(u_pGInf->szUserName) - 1);

    // иϢ
    b = u_load_cutover(pFile, u_pGInf->sCutOver, &nRows);

    if( b < 0 )
    {
        printf("\n󣺸Ϣװʧ\n");
        return(-1);
    }
    else if( b == 1 )
    {
        printf("\n󣺼¼Ŀ %d\n", N_CUTOVER);
        return(-1);
    }

    u_pGInf->nCutOver = nRows;
    u_pGInf->nValid[RN_CUTOVER] = 1;   // װ

    return(0);
}

/**************************************
 ٽˢ
 ڲint io    --  1=  0=뿪
 ֵ  -1ʧ  0ɹ
 **************************************/
int u_Xzone_write(int io)
{
    struct sembuf sops[3];

    if( io == 1 )    /*  */
    {
        /* ȴˢͷ */
        sops[0].sem_num = SN_REFRESH;
        sops[0].sem_op  = 0;
        sops[0].sem_flg = SEM_UNDO;

        /* ˢ */
        sops[1].sem_num = SN_REFRESH;
        sops[1].sem_op  = 1;
        sops[1].sem_flg = SEM_UNDO;

        /* ȴͷ */
        sops[2].sem_num = SN_READ;
        sops[2].sem_op  = 0;
        sops[2].sem_flg = SEM_UNDO;

        if( semop(t_semid, sops, 3) < 0 ) return(-1);
    }
    else             /* 뿪 */
    {
        /* رˢ */
        if( GC_semop(t_semid, SN_REFRESH, -1, 0) < 0 ) return(-1);
    }

    return(0);
}

/**************************************
 ٽ
 ڲint io    --  1=  0=뿪
 ֵ  -1ʧ  0ɹ
 **************************************/
int u_Xzone_read(int io)
{
    struct sembuf sops[2];

    if( io == 1 )    /*  */
    {
        /* ȴˢͷ */
        sops[0].sem_num = SN_REFRESH;
        sops[0].sem_op  = 0;
        sops[0].sem_flg = SEM_UNDO;

        /* 򿪶 */
        sops[1].sem_num = SN_READ;
        sops[1].sem_op  = 1;
        sops[1].sem_flg = SEM_UNDO;

        if( semop(t_semid, sops, 2) < 0 ) return(-1);
    }
    else             /* 뿪 */
    {
        /* رն */
        if( GC_semop(t_semid, SN_READ, -1, 0) < 0 ) return(-1);
    }

    return(0);
}

/**************************************
 TLV
 ڲchar **      -- Ŀָ
           const char * -- Value
           const char * -- Tag
 ֵ  -1ʧ  >=0ݳ
 **************************************/
int u_packTLV(char **pBody, const char *pValue, const char *pTag)
{
    int  nL = 0;
    char szBuf[64];

    if( pBody == NULL || *pBody == NULL ) return(-1);
    if( pTag == NULL || *pTag == 0 ) return(-1);

    // TAG ȼ
    if( strlen(pTag) > TL_TAG ) return(-1);

    sprintf(*pBody, "%-*s", TL_TAG, pTag);
    (*pBody) += TL_TAG;

    if( pValue ) nL = strlen(pValue);
    sprintf(szBuf, "%-*d", TL_LEN, nL);

    // ݳȼ
    if( strlen(szBuf) > TL_LEN ) return(-1);

    strcpy(*pBody, szBuf);
    (*pBody) += TL_LEN;

    if( nL > 0 )
    {
        strcpy(*pBody, pValue);
        (*pBody) += nL;
    }
    **pBody = 0;

    return(nL);
}

//--------------------------------------------------------
#ifdef  __cplusplus
extern "C" {
#endif

/******************************
 ȡڴ桢źŵ
 ڲkey_t   --  KEY ֵ
 ֵ  -1ʧ  0ɹ
 ******************************/
int u_get_ipc(key_t aKey)
{
    int nReadFlag = 0;

    /* źŵ */
    if( (t_semid = semget(aKey, 0, 0)) < 0 ) return(-1);

    /* ڴ */
    if( (t_shmid = shmget(aKey, 0, 0)) < 0 ) return(-1);

    /*  */
    if( t_outsys == 1 ) nReadFlag = SHM_RDONLY;

    if( (t_shmhead = (char *) shmat(t_shmid, 0, nReadFlag)) == (char *) -1 ) return(-1);

    // ڴָ붨λ
    u_pGInf = (UAP_GINF *)t_shmhead;

    return(0);
}

/****************
 Ͽӹڴ
 ****************/
void u_unget_ipc(void)
{
    if( t_shmhead )
    {
        shmdt(t_shmhead);
        t_shmhead = NULL;
    }

    t_shmid = -1;
    t_semid = -1;
}

/**************
 ӵIDȽϺ
 **************/
int u_nodecpr(const void *k, const void *e)
{
    return( strcmp((char *)k, ((UAP_NODE *) e)->szNodeID) );
}

/************************************
 ȡӵϢ
 ڲconst char * -- ӵID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_nodeinf(const char *pNodeID, char *pOutBuf)
{
    char *pO, szBuf[64];

    UAP_NODE *p = NULL;

    static UAP_NODE sNode;
    static UAP_PROT sProt;

    // ϷԼ
    if( pNodeID == NULL || *pNodeID == 0 ) return(0);
    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nValid[RN_NODE] && u_pGInf->nNode )
    {
        p = (UAP_NODE *) bsearch(pNodeID, u_pGInf->sNode, u_pGInf->nNode, sizeof(UAP_NODE), u_nodecpr);

        if( p )
        {
            memcpy(&sNode, p, sizeof(UAP_NODE));

            // ЭϢ
            if( sNode.nProtOffset >= 0 )
            {
                memcpy(&sProt, u_pGInf->sProt + sNode.nProtOffset, sizeof(UAP_PROT));

                if( sProt.nQHOffset >= 0 )
                    u_packTLV(&pO, u_pGInf->szFlow + sProt.nQHOffset, T_REQHEAD);
                if( sProt.nPHOffset >= 0 )
                    u_packTLV(&pO, u_pGInf->szFlow + sProt.nPHOffset, T_REPHEAD);
            }
        }
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    // ޼¼
    if( p == NULL || sNode.nProtOffset < 0 ) return(0);

    // ȡǰ
    z_get_dt(szBuf, 14, "f", 0);

    // ʱЧ
    if( strcmp(sNode.szEffTime, szBuf) > 0 || strcmp(sNode.szExpTime, szBuf) < 0 ||
        strcmp(sProt.szEffTime, szBuf) > 0 || strcmp(sProt.szExpTime, szBuf) < 0 )
    {
         return(0);
    }

    // TLV
    u_packTLV(&pO, sNode.szProtID, T_PROTOCOLID);
    u_packTLV(&pO, sNode.szDefChanID, T_DEFCHANID);
    sprintf(szBuf, "%d", sNode.cAuthMode);
    u_packTLV(&pO, szBuf, T_AUTHMODE);
    sprintf(szBuf, "%d", sNode.cRouteBy);
    u_packTLV(&pO, szBuf, T_ROUTEFLAG);
    sprintf(szBuf, "%d", sNode.cLogLevel);
    u_packTLV(&pO, szBuf, T_LOGLEVEL);
    u_packTLV(&pO, sNode.szRouteTag, T_ROUTEFIELD);
    u_packTLV(&pO, sNode.szRouteScript, T_ROUTESCRIPT);
    sprintf(szBuf, "%d", sProt.cProtType);
    u_packTLV(&pO, szBuf, T_PROTOCOLTYPE);
    sprintf(szBuf, "%d", sProt.cEncMode);
    u_packTLV(&pO, szBuf, T_ENCMODE);
    u_packTLV(&pO, sProt.szEncKey, T_ENCKEY);
    *pO = 0;

    return(1);
}

/**************
 IP֤ȽϺ
 **************/
int u_IPcpr(const void *k, const void *e)
{
    int r;
    UAP_IPAUTH *pK, *pE;

    pK = (UAP_IPAUTH *) k;
    pE = (UAP_IPAUTH *) e;

    if( (r = strcmp(pK->szIP, pE->szIP)) ) return r;
    return( strcmp(pK->szNodeID, pE->szNodeID) );
}

/**********************************
 ִIP֤
 ڲconst char * -- ӵID
           const char * -- ֤IP
 ֵ  -1ʧ  0ܾ  1ͨ
 **********************************/
int u_do_ipauth(const char *pNodeID, const char *pIP)
{
    char szBuf[64];

    UAP_IPAUTH sIP, *p = NULL;

    if( pNodeID == NULL || *pNodeID == 0 ) return(0);
    if( pIP == NULL || *pIP == 0 ) return(0);

    strcpy(sIP.szNodeID, pNodeID);
    strcpy(sIP.szIP, pIP);

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲIP֤Ϣ
    if( u_pGInf->nValid[RN_IPA] && u_pGInf->nIP )
    {
        p = (UAP_IPAUTH *) bsearch(&sIP, u_pGInf->sIP, u_pGInf->nIP, sizeof(UAP_IPAUTH), u_IPcpr);
        if( p ) memcpy(&sIP, p, sizeof(UAP_IPAUTH));
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // ȡǰ
    z_get_dt(szBuf, 14, "f", 0);

    // ʱЧ
    if( strcmp(sIP.szEffTime, szBuf) > 0 || strcmp(sIP.szExpTime, szBuf) < 0 )
    {
         return(0);
    }

    return(1);
}

/****************
 û֤ȽϺ
 ****************/
int u_usercpr(const void *k, const void *e)
{
    int r;
    UAP_USERAUTH *pK, *pE;

    pK = (UAP_USERAUTH *) k;
    pE = (UAP_USERAUTH *) e;

    if( (r = strcmp(pK->szUser, pE->szUser)) ) return r;
    return( strcmp(pK->szNodeID, pE->szNodeID) );
}

/************************************
 ִû֤
 ڲconst char * -- ӵID
           const char * -- ֤û
           const char * -- ֤
 ֵ  -1ʧ  0ܾ  1ͨ
 ************************************/
int u_do_userauth(const char *pNodeID, const char *pUser, const char *pPass)
{
    char szBuf[64];

    UAP_USERAUTH sUser, *p = NULL;

    if( pNodeID == NULL || *pNodeID == 0 ) return(0);
    if( pUser == NULL || *pUser == 0 ) return(0);
    if( pPass == NULL ) return(0);

    strcpy(sUser.szNodeID, pNodeID);
    strcpy(sUser.szUser, pUser);

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲû֤Ϣ
    if( u_pGInf->nValid[RN_USRA] && u_pGInf->nUser )
    {
        p = (UAP_USERAUTH *) bsearch(&sUser, u_pGInf->sUser, u_pGInf->nUser, sizeof(UAP_USERAUTH), u_usercpr);
        if( p ) memcpy(&sUser, p, sizeof(UAP_USERAUTH));
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // ȡǰ
    z_get_dt(szBuf, 14, "f", 0);

    // ʱЧ
    if( strcmp(sUser.szEffTime, szBuf) > 0 || strcmp(sUser.szExpTime, szBuf) < 0 )
    {
         return(0);
    }

    // ж
    if( strcmp(sUser.szPass, pPass) ) return(0);

    return(1);
}

/****************
 ҵϢȽϺ
 ****************/
int u_busicpr(const void *k, const void *e)
{
    int r;
    UAP_BUSI *pK, *pE;

    pK = (UAP_BUSI *) k;
    pE = (UAP_BUSI *) e;

    if( (r = strcmp(pK->szBusiID, pE->szBusiID)) ) return r;
    if( (r = strcmp(pK->szChanID, pE->szChanID)) ) return r;
    return( strcmp(pK->szProtID, pE->szProtID) );
}

/************************************
 ȡҵϢ
 ڲconst char * -- ҵID
           const char * -- ID
           const char * -- ЭID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_busiinf(const char *pBusiID, const char *pChanID, const char *pProtID, char *pOutBuf)
{
    char *pO, szBuf[64];

    UAP_BUSI  sBusi, *p = NULL;

    if( pBusiID == NULL || *pBusiID == 0 ) return(0);
    if( pChanID == NULL || *pChanID == 0 ) return(0);
    if( pProtID == NULL || *pProtID == 0 ) return(0);
    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    strcpy(sBusi.szBusiID, pBusiID);
    strcpy(sBusi.szChanID, pChanID);
    strcpy(sBusi.szProtID, pProtID);

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲҵID
    if( u_pGInf->nValid[RN_BUSI] && u_pGInf->nBusi )
    {
        p = (UAP_BUSI *) bsearch(&sBusi, u_pGInf->sBusi, u_pGInf->nBusi, sizeof(UAP_BUSI), u_busicpr);
        if( p )
        {
            memcpy(&sBusi, p, sizeof(UAP_BUSI));
            if( sBusi.nFlowOffset >= 0 )
                u_packTLV(&pO, u_pGInf->szFlow + sBusi.nFlowOffset, T_FLOWSCRIPT);
        }
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL || sBusi.nFlowOffset < 0 ) return(0);

    // ȡǰ
    z_get_dt(szBuf, 14, "f", 0);

    // ʱЧ
    if( strcmp(sBusi.szEffTime, szBuf) > 0 || strcmp(sBusi.szExpTime, szBuf) < 0 )
    {
         return(0);
    }

    // TLV
    sprintf(szBuf, "%d", sBusi.cUrgencyUse);
    u_packTLV(&pO, szBuf, T_URGENCYUSE);
    sprintf(szBuf, "%d", sBusi.nTimeout);
    u_packTLV(&pO, szBuf, T_TIMEOUT);
    sprintf(szBuf, "%d", sBusi.cLogLevel);
    u_packTLV(&pO, szBuf, T_LOGLEVEL);
    u_packTLV(&pO, sBusi.szBusiType, T_BUSITYPE);
    *pO = 0;

    return(1);
}

/****************
 ŶϢȽϺ
 ****************/
int u_h3cpr(const void *k, const void *e)
{
    int b;
    UAP_H3 *pK = (UAP_H3 *) k;
    UAP_H3 *pE = (UAP_H3 *) e;

    if( (b = pK->nRegion - strlen(pE->szBegH3)) ) return(b);
    else if( strcmp(pK->szBegH3, pE->szBegH3) < 0 ) return(-1);
    else if( strcmp(pK->szBegH3, pE->szEndH3) > 0 ) return(1);
    return(0);
}

/************************************
 ȡŶϢ
 ڲchar *       -- 
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_h3inf(const char *pTel, char *pOutBuf)
{
    int   nRegion = 0;
    char *pO, szBuf[64];

    UAP_H3 sH, *p = NULL;

    if( pTel == NULL || *pTel == 0 ) return(0);
    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    sH.nRegion = strlen(pTel);
    strncpy(sH.szBegH3, pTel, sizeof(sH.szBegH3) - 1);
    sH.szBegH3[sizeof(sH.szBegH3) - 1] = 0;

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nValid[RN_H3] && u_pGInf->nH3 )
    {
        p = (UAP_H3 *) bsearch(&sH, u_pGInf->sH3, u_pGInf->nH3, sizeof(UAP_H3), u_h3cpr);
        if( p ) nRegion = p->nRegion;
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // TLV
    sprintf(szBuf, "%d", nRegion);
    u_packTLV(&pO, szBuf, T_BELONGAREA);
    *pO = 0;

    return(1);
}

/******************
 ϢȽϺ
 ******************/
int u_rcodecpr(const void *k, const void *e)
{
    int b;
    UAP_RCODE *pK = (UAP_RCODE *) k;
    UAP_RCODE *pE = (UAP_RCODE *) e;

    if( (b = strcmp(pK->szFromCode, pE->szFromCode)) ) return(b);
    if( (b = strcmp(pK->szBusiID, pE->szBusiID)) ) return(b);
    return( strcmp(pK->szChanID, pE->szChanID) );
}

/************************************
 ȡϢ
 ڲconst char * -- ID
           const char * -- ҵID
           const char * -- Դ
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_rcodeinf(const char *pChanID, const char *pBusiID, const char *pFrom, char *pOutBuf)
{
    char *pO;

    UAP_RCODE sR, *pT, *p = NULL;

    if( pChanID == NULL || *pChanID == 0 ) return(0);
    if( pBusiID == NULL || *pBusiID == 0 ) return(0);
    if( pFrom == NULL || *pFrom == 0 ) return(0);

    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    strcpy(sR.szChanID, pChanID);
    strcpy(sR.szBusiID, pBusiID);
    strcpy(sR.szFromCode, pFrom);

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nValid[RN_RCODE] && u_pGInf->nRCode )
    {
        p = (UAP_RCODE *) bsearch(&sR, u_pGInf->sRCode, u_pGInf->nRCode, sizeof(UAP_RCODE), u_rcodecpr);
        if( p == NULL )
        {
            pT = u_pGInf->sRCode + u_pGInf->nRCode;
            strcpy(sR.szFromCode, "DEFAULT");
            p = (UAP_RCODE *) bsearch(&sR, pT, u_pGInf->nRCode1, sizeof(UAP_RCODE), u_rcodecpr);

            if( p == NULL )
            {
                pT = u_pGInf->sRCode + u_pGInf->nRCode + u_pGInf->nRCode1;
                strcpy(sR.szBusiID, "DEFAULT");
                p = (UAP_RCODE *) bsearch(&sR, pT, u_pGInf->nRCode2, sizeof(UAP_RCODE), u_rcodecpr);
            }
        }
        if( p ) memcpy(&sR, p, sizeof(UAP_RCODE));
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // TLV
    u_packTLV(&pO, sR.szClass, T_RETCLASS);
    u_packTLV(&pO, sR.szToCode, T_TOCODE);
    u_packTLV(&pO, sR.szRetMsg, T_RETMSG);
    *pO = 0;

    return(1);
}

/****************************
 ƷӳϢȽϺ->
 ****************************/
int u_pmapOcpr(const void *k, const void *e)
{
    int b;
    UAP_PMAP *pK = (UAP_PMAP *) k;
    UAP_PMAP *pE = (UAP_PMAP *) e;

    if( (b = strcmp(pK->szOldPID, pE->szOldPID)) ) return(b);
    if( (b = strcmp(pK->szProdType, pE->szProdType)) ) return(b);
    return( pK->nRegion - pE->nRegion );
}

/************************************
 ȡƷӳϢ->
 ڲint          -- 
           const char * -- Ʒ
           const char * -- ɲƷID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_pmapO(int nRegion, const char *pProdTyp, const char *pOldPID, char *pOutBuf)
{
    char *pO, szBuf[64];

    UAP_PMAP sR, *pT, *p = NULL;

    if( pProdTyp == NULL || *pProdTyp == 0 ) return(0);
    if( pOldPID == NULL || *pOldPID == 0 ) return(0);

    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    sR.nRegion = nRegion;
    strcpy(sR.szProdType, pProdTyp);
    strcpy(sR.szOldPID, pOldPID);

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nValid[RN_PMAP] && u_pGInf->nPMap )
    {
        pT = u_pGInf->sPMap + u_pGInf->nPMap;
        p = (UAP_PMAP *) bsearch(&sR, pT, u_pGInf->nPMap, sizeof(UAP_PMAP), u_pmapOcpr);
        if( p == NULL )
        {
            sR.nRegion = 999;
            p = (UAP_PMAP *) bsearch(&sR, pT, u_pGInf->nPMap, sizeof(UAP_PMAP), u_pmapOcpr);
        }
        if( p ) memcpy(&sR, p, sizeof(UAP_PMAP));
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // TLV
    u_packTLV(&pO, sR.szProdID, T_PRODID);
    u_packTLV(&pO, sR.szBizCode, T_OLDBIZCODE);
    sprintf(szBuf, "%d", sR.cOperType);
    u_packTLV(&pO, szBuf, T_OPERTYPE);
    *pO = 0;

    return(1);
}

/****************************
 ƷӳϢȽϺ->
 ****************************/
int u_pmapNcpr(const void *k, const void *e)
{
    return( strcmp((char *)k, ((UAP_PMAP *) e)->szProdID) );
}

/************************************
 ȡƷӳϢ->
 ڲconst char * -- ƷID
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_pmapN(const char *pProdID, char *pOutBuf)
{
    char *pO, szBuf[64];

    UAP_PMAP sR = {0}, *p = NULL;

    if( pProdID == NULL || *pProdID == 0 ) return(0);
    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nValid[RN_PMAP] && u_pGInf->nPMap )
    {
        p = (UAP_PMAP *) bsearch(pProdID, u_pGInf->sPMap, u_pGInf->nPMap, sizeof(UAP_PMAP), u_pmapNcpr);
        if( p ) memcpy(&sR, p, sizeof(UAP_PMAP));
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // TLV
    u_packTLV(&pO, sR.szOldPID, T_OLDPRODID);
    sprintf(szBuf, "%d", sR.cOperType);
    u_packTLV(&pO, szBuf, T_BUSITYPE);
    *pO = 0;

    return(1);
}

/************************************
 ȡиϢ
 ڲint          -- 
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_cutover(int nRegion, char *pOutBuf)
{
    int   i;
    char *pO, szBuf[64];

    UAP_CUTOVER sR = {0, 0};

    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    for( i = 0; i < u_pGInf->nCutOver; i++ )
    {
        if( u_pGInf->sCutOver[i].nRegion == nRegion )
        {
            memcpy(&sR, &(u_pGInf->sCutOver[i]), sizeof(UAP_CUTOVER));
            break;
        }
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( sR.nRegion == 0 ) return(0);

    // TLV
    sprintf(szBuf, "%d", sR.cCutOver);
    u_packTLV(&pO, szBuf, T_CUTOVER);
    *pO = 0;

    return(1);
}

/**********************************
 õиӱ־
 ڲint          -- 
           int          -- ӱ־
 ֵ  -1ʧ  0޼¼  1ɹ
 **********************************/
int u_set_cutover(int nRegion, int nCutOver)
{
    int   i, nFound = 0;

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 ) return(-1);

    for( i = 0; i < u_pGInf->nCutOver; i++ )
    {
        if( u_pGInf->sCutOver[i].nRegion == nRegion )
        {
            if( nCutOver != -1 ) u_pGInf->sCutOver[i].cCutOver = nCutOver;
            nFound = 1;
            break;
        }
    }

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 ) return(-1);

    return(nFound);
}

/****************
 ӦϢȽϺ
 ****************/
int u_urgecpr(const void *k, const void *e)
{
    int r;
    UAP_URGE *pK, *pE;

    pK = (UAP_URGE *) k;
    pE = (UAP_URGE *) e;

    if( (r = strcmp(pK->szChanID, pE->szChanID)) ) return(r);
    return( pK->nRegion - pE->nRegion );
}

/************************************
 ȡӦ״̬Ϣ
 ڲint          -- 
           char *       -- 
           char *       -- Ŀ껺
 ֵ  -1ʧ  0޼¼  1ɹ
 ************************************/
int u_get_urge(int nRegion, const char *pChannel, char *pOutBuf)
{
    char *pO, szBuf[64];

    UAP_URGE sR, *p = NULL;

    if( pChannel == NULL || *pChannel == 0 ) return(0);
    if( pOutBuf == NULL ) return(0);
    pO = pOutBuf;

    sR.nRegion = nRegion;
    strncpy(sR.szChanID, pChannel, sizeof(sR.szChanID) - 1);
    sR.szChanID[sizeof(sR.szChanID) - 1] = 0;

    // ٽ鿴
    if( u_Xzone_read(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nUrge )
    {
        p = (UAP_URGE *) bsearch(&sR, u_pGInf->sUrge, u_pGInf->nUrge, sizeof(UAP_URGE), u_urgecpr);
        if( p ) memcpy(&sR, p, sizeof(UAP_URGE));
    }

    // ٽ
    if( u_Xzone_read(X_OUT) < 0 ) return(-1);

    if( p == NULL ) return(0);

    // TLV
    sprintf(szBuf, "%d", sR.cECrm);
    u_packTLV(&pO, szBuf, T_URGCRM);
    sprintf(szBuf, "%d", sR.cEBoss);
    u_packTLV(&pO, szBuf, T_URGBOSS);
    sprintf(szBuf, "%d", sR.cERes);
    u_packTLV(&pO, szBuf, T_URGRES);
    sprintf(szBuf, "%d", sR.cMsgBlock);
    u_packTLV(&pO, szBuf, T_MSGBLOCK);
    u_packTLV(&pO, sR.szRepMsg, T_BLOCKMSG);
    *pO = 0;

    return(1);
}

/**********************************
 Ӧ״̬
 ڲint      -- 
           char *   -- 
           char *   -- Ӧ״̬
           char *   -- ״̬ʱ
 ֵ  -1ʧ  0޼¼  1ɹ
 **********************************/
int u_set_urge(int nRegion, const char *pChannel, const char *pUrge, const char *pTime)
{
    char *p, szTmp[8], szTime[16];
    int   nFound = 0;

    // Ӧ״̬
    int   nECrm, nEBoss, nERes;

    UAP_URGE sR, *pR = NULL;

    if( pChannel == NULL || *pChannel == 0 ) return(0);
    if( pUrge == NULL || *pUrge == 0 ) return(0);

    // ״̬ʱ
    if( pTime == NULL || *pTime == 0 )
    {
        z_get_dt(szTime, 14, "f", 0);
    }
    else
    {
        strncpy(szTime, pTime, sizeof(szTime) - 1);
        szTime[sizeof(szTime) - 1] = 0;
    }

    // Ӧ״̬
    p = (char *)pUrge;

    z_get_fieldv(&p, szTmp, NULL, sizeof(szTmp) - 1, ",");
    nECrm = (int) strtol(szTmp, (char **)NULL, 10);

    z_get_fieldv(&p, szTmp, NULL, sizeof(szTmp) - 1, ",");
    nEBoss = (int) strtol(szTmp, (char **)NULL, 10);

    z_get_fieldv(&p, szTmp, NULL, sizeof(szTmp) - 1, ",");
    nERes = (int) strtol(szTmp, (char **)NULL, 10);

    sR.nRegion = nRegion;
    strncpy(sR.szChanID, pChannel, sizeof(sR.szChanID) - 1);
    sR.szChanID[sizeof(sR.szChanID) - 1] = 0;

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 ) return(-1);

    // ֲ
    if( u_pGInf->nUrge )
    {
        pR = (UAP_URGE *) bsearch(&sR, u_pGInf->sUrge, u_pGInf->nUrge, sizeof(UAP_URGE), u_urgecpr);
        if( pR )
        {
            if( nECrm  != -1 ) pR->cECrm  = nECrm;
            if( nEBoss != -1 ) pR->cEBoss = nEBoss;
            if( nERes  != -1 ) pR->cERes  = nERes;

            strcpy(pR->szETime, szTime);
            nFound = 1;
        }
    }

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 ) return(-1);

    return(nFound);
}

#ifdef  __cplusplus
}
#endif

int CUapApi::mKey = 0;

void CUapApi::setIPCKey(key_t aKey)
{
    mKey = aKey;
}

int CUapApi::getIPC(key_t aKey)
{
    return( u_get_ipc(aKey) );
}

void CUapApi::ungetIPC(void)
{
    u_unget_ipc();
}

int CUapApi::getNodeInf(const char *pNodeID, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_nodeinf(pNodeID, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::doIPAuth(const char *pNodeID, const char *pIP)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_do_ipauth(pNodeID, pIP);
    ungetIPC();

    return(r);
}

int CUapApi::doUserAuth(const char *pNodeID, const char *pUser, const char *pPass)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_do_userauth(pNodeID, pUser, pPass);
    ungetIPC();

    return(r);
}

int CUapApi::getBusiInf(const char *pNodeID, const char *pChanID, const char *pProtID, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_busiinf(pNodeID, pChanID, pProtID, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::getH3Inf(const char *pTel, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_h3inf(pTel, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::getRCodeInf(const char *pChanID, const char *pBusiID, const char *pFrom, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_rcodeinf(pChanID, pBusiID, pFrom, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::getPMapO(int nRegion, const char *pProdTyp, const char *pOldPID, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_pmapO(nRegion, pProdTyp, pOldPID, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::getPMapN(const char *pProdID, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_pmapN(pProdID, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::getCutOver(int nRegion, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_cutover(nRegion, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::setCutOver(int nRegion, int nCutOver)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_set_cutover(nRegion, nCutOver);
    ungetIPC();

    return(r);
}

int CUapApi::getUrge(int nRegion, const char *pChannel, char *pOutBuf)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_get_urge(nRegion, pChannel, pOutBuf);
    ungetIPC();

    return(r);
}

int CUapApi::setUrge(int nRegion, const char *pChannel, const char *pUrge, const char *pTime)
{
    int r;

    if( getIPC(mKey) < 0 ) return(-1);
    r = u_set_urge(nRegion, pChannel, pUrge, pTime);
    ungetIPC();

    return(r);
}

