/***********************************************************************
*
* ļ        GDLog.cpp
* ģĿģ¼ˮ־CLogFileʵ֣
* ߼ڣ  wang_jin 2009-05-24
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#include "Common/Common.h"
#include "FileOpt/FileOpt.h"
#include "GDLock/GDLock.h"
#include "GDLog/GDLog.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"

#ifdef _WIN32
#	include <windows.h>
#endif
#include <time.h>
#include <stdarg.h>


void CGDLog::WriteCorLog( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "cor" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteErrLog( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "err" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
	else
	{
		va_list args;
		va_start( args, fmt );
		GDETrace2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteSysLog( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "sys" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteSecLog( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "sec" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteWatcherEvent( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "watcher" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteNofierEvent( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "watcher" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteScannerEvent( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "scanner" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteFilterEvent( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "filter" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteDriverEvent( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "driver" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteMonitorEvent( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "monitor" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteEventList( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "evtlist" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteTaskList( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "tasklist" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteSendList( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "sendlist" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteFileList( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "filelist" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteMsgList( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "msglist" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

void CGDLog::WriteLegalList( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "legalist" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}

//¼߳״̬
void CGDLog::WriteThreadState( const char* fmt, ... )
{
	static bool bInitialied = false;
	static CLogFile * pLog = NULL;

	if ( ! bInitialied )
	{
		bInitialied = true;
		// ʼ
		pLog = CLogFile::InitLogFile( "thread" );
	}

	if ( pLog )
	{
		va_list args;
		va_start( args, fmt );
		bool bRet = pLog->WriteLog2( fmt, args );
		va_end( args );
	}
}
