/******************************************************************************
*
* ļ              GDTraceEx.cpp
* ģĿģ      ¼־
* ߼ڣ        wang_jin 2007-12-27
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            wang_jin 2008-07-12
*
******************************************************************************/

#pragma warning( disable: 4251 4541 4786 )

#include "Common/DateTime.h"
#include "GDLog/ThreadData.h"
#include "GDTraceEx.h"

#include <stdarg.h>


void CGDTraceEx::TraceInfo( int n, enumLogLevel level, const char* fmt, va_list argp )
{
	// ȡ߳Ϣа־Ϣļ + ţ+ţ
	CThreadData * pThreadData = CThreadData::GetCurrentThreadData(); // ߳
	if ( NULL == pThreadData )
	{
		return ; // ûΪ̶߳߳ݶ
	}

	// ̺ͨ߳Ƿͬ״δ־ļ
	CLogFile * pTraceFile = pThreadData->GetTraceFile();
	if ( NULL == pTraceFile )
	{
		return ; // ûΪ̶߳־
	}
	
	// ¼־
	if ( n < 0 ) pThreadData->m_nIndent += n;

	char strDateTime[20] = {0};
	CDateTime::FormatCurrentTime( strDateTime, "%mm-%dd %HH:%MM:%SS", sizeof( strDateTime ) );

	char szIndent[] = "|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-";
	if ( pThreadData->m_nIndent < 0 ) pThreadData->m_nIndent = 0;
	szIndent[ 2 + pThreadData->m_nIndent * 2 ] = '\0';

	char prefix[260] = {0};
	sprintf(prefix, "%s.%4d PN:%08x SN:%08x NO.%-6u Tid:%-4x LVL:%d %s", 
			strDateTime, 
#ifdef WIN32
			GetTickCount() % 10000, 
#else
			clock() * 10000 / CLOCKS_PER_SEC, 
#endif
			pThreadData->m_nSerial, pThreadData->m_nSubSerial, pThreadData->m_nRecSerial++, 
			pThreadData->m_nThreadId, level, szIndent);

	pTraceFile->WriteFile( prefix, fmt, argp );

	if ( n > 0 ) pThreadData->m_nIndent += n;
}

void CGDTraceEx::TraceIn( enumLogLevel level, const char* fmt, va_list argp )
{
	TraceInfo( 1, level, fmt, argp );
}

void CGDTraceEx::Trace( enumLogLevel level, const char* fmt, va_list argp )
{
	TraceInfo( 0, level, fmt, argp );
}

void CGDTraceEx::TraceOut( enumLogLevel level, const char* fmt, ... )
{
	va_list args;
	va_start( args, fmt );
	TraceInfo( -1, level, fmt, args );
	va_end( args );
}
