/***********************************************************************
*
* ļ        LogConfig.cpp
* ģĿģ¼־Ϣ
* ߼ڣ  wang_jin 2009-03-03
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼	  
*
***********************************************************************/

#pragma warning( disable: 4251 4786 )

#include "FileOpt/FileOptDef.h"
#include "GDLock/GDLock.h"
#include "GDLog/ThreadData.h"
#include "GDLog/LogConfig.h"
#include "TinyXml/tinyxml.h"
#include "GDTraceEx.h"
#include "GDLog/GDTrace.h"

#include <map>
#ifdef WIN32
#	include <windows.h>
#else
#endif


CThreadMutex CLogConfig::m_mutex;
map < string, CLogConfig* > CLogConfig::m_logInfo;
bool CLogConfig::m_bInitialized = false;

CLogConfig::CLogConfig( const char* sLogName )
:m_sLogName(sLogName), m_nLogCount(8), m_nLogSize(8), m_bScroll(false)	// m_bScrollĳʼ by liu_yfeng 2009-04-08
{
}

CLogConfig::~CLogConfig()
{
}

void CLogConfig::SetLogConfig( const char* sLogName, bool bScroll, int nSize, int nCount, const char* sLogPath )
{
	try
	{
		CLogConfig* pLogConfig = NULL;
		CThreadLock lock(m_mutex);
		map< string, CLogConfig* >::iterator iter = m_logInfo.find( sLogName );
		
		if ( iter == m_logInfo.end() )
		{
			pLogConfig = new CLogConfig( sLogName );
#ifdef NOT_USE_STD_LIB
			m_logInfo.insert( map<string, CLogConfig*>::value_type( sLogName, pLogConfig ) );
#else
			m_logInfo.insert( make_pair( sLogName, pLogConfig ) );
#endif
		}
		else 
		{
			pLogConfig = (CLogConfig*)(iter->second);
		}

		pLogConfig->m_bScroll = bScroll;
		pLogConfig->m_nLogSize = nSize;
		pLogConfig->m_nLogCount = nCount;
		if ( sLogPath )
		{
			pLogConfig->m_sLogPath = sLogPath;
		}
	}
	catch ( ... )
	{
		GDETrace("CThreadData:SetLogConfig(...)");
	}
}

bool CLogConfig::LoadLogConfig( const char* sCfgFile, const char* sCfgNode )
{
	try
	{
		TiXmlDocument doc;
		if ( ! doc.LoadFile( sCfgFile ) )
		{
			// ݴ
			return ( false );
		}
		
		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = hDoc.FirstChildElement("option").Element();
		if ( ! pRootElem )
		{
			// ݴ
			( false );
		}
		// ļм־ѡ
		TiXmlElement* pLogElem = NULL;
		pLogElem = pRootElem->FirstChildElement( sCfgNode );
		if ( ! pLogElem )
		{
			// ݴ
			return ( false );
		}
		const char* pLogAvailable = pLogElem->Attribute( "available" );
		if ( pLogAvailable && *pLogAvailable == '1' )
		{
			// ־
			int nLevel = LOG_WAR;
			int nSize = 8; // MBytes
			int nCount = 9;
			int nScroll = 1;
			const char* pLogParam = NULL;
			pLogParam = pLogElem->Attribute( "level" );
			if ( pLogParam && *pLogParam )
			{
				nLevel = atoi( pLogParam );
			}
			pLogParam = pLogElem->Attribute( "size" );
			if ( pLogParam && *pLogParam )
			{
				nSize = atoi( pLogParam );
			}
			pLogParam = pLogElem->Attribute( "count" );
			if ( pLogParam && *pLogParam )
			{
				nCount = atoi( pLogParam );
			}
			pLogParam = pLogElem->Attribute( "scroll" );
			if ( pLogParam && *pLogParam )
			{
				nScroll = atoi( pLogParam );
			}
			
			TiXmlElement* pCommonLogElem = NULL;
			pCommonLogElem = pLogElem->FirstChildElement( "common" );
			if ( pCommonLogElem )
			{
				const char* pCommonLogAvailable = pCommonLogElem->Attribute( "available" );
				if ( pCommonLogAvailable && *pCommonLogAvailable == '1' )
				{
					// ¼common־
					int lnLevel = nLevel;
					int lnSize = nSize; // MBytes
					int lnCount = nCount;
					int lnScroll = nScroll;
					const char* pCommonLogParam = NULL;
					pCommonLogParam = pCommonLogElem->Attribute( "level" );
					if ( pCommonLogParam && *pCommonLogParam )
					{
						lnLevel = atoi( pCommonLogParam );
					}
					pCommonLogParam = pLogElem->Attribute( "size" );
					if ( pCommonLogParam && *pCommonLogParam )
					{
						lnSize = atoi( pCommonLogParam );
					}
					pCommonLogParam = pLogElem->Attribute( "count" );
					if ( pCommonLogParam && *pCommonLogParam )
					{
						lnCount = atoi( pCommonLogParam );
					}
					pCommonLogParam = pLogElem->Attribute( "scroll" );
					if ( pCommonLogParam && *pCommonLogParam )
					{
						lnScroll = nScroll==1 ? atoi( pCommonLogParam ) : nScroll;
					}

					if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "coravailable" )) && (*pCommonLogAvailable == '1') )
					CLogConfig::SetLogConfig( "cor", lnScroll==1, lnSize, lnCount );

					if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "erravailable" )) && (*pCommonLogAvailable == '1') )
					CLogConfig::SetLogConfig( "err", lnScroll==1, lnSize, lnCount );

					if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "secavailable" )) && (*pCommonLogAvailable == '1') )
					CLogConfig::SetLogConfig( "sec", lnScroll==1, lnSize, lnCount );

					if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "sysavailable" )) && (*pCommonLogAvailable == '1') )
					CLogConfig::SetLogConfig( "sys", lnScroll==1, lnSize, lnCount );

					if ( *sCfgNode == 'l' ) // log for ma & sa
					{
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "watcher" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "watcher", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "watcher" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "watcher", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "scanner" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "scanner", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "filter" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "filter", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "driver" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "driver", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "monitor" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "monitor", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "evtlist" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "evtlist", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "legalist" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "legalist", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "tasklist" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "tasklist", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "sendlist" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "sendlist", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "filelist" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "filelist", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "msglist" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "msglist", lnScroll==1, lnSize, lnCount );
						
						if ( (pCommonLogAvailable = pCommonLogElem->Attribute( "thread" )) && (*pCommonLogAvailable == '1') )
							CLogConfig::SetLogConfig( "thread", lnScroll==1, lnSize, lnCount );
					}
				}
			}

			TiXmlElement* pTraceLogElem = NULL;
			pTraceLogElem = pLogElem->FirstChildElement( "trace" );
			if ( pTraceLogElem )
			{
				const char* pTraceLogAvailable = pTraceLogElem->Attribute( "available" );
				if ( pTraceLogAvailable && *pTraceLogAvailable == '1' )
				{
					// ¼trace־
					int lnLevel = nLevel;
					int lnSize = nSize; // MBytes
					int lnCount = nCount;
					int lnScroll = nScroll;
					const char* pTraceLogParam = NULL;
					pTraceLogParam = pTraceLogElem->Attribute( "level" );
					if ( pTraceLogParam && *pTraceLogParam )
					{
						lnLevel = atoi( pTraceLogParam );
					}

					CGDTrace::m_nLevel = (enumLogLevel)lnLevel;

					pTraceLogParam = pLogElem->Attribute( "size" );
					if ( pTraceLogParam && *pTraceLogParam )
					{
						lnSize = atoi( pTraceLogParam );
					}
					pTraceLogParam = pLogElem->Attribute( "count" );
					if ( pTraceLogParam && *pTraceLogParam )
					{
						lnCount = atoi( pTraceLogParam );
					}
					pTraceLogParam = pLogElem->Attribute( "scroll" );
					if ( pTraceLogParam && *pTraceLogParam )
					{
						lnScroll = nScroll==1 ? atoi( pTraceLogParam ) : nScroll;
					}

					if ( *sCfgNode == 'l' ) // log for ma & sa
					{
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "mainavailable" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "main", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "eventavailable" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "event", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "filetranavailable" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "file", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "messageavailable" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "msg", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "corbaavailable" )) && (*pTraceLogAvailable == '1') )
						{
							CLogConfig::SetLogConfig( "fileserver", lnScroll==1, lnSize, lnCount );
							CLogConfig::SetLogConfig( "dirserver", lnScroll==1, lnSize, lnCount );
							CLogConfig::SetLogConfig( "wmserver", lnScroll==1, lnSize, lnCount );
						}
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "dbtree" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "dbtree", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "dust" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "dust", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "filter" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "filter", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "manager" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "manager", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "run" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "run", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "task" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "task", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "watch" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "watch", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "scan" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "scan", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "event0" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "event0", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "file0" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "file0", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "msg0" )) && (*pTraceLogAvailable == '1') )
							CLogConfig::SetLogConfig( "msg0", lnScroll==1, lnSize, lnCount );
					}
					else if ( *sCfgNode == 'f' ) // log for filter
					{
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "tamperavailable" )) && (*pTraceLogAvailable == '1') )
						CLogConfig::SetLogConfig( "tam", lnScroll==1, lnSize, lnCount );
						
						if ( (pTraceLogAvailable = pTraceLogElem->Attribute( "injectavailable" )) && (*pTraceLogAvailable == '1') )
						CLogConfig::SetLogConfig( "sql", lnScroll==1, lnSize, lnCount );
					}
				}
				else
				{
					CThreadData::SetEnable(false);
				}
			}
		}
		else
		{
			CThreadData::SetEnable(false);
		}
	}
	catch ( ... )
	{
		// ݴ
		return ( false );
	}

	return ( true );
}

CLogConfig* CLogConfig::GetLogConfig( const char* sLogName )
{
	CLogConfig* pLogConfig = NULL;

	try
	{
		if ( ! m_bInitialized )
		{
			char sOptionConfigName[GD_MAX_PATH] = {0};
			if ( *GetAppName()=='s' ) // sa
			{
				sprintf( sOptionConfigName, "%s%ccfg%csaoption.xml", GetInforGuardPath(), C_PATHLASH, C_PATHLASH );
			}
			else
			{
				sprintf( sOptionConfigName, "%s%ccfg%cmaoption.xml", GetInforGuardPath(), C_PATHLASH, C_PATHLASH );
			}
			LoadLogConfig( sOptionConfigName, *GetAppName()=='f'?"filter-log":"log" ); // filter
			m_bInitialized = true;
		}

		string name;
		if ( NULL == sLogName || '\0' == *sLogName )
		{
			CThreadData* pData = CThreadData::GetCurrentThreadData();
			if( !pData )
			{
				return NULL;
			}

			name = pData->m_sLogName;
		}
		else
		{
			name = sLogName;
		}

		CThreadLock lock(m_mutex);
		map< string, CLogConfig* >::iterator iter = m_logInfo.find( name );
		
		if ( iter == m_logInfo.end() )
		{
			// ûУ˵ļû䣬
			return NULL;
		}
		else 
		{
			pLogConfig = (CLogConfig*)(iter->second);
		}
	}
	catch ( ... )
	{
		GDETrace("CThreadData:GetLogConfig(...)");
	}

	return pLogConfig;
}

string CLogConfig::GetDefaultLogFilePath()
{
	string sPath = GetInforGuardPath();
	sPath += S_PATHLASH;
	sPath += "log";
	return sPath;
}
