/*****************
 ɼĻ v3.0
 *****************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <curses.h>
#include <signal.h>
#include <unistd.h>
#include <sys/time.h>
#include "zvar.h"
#include "zvdef.h"
#include "gcps.h"
#include "z.h"

#define    SMON_ITV    1               /* Ļ */
#define    MAX_WIDTH   132             /* ֵ֧Ļ */

static     int    si_cols = 0;         /* Ļȱ */

int main(int argc, char **argv)
{
    int    i, b,
           rlen, llen,
           leftn,

           sortcol = 0,
           isrev = 0;

    FILE  *fp;

    char   aline[CL], bline[CL],
           head[CL * 4],               /* ͷϢ */
           head1[CL],
           msg[CL + 128];

    char  *p,
           cmd[CL],
           filename[CL],               /* ɼϢʱļ */
           tmstr[20],                  /* ʱַ */
           pstat[10],                  /* ״̬ */
           warnnot[8],

           value[65],
           note_type[16],
           note_desc[17];

    uid_t  myuid;                      /* ûuid */

    myuid = 0;

    if( argc < 2 )
    {
        printf("Usage: %s ļ  ?\n", argv[0]);
        return(0);
    }

    if( argc > 2 ) sortcol = (int) strtol(argv[2], (char **)NULL, 10);
    if( argc > 3 ) isrev = (int) strtol(argv[3], (char **)NULL, 10);

    sprintf(filename, "%s/zmonfile.%d", ATMPDIR, getpid());

    /* ȡò */
    strcpy(u_pcfgfile, argv[1]);

    if( f_para_read() < 0 ) return(2);

    /* 趨ˢ */
    z_set_refresh(SMON_ITV, 0);

    /* ʼĻ */
    z_initscr();

    si_cols = COLS > MAX_WIDTH ? MAX_WIDTH : COLS;

    /* ͷ */
    for( i = 0; i < si_cols; i++ ) aline[i] = '*';
    aline[i] = 0;
    for( i = 0; i < si_cols; i++ ) bline[i] = '-';
    bline[i] = 0;

    strcpy(msg, "ɼĻ  V3.0");
    b = strlen(msg);

    llen = (si_cols - 2 - b) / 2;
    rlen = si_cols - 2 - b - llen;

    snprintf(head1, sizeof(head1), "%-8s %-8s %-16s %-16s %-3s %-8s%-4s %-8s %-17s %s",
        "ֹ˾", "ɼ", "", "", "?", "״̬", "ʣ", "ʱ", "ʱ", "ļ");

    snprintf(head, sizeof(head), "%s\n*%*s%s%*s*\n%s\n%s\n%s",
        aline, llen, "", msg, rlen, "", aline, head1, bline);

    myuid = geteuid();

    while( 1 )
    {
        /* ӹڴ */
        if( f_conn_zshm(u_zkey, 0) == NULL )
        {
            standout();
            mvprintw(1, 0, "ƽֹ̨");
            standend();
            refresh();
            sleep(1);
            break;
        }

        if( (fp = fopen(filename, "w")) == NULL )
        {
            standout();
            mvprintw(1, 0, "ʱļ %s ! Ŀ¼üļȨ", filename);
            standend();
            refresh();
            sleep(3);
            break;
        }

        u_pcfgs = u_cfgs;
        u_pruns = u_runs;

        for( i = 0; i < MAXN_Z; u_pcfgs++, u_pruns++, i++ )
        {
            if( u_pcfgs->no[0]  == 0 ) continue;

            if( myuid && (myuid != GC_getuid(NULL, u_pruns->pslot)) ) continue;

            /* ״̬ */
            switch( GC_getstat(NULL, u_pruns->pslot) )
            {
            case ST_STOPPING:               /* ֹͣ */
            case ST_STOPPED:                /* Ϊֹ */
                strcpy(pstat, "Ϊֹ");
                break;

            case ST_RELEASED:               /* ͷ */
                continue;

            default:
                if( u_pruns->errtime )
                    strcpy(pstat, "");
                else
                    strcpy(pstat, "");
            }

            note_type[0] = 0;
            note_desc[0] = 0;

            p = u_pcfgs->desc;
            z_get_fieldv(&p, value, NULL, 8, "|");
            z_get_fieldv(&p, value, NULL, 8, "|");

            /* ɼ */
            b = z_chi_nohalf(value, 8);
            strncpy(note_type, value, b);
            note_type[b] = 0;

            z_get_fieldv(&p, value, NULL, 16, "|");

            /* Ϣ */
            b = z_chi_nohalf(value, 16);
            strncpy(note_desc, value, b);
            note_desc[b] = 0;

            /* ϴβɼʱ */
            tmstr[0] = 0;
            if( u_pruns->endtime ) z_get_dt(tmstr, 8, "t", u_pruns->endtime);

            /* ʣļĿ */
            leftn = u_pruns->leftfiles > 9999 ? 9999 : u_pruns->leftfiles;

            if( u_pcfgs->warn_mode[WF_ALL] == '1' )
                strcpy(warnnot, "");
            else
                strcpy(warnnot, "");

            fprintf(fp, "%-8s %-8s %-16s %-16.16s %-3s %-8s%4d %-8s %-17.17s %s\n",
                u_pruns->uname, note_type, note_desc, u_pcfgs->no, warnnot, pstat, leftn,
                tmstr, u_pruns->hdftime, u_pruns->currfile);

            if( u_pruns->errtime )
            {
                z_get_dt(tmstr, 19, "l", u_pruns->errtime);
                fprintf(fp, "%s %s\n", tmstr, u_pruns->errmsg);
            }
        }
        fclose(fp);

        /* Ͽӹڴṹ */
        f_disconn_zshm();

        if( sortcol > 0 )
        {
            snprintf(cmd, sizeof(cmd), "%s -k%d %s > %s.sort; mv %s.sort %s",
                isrev > 0 ? "sort -b -r" : "sort -b",
                sortcol, filename, filename, filename, filename);

            system(cmd);
        }

        /* ʾļ */
        if( z_disscr(filename, head, si_cols) < 0 ) break;
    }

    unlink(filename);
    z_endwin();

    exit(0);
}
