/************
 UAP 
 ************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <errno.h>
#include <unistd.h>
#include "uap_fdecl.h"
#include "uap_gvdecl.h"
#include "uap_agent.h"
#include "gcps.h"
#include "z.h"

#define   L_USAGEINF        60      /* ʾϢ */

// ָ
int u_socket_cmd(const char *pCfg, const char *pTCode,
                 const char *pHostID, const char *pReq);

/****************
 ʾʹð
 ****************/
static void u_show_usage(void)
{
    printf("* -c <cfgfile> -h <hostid> -t <tcode> -b <body>            *\n");
    printf("*                                                          *\n");
    printf("* -c cfgfile         --  Լļ            *\n");
    printf("* -h hostid          --  Ŀʶ                      *\n");
    printf("* -t tcode           --  ״                          *\n");
    printf("* -b body            --  ָ岿                  *\n");
    printf("************************************************************\n");
}

//===================================================================
//

int main(int argc, char **argv)
{
    int   c, b,
          fc, fh, ft, fb;                   /* ѡ־ */

    int   nLen, nLeftL, nRightL;

    char  szBuf[128],
          szCfgFile[256],                   /* ļ */
          szHostID[64],                     /* ʶ */
          szTCode[8],                       /* ״ */
          szBody[256];                      /* ָ */

    struct sigaction sa;
    sigset_t st;

    // źŴ
    sigemptyset(&sa.sa_mask);
    sa.sa_flags = 0;

    // INTQUITź
    sa.sa_handler = SIG_IGN;
    sigaction(SIGINT,  &sa, NULL);
    sigaction(SIGQUIT, &sa, NULL);

    // ָ TERM źŴ
    sa.sa_handler = SIG_DFL;
    sigaction(SIGTERM, &sa, NULL);

    /* ܵ TERM ź */
    sigemptyset(&st);
    sigaddset(&st, SIGTERM);

    sigprocmask(SIG_UNBLOCK, &st, NULL);

    // ʾʾϢ
    printf("************************************************************\n");
    printf("*                    UAP control center                    *\n");

    sprintf(szBuf, "For %s  Ver %s (%s %s)", OSNOTE, VER, MAKEDATE, MAKETIME);

    nLen = strlen(szBuf);
    nLeftL = (L_USAGEINF - 2 - nLen) / 2;
    nRightL = L_USAGEINF - 2 - nLen - nLeftL;

    printf("*%*s%s%*s*\n", nLeftL, "", szBuf, nRightL, "");
    printf("************************************************************\n");

    // ʼ
    b = c = 0;
    fc = fh = ft = fb = 0;

    szCfgFile[0] = 0;
    szHostID[0] = 0;
    szTCode[0] = 0;
    szBody[0] = 0;

    while( (c = getopt(argc, argv, ":c:h:t:b:")) != -1 )
    {
        switch (c)
        {
        case 'c':                           /* ļ */
            fc ++;
            strncpy(szCfgFile, optarg, sizeof(szCfgFile) - 1);
            szCfgFile[sizeof(szCfgFile) - 1] = 0;
            break;

        case 'h':                           /* ʶ */
            fh ++;
            strncpy(szHostID, optarg, sizeof(szHostID) - 1);
            szHostID[sizeof(szHostID) - 1] = 0;
            break;

        case 't':                           /* ״ */
            ft ++;
            strncpy(szTCode, optarg, sizeof(szTCode) - 1);
            szTCode[sizeof(szTCode) - 1] = 0;
            break;

        case 'b':                           /*  */
            fb ++;
            strncpy(szBody, optarg, sizeof(szBody) - 1);
            szBody[sizeof(szBody) - 1] = 0;
            break;

        case ':':                           /* ȱѡ */
        case '?':                           /* Чѡ */
            b = -1;
            break;
        }
    }

    /* ﷨ */
    if( b == 0 )
    {
        /* ѡָ */
        if( (fc != 1 || fh != 1 || ft != 1 || fb != 1) ||

            (optind < argc) )               /*  */
        {
             b = -1;
        }
    }

    if( b < 0 )
    {
        u_show_usage();                     /* ʾ */
        return(1);
    }

    //--------------------------------------------------------
    if( strcmp(szTCode, TC_UPDATECFG) == 0 ||   /* ļ */
        strcmp(szTCode, TC_CMDEXEC) == 0 )      /* ִָ */
    {
        u_socket_cmd(szCfgFile, szTCode, szHostID, szBody);
    }
    else
    {
        printf("ЧĽ״%s\n", szTCode);
    }

    return(0);
}

/**********************************
 ָ
 ڲconst char * -- ļ
           const char * -- ״
           const char * -- ʶ
           const char * -- 
 **********************************/
int u_socket_cmd(const char *pCfg, const char *pTCode,
                 const char *pHostID, const char *pReq)
{
    char    *p,
             szFile[64],
             szIP[64],
             szPort[64],
             szBuf[64];

    uint16_t nPort;

    // ȡļ
    if( GC_read_cfg(pCfg) < 0 )
    {
        printf("󣺶ȡļ %s ʧ\n", pCfg);
        return(-1);
    }

    // ȡļIP˿
    if( z_readini(pCfg, SG_HOSTID, pHostID, szBuf, sizeof(szBuf) - 1, 0) )
    {
        printf("󣺶ȡϢʧ %s\n", pHostID);
        return(-1);
    }

    // ֽIP˿
    p = szBuf;

    z_get_fieldv(&p, szIP, NULL, sizeof(szIP) - 1, ":");
    z_get_fieldv(&p, szPort, NULL, sizeof(szPort) - 1, ":");

    nPort = (uint16_t) strtol(szPort, (char **)NULL, 10);

    // ӷ
    printf(" %s ... ", szBuf);
    fflush(stdout);

    if( GC_topencn(szIP, nPort) < 0 )
    {
        printf("Failed.\n");
        return(-1);
    }
    printf("OK.\n");

    // 
    GC_setpheadn(pTCode, 2);

    if( GC_sendtextc(pReq) < 0 )
    {
        printf("󣺷\n");
        return(-1);
    }
    printf("Ok, ȴӦ ... ");
    fflush(stdout);

    // ļʽӦ
    strcpy(szFile, ".tmpout.uapcc");

    if( GC_sock_frcvc(szFile, 0, 0, NULL) < 0 )
    {
        printf("Failed.\n");
        return(-1);
    }
    printf("OK.\n");

    // ʾļ
    snprintf(szBuf, sizeof(szBuf), "cat %s", szFile);
    system(szBuf);

    // ɾļ
    unlink(szFile);

    return(0);
}
