//======================================================================
// 
// Event.c
//
// Copyright (C) CVIC Software Engineering CO.,LTD.
//
// ¼
// 
//======================================================================


#include "Event.h"
#include "Define.h"


// ¼,Ӧϵ¼
ULONG		gEventSequence = 0;

// ¼ͷ
PEVENT_LIST			gStoreHead = NULL;
// ¼ĵǰֵ
PEVENT_LIST			gStoreNext = NULL;

// ¼жд
KSPIN_LOCK          gStoreMutex;

// ¼ǰĸ
ULONG				gNumStore = 0;
// ¼洢
ULONG               gMaxStore = 1000000/MAX_STORE;


VOID InitEvent()
{
	KeInitializeSpinLock( &gStoreMutex );
}


VOID ClearSequence()
{
	gEventSequence = 0;
}

// ¼
VOID ClearEvent()
{
	KIRQL oldirql;
	PEVENT_LIST oldStore;

	KeAcquireSpinLock( &gStoreMutex, &oldirql );

	while( gStoreHead )
	{
		oldStore = gStoreHead;
		gStoreHead = gStoreHead->pNext;
		ExFreePool( oldStore );
	}

	gNumStore = 0;
	gStoreHead = NULL;
	gStoreNext = NULL;

	KeReleaseSpinLock( &gStoreMutex, oldirql );
}

// ¼ȡ¼,GUIȡ¼
VOID GetEvent( OUT PVOID OutputBuffer OPTIONAL, OUT PIO_STATUS_BLOCK IoStatus )
{
	KIRQL oldirql;
	KeAcquireSpinLock( &gStoreMutex, &oldirql );

	if ( gStoreHead )
	{
		PEVENT_LIST storTemp = gStoreHead;
		gStoreHead = gStoreHead->pNext;

		memcpy( OutputBuffer, &storTemp->event, sizeof(EVENT_ITEM) );
		IoStatus->Information = sizeof(EVENT_ITEM);

		ExFreePool( storTemp );
		gNumStore--;
	}
	else
	{
		IoStatus->Information = 0;
	}

	KeReleaseSpinLock( &gStoreMutex, oldirql );
}

// ¼¼,ϵ¼¼б
VOID AddEvent( MYULONG pid, ULONG type, PCHAR pPath )
{
	KIRQL              oldirql;
	
	KeAcquireSpinLock( &gStoreMutex, &oldirql );

	// ֵ,ټ
	if ( gNumStore >= gMaxStore )
	{
		KeReleaseSpinLock( &gStoreMutex, oldirql );
		return;
	}

	if ( NULL == gStoreHead )
	{
		gStoreHead = ExAllocatePool( NonPagedPool, sizeof(EVENT_LIST) );
		gStoreNext = gStoreHead;
	}
	else
	{
		gStoreNext->pNext = ExAllocatePool( NonPagedPool, sizeof(EVENT_LIST) );
		gStoreNext = gStoreNext->pNext;
	}
	gStoreNext->event.seq = InterlockedIncrement(&gEventSequence);
	KeQuerySystemTime( &gStoreNext->event.time );
	gStoreNext->event.pid = pid;
	gStoreNext->event.type = type;
	strcpy( gStoreNext->event.path, pPath );
	gStoreNext->pNext = NULL;
	gNumStore++;

	KeReleaseSpinLock( &gStoreMutex, oldirql );
}

