//======================================================================
// 
// Filter.c
//
// Copyright (C) CVIC Software Engineering CO.,LTD.
//
// ͨõķ
// 
//======================================================================


//#include <ntstrsafe.h>
#include <stddef.h>
#include "Filter.h"
#include "Policy.h"

// ϵͳƫ
#ifdef _X86_
#	define W2000_PROCESS_PEB_OFFSET						0		//0x01B0	2000+xp(֧)

#	define W2003_PROCESS_PEB_OFFSET						0x0190				//nosp(OK,Թ)
#	define W2003_PROCESS_PEB_OFFSET_SP1					0x01A0				//SP1(OK,Թ)
#	define W2003_PROCESS_PEB_OFFSET_SP2					0x01A0				//sp2 (OK,Թ)

#	define W2008_PROCESS_PEB_OFFSET						0x0188				//nosp(ûз,ûв)	// ûвԻ
#	define W2008_PROCESS_PEB_OFFSET_SP1					0x0188				//SP1(OK,Թ)
#	define W2008_PROCESS_PEB_OFFSET_SP2					0x0188				//sp2(޷,Թ)

#	define PROCESS_PARAMETERS_OFFSET					0x0010
#	define IMAGE_PATH_NAME_OFFSET						0x003C
#else
#	define W2000_PROCESS_PEB_OFFSET						0					//2000+xp(֧)

#	define W2003_PROCESS_PEB_OFFSET						0x02C0				//nosp(ûз,ûв)
#	define W2003_PROCESS_PEB_OFFSET_SP1					0x02C0				//SP1 (OK,Թ)
#	define W2003_PROCESS_PEB_OFFSET_SP2					0x02C0				//sp2 (OK,Թ)

#	define W2008_PROCESS_PEB_OFFSET						0x0290				//nosp(ûз,ûв)
#	define W2008_PROCESS_PEB_OFFSET_SP1					0x0290				//SP1(,ûв)
#	define W2008_PROCESS_PEB_OFFSET_SP2					0x0290				//sp2(ûз,ûв)

#	define PROCESS_PARAMETERS_OFFSET					0x0020
#	define IMAGE_PATH_NAME_OFFSET						0x0068

#endif


//
// This is the offset into a KPEB of the current process name. This is determined
// dynamically by scanning the process block belonging to the GUI for the name
// of the system process, in who's context we execute in DriverEntry
ULONG				gProcessNameOffset;

PHASH_ENTRY	        gHashTable[NUMHASH];

PHASH_ENTRY         gFreeHashList = NULL;

//
// Mutex to protect hash table.
KSPIN_LOCK	        gHashMutex;


VOID InitFilter()
{
	ULONG i;

	for(i = 0; i < NUMHASH; i++ )
	{
		gHashTable[i] = NULL;
	}
	// Find the process name offset
	gProcessNameOffset = GetProcessNameOffset();
	KeInitializeSpinLock( &gHashMutex );
}

VOID ClearFilter()
{
	PHASH_ENTRY		hashEntry, nextEntry;
	ULONG		    i;
	KIRQL           oldIrql;

	KeAcquireSpinLock( &gHashMutex, &oldIrql );

	// First, free the hash table entries
	for( i = 0; i < NUMHASH; i++ )
	{
		hashEntry = gHashTable[i];

		while( hashEntry )
		{
			nextEntry = hashEntry->Next;
			ExFreePool( hashEntry->FullPathName );
			ExFreePool( hashEntry );
			hashEntry = nextEntry;
		}

		gHashTable[i] = NULL;
	}

	hashEntry = gFreeHashList;
	while( hashEntry )
	{
		nextEntry = hashEntry->Next;
		ExFreePool( hashEntry );
		hashEntry = nextEntry;
	}
	gFreeHashList = NULL;
	KeReleaseSpinLock( &gHashMutex, oldIrql );
}

// ǷȨ
BOOLEAN IsSuperProcess()
{
	KIRQL  oldirql;
	CHAR                name[MAX_PATH_LEN];
	CHAR				nameEx[MAX_PATH_LEN+2];
	BOOLEAN				ret = FALSE;
	PCWSTR				fullName = GetProcessName();
	size_t					len;
	size_t					i;

	memset( name, 0, MAX_PATH_LEN );
	memset( nameEx, 0, MAX_PATH_LEN+2);

	if ( 0 == fullName || !MmIsAddressValid( (DWORD*)fullName) )
	{
		DbgPrint(( "GuardFileDriver: IsSuperProcess(fullName=NULL)\n" ));
		return FALSE;
	}
	else
	{
		WCHAR wcName[MAX_PATH_LEN];
		memset( wcName, 0, MAX_PATH_LEN );
		wcscpy( wcName, fullName );
		len = wcslen( wcName );

		for ( i=0; i<len; i++ )
		{
			name[i] = (CHAR)wcName[i];
		}

		ToUpper( name );
		strcpy( nameEx, "|" );
		strncat( nameEx, name, MAX_PATH_LEN );
		strcat( nameEx, "|" );

		

		KeAcquireSpinLock( &gFilterMutex, &oldirql );

		DbgPrint(( "GuardFileDriver: IsSuperProcess-start(%s)\n", name ));

		if ( NULL != gPSuperProcess && NULL != name )
		{
			ret = IsSubString( gPSuperProcess, nameEx );
		}

		KeReleaseSpinLock( &gFilterMutex, oldirql );

		DbgPrint(( "GuardFileDriver: IsSuperProcess-end(%d)\n", ret ));

		return ret;
	}
}

// ȡPEBƫ
ULONG GetProcessNameOffset( VOID )
{
	int index = 0;
    ULONG OsMajorVersion;
    ULONG OsMinorVersion ;

    PsGetVersion( &OsMajorVersion, &OsMinorVersion, NULL, NULL );

    //Ŀǰֻ֧Win 2000/xp/2003/2008
    if( OsMajorVersion < 5 || OsMinorVersion > 2 )
    {
		DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(WindowsNt 98)\n" ));
        return 0;
    }

    //ȡPEBͬƽ̨λǲͬġ
    if( OsMajorVersion == 5 && OsMinorVersion < 2)//2000  0X0500      XP 0X0501
    {
		DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2000)\n" ));
        return W2000_PROCESS_PEB_OFFSET;
    }
    else if(OsMajorVersion == 5 && OsMinorVersion ==2) //2003  0X0502
    {
		RTL_OSVERSIONINFOEXW osverinfo = { sizeof(osverinfo) };

		RtlGetVersion( (PRTL_OSVERSIONINFOW)&osverinfo );
		if ( osverinfo.wServicePackMajor==0 )
		{
            DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2003+NOSP[%x])\n", W2003_PROCESS_PEB_OFFSET ));
			return W2003_PROCESS_PEB_OFFSET;
        }
		else if ( osverinfo.wServicePackMajor==1 )
		{
            DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2003+SP1[%x])\n", W2003_PROCESS_PEB_OFFSET_SP1 ));
			return W2003_PROCESS_PEB_OFFSET_SP1;
        }
		else if ( osverinfo.wServicePackMajor==2 )
		{
            DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2003+SP2[%x])\n", W2008_PROCESS_PEB_OFFSET_SP2 ));
			return W2003_PROCESS_PEB_OFFSET_SP2;
        }

		return 0;
    }
    else if( OsMajorVersion == 6 && OsMinorVersion < 2 ) //2008  0X0600
    {
		RTL_OSVERSIONINFOEXW osverinfo = { sizeof(osverinfo) };

		RtlGetVersion( (PRTL_OSVERSIONINFOW)&osverinfo );
		if ( osverinfo.wServicePackMajor==0 )
		{
            DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2008+NOSP[%x])\n", W2008_PROCESS_PEB_OFFSET ));
			return W2008_PROCESS_PEB_OFFSET;
        }
		else if ( osverinfo.wServicePackMajor==1 )
		{
            DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2008+SP1[%x])\n", W2008_PROCESS_PEB_OFFSET_SP1 ));
			return W2008_PROCESS_PEB_OFFSET_SP1;
        }
		else if ( osverinfo.wServicePackMajor==2 )
		{
            DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(Windows2008+SP2[%x])\n", W2008_PROCESS_PEB_OFFSET_SP2 ));
			return W2008_PROCESS_PEB_OFFSET_SP2;
        }

		return 0;
    }
	else
	{
		DbgPrint(( "GuardFileDriver: GetProcessNameOffset-(0)\n" ));
		return 0;
	}
}

// ȡȫ
PCWSTR GetProcessName()
{
	MYULONG dwAddress = (MYULONG)PsGetCurrentProcess();

#ifdef _WIN64
	//DbgPrint(( "GuardFileDriver: GetProcessName-start64(%I64x)\n", dwAddress ));

	if(dwAddress == 0 || dwAddress == 0xFFFFFFFFFFFFFFFF)
	{
		return 0;
	}
#else
	//DbgPrint(( "GuardFileDriver: GetProcessName-start32(%x)\n", dwAddress ));

	if(dwAddress == 0 || dwAddress == 0xFFFFFFFF)
	{
		return 0;
	}
#endif

	dwAddress += gProcessNameOffset;			// PEB
	if( (dwAddress = *(MYULONG*)dwAddress) == 0)
	{
		return 0;
	}

	dwAddress += PROCESS_PARAMETERS_OFFSET;		// ProcessParameters
	if((dwAddress = *(MYULONG*)dwAddress) == 0)
	{
		return 0;
	}

	dwAddress += IMAGE_PATH_NAME_OFFSET;	// ImagePathName
	if((dwAddress = *(MYULONG*)dwAddress) == 0)
	{
		return 0;
	}

	//DbgPrint(( "GuardFileDriver: GetProcessName-(%ws)\n", (PCWSTR)dwAddress ));
	return (PCWSTR)dwAddress;
}

// жû*
BOOLEAN IsIncludeChar( PCHAR src, CHAR c )
{
	while(*src)
	{
		if(*src==c)
		{
			return TRUE;
		}
		++src;
	}

	return FALSE;
}

// Ƿ񱻱ļ
BOOLEAN IsProtectFile( PCHAR fullname, ULONG eventType )
{
	KIRQL  oldirql;
	PPATH_INFO pFilterTemp;

	KeAcquireSpinLock( &gFilterMutex, &oldirql );
	pFilterTemp = gPFilterInfo;

	ToUpper(fullname);
	DbgPrint(( "GuardFileDriver: IsProtectFile-start(%s)\n", fullname ));
	
	while ( pFilterTemp )
	{
		BOOLEAN ret = IsSubPath( pFilterTemp->pPath, fullname );
		if ( ret )
		{
			// ų¼
			switch ( eventType )
			{
			case MONITOR_EVENT_DRIVER_CREATE:
				if ( pFilterTemp->bExcludeCreateEvent )
				{
					KeReleaseSpinLock( &gFilterMutex, oldirql );
					return FALSE;
				}
				break;
			case MONITOR_EVENT_DRIVER_DELETE:
				if ( pFilterTemp->bExcludeDeleteEvent )
				{
					KeReleaseSpinLock( &gFilterMutex, oldirql );
					return FALSE;
				}
				break;
			case MONITOR_EVENT_DRIVER_CHANGE:
				if ( pFilterTemp->bExcludeChangeEvent )
				{
					KeReleaseSpinLock( &gFilterMutex, oldirql );
					return FALSE;
				}
				break;
			case MONITOR_EVENT_DRIVER_RENAME:
				if ( pFilterTemp->bExcludeRenameEvent )
				{
					KeReleaseSpinLock( &gFilterMutex, oldirql );
					return FALSE;
				}
				break;
			default:
				break;
			}

			// ų·
			if ( NULL != pFilterTemp->pExcludePath )
			{
				PLIST_INFO pItem = pFilterTemp->pExcludePath;
				while ( pItem )
				{
					if ( IsIncludeChar( pItem->pItem, '*' ) )
					{
						ret = MatchWithPattern( pItem->pItem, fullname, TRUE );
					}
					else
					{
						ret = IsSubPath( pItem->pItem, fullname );
					}

					if ( ret )
					{
						KeReleaseSpinLock( &gFilterMutex, oldirql );
						//DbgPrint(( "GuardFileDriver: IsProtectFile-end(0)\n" ));
						return FALSE;
					}
					pItem = pItem->pNext;
				}
			}

			// ųļ
			if ( NULL != pFilterTemp->pExcludeFile )
			{
				PLIST_INFO pItem = pFilterTemp->pExcludeFile;
				while ( pItem )
				{
					if ( IsIncludeChar( pItem->pItem, '*' ) )
					{
						ret = MatchWithPattern( pItem->pItem, fullname, TRUE );
					}
					else
					{
						ret = IsEqual( pItem->pItem, fullname );
					}
					if ( ret )
					{
						KeReleaseSpinLock( &gFilterMutex, oldirql );
						//DbgPrint(( "GuardFileDriver: IsProtectFile-end(0)\n" ));
						return FALSE;
					}
					pItem = pItem->pNext;
				}
			}

			// ų
			if ( NULL != pFilterTemp->pExcludeType )
			{
				ret = IsExcludeType( pFilterTemp->pExcludeType, fullname );
				if ( ret )
				{
					KeReleaseSpinLock( &gFilterMutex, oldirql );
					//DbgPrint(( "GuardFileDriver: IsProtectFile-end(0)\n" ));
					return FALSE;
				}
			}

			// ģƥ
			if ( NULL != pFilterTemp->pExcludeBlur )
			{
				ret = IsExcludeBlur( pFilterTemp->pExcludeBlur, fullname );	// ֻļģƥ
				//ret = MatchWithPattern( pFilterTemp->pExcludeBlur, fullname );	// ļ·ƥ
				if ( ret )
				{
					KeReleaseSpinLock( &gFilterMutex, oldirql );
					//DbgPrint(( "GuardFileDriver: IsProtectFile-end(0)\n" ));
					return FALSE;
				}
			}

			KeReleaseSpinLock( &gFilterMutex, oldirql );
			//DbgPrint(( "GuardFileDriver: IsProtectFile-end(1)\n" ));
			return TRUE;
		}
		pFilterTemp = pFilterTemp->pNext;
	}
	KeReleaseSpinLock( &gFilterMutex, oldirql );
	//DbgPrint(( "GuardFileDriver: IsProtectFile-end(0)\n" ));
	return FALSE;
}

//

VOID FreeHashEntry( PFILE_OBJECT fileObject )
{
    PHASH_ENTRY		hashEntry, prevEntry;
    KIRQL                oldirql;

    KeAcquireSpinLock( &gHashMutex, &oldirql );

    // Look-up the entry
    hashEntry = gHashTable[ HASHOBJECT( fileObject ) ];
    prevEntry = NULL;

    while( hashEntry && hashEntry->FileObject != fileObject )
	{
        prevEntry = hashEntry;
        hashEntry = hashEntry->Next;
    }
 
    // If we fall of the hash list without finding what we're looking
    // for, just return.
    if( !hashEntry )
	{
        KeReleaseSpinLock( &gHashMutex, oldirql );
        return;
    }

    // Got it! Remove it from the list
    if( prevEntry )
	{
        prevEntry->Next = hashEntry->Next;

    }
	else
	{
        gHashTable[ HASHOBJECT( fileObject )] = hashEntry->Next;
    }

    // Free the memory associated with the name of the free entry.
    ExFreePool( hashEntry->FullPathName );
    hashEntry->Next = gFreeHashList;
    gFreeHashList = hashEntry;

    KeReleaseSpinLock( &gHashMutex, oldirql );
}

VOID HashCleanup()
{
    PHASH_ENTRY		hashEntry, nextEntry;
    ULONG		    i;
    KIRQL           oldIrql;

    KeAcquireSpinLock( &gHashMutex, &oldIrql );

    // First, free the hash table entries
    for( i = 0; i < NUMHASH; i++ )
	{
        hashEntry = gHashTable[i];

        while( hashEntry )
		{
            nextEntry = hashEntry->Next;
            ExFreePool( hashEntry->FullPathName );
            ExFreePool( hashEntry );
            hashEntry = nextEntry;
        }

        gHashTable[i] = NULL;
    }

    hashEntry = gFreeHashList;
    while( hashEntry )
	{
        nextEntry = hashEntry->Next;
        ExFreePool( hashEntry );
        hashEntry = nextEntry;
    }
    gFreeHashList = NULL;
    KeReleaseSpinLock( &gHashMutex, oldIrql );
}

// ȡļ·
VOID GetFullPath( BOOLEAN createPath, PFILE_OBJECT fileObject, PHOOK_EXTENSION hookExt, PCHAR fullPathName )
{
	size_t               pathLen;
	PCHAR               pathOffset;
	PFILE_OBJECT        relatedFileObject;
	PHASH_ENTRY         hashEntry, newEntry;
	ANSI_STRING         componentName;
	KIRQL               oldirql;
	PFILE_NAME_INFORMATION fileNameInfo;
	UNICODE_STRING      fullUniName;

	// Only do this if a GUI is active and filtering is on
	if( !hookExt || !fullPathName)
	{
		fullPathName[0] = 0;
		return;
	}

	// First, lookup the object in the hash table to see if a name 
	// has already been generated for it
	KeAcquireSpinLock( &gHashMutex, &oldirql );

	hashEntry = gHashTable[ HASHOBJECT( fileObject ) ];
	while( hashEntry && hashEntry->FileObject != fileObject )
	{
		hashEntry = hashEntry->Next;
	}

	// Did we find an entry?
	if( hashEntry )
	{
		// Yes, so get the name from the entry.
		strcpy( fullPathName, hashEntry->FullPathName );
		KeReleaseSpinLock( &gHashMutex, oldirql );
		return;
	}

	KeReleaseSpinLock( &gHashMutex, oldirql );

	// We didn't find the name in the hash table, so we have to attempt
	// to construct it from the file objects.  Note that we won't always
	// be able to successfully do this, because the file system may
	// deallocate the name in the file object at its discretion. 

	// Is it DASD (Volume) I/O?
	if( !fileObject || !fileObject->FileName.Length || fileObject->FileName.Length > 2*MAX_PATH_LEN )
	{
		sprintf( fullPathName, "%C: DASD", hookExt->LogicalDrive );
		return;
	}

	// Okay, now we have to construct the name. If we're in the Create path,
	// we can use the file objects. Otherwise we'll just query the file's name
	if( createPath )
	{
		// Do this in an exception handling block, in case of mangled names in the
		// file object
		__try
		{
			// Now, create the full path name. First, calculate the length taking into 
			// account space for seperators and the leading drive letter plus ':'
			pathLen = fileObject->FileName.Length/2 + 2;

			relatedFileObject = fileObject->RelatedFileObject;

			//
			// Only look at related file object if this is a relative name
			//
			if( fileObject->FileName.Buffer[0] != L'\\' )
			{
				while( relatedFileObject )
				{
					// If its too long, just stop.
					if( pathLen + relatedFileObject->FileName.Length/2+1 >= MAX_PATH_LEN )
					{
						break;
					}

					pathLen += relatedFileObject->FileName.Length/2+1;

					relatedFileObject = relatedFileObject->RelatedFileObject;
				}

			}

			// Add the drive letter first at the front of the name
			sprintf( fullPathName, "%C:", hookExt->LogicalDrive );

			// Now, start at the end and work back to the beginning of the path
			pathOffset = fullPathName + pathLen - fileObject->FileName.Length/2;

			RtlUnicodeStringToAnsiString( &componentName, &fileObject->FileName, TRUE );    

			strncpy( pathOffset, componentName.Buffer, componentName.Length + 1 );

			RtlFreeAnsiString( &componentName );

			relatedFileObject = fileObject->RelatedFileObject;

			if( fileObject->FileName.Buffer[0] != L'\\' )
			{
				while( relatedFileObject )
				{
					*(pathOffset - 1) = '\\';

					pathOffset -= relatedFileObject->FileName.Length/2 + 1;

					// Bail when we've maxed the string.
					if( pathOffset <= fullPathName )
					{
						break;
					}

					RtlUnicodeStringToAnsiString( &componentName, &relatedFileObject->FileName, TRUE );

					strncpy( pathOffset, componentName.Buffer, componentName.Length );

					RtlFreeAnsiString( &componentName );

					relatedFileObject = relatedFileObject->RelatedFileObject;
				}
			}

			// If we added two '\' to the front because there was a relative file object
			// that specified the root directory, remove one
			if( pathLen > 3 && fullPathName[2] == '\\' && fullPathName[3] == '\\' )
			{
				strcpy( fullPathName + 2, fullPathName + 3 );
			}

		}
		__except( EXCEPTION_EXECUTE_HANDLER )
		{
			// No name available - go with a dummy name
			sprintf( fullPathName, "%C: ???", hookExt->LogicalDrive );
		}
	}
	else
	{
		// Ask the file system for the name of the file, which its required to be
		// able to provide for the Win32 filename query function. We could use the
		// undocumented ObQueryNameString, but then we'd have to worry about
		// re-entrancy issues, since that call generates the IRP that we create
		// manually here. Since we send the IRP to the FSD below us, we don't need
		// to worry about seeing the IRP in our dispatch entry point.
		fileNameInfo = (PFILE_NAME_INFORMATION) ExAllocatePool( PagedPool, MAX_PATH_LEN*2 );

		if( QueryFileName(hookExt->FileSystem, fileObject, fileNameInfo, (MAX_PATH_LEN-3)*2+4 ))
		{
			fullUniName.Length = (SHORT) fileNameInfo->FileNameLength;
			fullUniName.Buffer = fileNameInfo->FileName;
			RtlUnicodeStringToAnsiString( &componentName, &fullUniName, TRUE ); 

			fullPathName[ componentName.Length + 2] = 0;
			sprintf( fullPathName, "%C:", hookExt->LogicalDrive );
			memcpy( &fullPathName[2], componentName.Buffer, componentName.Length );

			RtlFreeAnsiString( &componentName );

		}
		else
		{
			sprintf( fullPathName, "%C: ???", hookExt->LogicalDrive );
		}
		ExFreePool( fileNameInfo );

		pathLen = strlen( fullPathName );
	}

	// If its a network drive, take off the first drive letter. This is because
	// network drives share a common device objects and the names are fully formed to 
	// specify the network mounted drive letter already
	if( pathLen > 5 && fullPathName[4] == ':' && fullPathName[5] == '\\')
	{
		strcpy( fullPathName, fullPathName + 3 );
	}

	// Now that we have a name associated with the file object, put the
	// association in a hash table
	KeAcquireSpinLock( &gHashMutex, &oldirql );

	// Allocate a hash entry
	if( gFreeHashList )
	{
		newEntry = gFreeHashList;
		gFreeHashList = newEntry->Next;
	}
	else
	{
		newEntry = ExAllocatePool( NonPagedPool, sizeof(HASH_ENTRY ));
	}

	// If no memory for a new entry, oh well.
	if( newEntry )
	{
		// Fill in the new entry and put it in the hash table
		newEntry->FileObject 	= fileObject;
		newEntry->FullPathName	= ExAllocatePool( NonPagedPool, strlen(fullPathName)+1);

		// Make sure there was memory for the name
		if( !newEntry->FullPathName )
		{
			newEntry->Next = gFreeHashList;
			gFreeHashList   = newEntry;

		}
		else
		{
			newEntry->Next = gHashTable[ HASHOBJECT(fileObject) ];
			gHashTable[ HASHOBJECT(fileObject) ] = newEntry;	
			strcpy( newEntry->FullPathName, fullPathName );
		}
	}
	KeReleaseSpinLock( &gHashMutex, oldirql );
}


BOOLEAN QueryFileName( PDEVICE_OBJECT DeviceObject, 
						PFILE_OBJECT FileObject,
						PFILE_NAME_INFORMATION FileName, ULONG FileNameLength )
{
	PIRP irp;
	KEVENT event;
	IO_STATUS_BLOCK IoStatusBlock;
	PIO_STACK_LOCATION ioStackLocation;

	// Initialize the event
	KeInitializeEvent(&event, SynchronizationEvent, FALSE);

	// Allocate an irp for this request.  This could also come from a 
	// private pool, for instance.
	irp = IoAllocateIrp(DeviceObject->StackSize, FALSE);

	if (!irp)
	{
		// Failure!
		return FALSE;
	}

	// Build the IRP's main body
	irp->AssociatedIrp.SystemBuffer = FileName;
	irp->UserEvent = &event;
	irp->UserIosb = &IoStatusBlock;
	irp->Tail.Overlay.Thread = PsGetCurrentThread();
	irp->Tail.Overlay.OriginalFileObject = FileObject;
	irp->RequestorMode = KernelMode;
	irp->Flags = 0;

	// Set up the I/O stack location.
	ioStackLocation = IoGetNextIrpStackLocation(irp);
	ioStackLocation->MajorFunction = IRP_MJ_QUERY_INFORMATION;
	ioStackLocation->DeviceObject = DeviceObject;
	ioStackLocation->FileObject = FileObject;
	ioStackLocation->Parameters.QueryFile.Length = FileNameLength;
	ioStackLocation->Parameters.QueryFile.FileInformationClass = FileNameInformation;

	// Set the completion routine.
	IoSetCompletionRoutine(irp, QueryFileNameComplete, 0, TRUE, TRUE, TRUE);

	// Send it to the FSD
	(void) IoCallDriver(DeviceObject, irp);

	// Wait for the I/O
	KeWaitForSingleObject(&event, Executive, KernelMode, TRUE, 0);

	// Done!
	return( NT_SUCCESS( IoStatusBlock.Status ));
}

NTSTATUS QueryFileNameComplete( PDEVICE_OBJECT DeviceObject, PIRP Irp, PVOID Context )
{
	// Copy the status information back into the "user" IOSB.
	*Irp->UserIosb = Irp->IoStatus;

	if( !NT_SUCCESS(Irp->IoStatus.Status) )
	{
		DbgPrint(("GuardFileDriver: QueryFileNameComplete-ERROR ON IRP: %x\n", Irp->IoStatus.Status ));
	}

	// Set the user event - wakes up the mainline code doing this.
	KeSetEvent(Irp->UserEvent, 0, FALSE);

	// Free the IRP now that we are done with it.
	IoFreeIrp(Irp);

	// We return STATUS_MORE_PROCESSING_REQUIRED because this "magic" return value
	// tells the I/O Manager that additional processing will be done by this driver
	// to the IRP - in fact, it might (as it is in this case) already BE done - and
	// the IRP cannot be completed.
	return STATUS_MORE_PROCESSING_REQUIRED;
}

// ˴

BOOLEAN IsEqual( IN PCHAR FuncName1, IN PCHAR FuncName2 )
{
	return ( RtlCompareMemory( FuncName1, FuncName2, strlen(FuncName1) ) == strlen(FuncName2) );
}

BOOLEAN IsSubString( IN PCHAR str1, IN PCHAR str2 )
{
	PCHAR strCur = strstr( str1, str2 );

	if ( NULL != strCur && *strCur )
	{
		return TRUE;
	}
	else
	{
		return FALSE;
	}
}

BOOLEAN IsSubPath( IN PCHAR TopPath, IN PCHAR SubPath )
{
	SIZE_T topSize = strlen(TopPath);
	SIZE_T Size = RtlCompareMemory( TopPath, SubPath, topSize );

	if ( topSize > 0 && ( Size == topSize || ( (Size==strlen(SubPath)) && (Size==topSize-1) ) ) )
	{
		return TRUE;
	}

	return FALSE;
}

PCHAR StrRChr( PCHAR src, int c )
{
	PCHAR p=NULL;

	while(*src)
	{
		if(*src==c)
			p=src;
		++src;
	}

	return p;
}

BOOLEAN IsExcludeType( IN PCHAR type, IN PCHAR FilePath )
{
	//ȡļ
	PCHAR fileExt = StrRChr( FilePath, '.' );
	
	if ( NULL == fileExt )
	{
		return FALSE;
	}

	fileExt++;

	if ( fileExt[0] )
	{
		// ƥĴ
		CHAR fileExtEx[11] = "|";
		strncat( fileExtEx, fileExt, 8 );
		strcat( fileExtEx, "|" );

		return IsSubString( type, fileExtEx );
	}
	
	return FALSE;
}

BOOLEAN IsExcludeBlur( IN PCHAR blur, IN PCHAR FilePath )
{
	//ȡļ
	PCHAR fileName = StrRChr( FilePath, '\\' );
	
	if ( NULL == fileName )
	{
		return FALSE;
	}

	fileName++;

	if ( fileName[0] )
	{
		if ( MatchWithPattern( blur, fileName, TRUE ) )
		{
			return TRUE;
		}
		return FALSE;
	}
	
	return FALSE;
}

BOOLEAN MatchWithPattern( PCHAR pattern, PCHAR str, BOOLEAN bNoCase )
{
	// 
	//assert( pattern && str );
	PCHAR p = pattern;
	PCHAR s = str;

	if ( ! pattern || !str )
	{
		if ( pattern == str )
		{
			return TRUE;
		}
		return FALSE;
	}
	else if ( *pattern == '\0' && *str == '\0' )
	{
		return TRUE;
	}

	// ʽȽ
	while ( *p && *s )
	{
		if ( *p != '*' ) // ʱҪַͬ
		{
			CHAR cp = *p;
			CHAR cs = *s;

			if ( bNoCase ) // ִСдתɴдȽ
			{
				if( cp >= 'a' && cp <= 'z' )
					cp = cp - 'a' + 'A';
				if( cs >= 'a' && cs <= 'z' )
					cs = cs - 'a' + 'A';
			}

			if ( cp != cs )
			{
				return FALSE;
			}
		}
		else // гͨ*
		{
			// ȡ*ַstrƥ
			p++;
			if ( !*p ) // ģʽ*ַƥɹ
			{
				return TRUE;
			}
			// ģʽ*ַƥ
			while ( *s )
			{
				if ( *p == *s ) // ٴƥɹ
				{
					// ݹ鴦ʣ
					if ( MatchWithPattern( p+1, s+1, bNoCase ) )
					{
						// ƥɹ
						return TRUE;
					}
					else
					{
						// ǰ÷ʽλƥ
					}
				}
				s ++;
			}
			// ղƥ
			return FALSE;
		}
		p ++;
		s ++;
	}
	// ĿǰΪֹ˫һֱͬ
	if ( *p == *s )
	{
		return TRUE;
	}

	// ڲ
	return FALSE;
}

/*
///////////////////////////////////////////////////////////////////////////////////
BOOLEAN MatchOkay( PCHAR Pattern )
{
	// If pattern isn't empty, it must be a wildcard
	if( *Pattern && *Pattern != '*' )
	{
		return FALSE;
	}
	
	// Matched
	return TRUE;
}

// Performs nifty wildcard comparison.
BOOLEAN MatchWithPattern( PCHAR Pattern, PCHAR Name )
{
	CHAR   upcase;
	
	// End of pattern?
	if( !*Pattern )
	{
		return FALSE;
	}
	
	// If we hit a wild card, do recursion
	if( *Pattern == '*' )
	{
		Pattern++;
		while( *Name && *Pattern )
		{
			if( *Name >= 'a' && *Name <= 'z' )
				upcase = *Name - 'a' + 'A';
			else
				upcase = *Name;
			
			// See if this substring matches
			if( *Pattern == upcase || *Name == '*' )
			{
				if( MatchWithPattern( Pattern+1, Name+1 ))
				{
					return TRUE;
				}
			}
			
			// Try the next substring
			Name++;
		}
		
		// See if match condition was met
		return MatchOkay( Pattern );
	}
	
	// Do straight compare until we hit a wild card
	while( *Name && *Pattern != '*' )
	{
		if( *Name >= 'a' && *Name <= 'z' )
			upcase = *Name - 'a' + 'A';
		else
			upcase = *Name;
		
		if( *Pattern == upcase )
		{
			Pattern++;
			Name++;
			
		}
		else
		{
			return FALSE;
		}
	}
	
	// If not done, recurse
	if( *Name )
	{
		return MatchWithPattern( Pattern, Name );
	}
	
	// Make sure its a match
	return MatchOkay( Pattern );
}
*/


