/***********************************************************************
*
* ļ        Watcher.h
* ģĿģڻȡļ¼
* ߼ڣ  wang_jin 2008-04-11
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef Watcher_H
#define Watcher_H

#pragma warning(disable:4786)

#include "Base/MonitorDef.h"
#include "Base/MonitorInterface.h"
#include "Common/Common.h"
#include "Common/Container.h"
#include "GDLock/GDLock.h"
#include "FileExclude/FileExclude.h"

#include <iostream>
#include <windows.h>
#include <assert.h>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <winbase.h>

using namespace std;

#ifndef NDEBUG
extern LONG GnAddCount[];
extern LONG GnRemoveCount[];
extern LONG GnChangeCount[];
extern LONG GnRenameCount[];
#endif


class CWatcher
{
	// Ŀ¼
	class CDirInfo
	{
	public:
		// ¼С
		enum{ MAX_BUFFER = 4096 };

		typedef struct event_buffer
		{
			CHAR buffer[ MAX_BUFFER ];	// ¼洢
			UINT offset;				// Чݽλãʼ洢λ
		} EventBuffer, *PEventBuffer;

		// 
		CDirInfo( CMonitorInformation& moniInfo , int dwFlags )
		{
			// Ŀ¼
			memset( m_szDir, 0, sizeof m_szDir );
			strcpy( m_szDir, moniInfo.m_monitorPath.c_str() );
			
			m_fileExclude.SetRules( moniInfo );

			// ǷĿ¼
			m_bSubDir = true;

			// ¼¼
			m_dwFlags = dwFlags;

			// ʼ
			m_hDir = NULL;
			ZeroMemory( &m_ol, sizeof(OVERLAPPED) );
			m_evtBuf.offset = 0;
			memset( m_evtBuf.buffer, 0, sizeof m_evtBuf.buffer );
		}
		// 
		~CDirInfo()
		{
			// ͷž
			if ( INVALID_HANDLE_VALUE != m_hDir )
			{
				CloseHandle( m_hDir );
			}
		}
		// صǰ󵥸Ŀ¼
		bool StartMonitor( HANDLE hIOCompletionPort )
		{
			// 豸(Ŀ¼)
			m_hDir = CreateFile( 
				m_szDir, 
				FILE_LIST_DIRECTORY, 
				FILE_SHARE_READ | FILE_SHARE_WRITE,	// | FILE_SHARE_DELETE, 
				NULL, 
				OPEN_EXISTING, 
				FILE_FLAG_BACKUP_SEMANTICS | FILE_FLAG_OVERLAPPED, 
				NULL );

			if ( NULL == m_hDir )
			{
				cout << "CreateFile Failed: " << GetLastError() << endl;
				return false;
			}

			m_status = STATUS_STARTING;
			// ļĿ¼ɶ˿ϵ
			if ( CreateIoCompletionPort( m_hDir, hIOCompletionPort, (DWORD)this, 0 ) != hIOCompletionPort )
			{
				cout << "CreateIoCompletionPort Failed: " << GetLastError() << endl;
			}

			m_status = STATUS_NORMAL;

			// ִ첽I/O
			bool bRet = ReadDirectoryChanges();
			if ( ! bRet )
			{
				// ʧ
				return false;
			}

			return true;
		}
		// ֹͣصǰ󵥸Ŀ¼
		bool StopMonitor( HANDLE hIOCompletionPort )
		{
			m_status = STATUS_STOPPING;
			// ֹǰĿ¼Ӧ첽IO
			::PostQueuedCompletionStatus( hIOCompletionPort, sizeof(CDirInfo), (DWORD)this, &m_ol );
			while ( STATUS_STOPPING == m_status ) GDMINSLEEP();

			m_status = STATUS_CLOSING;
			// رյǰĿ¼
			if ( CloseHandle( m_hDir ) )
			{
				while ( STATUS_CLOSING == m_status ) GDMINSLEEP();
				m_hDir = INVALID_HANDLE_VALUE;
				return true;
			}
			return false;
		}
		bool ReadDirectoryChanges();
		bool SetPolicy( CMonitorInformation& moniInfo )
		{
			return m_fileExclude.SetRules( moniInfo );
		}

	private:
		HANDLE m_hDir;					// Ŀ¼
		OVERLAPPED m_ol;				// 첽
		bool m_bSubDir;					// ǷĿ¼
		UINT m_dwFlags;					// Ŀ¼¼

	public:
		CHAR m_sDirId[ GD_MAX_PATH ];   // Ŀ¼ID
		CHAR m_szDir[ GD_MAX_PATH ];    // Ŀ¼(Ǳ)
		CHAR m_dust[ GD_MAX_PATH ];     // ռλ

		EventBuffer m_evtBuf;			// ¼洢

		int m_nIdx;
		CFileExclude m_fileExclude;		// ų
		enum
		{ 
			STATUS_STARTING,
			STATUS_STARTED,
			STATUS_STOPPING, 
			STATUS_STOPED, 
			STATUS_CLOSING,
			STATUS_CLOSED,
			STATUS_NORMAL=STATUS_STARTED, 
			STATUS_ERROR
		} m_status;						// ״̬

	};

	// ¼Ϣ
	class CEventInfo
	{
	public:
		// 
		CEventInfo()
		:m_nTickCount(0), m_nAction(0), m_nAttribute(0), m_pFileExclude(NULL)
		{}
		CEventInfo( const CEventInfo& ei )
		{
			memcpy( this, &ei, sizeof(CEventInfo) );
		}
		CEventInfo( PFILE_NOTIFY_INFORMATION pfi, const char * szMonitorPath )
		:m_nTickCount(0), m_nAction(0), m_nAttribute(0), m_pFileExclude(NULL)
		{
			m_nTickCount = GetTickCount();
			GetLocalTime( &m_time );

			memset( m_szFileName, '\0', sizeof(m_szFileName) );
			memset( m_newFileName, '\0', sizeof(m_newFileName) );

			char ansiFileName[GD_MAX_PATH] = {0};
			WideCharToMultiByte( 
				CP_ACP,			// ANSI
				0, 
				pfi->FileName,	// תַ
				min(pfi->FileNameLength/2, sizeof(ansiFileName)-strlen(szMonitorPath)-2), 
				ansiFileName,	// תַ
				min(pfi->FileNameLength, sizeof(ansiFileName)-strlen(szMonitorPath)-2),
				NULL, 
				NULL );
			strcpy(m_szFileName, szMonitorPath);
			strcat(m_szFileName, "\\");
			strcat( m_szFileName, ansiFileName );

			m_nAction = pfi->Action;
			m_nAttribute = 0;
		}
		~CEventInfo()
		{
		}
		void ShowEvent()
		{
			static int n = 0;
			switch ( m_nAction )
			{
			case FILE_ACTION_ADDED: //The file was added to the directory.
				cout << n << " FILE_ACTION_ADDED: " << m_szFileName << endl;
				break;
			case FILE_ACTION_REMOVED: //The file was removed from the directory.
				cout << n++ << " FILE_ACTION_REMOVED: " << m_szFileName << endl;
				break;
			case FILE_ACTION_MODIFIED: //The file was modified. This can be a change in the time stamp or attributes.
				cout << n << " FILE_ACTION_MODIFIED: " << m_szFileName << endl;
				break;
			case FILE_ACTION_RENAMED_OLD_NAME: //The file was renamed and this is the old name.
				if ( '\0' == m_newFileName[0] )
					cout << n << " FILE_ACTION_RENAMED_OLD_NAME: " << m_szFileName << endl;
				else
					cout << n << " FILE_ACTION_RENAMED_OLD_NAME: " << m_szFileName << " NEW_NAME: " << m_newFileName << endl;
				break;
			case FILE_ACTION_RENAMED_NEW_NAME: //The file was renamed and this is the new name.
				cout << n << " FILE_ACTION_RENAMED_NEW_NAME: " << m_szFileName << endl;
				break;
			default:
				break;
				
			}
		}
		friend std::ostream& operator<<( std::ostream& os, const CEventInfo& a )  
		{
			DWORD dwPointer = 0;
			dwPointer = (DWORD)a.m_pFileExclude;
			CGDString::ReplaceChar( (char *)a.m_szFileName, ' ', '>' );
			CGDString::ReplaceChar( (char *)a.m_newFileName, ' ', '>' );
			os << a.m_nAction << endl \
			   << a.m_nAttribute << endl \
			   << dwPointer << endl \
			   << a.m_time.wYear << endl \
			   << a.m_time.wMonth << endl \
			   << a.m_time.wDayOfWeek << endl \
			   << a.m_time.wDay << endl \
			   << a.m_time.wHour << endl \
			   << a.m_time.wMinute << endl \
			   << a.m_time.wSecond << endl \
			   << a.m_time.wMilliseconds << endl \
			   << a.m_szFileName << endl \
			   << a.m_newFileName << endl;
			return os;  
		} 
		friend std::istream& operator>>( std::istream& is, CEventInfo& a )
		{
			DWORD dwPointer = 0;
			is >> a.m_nAction \
			   >> a.m_nAttribute \
			   >> dwPointer \
			   >> a.m_time.wYear \
			   >> a.m_time.wMonth \
			   >> a.m_time.wDayOfWeek \
			   >> a.m_time.wDay \
			   >> a.m_time.wHour \
			   >> a.m_time.wMinute \
			   >> a.m_time.wSecond \
			   >> a.m_time.wMilliseconds \
			   >> a.m_szFileName \
			   >> a.m_newFileName;
			a.m_pFileExclude = (CFileExclude*)dwPointer;
			CGDString::ReplaceChar( a.m_szFileName, '>', ' ' );
			CGDString::ReplaceChar( a.m_newFileName, '>', ' ' );
			return is;
		} 

	public:
		UINT m_nTickCount;
		int m_nAction;
		int m_nAttribute;					// Ŀ¼ļȵ
		char m_sDirId[ GD_MAX_PATH ];                       // Ŀ¼ID add by wu_bin
		SYSTEMTIME m_time;
		TCHAR m_szFileName[ GD_MAX_PATH ];
		TCHAR m_newFileName[ GD_MAX_PATH ];
		TCHAR m_szKey[ GD_MAX_PATH ];      // Ŀ¼ID add by wu_bin
		CFileExclude* m_pFileExclude;
	};

	enum{ MAX_LIST_SIZE = 102400 };

public:
	CWatcher();
	~CWatcher();

private:
	HANDLE m_hEvent;						// ¼ڹ߳ͣͬ
	HANDLE m_hIOCPRead;						// ɶ˿ھ(ڶ¼)
	HANDLE m_hIOCPHold;						// ɶ˿ھ(ڴ¼)
	UINT m_nThreads;						// ̸߳
	UINT m_nMilliSeconds;					// ¼ϲʱ()
	BOOL m_bWorking;						// ƹ߳˳

	CRITICAL_SECTION m_cs;					// ¼в
	deque< void* > m_deque;					// ¼
	list< CEventInfo* > m_filter;			// ¼˶
	map < string, CDirInfo* > m_dirmap;		// Ŀ¼б
	map < string, CEventInfo* > m_evtmap;	// ļ¼
	CContainerOld < CEventInfo > m_queue;		// ¼б(֧)

	static UINT m_dwDefaultFlags;			// Ĭϼ¼

public:
	// 
	bool Initialize( const char * sParams );
	// ӼĿ¼
	bool WatchDirectory( CMonitorInformation& moniInfo );
	// ɾĿ¼
	bool UnwatchDirectory( const char * sDirId );
	// ֹͣ
	bool Uninitialize();
	// Ƿ
	bool IsWatchingDirectory( const char * sDir );
	bool IsWatched( const char* sDirId );
	bool IsWatchedByWebsiteId( const char * sWebsiteId );
	
	
	// ˼¼߳
	static UINT __stdcall FilterRoutine( LPVOID lpParam );
	// ¼߳
	static UINT __stdcall DequeRoutine( LPVOID lpParam );
	// ȡ¼߳
	static UINT __stdcall CompletionRoutine( LPVOID lpParam );
	// ȡ¼APIָ

	static void ParseEvent( CWatcher* pWatcher, CDirInfo* pDirInfo, DWORD dwBytes );

	// ¼ӿ
	CEventInfo* FilterEvent();
	bool GetMonitorEvent( EVENT_S& evt );

	// ü¼
	void SetEventFlag( UINT nFlags );
	// ¼ϲʱ䣨1/1000룩
	void SetEventDelay( int ms );
};


inline void CWatcher::ParseEvent( CWatcher* pWatcher, CDirInfo* pDirInfo, DWORD dwBytes )
{
	DWORD cbOffset = 0;
	CEventInfo* pEvtInfo = NULL;
	PFILE_NOTIFY_INFORMATION pfi = NULL;

	pfi = (PFILE_NOTIFY_INFORMATION)pDirInfo->m_evtBuf.buffer;
	while ( (char *)pfi < pDirInfo->m_evtBuf.buffer + dwBytes )
	{
#ifdef USE_TRY
		try
#endif
		{
			cbOffset = pfi->NextEntryOffset; // ֵδȷǷЧ

			if ( FILE_ACTION_RENAMED_OLD_NAME == pfi->Action )
			{
				// ǰ¼Ϊġļ¼жǷġļ¼
				if ( (char *)pfi + cbOffset < pDirInfo->m_evtBuf.buffer + dwBytes )
				{
					// 
					PFILE_NOTIFY_INFORMATION tmp = (PFILE_NOTIFY_INFORMATION) ((LPBYTE) pfi + cbOffset);
					assert(tmp);
					cbOffset = tmp->NextEntryOffset; // ֵδȷǷЧ
					if ( tmp ) // 
					{
						CEventInfo* pEvtInfoTmp = new CEventInfo( tmp, pDirInfo->m_szDir );

						pEvtInfo = new CEventInfo( pfi, pDirInfo->m_szDir );
						if ( pEvtInfo )
						{
							strcpy( pEvtInfo->m_newFileName, pEvtInfoTmp->m_szFileName );
						}

						delete pEvtInfoTmp;
						pEvtInfoTmp = NULL;
					}
					else
					{
						assert(0);
					}
				}
				else
				{
					// ļ¼
					UINT len = sizeof(FILE_NOTIFY_INFORMATION)+pfi->FileNameLength - sizeof(WCHAR)*2;
					memcpy( pDirInfo->m_evtBuf.buffer, (LPBYTE)pfi, len );
					pDirInfo->m_evtBuf.offset = len;
					return;
				}
			}
			else // ¼
			{
				pEvtInfo = new CEventInfo( pfi, pDirInfo->m_szDir );
			}
#ifndef NDEBUG
			if ( pEvtInfo->m_nAction == FILE_ACTION_ADDED )
			{
				::InterlockedIncrement( &GnAddCount[0] );
			}
			else if ( pEvtInfo->m_nAction == FILE_ACTION_REMOVED )
			{
				::InterlockedIncrement( &GnRemoveCount[0] );
			}
			else if ( pEvtInfo->m_nAction == FILE_ACTION_MODIFIED )
			{
				::InterlockedIncrement( &GnChangeCount[0] );
			}
			else if ( pEvtInfo->m_nAction == FILE_ACTION_RENAMED_OLD_NAME )
			{
				::InterlockedIncrement( &GnRenameCount[0] );
			}
#endif
		}
#ifdef USE_TRY
		catch(...)
		{
			if ( pEvtInfo )
			{
				delete pEvtInfo;
				pEvtInfo = NULL;
			}
			// ѴϢʽ
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER |
				FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(), // Ϣ
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf, // ʽĴϢ
				0,
				NULL
				);
			CGDLog::WriteErrLog( "1080:CompletionRoutine Exception1 = %s\n", lpMsgBuf );
			LocalFree( lpMsgBuf );
			break;
		}
#endif
#ifdef USE_TRY
		try
#endif
		{
			if ( pEvtInfo )
			{
				//Ŀ¼ID,ID·ϳsKey  by wu_bin
				strcpy( pEvtInfo->m_sDirId, pDirInfo->m_sDirId );
				sprintf( pEvtInfo->m_szKey, "%s@%s", pEvtInfo->m_sDirId, pEvtInfo->m_szFileName );
				pEvtInfo->m_pFileExclude = &pDirInfo->m_fileExclude;
#	ifndef NDEBUG
				if ( pEvtInfo->m_nAction == FILE_ACTION_ADDED )
				{
					::InterlockedIncrement( &GnAddCount[1] );
				}
				else if ( pEvtInfo->m_nAction == FILE_ACTION_REMOVED )
				{
					::InterlockedIncrement( &GnRemoveCount[1] );
				}
				else if ( pEvtInfo->m_nAction == FILE_ACTION_MODIFIED )
				{
					::InterlockedIncrement( &GnChangeCount[1] );
				}
				else if ( pEvtInfo->m_nAction == FILE_ACTION_RENAMED_OLD_NAME )
				{
					::InterlockedIncrement( &GnRenameCount[1] );
				}
#	endif

#if 0 // 
				pEvtInfo->ShowEvent();
				delete pEvtInfo;
#elif 1 // ߻߳
				PostQueuedCompletionStatus( pWatcher->m_hIOCPHold, 0, (DWORD)pEvtInfo, NULL );
#else // ֱӲ
				// 
				EnterCriticalSection(&pWatcher->m_cs);
				// 
				pWatcher->m_deque.push_back( pEvtInfo );
				// 
				LeaveCriticalSection(&pWatcher->m_cs);
#endif
			}
		}
#ifdef USE_TRY
		catch(...)
		{
			if ( pEvtInfo )
			{
				delete pEvtInfo;
				pEvtInfo = NULL;
			}
			// ѴϢʽ
			LPVOID lpMsgBuf;
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER |
				FORMAT_MESSAGE_FROM_SYSTEM |
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				GetLastError(), // Ϣ
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf, // ʽĴϢ
				0,
				NULL
				);
			CGDLog::WriteErrLog( "1081:CompletionRoutine Exception2 = %s\n", lpMsgBuf );
			LocalFree( lpMsgBuf );
			break;
		}
#endif
		if ( 0 == cbOffset ) break; // ûк¼
		pfi = (PFILE_NOTIFY_INFORMATION) ((LPBYTE)pfi + cbOffset); // δȷǷЧ
	}//while
}

#endif
