/***********************************************************************
*
* ļ              MonitorPathTree.cpp
* ģĿģ      ʵĿ¼洢
* ߼ڣ        liu_yfeng 2008-04-01
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
***********************************************************************/

#pragma warning(disable:4786)

#include "MonitorPathTree.h"
#include "EventInfoScanner.h"

#include "Base/MonitorInterface.h"
#include "Common/Common.h"
#include "Common/DateTime.h"
#include "GDLog/GDLog.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"


using namespace std;


namespace InforGuard{
namespace FileScanner{

CGDTimer CMonitorPathTree::scanTimer(30);
CMonitorPathTree::CMonitorPathTree( CMonitorInformation& moniInfo ) : CPathTree( moniInfo )
{
	m_db = NULL;
}


CMonitorPathTree::~CMonitorPathTree()
{
	if ( NULL != m_pObjDir )
	{
		if ( m_oldRoot )
		{
			if ( m_db )
			{
				m_db->FreeDirTree( m_oldRoot );
				m_oldRoot = NULL;
			}
		}
		if ( m_curRoot )
		{
			m_curRoot = m_pObjDir->freeTree( m_curRoot );
		}
		
		delete m_pObjDir;
		m_pObjDir = NULL;
	}
}



void CMonitorPathTree::Scan()
{
	try
	{
		m_nAddEventStartTime = time( NULL ) - 1;
		CreateOld();
		CreateCur();
//		CDateTime::Sleep( 10000 );
	}
	catch( CExceptionError& )
	{
		CGDLog::WriteErrLog( "1069:CMonitorPathTree:Scan catch CExceptionError" );
		return;
	}
	catch ( ... )
	{
		CGDLog::WriteErrLog( "1070:CMonitorPathTree:Scan catch ..." );
		return;
	}
	
	if ( NULL != m_oldRoot && NULL != m_curRoot )
	{
		Compare( m_curRoot, m_oldRoot, m_dir.c_str() );
	}
}


void CMonitorPathTree::CreateOld()
{
	try
	{
		if ( NULL == m_db )
		{
			m_db = CDB::GetInitInstance();
		}
		if ( NULL != m_db )
		{
			if ( NULL != m_oldRoot )
			{
				m_db->FreeDirTree( m_oldRoot );
			}
			
			//wu_bin:߳״̬־
			if (CMonitorPathTree::scanTimer.IsTimeout())
			{
				CGDLog::WriteThreadState("scan loop running(%d)...[%s]", scanTimer.GetMaxRunCount(), m_dir.c_str());     
			}
			
			// ݿȡĿ¼ṹ
			m_oldRoot = ( PPATHNODE ) m_db->GetDirTree( m_dir.c_str() );

			//wu_bin:߳״̬־
			if (CMonitorPathTree::scanTimer.IsTimeout())
			{
				CGDLog::WriteThreadState("scan loop running(%d)...[%s]", scanTimer.GetMaxRunCount(), m_dir.c_str());     
			}
		}
	}
	catch ( ... )
	{
	}
}


void CMonitorPathTree::Compare( PPATHNODE cur, PPATHNODE old, const char* rootPath )
{
	char filePathName[GD_MAX_PATH] = {0};
	char szTempPath[GD_MAX_PATH] = {0};
	// ѭѭһ
    
	while( cur && old )
	{		
		// Ŀ¼
		int n = strcmp( cur->szName, old->szName );
		// ֯ǰĿ¼,ļλӽݹ
		if( ( strlen(cur->szName) > 1 && cur->szName[1]==':' )||cur->szName[0]=='/')
		{
			strcpy( szTempPath, rootPath );
		}
		else
		{
			sprintf( szTempPath, "%s%c%s", rootPath, C_PATHLASH, cur->szName );
		}
		//wu_bin:߳״̬־
		if (CMonitorPathTree::scanTimer.IsTimeout())
		{
			CGDLog::WriteThreadState("scan loop running(%d)...[%s]", scanTimer.GetMaxRunCount(), szTempPath);     
		}

		if ( n < 0 )
		{
			// ɾĿ¼¼
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, old->szName );
			if ( old->time_createTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
			//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
			{
                CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
			}
			
			// ȱʧ
			old = old->bro;
		}
		else if ( n > 0 )
		{
			// ½Ŀ¼¼
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, cur->szName );
			if ( cur->time_createTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
			//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
			{
                CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
			}
			cur = cur->bro;
		}
		else			// һεһȵ
		{
			// Ŀ¼ͬ
			PFILENODE listcur = cur->list;
			PFILENODE listold = old->list;

			// ѭѭȽһļ
			while ( listcur && listold )
			{
				int m = strcmp( listcur->szName, listold->szName);
				if ( m < 0 )
				{
					// ɾļ¼
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listold->szName);
					if ( listold->time_LastWriteTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
					//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
					}
					// ȱʧ
					listold = listold->link;
				}
				else if ( m > 0 )
				{
					// ½ļ¼
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listcur->szName);
					if ( listcur->time_LastWriteTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
					//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
					}
					listcur = listcur->link;
				}
				else
				{
					// ͬ(һļ)
					listcur = listcur->link;
					listold = listold->link;
				}
			}
			if ( NULL == listcur && NULL != listold )
			{
				// ɾļ¼
				while ( listold )
				{
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listold->szName);
					if ( listold->time_LastWriteTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
					//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
					}
					listold = listold->link;
				}
			}
			else if ( NULL == listold && NULL != listcur )
			{
				// ½ļ¼
				while ( listcur )
				{
					sprintf( filePathName, "%s%c%s", szTempPath, C_PATHLASH, listcur->szName);
					if ( listcur->time_LastWriteTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
					//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
					{
						CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
					}
					listcur = listcur->link;
				}
			}
			// ׼Ŀ¼ļбΪգһĿ¼ɣһ
			if ( cur->son || old->son )
			{
				// ӽݹ(һ)
				Compare( cur->son, old->son, szTempPath );
			}
			// Ӻѭֵ
			cur = cur->bro;
			old = old->bro;
		}
	}//while

	if ( NULL == cur && NULL != old )
	{
		// ɾĿ¼¼
		while ( old )
		{
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, old->szName );
			if ( old->time_createTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
			//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_DELETE, filePathName ) )
			{
				CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_DELETE, filePathName );
			}
			old = old->bro;
		}
	}
	else if ( NULL == old && NULL != cur )
	{
		// ½Ŀ¼¼
		while ( cur )
		{
			sprintf( filePathName, "%s%c%s", rootPath, C_PATHLASH, cur->szName );
			if ( cur->time_createTime < m_nAddEventStartTime && !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
			//if ( !m_pFileExclude->IsExcludeEvent( MONITOR_EVENT_SCANNER_CREATE, filePathName ) )
			{
				CEventInfoScanner::Add(  MONITOR_EVENT_SCANNER_CREATE, filePathName );
			}
			cur = cur->bro;
		}
	}
	// ׼Ŀ¼ͬΪգ(һ)
}


}	// namespace FileScanner
}	// namespace InforGuard

