/******************************************************************************
*
* ļ              MsgTranClient.cpp
* ģĿģ      ࣬ʵϢʹ
* ߼ڣ        wang_jin 2007-10-18
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            wang_jin 2009-08-07
*
******************************************************************************/

#pragma warning(disable:4251)

#include <STAR/CORBA.h>

#include "Base/App.h"
#include "Base/NetTran.h"
#include "Base/RunInfor.h"
#include "Base/Tool.h"
#include "Common/DateTime.h"
#include "Common/GDString.h"
#include "GDLog/GDTrace.h"
#include "MsgTran/MsgTranClient.h"


CMsgTranClient::CMsgTranClient()
{
}

CMsgTranClient::~CMsgTranClient()
{
}

long CMsgTranClient::PushMessageToMc( const MsgBlockStruct& mb ) throw ( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "mb[" + CTool::MB2String( mb ) 
		+ "]";

	CGDTrace trace( LOG_L6, "CMsgTranClient:PushMessageToMc(%s)", sParam.c_str() ); 

	// ׼ͨѶϢ
	InforGuard::netIpPort host1, host2;
	host1.sIp = CORBA::string_dup( CAppConfig::Instance().GetLocalIp().c_str() );
	host1.sPort = CORBA::string_dup( CAppConfig::Instance().GetLocalPort().c_str() );
	host2.sIp = CORBA::string_dup( CAppConfig::Instance().GetMcIp().c_str() );
	host2.sPort = CORBA::string_dup( CAppConfig::Instance().GetMcPort().c_str() );
	InforGuard::HostChain hostChain;
	hostChain.length(2);
	hostChain[0] = host1;
	hostChain[1] = host2;

	long nRet = PushMessage( hostChain, mb );
	return trace.SetRetValue( nRet );
}

long CMsgTranClient::PushMessage(const InforGuard::HostChain& seqIpPort, const MsgBlockStruct& mb )
	throw ( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "mb[" + CTool::MB2String( mb ) 
		+ "]seqIpPort[" + CNetTran::HostChainToString(seqIpPort)
		+ "]";

	CGDTrace trace( LOG_L6, "CMsgTranClient:PushMessage(%s)", sParam.c_str() ); 

	MsgBlockStruct lmb;
	lmb.nMid = mb.nMid;
	lmb.nLevel = mb.nLevel;
	lmb.nSerial = mb.nSerial;
	lmb.sSrc = CORBA::string_dup( mb.sSrc.c_str() );
	lmb.sDst = CORBA::string_dup( mb.sDst.c_str() );

	string msgContent = CGDString::ltoa( mb.nMid );
	msgContent.append( "`" );
	msgContent.append( CGDString::ltoa( mb.nLevel ) );
	msgContent.append( "`" );
	msgContent.append( CGDString::ltoa( mb.nSerial ) );
	msgContent.append( "`" );
	int nSize = mb.pl.size();
	for ( int i=0; i<nSize; i++ ) // Сڴװ
	{
		msgContent.append( mb.pl[i] );
		msgContent.append( "|" );
	}
	lmb.pl.push_back( msgContent );

	long nRet = PushMessageMulti( seqIpPort, lmb );
	return trace.SetRetValue( nRet );
}

long CMsgTranClient::PushMessageMulti(const InforGuard::HostChain& seqIpPort, const MsgBlockStruct& mb )
	throw ( CExceptionError )
{
	string sParam;
	sParam = sParam
		+ "mb[" + CGDString::ltoa( mb.pl.size() ) 
		+ "]seqIpPort[" + CNetTran::HostChainToString(seqIpPort)
		+ "]";

	CGDTrace trace( LOG_L6, "CMsgTranClient:PushMessage(%s)", sParam.c_str() ); 

	InforGuard::MsgBlock imb;
	
	imb.mid = mb.nMid;
	imb.level = mb.nLevel;
	imb.serial = mb.nSerial;

	imb.src = CORBA::string_dup( mb.sSrc.c_str() );
	imb.dst = CORBA::string_dup( mb.sDst.c_str() );

	int i;
	int nCount = mb.pl.size();
	imb.pl.length( nCount );
	for (i=0; i<nCount; i++)
	{
		imb.pl[i] = CORBA::string_dup( mb.pl[i].c_str() );
	}

	long nRet = -1;

	string sIp;
	string sPort;
	CNetTran::GetNextIpPort(seqIpPort, sIp, sPort);
//	CTool::EchoHost( seqIpPort );
	for ( i=0; i<2; i++ ) // һ
	{
		std::string sErrInfo;
		static bool bWriteLog = true;	// ֻһ
		try
		{
			MsgTran_var ref;
			CNetTran::GetMsgTranObject( sIp.c_str(), sPort.c_str(), ref );
			
			//CTool::EchoHost( seqIpPort );
			nRet = ref->PutMessage( seqIpPort, imb );
			bWriteLog = true;
			break;
		}
		catch ( CExceptionError & ex )
		{
			ex.AddErrText( "CMsgTranClient:PushMessage(%s)", sParam.c_str() );
			sErrInfo = ex.GetErrText();
			//throw ex;
		}
		catch( const InforGuard::ExceptionError& ex )
		{
			CExceptionError e;
			CNetTran::ConvertException(ex, e);
			e.AddErrText( "CMsgTranClient:PushMessage(%s)", sParam.c_str() );
			sErrInfo = e.GetErrText();
			//throw e;
		}
		catch( const CORBA::Exception& ex )
		{
			// ת쳣ʽ
			CExceptionError e;
			e.AddErrText( "CMsgTranClient:PushMessage(%s)[%s]", sParam.c_str(), ex._to_string() );
			sErrInfo = e.GetErrText();
			//throw e;
		}
		// һCORBA쳣ֱΪ
		CNetTran::RemoveMsgTranObject( sIp.c_str(), sPort.c_str() );
		if ( bWriteLog )
		{
			if ( 1 <= i )
			{
				bWriteLog = false;
				CExceptionError e;
				e.AddErrText( "%s", sErrInfo.c_str() );
				throw e;
			}
		}
		CDateTime::Sleep( 200 );
	}

	return trace.SetRetValue( nRet );
}

long CMsgTranClient::PullMessage( const InforGuard::HostChain& seqIpPort, MsgBlockStruct& mb ) throw( CExceptionError )
{
	CGDTrace trace( LOG_L6, "CMsgTranClient:PullMessage()" );
	
	InforGuard::MsgBlock_var pmb;
	MsgTran_var ref;
	CNetTran::GetMsgTranObject( seqIpPort[1].sIp, seqIpPort[1].sPort, ref );

	long nRet = 0;
	try
	{
		nRet = ref->GetMessage( seqIpPort, pmb );
	}
	catch(...)
	{
		assert(0); // δʹú
	}

	if ( nRet == 0 )
	{
		mb.nMid = (enumMsgID)pmb->mid;
		mb.nLevel = pmb->level;
		mb.nSerial = pmb->serial;
		mb.sSrc = pmb->src;
		mb.sDst = pmb->dst;
		int nCount = pmb->pl.length();
		for (int i=0; i<nCount; i++)
		{
			string param = pmb->pl[i].in();
			mb.pl.push_back( param );
		}
	}

	return trace.SetRetValue( nRet );
}
