/****************
 غ
 ****************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "gcps.h"
#include "z.h"
#include "mo15.h"

/* ----------------------------------------------------------------- */

CHKFUNC test1;
CHKFUNC getrows;

static struct code_func
{
    char        *name;           /*  */
    CHKFUNC_PTR func;            /* ָ */
} t_funcs[] =
{
    {"test1",   test1},          /* Ժ1 */
    {"getrows", getrows},        /* ضеĲƴһ */
    {0, 0}                       /*  */
};

/* ----------------------------------------------------------------- */

static TAGVALUE t_otags[8];

int test1(SMRULE *prule, TAGVALUE *ptv, char *out)
{
    strcpy(out, "200");
    return(0);
}

/**********************************
 ƲҺָ룬ִСд
 **********************************/
CHKFUNC_PTR u_func_search(const char *name)
{
    int  i;

    for( i = 0; t_funcs[i].name; i++ )
    {
        if( strcasecmp(name, t_funcs[i].name) == 0 )
        {
            return( t_funcs[i].func );
        }
    }

    return(0);
}

/******************************
 
 ֵ  -1  ݿϵͳ
            0  Уͨ
            1  Уʧ
 ******************************/
int u_rule_check(SMRULE *prule, char *logictype, char *logictext)
{
    int   b, r, nlist;
    char  vname[65], vout[513];

    static char text1[2049];

    z_lrtrim(logictext);

    /* 滻 logictext еĿɱ */
    u_var_replace(logictext, text1);

    r = strlen(text1) - 1;
    if( text1[r] == ';' ) text1[r] = 0;                /* ޳βֺ */

/* ----------------------------------------------------------------- */

    if( strcasecmp(logictype, TEXT_T_SQL) == 0 )
    {
        memset(t_otags, 0, sizeof(t_otags));
        r = u_dyn_sql(text1, &b, t_otags, &nlist);
			  if(u_writelog >= 1) z_logv(u_logfile, "checksql=[%s]\n r=[%d]", text1, r);

        if( r < 0 )
        {
            z_logv(u_logfile, "󣺶̬sql '%s' =%d", text1, b);
            return(-1);
        }
        else if( r > 0 )
        {
            z_logv(u_logfile, "󣺶̬sql=%d", r);
            return(0);
        }

        for( b = 0; b < nlist; b++ )
        {
            u_settag(t_otags[b].tag, t_otags[b].value, TEXT_T_NORMAL, PARA_RKEY);
					  if(u_writelog >= 1) z_logv(u_logfile, "checksql tag=[%s]value=[%s]", text1, t_otags[b].tag, t_otags[b].value);
        }
    }

/* ----------------------------------------------------------------- */
    else if( strcasecmp(logictype, TEXT_T_FUNC) == 0 )
    {
        r = u_func_eval(prule, text1, vname, vout);
				if(u_writelog >= 1) z_logv(u_logfile, "u_func_eval=%d", r);

        if( r == 1 ) return(0);
        else if( r < 0 ) return(-1);

        u_settag(vname, vout, TEXT_T_NORMAL, PARA_RKEY);
    }

/* ----------------------------------------------------------------- */
    else if( strcasecmp(logictype, TEXT_T_SHELL) == 0 )
    {
				if(u_writelog >= 1) z_logv(u_logfile,"TXT_T_SHELL=[%s]", text1);    
        if( u_kshcmd(text1, NULL, vout, 2048) < 0 ) return(-1);

        u_settag(NAME_CHKCODE, vout, TEXT_T_NORMAL, PARA_RKEY);
    }
    else
    {
        return(0);
    }

    /*  */
    b = u_gettag(NAME_CHKCODE, NULL, PARA_ALL);

		z_logv(u_logfile,"chk result=[%s]", u_tagvalue[b].value);    
    if( strcmp(u_tagvalue[b].value, CODE_CHECKOK) == 0 ) return(0);
    else return(1);
}

/********************************************
 ksh ִshellı
 ڲchar     *cmd     --shellı
           char     *vdef    --shell
 ڲchar     *outbuf  --Ϣ
           int       outlen  --Ϣ

 ֵ  0-255   ӽ˳״̬
           -1      ϵͳ
           -3      ӽ̱źж
 ********************************************/
int u_kshcmd(char *cmd, char *vdef, char *outbuf, int outlen)
{
    pid_t cpid;

    int child_stat,       /* ӽ˳״̬ */
        pipe1[2], fd[2];

    struct sigaction sachld, osachld, saign, osaintr, osaquit;

    *outbuf = 0;

    if( pipe(fd) < 0 ) return(-1);

    saign.sa_handler = SIG_IGN;    /* ignore SIGINT and SIGQUIT */
    sigemptyset(&saign.sa_mask);
    saign.sa_flags = 0;

    if( sigaction(SIGINT, &saign, &osaintr) < 0 ) return(-1);
    if( sigaction(SIGQUIT, &saign, &osaquit) < 0 ) return(-1);

    memset(&sachld, 0, sizeof(sachld));
    sigemptyset(&sachld.sa_mask);
    sachld.sa_flags = 0;

    /* ָźŴ */
    sachld.sa_handler = SIG_DFL;
    sigaction(SIGCHLD, &sachld, &osachld);

    cpid = fork();

    if( cpid < 0 )
    {
        sigaction(SIGCHLD, &osachld, NULL);
        close(fd[0]);
        close(fd[1]);
        return(-1);
    }
    else if( cpid == 0 )
    {
        close(fd[0]);
        umask(000);

        /* restore previous signal actions */
        sigaction(SIGINT, &osaintr, NULL);
        sigaction(SIGQUIT, &osaquit, NULL);
        sigaction(SIGCHLD, &osachld, NULL);

        if( pipe(pipe1) < 0 ) exit(-1);

        /* дܵ */
        if( vdef ) write(pipe1[1], vdef, strlen(vdef));
        write(pipe1[1], cmd, strlen(cmd));
        write(pipe1[1], "\nexit 0\n", 8);

        close(pipe1[1]);

        /* д */
        close(0);
        dup(pipe1[0]);

        close(1);
        dup(fd[1]);

        close(2);

        execlp("ksh", "ksh", (char *)0);
        exit(-1);
    }
    close(fd[1]);

    /* ȴӽִ */
    if( waitpid(cpid, &child_stat, 0) < 0 )
    {
        if( kill(cpid, 0) == 0 ) kill(cpid, SIGKILL);
        return(-2);
    }

    sigaction(SIGCHLD, &osachld, NULL);
    sigaction(SIGINT, &osaintr, NULL);
    sigaction(SIGQUIT, &osaquit, NULL);

    /* 鿴ӽǷźж */
    if( WIFSIGNALED(child_stat) ) return(-3);

    /* ȡȫϢƥ */
    if( outbuf ) GC_read_until(fd[0], outbuf, outlen, "\001\002\003");
    close(fd[0]);
		if(u_writelog >= 1) z_logv(u_logfile, "shell_result=[%s]",outbuf);
    /* ӽ˳״̬ */
    return( WEXITSTATUS(child_stat) );
}

/**************************************
 ƽֵ̨֧ú
 ڲSMRULE  *prule    --
           char     *text1   --
 ڲchar     *vname   --
           char     *vout    --

 ֵ   0      ɹ
            1      ֵ֧ĺ
           -1      ʧ
 **************************************/
int u_func_eval(SMRULE *prule, char *text1, char *vname, char *vout)
{
    char *p, fname[65];

    CHKFUNC_PTR pf;

    *vname = 0;
    *vout = 0;

    z_atrim(text1);

    /* ֽ */
    p = text1;

    if( z_get_fieldv(&p, vname, NULL, 64, "=") == 0 )    /*  */
    {
        strcpy(fname, vname);
        strcpy(vname, NAME_CHKCODE);
    }
    else
        z_get_fieldv(&p, fname, NULL, 64, ";");

    if( (pf = u_func_search(fname)) == 0 )
    {
        z_logv(u_logfile, "󣺲ֵ֧ĺ%s", fname);
        return(1);
    }

    /*  */
    if( pf(prule, u_tagvalue, vout) ) return(-1);

    return(0);
}

int getrows(SMRULE *prule, TAGVALUE *ptv, char *out)
{
    strcpy(out, "200");
    return(0);
}

