//======================================================================
// 
// Policy.c
//
// Copyright (C) CVIC Software Engineering CO.,LTD.
//
// 
// 
//======================================================================


#include "Policy.h"


// Ȩ
PCHAR				gPSuperProcess;

// 
PPATH_INFO			gPFilterInfo = NULL;

// 
KSPIN_LOCK          gFilterMutex;


VOID InitPolicy()
{
	KeInitializeSpinLock( &gFilterMutex );
}

// ͷŲ
VOID ReleasePolicy( PPATH_INFO policy )
{
	// ղ	???????????????????????????????????ӦúͷӦ
	if ( NULL != policy )
	{
		// ͷżĿ¼
		if ( NULL != policy->pPath )
		{
			ExFreePool( policy->pPath );
			policy->pPath = NULL;
		}

		// ͷųĿ¼
		if ( NULL != policy->pExcludePath )
		{
			PLIST_INFO listCur = policy->pExcludePath;
			while ( NULL != listCur )
			{
				PLIST_INFO listNext = listCur->pNext;
				ExFreePool( listCur );
				listCur = listNext;
			}
			policy->pExcludePath = NULL;
		}

		// ͷųļ
		if ( NULL != policy->pExcludeFile )
		{
			PLIST_INFO listCur = policy->pExcludeFile;
			while ( NULL != listCur )
			{
				PLIST_INFO listNext = listCur->pNext;
				ExFreePool( listCur );
				listCur = listNext;
			}
			policy->pExcludeFile = NULL;
		}

		// ͷų
		if ( NULL != policy->pExcludeType )
		{
			ExFreePool( policy->pExcludeType );
			policy->pExcludeType = NULL;
		}

		// ͷģų
		if ( NULL != policy->pExcludeBlur )
		{
			ExFreePool( policy->pExcludeBlur );
			policy->pExcludeBlur = NULL;
		}

		// ͷһĿ¼Ϣ
		if ( NULL != policy->pNext )
		{
			ReleasePolicy( policy->pNext );
		}

		// ͷŽϢ
		ExFreePool( policy );
		policy = NULL;
	}
}

VOID ClearPolicy()
{
	KIRQL  oldirql;
	KeAcquireSpinLock( &gFilterMutex, &oldirql );

	if ( gPFilterInfo )
	{
		ReleasePolicy( gPFilterInfo );
		gPFilterInfo = NULL;
	}

	if ( gPSuperProcess )
	{
		ExFreePool( gPSuperProcess );
		gPSuperProcess = NULL;
	}

	KeReleaseSpinLock( &gFilterMutex, oldirql );
}

// Ȩ
VOID ClearSetSuperProcess()
{
	KIRQL  oldirql;
	KeAcquireSpinLock( &gFilterMutex, &oldirql );

	if ( gPSuperProcess )
	{
		ExFreePool( gPSuperProcess );
		gPSuperProcess = NULL;
	}

	KeReleaseSpinLock( &gFilterMutex, oldirql );
}

// Ȩ
VOID SetSuperProcess( IN PVOID InputBuffer OPTIONAL, IN ULONG InputBufferLength )
{
	KIRQL  oldirql;
	KeAcquireSpinLock( &gFilterMutex, &oldirql );
	if ( gPSuperProcess )
	{
		ExFreePool( gPSuperProcess );
		gPSuperProcess = NULL;
	}
	gPSuperProcess = ExAllocatePool( NonPagedPool, InputBufferLength );
	memcpy( gPSuperProcess, InputBuffer, InputBufferLength );
	DbgPrint(( "GuardFileDriver: SetSuperProcess-(%s)\n", gPSuperProcess ));
	ToUpper( gPSuperProcess );
	KeReleaseSpinLock( &gFilterMutex, oldirql );
}

// ųĿ¼ųļ
PLIST_INFO SetListInfo( IN PCHAR str, IN ULONG len )
{
	PLIST_INFO listInfo = NULL;
	PLIST_INFO listInfoCur = NULL;
	ULONG		i = 0;
	ULONG		startOffset = 0;

	// ȷͷλ
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == MLEMENT_SEPCHARE )
		{
			break;
		}
	}

	// ȡ
	i++;
	startOffset = i;
	for ( i; i<len; i++ )
	{
		// Ҫstr|βĻһݼӲȥ
		if ( (*( str + i )) == MLEMENT_SEPCHARE )
		{
			ULONG typeLen = i - startOffset;
			if ( typeLen > 1 )
			{
				// ڴ
				if ( NULL == listInfo )
				{
					listInfo = ExAllocatePool( NonPagedPool, sizeof(PLIST_INFO) );
					listInfoCur = listInfo;
				}
				else
				{
					listInfoCur->pNext = ExAllocatePool( NonPagedPool, sizeof(PLIST_INFO) );
					listInfoCur = listInfoCur->pNext;
				}

				// 
				listInfoCur->pItem = ExAllocatePool( NonPagedPool, typeLen + 1 );
				memset( listInfoCur->pItem, '\0', typeLen + 1 );
				memcpy( listInfoCur->pItem, str + startOffset, typeLen );
				ToUpper( listInfoCur->pItem );
				listInfoCur->pNext = NULL;
				startOffset = i+1;
			}
		}
	}

	return listInfo;
}

PPATH_INFO SetOnePath( IN PCHAR str, IN ULONG len )
{
	PPATH_INFO pPathInfo;
	ULONG	i = 0;
	ULONG	startOffset;
	ULONG	typeLen;

	pPathInfo = ExAllocatePool( NonPagedPool, sizeof(PATH_INFO) );

	// ȡĿ¼
	startOffset = i;
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == TYPE_SEPCHARE )
		{
			break;
		}
	}
	typeLen = i - startOffset;
	if ( typeLen > 1 )
	{
		pPathInfo->pPath = ExAllocatePool( NonPagedPool, typeLen + 1 );
		memset( pPathInfo->pPath, '\0', typeLen + 1 );
		memcpy( pPathInfo->pPath, str + startOffset, typeLen );
		ToUpper( pPathInfo->pPath );
	}
	else
	{
		pPathInfo->pPath = NULL;
	}

	// ȡų·
	i++;
	startOffset = i;
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == TYPE_SEPCHARE )
		{
			break;
		}
	}
	typeLen = i - startOffset;
	if ( typeLen > 1 )
	{
		PCHAR sExcludePaths = ExAllocatePool( NonPagedPool, typeLen );
		memcpy( sExcludePaths, str + startOffset, typeLen );
		pPathInfo->pExcludePath = SetListInfo( sExcludePaths, typeLen );
		ExFreePool( sExcludePaths );
	}
	else
	{
		pPathInfo->pExcludePath = NULL;
	}

	// ųļ
	i++;
	startOffset = i;
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == TYPE_SEPCHARE )
		{
			break;
		}
	}
	typeLen = i - startOffset;
	if ( typeLen > 1 )
	{
		PCHAR sExcludeFiles = ExAllocatePool( NonPagedPool, typeLen );
		memcpy( sExcludeFiles, str + startOffset, typeLen );
		pPathInfo->pExcludeFile = SetListInfo( sExcludeFiles, typeLen );
		ExFreePool( sExcludeFiles );
	}
	else
	{
		pPathInfo->pExcludeFile = NULL;
	}

	// ų
	i++;
	startOffset = i;
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == TYPE_SEPCHARE )
		{
			break;
		}
	}
	typeLen = i - startOffset;
	if ( typeLen > 1 )
	{
		pPathInfo->pExcludeType = ExAllocatePool( NonPagedPool, typeLen + 1 );
		memset( pPathInfo->pExcludeType, '\0', typeLen + 1 );
		memcpy( pPathInfo->pExcludeType, str + startOffset, typeLen );
		ToUpper( pPathInfo->pExcludeType );
	}
	else
	{
		pPathInfo->pExcludeType = NULL;
	}

	// ģģ
	i++;
	startOffset = i;
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == TYPE_SEPCHARE )
		{
			break;
		}
	}
	typeLen = i - startOffset;
	if ( typeLen > 1 )
	{
		pPathInfo->pExcludeBlur = ExAllocatePool( NonPagedPool, typeLen + 1 );
		memset( pPathInfo->pExcludeBlur, '\0', typeLen + 1 );
		memcpy( pPathInfo->pExcludeBlur, str + startOffset, typeLen );
		ToUpper( pPathInfo->pExcludeBlur );
	}
	else
	{
		pPathInfo->pExcludeBlur = NULL;
	}
	
	// ų¼
	i++;
	startOffset = i;
	for ( i; i<len; i++ )
	{
		if ( (*( str + i )) == TYPE_SEPCHARE )
		{
			break;
		}
	}
	typeLen = i - startOffset;
	if ( typeLen > 1 )
	{
		PCHAR sExcludeEvent = ExAllocatePool( NonPagedPool, typeLen );
		memcpy( sExcludeEvent, str + startOffset, typeLen );

		pPathInfo->bExcludeCreateEvent = FALSE;
		pPathInfo->bExcludeDeleteEvent = FALSE;
		pPathInfo->bExcludeChangeEvent = FALSE;
		pPathInfo->bExcludeRenameEvent = FALSE;

		if ( typeLen >= 2 && ( *( sExcludeEvent + 1 ) ) != '0' )
		{
			pPathInfo->bExcludeCreateEvent = TRUE;
		}
		if ( typeLen >= 4 && ( *( sExcludeEvent + 3 ) ) != '0' )
		{
			pPathInfo->bExcludeCreateEvent = TRUE;
		}
		if ( typeLen >= 6 && ( *( sExcludeEvent + 5 ) ) != '0' )
		{
			pPathInfo->bExcludeCreateEvent = TRUE;
		}
		if ( typeLen >= 8 && ( *( sExcludeEvent + 7 ) ) != '0' )
		{
			pPathInfo->bExcludeCreateEvent = TRUE;
		}
		
		ExFreePool( sExcludeEvent );
	}
	else
	{
		pPathInfo->bExcludeCreateEvent = FALSE;
		pPathInfo->bExcludeDeleteEvent = FALSE;
		pPathInfo->bExcludeChangeEvent = FALSE;
		pPathInfo->bExcludeRenameEvent = FALSE;
	}

	return pPathInfo;
}

// ò
VOID SetPolicy( IN PVOID InputBuffer OPTIONAL, IN ULONG InputBufferLength )
{
	KIRQL  oldirql;
	PPATH_INFO pathCur;
	PCHAR				policyBuf;		// ַ
	ULONG				i;
	ULONG				pathStartOffset;

	DbgPrint(( "GuardFileDriver: SetPolicy-start\n"));

	KeAcquireSpinLock( &gFilterMutex, &oldirql );

	// ȡԴ
	policyBuf = ExAllocatePool( NonPagedPool, InputBufferLength );
	memcpy( policyBuf, InputBuffer, InputBufferLength );
	DbgPrint(( "GuardFileDriver: SetPolicy-(%s) %d\n", policyBuf, InputBufferLength ));

	// ͷŲ
	ReleasePolicy( gPFilterInfo );
	gPFilterInfo = NULL;

	// Ӳ
	// ַ
	i = 0;
	// ҵһPATH_START
	for ( i; i<InputBufferLength; i++ )
	{
		if ( (*( policyBuf + i )) == PATH_START  )
		{
			break;
		}
	}

	// ȡÿһĿ¼
	i++;
	pathStartOffset = i;
	while ( i < InputBufferLength )
	{
		if ( (*( policyBuf + i )) == PATH_START || (*( policyBuf + i )) == ALL_END )
		{
			// ַ
			ULONG len = i -  pathStartOffset;
			if ( len > 0 )
			{
				PCHAR strPath = ExAllocatePool( NonPagedPool, i -  pathStartOffset );
				memcpy( strPath, policyBuf + pathStartOffset, len );

				if ( NULL == gPFilterInfo )
				{
					gPFilterInfo = SetOnePath( strPath, len );
					pathCur = gPFilterInfo;
				}
				else
				{
					pathCur->pNext = SetOnePath( strPath, len );
					pathCur = pathCur->pNext;
				}
				pathCur->pNext = NULL;
				ExFreePool( strPath );
			}
			i++;
			pathStartOffset = i;
			if ( (*( policyBuf + i )) == ALL_END )
			{
				break;
			}
		}
		else
		{
			i++;
		}
	}

	ExFreePool( policyBuf );

	KeReleaseSpinLock( &gFilterMutex, oldirql );

	DbgPrint(( "GuardFileDriver: SetPolicy-end\n"));
}

// תɴд
VOID ToUpper( IN PCHAR str )
{
	PCHAR p = str;
	while ( p && *p )
	{
		*p = ('a'<=*p && *p<='z') ? (*p+'A'-'a') : *p;
		p ++;
	}
}
