/***********************************************************************
*
* ļ        ProtectLinux.h
* ģĿģFile Protection Module
* ߼ڣ  zhang_quan 2010-02-03
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef PROTECT_H
#define PROTECT_H


#include <Base/MonitorDef.h>
#include <Base/MonitorInterface.h>
#include <Base/ThreadPool.h>
#include <Common/Common.h>
#include <Common/Container.h>
#include <GDLock/GDLock.h>
#include <GDLog/GDLog.h>
#include <FileExclude/FileExclude.h>
#include <FileOpt/FileList.h>
#include <FileOpt/FileOpt.h>
#include <GDLog/GDTrace.h>
#include <iostream>
#include <string>
#include <queue>
#include <deque>
#include <list>
#include <map>

#include <pthread.h>
#include <signal.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdint.h>
#include <linux/types.h>

using namespace std;
#define NO_NAME (999)

class CProtect
{
	// Ŀ¼
	class CDirInfo
	{
	public:
		
//		enum DirOp {PLUS = 333, MINUS = 555};
		enum FINDTYPE {DIR = 0x2, FILE = 0x4, ALL = 0x8};
		// 
		CDirInfo( CMonitorInformation& moniInfo ) 
		{
			// Ŀ¼
			memset( m_szDir, 0, sizeof m_szDir );
			strcpy( m_szDir, moniInfo.m_monitorPath.c_str() );
//			GDPrint( "m_szDir is :[%s]\n", m_szDir );
			
//			modifyDirAttr( moniInfo, false );
//			setExcludeRules( moniInfo );
		}

		// 
		~CDirInfo()
		{
		}

		bool StartMonitor( CMonitorInformation& moniInfo )
		{
			CGDTrace trace( LOG_L6, "CDirInfo:StartMonitor" );
			int iRet = 256;
			chDirAttr( m_szDir, true, true );
			iRet = refreshExcludeRules( moniInfo );
			return (iRet == 0 ? true :false);
		}

		int refreshExcludeRules( CMonitorInformation &moniInfo)
		{
			CGDTrace trace( LOG_L6, "CDirInfo:refreshExcludeRules" );

			CMonitorInformation moniInfoBak;
			int iRet = getExcludeRules( moniInfoBak );
			iRet = (iRet == 0) ? modifyDirAttr( moniInfoBak, true ) : errno;
			iRet = (iRet == 0) ? setExcludeRules( moniInfo ) : errno;
			iRet = (iRet == 0) ? modifyDirAttr( moniInfo, false ) : errno;
			
			return iRet;
		}

		// ֹͣصǰ󵥸Ŀ¼
		bool StopMonitor()
		{
			int iRet = 256;
			iRet = chDirAttr(m_szDir, false, true);
			return (iRet == 0 ? true :false);
		}

		// set file or dir exclude rules to chDirAttr and store them into fileExclude
		inline int setExcludeRules( const CMonitorInformation& moniInfo )
		{
			return (m_fileExclude.SetRules( moniInfo )? 0 : -1);
		}
		
		// get file or dir exclude rules from fileExclude
		inline int getExcludeRules( CMonitorInformation &moniInfo )
		{
			return (m_fileExclude.GetRules( moniInfo ) ? 0 : -1);
		}

		int modifyDirAttr( CMonitorInformation &moniInfo, bool BPlusOrMinus)
		{
			int iRet = 0;
			vector<string>::iterator iter;

		    //ųĿ¼б
			int iPos;
			for (iter = moniInfo.m_excludePath.begin(),moniInfo.m_excludePath.size() > 0; iter != moniInfo.m_excludePath.end(); iter++)
			{
				if(!(strncmp( (*iter).c_str(), moniInfo.m_monitorPath.c_str(), moniInfo.m_monitorPath.size())))
					if ((*iter).find("*") != string::npos)
					{
						iPos = (*iter).find_last_of("/");
						iRet = chDirAttr((*iter).substr(0, iPos).c_str(), BPlusOrMinus, false, true, (*iter).substr(iPos+1).c_str(), ALL);
						if (BPlusOrMinus == false)
						{
							iRet = chDirAttr((*iter).substr(0, iPos).c_str(), true);
						}
					}
					else
					{
						iRet = chDirAttr((*iter).c_str(), BPlusOrMinus, true);
					}
				if( iRet )
					CGDLog::WriteErrLog("CProtect:modifyDirAttr DirList return value:[%x],[%s]", iRet, strerror(iRet));
			}

			//ųļб
			for (iter = moniInfo.m_excludeFile.begin(), moniInfo.m_excludeFile.size() > 0; iter != moniInfo.m_excludeFile.end(); iter++)
			{
				if(!(strncmp( (*iter).c_str(), moniInfo.m_monitorPath.c_str(), moniInfo.m_monitorPath.size())))
					iRet = chDirAttr((*iter).c_str(), BPlusOrMinus, false, false, "", FILE);
				if( iRet )
					CGDLog::WriteErrLog("CProtect:modifyDirAttr FileList return value:[%x],[%s]", iRet , strerror(iRet));
			}

    		//ųļ
			string sTmp = "";
			for (iter = moniInfo.m_excludeType.begin(); iter != moniInfo.m_excludeType.end(); iter++)
			{
				sTmp = "*." + *iter;
				iRet = chDirAttr(m_szDir, BPlusOrMinus, true, true, sTmp, FILE);
				sTmp ="";
				if( iRet )
					CGDLog::WriteErrLog("CProtect:modifyDirAttr FileExcludeType return value:[%x],[%s]", iRet, strerror(iRet));
			}	

			//ģƥų
			for (iter = moniInfo.m_excludeBlur.begin(); iter != moniInfo.m_excludeBlur.end(); iter++)
			{
				iRet = chDirAttr(m_szDir, BPlusOrMinus, false, true, (*iter).c_str(), FILE );
				if (BPlusOrMinus == false)
				{
					iRet = chDirAttr((*iter).substr(0, iPos).c_str(), true);
				}
				if( iRet )
					CGDLog::WriteErrLog("CProtect:modifyDirAttr FileMatchExclude return value:[%x],[%s]", iRet, strerror(iRet));
			}	
			
			return iRet;
		}

		//ıĿ¼, ĺ漰κҵ߼
		// m_szName:dirname or filename or vague matching,etc.
		// bPlusOrMinus:true=+i, false=-i.
		// bPrefix:if prefix is required, pass real parameter, otherwise no param passed here.
		// sPattern: required for -name option
		inline static int 
		chDirAttr( const char *m_cName, 
				   bool bPlusOrMinus, 
				   bool bRecursive = false, 
				   bool bPrefix = false, 
				   string sPattern = "" , 
				   FINDTYPE findType = ALL)
		{	
			string sTmp;
			sTmp = sTmp + "m_cName:[" + m_cName
				+ "]bPlusOrMinus:[" + (bPlusOrMinus ? "1" : "0") 
				+ "], bRecursive:[" + (bRecursive ? "1" : "0") 
				+ "] bPrefix:["     + (bPrefix ? "1" : "0") 
				+ "] sPattern:["    + sPattern;
			CGDTrace trace( LOG_L6, "CDirInfo:chDirAttr[%s]", sTmp.c_str());

			string m_szName = m_cName;
			if (!bPrefix && !(m_cName && *m_cName))
				return NO_NAME;	

			string s = "";
			// find m_szDir -name "m_szDir"	| xargs chattr +-i 
			if (bPrefix)
			{
				s += "find \"" + m_szName + "\"" ;

				if (findType & DIR)
					s += " -type d ";
				else if (findType & FILE)
					s += " -type f ";

				s += " -name \"" + sPattern + "\" -print0 | xargs -0 ";
			}

			s += "chattr ";
			s += bPlusOrMinus ? "+i " : "-i ";
			s += bRecursive ? "-R " : "";

			// chattr +-i -R filename or dirname
			if (!bPrefix)	
				s +=  "\"" + m_szName + "\"";

			s += " > /dev/null 2>&1";
//			GDPrint("all the ChDirAttr command is [%s]\n", s.c_str());

#ifdef NDEBUG
			signal(SIGCHLD, SIG_DFL);
#endif
			int iRet = system (s.c_str());	
#ifdef NDEBUG
			signal(SIGCHLD, SIG_IGN);
#endif

			// iRet =127 /bin/sh not available; 
			if( iRet != 0 )
			{
				int iPos = 0;
				iPos = s.find("chattr");
				s.replace(iPos, 6, "FIPROT", 6);

				if(bPlusOrMinus)
					s.replace(s.find("+i"), 2, "AD", 2);
				else
					s.replace(s.find("-i"), 2, "DE", 2);

				CGDLog::WriteErrLog("system function return value:[%x],[%s], command:[%s]", iRet, strerror(errno), s.c_str());
				iRet = (iRet != -1) ? 0 : -1;
			}
			
			return iRet;
		}

		inline long removeExcludeDirAttr()
		{
		// here to invoke a function to extract the exclusion policy and parse them into 2 lists, one is for storage, the other is for chattr -i or +i, minus or plus should be affirmed here.    better to call the same function here   and when to return
			CMonitorInformation moniInfo;
			getExcludeRules( moniInfo );
			modifyDirAttr( moniInfo, false );
		}	

	public:
		char m_szDirId[ GD_MAX_PATH ];  // Ŀ¼ID add by wu_bin
		char m_szDir[ GD_MAX_PATH ];    // Ŀ¼(Ǳ)
		char m_dust[ GD_MAX_PATH ];     // ռλ

		int m_nIdx;
		CFileExclude m_fileExclude;		// ų
		enum
		{ 
			STATUS_STARTING,
			STATUS_STARTED,
			STATUS_STOPPING, 
			STATUS_STOPED, 
			STATUS_CLOSING,
			STATUS_CLOSED,
			STATUS_NORMAL=STATUS_STARTED, 
			STATUS_ERROR
		} m_status;						// ״̬

	};//CdirInfo

public:
	CProtect();
	~CProtect();

private:
	bool isInited; 
	pthread_mutex_t m_mutex;
	bool m_bWorking;						// ƹ߳˳
	pthread_mutex_t m_cs;					// ¼в
	static std::map<std::string, CDirInfo*> m_dirmap;	// Ŀ¼б

public:
	// 
	bool Initialize( const char * sParams );
	// ӼĿ¼
	bool WatchDirectory( CMonitorInformation& moniInfo );
	// ɾĿ¼
	bool UnwatchDirectory( const char * sDirId );
	// ֹͣ
	bool Uninitialize();
	// Ƿ
	bool IsWatchingDirectory( const char * szDir );
	bool IsWatched( const char* sDirId );
    bool IsWatchedByWebsiteId( const char * sWebsiteId );

public:
	inline static int 
	chDirAttr( const char *m_szName, bool bPlusOrMinus, bool bRecursive = false, bool bPrefix = false, string sPattern = "" )
	{
		return CDirInfo::chDirAttr( m_szName, bPlusOrMinus, bRecursive, bPrefix, sPattern );
	}

	//ȥųĿ¼i
	inline static long removeExcludeDirAttr( const char * sDirId)
	{
		map< string, CDirInfo* >::iterator it = m_dirmap.find( sDirId );
		if ( it == m_dirmap.end() )
			return 256;

		CDirInfo* pDirInfo = it->second;
		return pDirInfo->removeExcludeDirAttr();
	}
		
};//CProtect

#endif // #ifndef ProtectLinux_H

