/************
 UAP ڴˢ
 ************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/sem.h>
#include "uap_fdecl.h"
#include "uap_gvdecl.h"
#include "gcps.h"
#include "z.h"
#include "es_fdecl.h"

/**************
 ЭIDȽϺ
 **************/
int u_protcpr(const void *k, const void *e)
{
    return( strcmp((char *)k, ((UAP_PROT *) e)->szProtID) );
}

/************************
 ýӵеЭƫ
 ************************/
int u_set_nodeprot(void)
{
    int  i, nLastProt = -1;         // һЭƫ
    char szLastID[65] = {0};        // һЭID

    UAP_PROT *p = NULL;

    // жЭĿ
    if( u_pGInf->nProt == 0 ) return(0);

    // ӵϢ
    for( i = 0; i < N_NODE && u_pGInf->sNode[i].szNodeID[0]; i++ )
    {
        // ЭIDͬʱֲЭϢ
        if( strcmp(szLastID, u_pGInf->sNode[i].szProtID) )
        {
            strcpy(szLastID, u_pGInf->sNode[i].szProtID);

            p = (UAP_PROT *) bsearch(u_pGInf->sNode[i].szProtID, u_pGInf->sProt, u_pGInf->nProt, sizeof(UAP_PROT), u_protcpr);

            // ƫ
            if( p == NULL )
                nLastProt = -1;
            else
                nLastProt = p - u_pGInf->sProt;
        }

        // ýӵṹеЭƫ
        u_pGInf->sNode[i].nProtOffset = nLastProt;
    }

    return(0);
}

/********************
 űϢȽϺ
 ********************/
int u_flowcpr(const void *k, const void *e)
{
    return( strcmp((char *)k, ((UAP_FLOW *) e)->szFlowID));
}

/************
 ҽűƫ
 ************/
int u_seek_flow(const char *pID)
{
    static int  nLastFlow = -1;         // һűƫ
    static char szLastID[65] = {0};     // һűID

    UAP_FLOW *p = NULL;

    if( pID == NULL || *pID == 0 ) return(-1);

    // űIDͬʱֲҽűϢ
    if( strcmp(szLastID, pID) )
    {
        strcpy(szLastID, pID);

        p = (UAP_FLOW *) bsearch(pID, u_pGInf->sFlow, u_pGInf->nFlow, sizeof(UAP_FLOW), u_flowcpr);

        // ƫ
        if( p == NULL )
            nLastFlow = -1;
        else
            nLastFlow = p->nOffset;
    }

    return(nLastFlow);
}

/************************
 ҵеĽűƫ
 ************************/
int u_set_busiflow(void)
{
    int  i;

    // жϽűĿ
    if( u_pGInf->nFlow == 0 ) return(0);

    // ҵϢ
    for( i = 0; i < N_BUSI && u_pGInf->sBusi[i].szBusiID[0]; i++ )
    {
        u_pGInf->sBusi[i].nFlowOffset = u_seek_flow(u_pGInf->sBusi[i].szFlowID);
    }

    return(0);
}

/************************
 ЭеĽűƫ
 ************************/
int u_set_protflow(void)
{
    int  i;

    // жϽűĿ
    if( u_pGInf->nFlow == 0 ) return(0);

    // ЭϢ
    for( i = 0; i < N_PROT && u_pGInf->sProt[i].szProtID[0]; i++ )
    {
        u_pGInf->sProt[i].nQHOffset = u_seek_flow(u_pGInf->sProt[i].szQHeadID);
        u_pGInf->sProt[i].nPHOffset = u_seek_flow(u_pGInf->sProt[i].szPHeadID);
    }

    return(0);
}

/************
 ˢ½ӵ
 ************/
int u_refresh_node(int nTmout)
{
    int i, b,
        nCode = 0,      // ݿ
        nRows = 0;      // ¼Ŀ

    UAP_NODE *p = NULL;

    // ڴ
    p = (UAP_NODE *) malloc(sizeof(u_pGInf->sNode));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sNode));

    for( i = 0; i < N_NODE; i++ )
    {
        p[i].nProtOffset = -1;
    }

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_node(p, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_NODE);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sNode, p, sizeof(u_pGInf->sNode));
    u_pGInf->nNode = nRows;

    // ýӵеЭƫ
    u_set_nodeprot();

    // ýӵеIPûϢ
    //u_set_nodeipusr();

    u_pGInf->nValid[RN_NODE] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/************
 ˢЭ
 ************/
int u_refresh_prot(int nTmout, const char *pProList)
{
    int b,
        nCode = 0,      // ݿ
        nRows = 0;      // ¼Ŀ

    UAP_PROT *p = NULL;

    // ڴ
    p = (UAP_PROT *) malloc(sizeof(u_pGInf->sProt));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sProt));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_prot(p, pProList, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_PROT);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sProt, p, sizeof(u_pGInf->sProt));
    u_pGInf->nProt = nRows;

    // ýӵеЭƫ
    u_set_nodeprot();

    // ЭеĽűƫ
    u_set_protflow();

    u_pGInf->nValid[RN_PROT] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/**********
 ˢIP
 **********/
int u_refresh_IP(int nTmout)
{
    int b,
        nCode = 0,      // ݿ
        nRows = 0;      // ¼Ŀ

    UAP_IPAUTH *p = NULL;

    // ڴ
    p = (UAP_IPAUTH *) malloc(sizeof(u_pGInf->sIP));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sIP));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_IP(p, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_IPA);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sIP, p, sizeof(u_pGInf->sIP));
    u_pGInf->nIP = nRows;

    // ýӵеIPûϢ
    //u_set_nodeipusr();

    u_pGInf->nValid[RN_IPA] = 1;    // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/************
 ˢû
 ************/
int u_refresh_user(int nTmout)
{
    int b,
        nCode = 0,      // ݿ
        nRows = 0;      // ¼Ŀ

    UAP_USERAUTH *p = NULL;

    // ڴ
    p = (UAP_USERAUTH *) malloc(sizeof(u_pGInf->sUser));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sUser));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_user(p, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_USRA);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sUser, p, sizeof(u_pGInf->sUser));
    u_pGInf->nUser = nRows;

    // ýӵеIPûϢ
    //u_set_nodeipusr();

    u_pGInf->nValid[RN_USRA] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/************
 ˢҵ
 ************/
int u_refresh_busi(int nTmout, const char *pProList)
{
    int  b,
         nCode = 0,                 // ݿ
         nRows = 0;                 // ¼Ŀ

    UAP_BUSI *p = NULL;

    // ڴ
    p = (UAP_BUSI *) malloc(sizeof(u_pGInf->sBusi));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sBusi));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_busi(p, pProList, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_BUSI);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sBusi, p, sizeof(u_pGInf->sBusi));
    u_pGInf->nBusi = nRows;

    // ҵеĽűƫ
    u_set_busiflow();

    u_pGInf->nValid[RN_BUSI] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/************
 ˢ½ű
 ************/
int u_refresh_flow(int nTmout)
{
    int b,
        nCode = 0,      // ݿ
        nRows = 0,      // ¼Ŀ
        nLen = 0;       // űۼƳ

    UAP_FLOW *p = NULL;
    char *pBuf = NULL;

    // ڴ
    p = (UAP_FLOW *) malloc(sizeof(u_pGInf->sFlow));
    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }
    memset(p, 0, sizeof(u_pGInf->sFlow));

    pBuf = (char *) malloc(N_SCRIPT);
    if( pBuf == NULL )
    {
        free(p);
        printf("ڴʧ\n");
        return(-1);
    }
    memset(pBuf, 0, N_SCRIPT);

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_flow(p, pBuf, &nCode, &nRows, &nLen);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        free(pBuf);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        free(pBuf);
        printf("\n󣺼¼Ŀ %d\n", N_FLOW);
        return(-1);
    }
    printf("OK (%d rows, %d in length).\n", nRows, nLen);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        free(pBuf);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sFlow, p, sizeof(u_pGInf->sFlow));
    memcpy(u_pGInf->szFlow, pBuf, N_SCRIPT);
    u_pGInf->nFlow = nRows;
    u_pGInf->nFlowLen = nLen;

    // ҵеĽűƫ
    u_set_busiflow();

    // ЭеĽűƫ
    u_set_protflow();

    u_pGInf->nValid[RN_FLOW] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        free(pBuf);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    free(pBuf);
    return(0);
}

/************
 ˢºŶ
 ************/
int u_refresh_h3(int nTmout)
{
    int b,
        nCode = 0,      // ݿ
        nRows = 0;      // ¼Ŀ

    UAP_H3 *p = NULL;

    // ڴ
    p = (UAP_H3 *) malloc(sizeof(u_pGInf->sH3));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sH3));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_h3(p, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_H3);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sH3, p, sizeof(u_pGInf->sH3));
    u_pGInf->nH3 = nRows;

    u_pGInf->nValid[RN_H3] = 1;     // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/**************
 ˢ·
 **************/
int u_refresh_rcode(int nTmout)
{
    int b,
        nCode  = 0,     // ݿ
        nRows  = 0,     // ¼Ŀ
        nRows1 = 0,     // ¼Ŀ
        nRows2 = 0;     // ¼Ŀ

    UAP_RCODE *p = NULL;

    // ڴ
    p = (UAP_RCODE *) malloc(sizeof(u_pGInf->sRCode));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sRCode));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_rcode(p, &nCode, &nRows, &nRows1, &nRows2);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_RCODE);
        return(-1);
    }
    printf("OK (%d + %d + %d = %d rows).\n", nRows, nRows1, nRows2, nRows + nRows1 + nRows2);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sRCode, p, sizeof(u_pGInf->sRCode));
    u_pGInf->nRCode = nRows;
    u_pGInf->nRCode1 = nRows1;
    u_pGInf->nRCode2 = nRows2;

    u_pGInf->nValid[RN_RCODE] = 1;  // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/****************
 ˢ²Ʒӳ
 ****************/
int u_refresh_pmap(int nTmout)
{
    int b,
        nCode  = 0,     // ݿ
        nRows  = 0;     // ¼Ŀ

    UAP_PMAP *p = NULL;

    // ڴ
    p = (UAP_PMAP *) malloc(sizeof(u_pGInf->sPMap));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sPMap));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    if( nTmout > 0 ) alarm(nTmout);
    b = u_load_pmap(p, &nCode, &nRows);
    if( nTmout > 0 ) alarm(0);

    if( b < 0 )
    {
        free(p);
        printf("ʧ %d\n", nCode);
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_PMAP);
        return(-1);
    }
    printf("OK (%d + %d = %d rows).\n", nRows, nRows, nRows + nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sPMap, p, sizeof(u_pGInf->sPMap));
    u_pGInf->nPMap = nRows;

    u_pGInf->nValid[RN_PMAP] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/************
 ˢ¸
 ************/
int u_refresh_cutover(const char *pFile)
{
    int b,
        nRows  = 0;     // ¼Ŀ

    UAP_CUTOVER *p = NULL;

    // ڴ
    p = (UAP_CUTOVER *) malloc(sizeof(u_pGInf->sCutOver));

    if( p == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(p, 0, sizeof(u_pGInf->sCutOver));

    // װ
    printf("ʾ ... ");
    fflush(stdout);

    b = u_load_cutover(pFile, p, &nRows);

    if( b < 0 )
    {
        free(p);
        printf("ʧ\n");
        return(-1);
    }
    else if( b == 1 )
    {
        free(p);
        printf("\n󣺼¼Ŀ %d\n", N_CUTOVER);
        return(-1);
    }
    printf("OK (%d rows).\n", nRows);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(p);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sCutOver, p, sizeof(u_pGInf->sCutOver));
    u_pGInf->nCutOver = nRows;

    u_pGInf->nValid[RN_CUTOVER] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(p);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(p);
    return(0);
}

/************
 ˢӦ
 ************/
int u_refresh_urge(const char *pFile)
{
    int   i, b;

    char  szUrl[256],
          szXmlReq[1024] = {0};

    char *pXmlResp;

    UAP_URGE *pUrge;
    ESINFO   *pEs, sEs;

    // ȡļӦϵͳURL
    if( z_getkeyv(pFile, SG_ESURL, szUrl, sizeof(szUrl) - 1) )
    {
        printf("ļ '%s' ûж %s\n", pFile, SG_ESURL);
        return(-1);
    }

    InitEs(&sEs);
    sEs.iEslists = 1;
    sEs.iChannel = 1;

    strcpy(sEs.cOpCode, TC_QUERY);
    sEs.iRegion = 0;

    // ڴ
    pXmlResp = (char *) malloc(1024 * N_URGE);

    if( pXmlResp == NULL )
    {
        printf("ڴʧ\n");
        return(-1);
    }

    memset(pXmlResp, 0, 1024 * N_URGE);

    // 챨
    if( (b = MakeEsXml(&sEs, 1, szXmlReq, pXmlResp)) < 0 )
    {
        printf("make xml failed=%d, [%s]\n", b, pXmlResp);
        free(pXmlResp);
        return(-1);
    }

    // ͱ
    printf("ʾ ... ");
    fflush(stdout);

    if( (b = GC_HttpPost(szUrl, NULL, szXmlReq, pXmlResp, 10, 30)) < 0 )
    {
        free(pXmlResp);
        printf("send http failed=%d\n", b);
        return(-1);
    }

    // ڴ
    pEs = (ESINFO *) malloc(sizeof(ESINFO) * N_URGE);

    if( pEs == NULL )
    {
        free(pXmlResp);
        printf("ڴʧ\n");
        return(-1);
    }

    memset(pEs, 0, sizeof(ESINFO) * N_URGE);

    // 
    if( (b = ParseEsXml(pXmlResp, pEs, N_URGE, szXmlReq)) < 0 )
    {
        free(pXmlResp);
        free(pEs);
        printf("parse xml failed=%d, [%s]\n", b, szXmlReq);
        return(-1);
    }
    free(pXmlResp);
    printf("OK (%d rows).\n", b);

    // ڴ
    pUrge = (UAP_URGE *) malloc(sizeof(UAP_URGE) * N_URGE);

    if( pUrge == NULL )
    {
        free(pEs);
        printf("ڴʧ\n");
        return(-1);
    }

    memset(pUrge, 0, sizeof(UAP_URGE) * N_URGE);

    for( i = 0; i < b; i++ )
    {
        pUrge[i].nRegion = pEs[i].iRegion;
        pUrge[i].cECrm = pEs[i].iCrmState;
        pUrge[i].cEBoss = pEs[i].iBossState;
        pUrge[i].cERes = pEs[i].iResState;
        pUrge[i].cMsgBlock = pEs[i].iMsgBlock;
        strcpy(pUrge[i].szChanID, pEs[i].cChannel);
        strcpy(pUrge[i].szETime, pEs[i].cStateTime);
        strcpy(pUrge[i].szRepMsg, pEs[i].cRepMsg);
    }
    free(pEs);

    // ٽˢ£
    if( u_Xzone_write(X_IN) < 0 )
    {
        free(pUrge);
        printf("ˢ¼ʧ\n");
        return(-1);
    }

    memcpy(u_pGInf->sUrge, pUrge, sizeof(u_pGInf->sUrge));
    u_pGInf->nUrge = b;

    u_pGInf->nValid[RN_URGE] = 1;   // װ

    // ٽ
    if( u_Xzone_write(X_OUT) < 0 )
    {
        free(pUrge);
        printf("ˢ½ʧ\n");
        return(-1);
    }

    free(pUrge);
    return(0);
}

/***********************************
 ˢָ
 ڲconst char * --  ļ
           int          --  
 ֵ  -1ʧ  0ɹ
 ***********************************/
int u_refresh_zone(const char *pFile, int aZone)
{
    int  b = 0, nCode,
         nEncry = 0,                // ϢǷ
         nTmout = T_DBTMOUT;        // ݿⳬʱʱ

    char szBuf[64],
         szTns[64],                 // ݿϢ
         szProList[1024] = {0};     // ϽЭIDб

    if( pFile == NULL || *pFile == 0 ) return(-1);

    // /Ӧˢ£ݿ
    if( aZone != R_CUTOVER && aZone != R_URGE )
    {
        // ȡļݿ
        if( z_getkeyv(pFile, SG_DBINFO, szTns, sizeof(szTns) - 1) )
        {
            printf("ļ '%s' ûж %s\n", pFile, SG_DBINFO);
            return(-1);
        }

        // ϢǷ
        if( z_getkeyv(pFile, SG_ENCRY, szBuf, sizeof(szBuf) - 1) == 0 )
        {
            nEncry = (int) strtol(szBuf, (char **)NULL, 10);
        }

        // ݿⳬʱʱ
        if( z_getkeyv(pFile, SG_DBTMOUT, szBuf, sizeof(szBuf) - 1) == 0 )
        {
            nTmout = (int) strtol(szBuf, (char **)NULL, 10);
        }

        // ȡļϽЭб
        z_getkeyv(pFile, SG_PROLIST, szProList, sizeof(szProList) - 1);

        printf("ʾݿ ... ");
        fflush(stdout);

        // ݿ
        if( nTmout > 0 ) alarm(nTmout);
        b = u_conndb(szTns, nEncry, &nCode);
        if( nTmout > 0 ) alarm(0);

        if( b < 0 )
        {
            printf("ʧ %d\n", nCode);
            return(-1);
        }
        printf("OK.\n");
    }

    switch( aZone )
    {
    case R_NODE:
        b = u_refresh_node(nTmout);
        break;

    case R_PROT:
        b = u_refresh_prot(nTmout, szProList);
        break;

    case R_IPA:
        b = u_refresh_IP(nTmout);
        break;

    case R_USRA:
        b = u_refresh_user(nTmout);
        break;

    case R_BUSI:
        b = u_refresh_busi(nTmout, szProList);
        break;

    case R_FLOW:
        b = u_refresh_flow(nTmout);
        break;

    case R_H3:
        b = u_refresh_h3(nTmout);
        break;

    case R_RCODE:
        b = u_refresh_rcode(nTmout);
        break;

    case R_PMAP:
        b = u_refresh_pmap(nTmout);
        break;

    case R_CUTOVER:
        b = u_refresh_cutover(pFile);
        break;

    case R_URGE:
        b = u_refresh_urge(pFile);
        break;

    default:
        b = -1;
        break;
    }

    // Ͽݿ
    u_disconnect_db();

    return(b);
}
