#include "StrOpt.h"
#include "stdafx.h"
#include "SampleConsumer.h"
#include "StringTokenizer.h""
//#include "common.h"

UINT SampleConsumer::m_MsgId = 0;
//nColumnCount = m_MsgDspRT->GetHeaderCtrl()->GetItemCount();

SampleConsumer::
SampleConsumer( const std::string& brokerURI, long numMessages, string topic_Queue, bool useTopic, long waitMillis )
: latch(1), doneLatch(numMessages), m_ConInit(NULL), m_MsgDspRT(NULL),MAX_ITEM_PERMITTED(10000) 
{
	connection = NULL;
	session = NULL;
	destination = NULL;
	consumer = NULL;
	this->waitMillis = waitMillis;
	this->useTopic = useTopic;
	this->brokerURI = brokerURI;
	this->topic_Queue = topic_Queue;

}

void 
SampleConsumer::
cleanup()
{
	//*************************************************
	// Always close destination, consumers and producers before
	// you destroy their sessions and connection.
	//*************************************************

	// Destroy resources.
	try{
		if( destination != NULL ) delete destination;
	}catch (CMSException& e) { e.printStackTrace(); }
	destination = NULL;

	try{
		if( consumer != NULL ) delete consumer;
	}catch (CMSException& e) { e.printStackTrace(); }
	consumer = NULL;

	// Close open resources.
	try{
		if( session != NULL ) session->close();
		if( connection != NULL ) connection->close();
	}catch (CMSException& e) { e.printStackTrace(); }

	// Now Destroy them
	try{
		if( session != NULL ) delete session;
	}catch (CMSException& e) { e.printStackTrace(); }
	session = NULL;

	try{
		if( connection != NULL ) delete connection;
	}catch (CMSException& e) { e.printStackTrace(); }
	connection = NULL;

	/*		try{
	if( m_ConInit != NULL ) delete m_ConInit;
	}catch (CMSException& e) { 
	e.printStackTrace(); 
	}
	connection = NULL;

	try{
	if( m_MsgDspRT != NULL ) delete m_MsgDspRT;
	}catch (CMSException& e) { 
	e.printStackTrace(); 
	}
	m_MsgDspRT = NULL;
	*/

}

void 
SampleConsumer::
run() 
{
	try {
		// Create a ConnectionFactory
		ConnectionFactory* connectionFactory =
			ConnectionFactory::createCMSConnectionFactory( brokerURI );

		// Create a Connection
		connection = connectionFactory->createConnection();
		delete connectionFactory;
		if ( connection && m_ConInit )
		{
			//				::AfxMessageBox("come here again");
			//				bool bPMValue = m_ConInit->PostMessage( WM_QUIT );
			//				::AfxMessageBox("test here");
			m_ConInit->EndDialog(0);
		}
		connection->start();

		connection->setExceptionListener(this);

		// Create a Session
		session = connection->createSession( Session::AUTO_ACKNOWLEDGE );

		// Create the destination (Topic or Queue)
		if( useTopic ) {
			destination = session->createTopic( topic_Queue );
		} else {
			destination = session->createQueue( topic_Queue );
		}

		// Create a MessageConsumer from the Session to the Topic or Queue
		consumer = session->createConsumer( destination );

		consumer->setMessageListener( this );

		std::cout.flush();
		std::cerr.flush();

		// Indicate we are ready for messages.
		latch.countDown();

		// Wait while asynchronous messages come in.
		doneLatch.await( waitMillis );

	} catch (CMSException& e) {
		e.printStackTrace();
	}
}

// Called from the consumer since this class is a registered MessageListener.
void 
SampleConsumer::
onMessage( const Message* message )
{
	static int count = 0;
	extern int LISTCTRL_COL;
	try
	{
		count++;
		const TextMessage* textMessage =
			dynamic_cast< const TextMessage* >( message );
		string text = "";
		
		if( textMessage != NULL ) {
			text = textMessage->getText();

			///////////////text|vector/////////////
			StringTokenizer tokenizer( text, "|" );
			vector<string> pathSplitter;
			for ( StringTokenizer::Iterator it = tokenizer.begin(); it != tokenizer.end(); ++it )
			{
				if ( !(*it).empty() )
					pathSplitter.push_back( (*it) );
			}

			//////////////һпյitem//////////////////
			CString strText = "";
			strText.Format(TEXT("item %d"), m_MsgId);
			m_MsgDspRT->InsertItem(	LVIF_TEXT|LVIF_STATE, m_MsgId, strText, 
				                   (m_MsgId%2)==0 ? LVIS_SELECTED : 0, LVIS_SELECTED,
				                    0, 0);

			//pathSplitterԪС֮ĲȡListCtrlʾ
			CStrOpt subStr;
			string subItem[LISTCTRL_COL] = {0};
			for ( int si=0; si < LISTCTRL_COL; si++ ) 
			{
				subStr = sdfssdfsf**********.strExtract( pathSplitter[si], );
			}


			// Initialize the text of the subitems.
			for ( int j=1; j < LISTCTRL_COL; j++ ) 
			{
				strText.Format( TEXT( "sub-item %d %d" ), m_MsgId, j );
				m_MsgDspRT->SetItemText( m_MsgId, j, subStrsubStr.c_str() );

				//save "|" split string into log file, for history message display
				//ʲôʽ
				save to file;
				////////////////////////////////////////////////////////////////////////
			}

			if ( m_MsgId < MAX_ITEM_PERMITTED ){
				m_MsgId ++;
			} else {
				////////set maximum item NO to a proper range///////////////////////////
				//ӴɾȥͷϵһϵԪأڴռ
				::AfxMessageBox( "still required to figure out what to append here" );
			}

		} else {
			text = "NOT A TEXTMESSAGE!";
		}

		if ( textMessage != NULL) {
			delete textMessage;
			textMessage = NULL;
		}

		printf( "Message #%d Received: %s\n", count, text.c_str() );
	} catch (CMSException& e) {
		e.printStackTrace();
	}

	// No matter what, tag the count down latch until done.
	doneLatch.countDown();
}