
/* Result Sets Interface */
#ifndef SQL_CRSR
#  define SQL_CRSR
  struct sql_cursor
  {
    unsigned int curocn;
    void *ptr1;
    void *ptr2;
    unsigned int magic;
  };
  typedef struct sql_cursor sql_cursor;
  typedef struct sql_cursor SQL_CURSOR;
#endif /* SQL_CRSR */

/* Thread Safety */
typedef void * sql_context;
typedef void * SQL_CONTEXT;

/* Object support */
struct sqltvn
{
  unsigned char *tvnvsn;
  unsigned short tvnvsnl;
  unsigned char *tvnnm;
  unsigned short tvnnml;
  unsigned char *tvnsnm;
  unsigned short tvnsnml;
};
typedef struct sqltvn sqltvn;

struct sqladts
{
  unsigned int adtvsn;
  unsigned short adtmode;
  unsigned short adtnum;
  sqltvn adttvn[1];
};
typedef struct sqladts sqladts;

static struct sqladts sqladt = {
  1,1,0,
};

/* Binding to PL/SQL Records */
struct sqltdss
{
  unsigned int tdsvsn;
  unsigned short tdsnum;
  unsigned char *tdsval[1];
};
typedef struct sqltdss sqltdss;
static struct sqltdss sqltds =
{
  1,
  0,
};

/* File name & Package Name */
struct sqlcxp
{
  unsigned short fillen;
           char  filnam[14];
};
static const struct sqlcxp sqlfpn =
{
    13,
    "securitydb.pc"
};


static unsigned int sqlctx = 633995;


static struct sqlexd {
   unsigned long  sqlvsn;
   unsigned int   arrsiz;
   unsigned int   iters;
   unsigned int   offset;
   unsigned short selerr;
   unsigned short sqlety;
   unsigned int   occurs;
      const short *cud;
   unsigned char  *sqlest;
      const char  *stmt;
   sqladts *sqladtp;
   sqltdss *sqltdsp;
   unsigned char  **sqphsv;
   unsigned long  *sqphsl;
            int   *sqphss;
            short **sqpind;
            int   *sqpins;
   unsigned long  *sqparm;
   unsigned long  **sqparc;
   unsigned short  *sqpadto;
   unsigned short  *sqptdso;
   unsigned int   sqlcmax;
   unsigned int   sqlcmin;
   unsigned int   sqlcincr;
   unsigned int   sqlctimeout;
   unsigned int   sqlcnowait;
            int   sqfoff;
   unsigned int   sqcmod;
   unsigned int   sqfmod;
   unsigned char  *sqhstv[6];
   unsigned long  sqhstl[6];
            int   sqhsts[6];
            short *sqindv[6];
            int   sqinds[6];
   unsigned long  sqharm[6];
   unsigned long  *sqharc[6];
   unsigned short  sqadto[6];
   unsigned short  sqtdso[6];
} sqlstm = {12,6};

// Prototypes
extern "C" {
  void sqlcxt (void **, unsigned int *,
               struct sqlexd *, const struct sqlcxp *);
  void sqlcx2t(void **, unsigned int *,
               struct sqlexd *, const struct sqlcxp *);
  void sqlbuft(void **, char *);
  void sqlgs2t(void **, char *);
  void sqlorat(void **, unsigned int *, void *);
}

// Forms Interface
static const int IAPSUCC = 0;
static const int IAPFAIL = 1403;
static const int IAPFTL  = 535;
extern "C" { void sqliem(char *, int *); }

typedef struct { unsigned short len; unsigned char arr[1]; } VARCHAR;
typedef struct { unsigned short len; unsigned char arr[1]; } varchar;

/* cud (compilation unit data) array */
static const short sqlcud0[] =
{12,4130,850,0,0,
5,0,0,1,0,0,31,21,0,0,0,0,0,1,0,
20,0,0,2,0,0,27,43,0,0,4,4,0,1,0,1,97,0,0,1,10,0,0,1,10,0,0,1,10,0,0,
51,0,0,3,0,0,32,49,0,0,0,0,0,1,0,
66,0,0,4,0,0,32,57,0,0,0,0,0,1,0,
81,0,0,5,142,0,6,101,0,0,6,6,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,2,9,0,0,2,9,0,0,2,9,
0,0,
120,0,0,6,0,0,29,119,0,0,0,0,0,1,0,
135,0,0,7,0,0,31,130,0,0,0,0,0,1,0,
150,0,0,8,0,0,31,135,0,0,0,0,0,1,0,
165,0,0,9,120,0,6,187,0,0,6,6,0,1,0,1,9,0,0,1,9,0,0,1,9,0,0,1,9,0,0,1,9,0,0,2,
9,0,0,
204,0,0,10,0,0,29,204,0,0,0,0,0,1,0,
219,0,0,11,0,0,31,209,0,0,0,0,0,1,0,
234,0,0,12,0,0,31,214,0,0,0,0,0,1,0,
249,0,0,13,0,0,29,236,0,0,0,0,0,1,0,
};


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sqlca.h>
#include <sqlcpr.h>
#include "securitydb.h"


void ErrorReport()
{
	char szErrorMessage[2048];

	size_t		buf_len,msg_len;
	buf_len = sizeof(szErrorMessage) - 1;
	SQLErrorGetText(NULL,szErrorMessage,&buf_len,&msg_len);
	if(msg_len>2048-1)
		msg_len = 2048 - 1;
	szErrorMessage[msg_len] = '\0';

	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */

	/* EXEC SQL ROLLBACK; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 0;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )5;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}



	printf("%s\r\n",szErrorMessage);

	if( strstr(szErrorMessage,"ORA-03113") != NULL )
		exit(1);
	if( strstr(szErrorMessage,"ORA-03114") != NULL )
		exit(1);
}

int J_DBConnect(char* conn)
{

	/* EXEC SQL BEGIN DECLARE SECTION; */

		char			connstr[256];
	/* EXEC SQL END DECLARE SECTION; */



	strncpy(connstr,conn,256);
	connstr[255] = '\0';

	/* EXEC SQL WHENEVER SQLERROR GOTO ConnectError; */

	/* EXEC SQL CONNECT :connstr; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )10;
 sqlstm.offset = (unsigned int  )20;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (unsigned char  *)connstr;
 sqlstm.sqhstl[0] = (unsigned long )256;
 sqlstm.sqhsts[0] = (         int  )256;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned long )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlstm.sqlcmax = (unsigned int )100;
 sqlstm.sqlcmin = (unsigned int )2;
 sqlstm.sqlcincr = (unsigned int )1;
 sqlstm.sqlctimeout = (unsigned int )0;
 sqlstm.sqlcnowait = (unsigned int )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto ConnectError;
}


	return 1;

ConnectError:
	ErrorReport();
	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */

	/* EXEC SQL ROLLBACK RELEASE; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )51;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	return 0;
}

int J_DBRelease()
{

	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */

	/* EXEC SQL ROLLBACK RELEASE; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 4;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )66;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	return 1;
}

/*ݲԱź,ȡݿû*/
int _GetDBUserAndPass(char* opname,char* oppass,char* dbuser,char* dbpass)
{
	 char id[]="qwextytrgfh34234ka3213";
	/* EXEC SQL BEGIN DECLARE SECTION; */

		/* VARCHAR v_opname[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_opname;

		/* VARCHAR v_oppass[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_oppass;

		/* VARCHAR v_dbuser[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_dbuser;

		/* VARCHAR v_dbpass[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_dbpass;

		/* VARCHAR v_id[60+1]; */
struct { unsigned short len; unsigned char arr[61]; } v_id;

		/* VARCHAR v_result[64+1]; */
struct { unsigned short len; unsigned char arr[65]; } v_result;

		short v_dbuser_ind;
		short v_dbpass_ind;
		short v_result_ind;
	/* EXEC SQL END DECLARE SECTION; */


	strncpy((char*)v_opname.arr,opname,32);
	v_opname.arr[32] = 0;
	v_opname.len = strlen((char*)v_opname.arr);

	strncpy((char*)v_oppass.arr,oppass,32);
	v_oppass.arr[32] = 0;
	v_oppass.len = strlen((char*)v_oppass.arr);

	strncpy((char*)v_id.arr,id,60);
	v_id.arr[60] = 0;
	v_id.len = strlen((char*)v_id.arr);

	memset((char*)v_dbuser.arr,0,sizeof((char*)v_dbuser.arr));
	v_dbuser.len = 0;

	memset((char*)v_dbpass.arr,0,sizeof((char*)v_dbpass.arr));
	v_dbpass.len = 0;

	memset((char*)v_result.arr,0,sizeof((char*)v_result.arr));
	v_result.len = 0;

	/* EXEC SQL WHENEVER NOT FOUND GOTO M_SQLNOTFOUND; */

	/* EXEC SQL WHENEVER SQLERROR GOTO M_SQLERROR; */


	/* EXEC SQL EXECUTE
	BEGIN
		ap_getdbuserandpass(
		:v_opname,
		:v_oppass,
		:v_id,
		:v_dbuser :v_dbuser_ind,
		:v_dbpass :v_dbpass_ind,
		:v_result :v_result_ind
		);
	END;
	END-EXEC; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 6;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin ap_getdbuserandpass ( :v_opname , :v_oppass , :v_id ,\
 :v_dbuser:v_dbuser_ind , :v_dbpass:v_dbpass_ind , :v_result:v_result_ind ) ;\
 END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )81;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (unsigned char  *)&v_opname;
 sqlstm.sqhstl[0] = (unsigned long )35;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned long )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&v_oppass;
 sqlstm.sqhstl[1] = (unsigned long )35;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned long )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&v_id;
 sqlstm.sqhstl[2] = (unsigned long )63;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned long )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&v_dbuser;
 sqlstm.sqhstl[3] = (unsigned long )35;
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         short *)&v_dbuser_ind;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned long )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&v_dbpass;
 sqlstm.sqhstl[4] = (unsigned long )35;
 sqlstm.sqhsts[4] = (         int  )0;
 sqlstm.sqindv[4] = (         short *)&v_dbpass_ind;
 sqlstm.sqinds[4] = (         int  )0;
 sqlstm.sqharm[4] = (unsigned long )0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&v_result;
 sqlstm.sqhstl[5] = (unsigned long )67;
 sqlstm.sqhsts[5] = (         int  )0;
 sqlstm.sqindv[5] = (         short *)&v_result_ind;
 sqlstm.sqinds[5] = (         int  )0;
 sqlstm.sqharm[5] = (unsigned long )0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 1403) goto M_SQLNOTFOUND;
 if (sqlca.sqlcode < 0) goto M_SQLERROR;
}



	v_result.arr[v_result.len] = 0;
/*printf("trace [%s]\n", v_result.arr);*/

	if( !strncmp((char*)v_result.arr,"OK",1) )
	{
		/* EXEC SQL COMMIT WORK; */

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 12;
  sqlstm.arrsiz = 6;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )120;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto M_SQLERROR;
}


		strncpy(dbuser, (char*)v_dbuser.arr, v_dbuser.len);
		dbuser[v_dbuser.len] = 0;
		strncpy(dbpass, (char*)v_dbpass.arr, v_dbpass.len);
		dbpass[v_dbpass.len] = 0;
		return 1;
	}
	else
	{
		dbuser[0] = 0;
		dbpass[0] = 0;
		/* EXEC SQL ROLLBACK; */

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 12;
  sqlstm.arrsiz = 6;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )135;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto M_SQLERROR;
}


		return 0;
	}

M_SQLNOTFOUND:
	/* EXEC SQL ROLLBACK; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 6;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )150;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto M_SQLERROR;
}


	return 0;

M_SQLERROR:
	ErrorReport();
	return -1;

}


/*õ½ݿû,ȫ*/
int _SetDBUserAndPass( char *olddbusername, char *olddbuserpass, char* newdbusername, char* newdbuserpass)
{
	 char id[]="qwextytrgfh34234ka3213";
	/* EXEC SQL BEGIN DECLARE SECTION; */

		/* VARCHAR v_odbuser[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_odbuser;

		/* VARCHAR v_odbpass[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_odbpass;

		/* VARCHAR v_ndbuser[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_ndbuser;

		/* VARCHAR v_ndbpass[32+1]; */
struct { unsigned short len; unsigned char arr[33]; } v_ndbpass;

		/* VARCHAR v_id[60+1]; */
struct { unsigned short len; unsigned char arr[61]; } v_id;

		/* VARCHAR v_result[64+1]; */
struct { unsigned short len; unsigned char arr[65]; } v_result;

		short v_result_ind;
	/* EXEC SQL END DECLARE SECTION; */


	strncpy((char*)v_odbuser.arr,olddbusername,32);
	v_odbuser.arr[32] = 0;
	v_odbuser.len = strlen((char*)v_odbuser.arr);

	strncpy((char*)v_odbpass.arr,olddbuserpass,32);
	v_odbpass.arr[32] = 0;
	v_odbpass.len = strlen((char*)v_odbpass.arr);

	strncpy((char*)v_ndbuser.arr,newdbusername,32);
	v_ndbuser.arr[32] = 0;
	v_ndbuser.len = strlen((char*)v_ndbuser.arr);

	strncpy((char*)v_ndbpass.arr,newdbuserpass,32);
	v_ndbpass.arr[32] = 0;
	v_ndbpass.len = strlen((char*)v_ndbpass.arr);

	strncpy((char*)v_id.arr,id,60);
	v_id.arr[60] = 0;
	v_id.len = strlen((char*)v_id.arr);

	memset((char*)v_result.arr,0,sizeof((char*)v_result.arr));
	v_result.len = 0;



	/* EXEC SQL WHENEVER NOT FOUND GOTO Mv_SQLNOTFOUND; */

	/* EXEC SQL WHENEVER SQLERROR GOTO Mv_SQLERROR; */


	/* EXEC SQL EXECUTE
	BEGIN
		ap_setdbuserandpass(
		:v_odbuser,
		:v_odbpass,
		:v_id,
		:v_ndbuser,
		:v_ndbpass,
		:v_result :v_result_ind
		);
	END;
	END-EXEC; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 6;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.stmt = "begin ap_setdbuserandpass ( :v_odbuser , :v_odbpass , :v_id\
 , :v_ndbuser , :v_ndbpass , :v_result:v_result_ind ) ; END ;";
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )165;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlstm.sqhstv[0] = (unsigned char  *)&v_odbuser;
 sqlstm.sqhstl[0] = (unsigned long )35;
 sqlstm.sqhsts[0] = (         int  )0;
 sqlstm.sqindv[0] = (         short *)0;
 sqlstm.sqinds[0] = (         int  )0;
 sqlstm.sqharm[0] = (unsigned long )0;
 sqlstm.sqadto[0] = (unsigned short )0;
 sqlstm.sqtdso[0] = (unsigned short )0;
 sqlstm.sqhstv[1] = (unsigned char  *)&v_odbpass;
 sqlstm.sqhstl[1] = (unsigned long )35;
 sqlstm.sqhsts[1] = (         int  )0;
 sqlstm.sqindv[1] = (         short *)0;
 sqlstm.sqinds[1] = (         int  )0;
 sqlstm.sqharm[1] = (unsigned long )0;
 sqlstm.sqadto[1] = (unsigned short )0;
 sqlstm.sqtdso[1] = (unsigned short )0;
 sqlstm.sqhstv[2] = (unsigned char  *)&v_id;
 sqlstm.sqhstl[2] = (unsigned long )63;
 sqlstm.sqhsts[2] = (         int  )0;
 sqlstm.sqindv[2] = (         short *)0;
 sqlstm.sqinds[2] = (         int  )0;
 sqlstm.sqharm[2] = (unsigned long )0;
 sqlstm.sqadto[2] = (unsigned short )0;
 sqlstm.sqtdso[2] = (unsigned short )0;
 sqlstm.sqhstv[3] = (unsigned char  *)&v_ndbuser;
 sqlstm.sqhstl[3] = (unsigned long )35;
 sqlstm.sqhsts[3] = (         int  )0;
 sqlstm.sqindv[3] = (         short *)0;
 sqlstm.sqinds[3] = (         int  )0;
 sqlstm.sqharm[3] = (unsigned long )0;
 sqlstm.sqadto[3] = (unsigned short )0;
 sqlstm.sqtdso[3] = (unsigned short )0;
 sqlstm.sqhstv[4] = (unsigned char  *)&v_ndbpass;
 sqlstm.sqhstl[4] = (unsigned long )35;
 sqlstm.sqhsts[4] = (         int  )0;
 sqlstm.sqindv[4] = (         short *)0;
 sqlstm.sqinds[4] = (         int  )0;
 sqlstm.sqharm[4] = (unsigned long )0;
 sqlstm.sqadto[4] = (unsigned short )0;
 sqlstm.sqtdso[4] = (unsigned short )0;
 sqlstm.sqhstv[5] = (unsigned char  *)&v_result;
 sqlstm.sqhstl[5] = (unsigned long )67;
 sqlstm.sqhsts[5] = (         int  )0;
 sqlstm.sqindv[5] = (         short *)&v_result_ind;
 sqlstm.sqinds[5] = (         int  )0;
 sqlstm.sqharm[5] = (unsigned long )0;
 sqlstm.sqadto[5] = (unsigned short )0;
 sqlstm.sqtdso[5] = (unsigned short )0;
 sqlstm.sqphsv = sqlstm.sqhstv;
 sqlstm.sqphsl = sqlstm.sqhstl;
 sqlstm.sqphss = sqlstm.sqhsts;
 sqlstm.sqpind = sqlstm.sqindv;
 sqlstm.sqpins = sqlstm.sqinds;
 sqlstm.sqparm = sqlstm.sqharm;
 sqlstm.sqparc = sqlstm.sqharc;
 sqlstm.sqpadto = sqlstm.sqadto;
 sqlstm.sqptdso = sqlstm.sqtdso;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode == 1403) goto Mv_SQLNOTFOUND;
 if (sqlca.sqlcode < 0) goto Mv_SQLERROR;
}



	v_result.arr[v_result.len] = 0;

	if( !strncmp((char*)v_result.arr,"OK",1) )
	{
		/* EXEC SQL COMMIT WORK; */

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 12;
  sqlstm.arrsiz = 6;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )204;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto Mv_SQLERROR;
}


		return 1;
	}
	else
	{
		/* EXEC SQL ROLLBACK; */

{
  struct sqlexd sqlstm;
  sqlstm.sqlvsn = 12;
  sqlstm.arrsiz = 6;
  sqlstm.sqladtp = &sqladt;
  sqlstm.sqltdsp = &sqltds;
  sqlstm.iters = (unsigned int  )1;
  sqlstm.offset = (unsigned int  )219;
  sqlstm.cud = sqlcud0;
  sqlstm.sqlest = (unsigned char  *)&sqlca;
  sqlstm.sqlety = (unsigned short)256;
  sqlstm.occurs = (unsigned int  )0;
  sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
  if (sqlca.sqlcode < 0) goto Mv_SQLERROR;
}


		return 0;
	}

Mv_SQLNOTFOUND:
	/* EXEC SQL ROLLBACK; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 6;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )234;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
 if (sqlca.sqlcode < 0) goto Mv_SQLERROR;
}


	return 0;

Mv_SQLERROR:
	ErrorReport();
	return -1;
}


int dbopen(const char* conn)
{
	return J_DBConnect((char*)conn);
}

int dbclose()
{
	return J_DBRelease();
}

int dbcommit()
{
	/* EXEC SQL WHENEVER SQLERROR CONTINUE; */

	/* EXEC SQL COMMIT WORK; */

{
 struct sqlexd sqlstm;
 sqlstm.sqlvsn = 12;
 sqlstm.arrsiz = 6;
 sqlstm.sqladtp = &sqladt;
 sqlstm.sqltdsp = &sqltds;
 sqlstm.iters = (unsigned int  )1;
 sqlstm.offset = (unsigned int  )249;
 sqlstm.cud = sqlcud0;
 sqlstm.sqlest = (unsigned char  *)&sqlca;
 sqlstm.sqlety = (unsigned short)256;
 sqlstm.occurs = (unsigned int  )0;
 sqlcxt((void **)0, &sqlctx, &sqlstm, &sqlfpn);
}


	return 1;
}


