#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "z.h"

int f_cmdexec(char *cmd, int cmdlen, char *outbuf, int outlen);

int main(void)
{
    FILE *fp;

    int   b;
    char  s[2048 + 1], t[2048 + 1];

    struct stat st;

    if( stat("testsh.file", &st) < 0 ) return(0);

    if( (fp = fopen("testsh.file", "r")) == NULL ) return(0);
    fread(s, 1, st.st_size, fp);

    s[st.st_size] = 0;
    z_memshow((unsigned char *)s, st.st_size + 1);

    b = f_cmdexec(s, st.st_size + 1, t, 16);
    printf("b=%d, [%s]\n", b, t);

    z_memshow((unsigned char *)t, 32);
}

/******************************************
 ksh ִshellı
 ڲchar     *cmd     --shellı
           int       cmdlen  --

 ڲchar     *outbuf  --Ϣ
           int       outlen  --Ϣ

 ֵ  0-255   ӽ˳״̬
           -1      ϵͳ
           -2      ӽ̱źж
 ******************************************/
int f_cmdexec(char *cmd, int cmdlen, char *outbuf, int outlen)
{
    pid_t cpid;

    int child_stat,       /* ӽ˳״̬ */
        b, pipe1[2], fd[2];

	char buf1[128];

    if( pipe(fd) < 0 ) return(-1);

    if( (cpid = fork()) == 0 )
    {
        close(fd[0]);

        if( pipe(pipe1) < 0 ) exit(-1);

		sprintf(buf1, "echo 1 2 3\n\
a b c|\n");

        /* дܵ */
        write(pipe1[1], buf1, strlen(buf1));
        write(pipe1[1], cmd, cmdlen);
        write(pipe1[1], "\nexit 0\n", 8);

        close(pipe1[1]);

        /* д */
        close(0);
        dup(pipe1[0]);

        close(1);
        dup(fd[1]);

        close(2);
        dup(fd[1]);

        execlp("ksh", "ksh", (char *)0);
        exit(-1);
    }
printf("cpid=%d\n", cpid);
    close(fd[1]);

    /* ȴӽִ */
    b = waitpid(cpid, &child_stat, 0);

    if( b < 0 )
    {
        if( kill(cpid, 0) == 0 ) kill(cpid, SIGKILL);
        return(-1);
    }

    /* 鿴ӽǷźж */
    if( (b = WIFSIGNALED(child_stat)) ) {
        return(-2);
    }

    b = GC_read_until(fd[0], outbuf, outlen, "\001\002\003");
    close(fd[0]);

    /* ӽ˳״̬ */
    return( WEXITSTATUS(child_stat) );
}
