

#ifndef __SPICE_CLIENT_CLIENT_H__
#define __SPICE_CLIENT_CLIENT_H__


#include <glib.h>
#include <glib-object.h>

#define __SPICE_CLIENT_H_INSIDE__


#include <spice/enums.h>
#include <spice/protocol.h>


#include "spice-types.h"
#include "spice-session.h"
#include "spice-channel.h"
#include "spice-option.h"
#include "spice-uri.h"
#include "spice-version.h"

#include "channel-main.h"
#include "channel-display.h"
#include "channel-cursor.h"
#include "channel-inputs.h"
#include "channel-playback.h"
#include "channel-record.h"
#include "channel-smartcard.h"
#include "channel-usbredir.h"
#include "channel-port.h"
#include "channel-webdav.h"

#include "smartcard-manager.h"
#include "usb-device-manager.h"
#include "spice-audio.h"
#include "spice-file-transfer-task.h"
#include "qmp-port.h"

G_BEGIN_DECLS


#define SPICE_CLIENT_ERROR spice_client_error_quark()


typedef enum
{
    SPICE_CLIENT_ERROR_FAILED,
    SPICE_CLIENT_ERROR_USB_DEVICE_REJECTED,
    SPICE_CLIENT_ERROR_USB_DEVICE_LOST,
    SPICE_CLIENT_ERROR_AUTH_NEEDS_PASSWORD,
    SPICE_CLIENT_ERROR_AUTH_NEEDS_USERNAME,
    SPICE_CLIENT_ERROR_AUTH_NEEDS_PASSWORD_AND_USERNAME,
    SPICE_CLIENT_ERROR_USB_SERVICE,
    SPICE_CLIENT_ERROR_FILE_XFER_STATUS_DISABLED,
} SpiceClientError;

#ifndef SPICE_DISABLE_DEPRECATED
#define SPICE_CLIENT_USB_DEVICE_REJECTED SPICE_CLIENT_ERROR_USB_DEVICE_REJECTED
#define SPICE_CLIENT_USB_DEVICE_LOST SPICE_CLIENT_ERROR_USB_DEVICE_LOST
#endif

GQuark spice_client_error_quark(void);

G_END_DECLS

#undef __SPICE_CLIENT_H_INSIDE__

#endif 

