

#include "config.h"

#include <glib.h>
#include <glib/gi18n-lib.h>
#include <common/macros.h>

#ifdef G_OS_WIN32
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

BOOL WINAPI DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved);

BOOL WINAPI DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    if (fdwReason == DLL_PROCESS_ATTACH) {
        char *basedir =
            g_win32_get_package_installation_directory_of_module(hinstDLL);
        char *utf8_localedir = g_build_filename(basedir, "share", "locale", NULL);
        
        char *localedir = g_win32_locale_filename_from_utf8 (utf8_localedir);

        bindtextdomain(GETTEXT_PACKAGE, localedir);
        g_free(localedir);
        g_free(utf8_localedir);
        g_free(basedir);
        bind_textdomain_codeset(GETTEXT_PACKAGE, "UTF-8");
    }
    return TRUE;
}

#else

SPICE_CONSTRUCTOR_FUNC(i18n_init)
{
    bindtextdomain (GETTEXT_PACKAGE, LOCALE_DIR);
    bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
}

#endif

