/***********************************************************************
*
* ļ			SqlConfig.cpp
* ģĿģ	ڹSQLļ
* ߼ڣ	liu_yfeng 2008-09-12
* 汾			1.0
* ȨϢ		CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning(disable:4786)


#include "SqlConfig.h"

#include "Common/Common.h"
#include "FileOpt/FileOpt.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/TmpLog.h"
#include "PcreRex/PcreRex.h"
#include "TinyXml/tinyxml.h"


const std::string SQLRULES_NAME = "sqlrules.xml";


CGDSqlConfig* CGDSqlConfig::GetInstace()
{
	return new CSqlConfig();
}

void CGDSqlConfig::DeleteInstace( CGDSqlConfig* pSqlConfig )
{
	if ( NULL != pSqlConfig )
	{
		delete pSqlConfig;
		pSqlConfig = NULL;
	}
}


CSqlConfig::CSqlConfig()
{
	const char* pPath = GetInforGuardPath();
	if ( ! pPath || ! (*pPath) )
	{
		// ݴ
		CGDLog::WriteErrLog( "1101:GetInforGuardPath() fail" );
	}
	m_SqlConfigPath = "";
	m_SqlConfigPath = m_SqlConfigPath + pPath + S_PATHLASH + "cfg";
}


CSqlConfig::~CSqlConfig()
{
}

bool CSqlConfig::SetSqlState( const bool bUse )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:SetSqlState()" );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		pRootElem->SetAttribute( "available", bUse ? "1" : "0" );
		if (doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( true );
		}
		else
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( false );
}

bool CSqlConfig::StartWeb( const char* sWebAddress )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:StartWeb(%s)", sWebAddress );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		if ( NULL == sWebAddress || *sWebAddress == '\0' )
		{
			return trace.SetRetResult( false );
		}
		else	// ɾųվ
		{
			TiXmlElement* pRulesElem = NULL;
			pRulesElem = pRootElem->FirstChildElement("rules");
			if ( NULL == pRootElem )
			{
				return trace.SetRetResult( false );
			}

			TiXmlElement* pExcludes = NULL;
			pExcludes = pRulesElem->FirstChildElement("excludes");
			if ( NULL != pExcludes )
			{
				// URL
				TiXmlElement* pUrls = NULL;
				pUrls = pExcludes->FirstChildElement("urls");
				if ( NULL != pUrls )
				{
					TiXmlElement* pUrl = NULL;
					pUrl = pUrls->FirstChildElement("url");
					while ( NULL != pUrl )
					{
						std::string strUrlRule = pUrl->Attribute( "value" );
						if ( PcreRex::match( sWebAddress, strUrlRule ) )
						{
							pUrls->RemoveChild( pUrl );
							if (doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
							{
								return trace.SetRetResult( true );
							}
							else
							{
								return trace.SetRetResult( false );
							}
						}
						pUrl = pUrl->NextSiblingElement();
					}

					return trace.SetRetResult( true );
				}
			}
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( false );
}

bool CSqlConfig::StopWeb( const char* sWebAddress )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:StopWeb(%s)", sWebAddress );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		if ( NULL == sWebAddress || *sWebAddress == '\0' )
		{
			return trace.SetRetResult( false );
		}
		else	// ųվ
		{
			TiXmlElement* pRulesElem = NULL;
			pRulesElem = pRootElem->FirstChildElement("rules");
			if ( NULL == pRootElem )
			{
				return trace.SetRetResult( false );
			}

			TiXmlElement* pExcludes = NULL;
			pExcludes = pRulesElem->FirstChildElement("excludes");
			if ( NULL != pExcludes )
			{
				// URL
				TiXmlElement* pUrls = NULL;
				pUrls = pExcludes->FirstChildElement("urls");
				if ( NULL != pUrls )
				{
					TiXmlElement* pUrl = NULL;
					pUrl = pUrls->FirstChildElement("url");
					while ( NULL != pUrl )
					{
						std::string strUrlRule = pUrl->Attribute( "value" );
						if ( PcreRex::match( sWebAddress, strUrlRule ) )
						{
							return trace.SetRetResult( true );
						}
						pUrl = pUrl->NextSiblingElement();
					}

					// 
					pUrl = NULL;
					pUrl = new TiXmlElement( "url" );
					if( pUrl != NULL )
					{
						std::string sRexValue;
						sRexValue = sRexValue + "(.)*" + sWebAddress + "(.)*";
						pUrl->SetAttribute( "value", sRexValue.c_str() );
						pUrls->InsertEndChild( *pUrl );
						delete pUrl;
						pUrl = NULL;
					}
				}
			}
		}

		if (!doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}

bool CSqlConfig::SetCycle( long nCycle )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:SetCycle()" );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		pRootElem->SetAttribute( "cycle", nCycle );	// жļ

		if (!doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}

bool CSqlConfig::SetLog( bool bUse )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:SetLog()" );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		// ȡ־Ϣ
		TiXmlElement* pLogElem = NULL;
		pLogElem = pRootElem->FirstChildElement("log");
		if ( NULL == pLogElem )
		{
			return trace.SetRetResult( false );
		}

		if ( bUse )
		{
			pLogElem->SetAttribute( "available", "1" );
		}
		else
		{
			pLogElem->SetAttribute( "available", "0" );
		}

		if (!doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}

bool CSqlConfig::SetLog( const char* sType, bool bUse, long nSize, long nCount )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:SetLog(%s)", sType );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		// ȡ־Ϣ
		TiXmlElement* pLogElem = NULL;
		pLogElem = pRootElem->FirstChildElement("log");

		TiXmlElement* pLogSub = NULL;
		pLogSub = pLogElem->FirstChildElement( sType );
		if ( NULL != pLogSub )
		{
			if ( bUse )
			{
				pLogSub->SetAttribute( "available", "1" );
			}
			else
			{
				pLogSub->SetAttribute( "available", "0" );
			}
			pLogSub->SetAttribute( "size", nSize );
			pLogSub->SetAttribute( "count", nCount );
		}

		if (!doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}

bool CSqlConfig::AddExcludeRule( const char* sValue, const char* sDescription )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:AddExcludeRule(%s,%s)", sValue, sDescription );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRootElem )
		{
			return trace.SetRetResult( false );
		}

		TiXmlElement* pExcludes = NULL;
		pExcludes = pRulesElem->FirstChildElement("excludes");
		if ( NULL != pExcludes )
		{
			// sqlrules
			TiXmlElement* pSqlRules = NULL;
			pSqlRules = pExcludes->FirstChildElement("sqlrules");
			if ( NULL != pSqlRules )
			{
				TiXmlElement* pRule = NULL;
				pRule = pSqlRules->FirstChildElement("rule");
				while ( NULL != pRule )
				{
					std::string strRule = pRule->Attribute( "value" );
					if ( PcreRex::match( sValue, strRule ) )
					{
						return trace.SetRetResult( true );
					}
					pRule = pRule->NextSiblingElement();
				}

				// 
				pRule = NULL;
				pRule = new TiXmlElement( "rule" );
				if( pRule != NULL )
				{
					std::string sRexValue;
					sRexValue = sRexValue + "(.)*" + sValue + "(.)*";
					pRule->SetAttribute( "value", sRexValue.c_str() );
					pSqlRules->InsertEndChild( *pRule );
					delete pRule;
					pRule = NULL;
				}
			}
		}

		if (!doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}


bool CSqlConfig::AddIncludeRule( const char* sValue, const char* sDescription )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:AddIncludeRule(%s,%s)",sValue, sDescription );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRootElem )
		{
			return trace.SetRetResult( false );
		}

		TiXmlElement* pIncludes = NULL;
		pIncludes = pRulesElem->FirstChildElement("includes");
		if ( NULL != pIncludes )
		{
			TiXmlElement* pRule = NULL;
			pRule = pIncludes->FirstChildElement("rule");
			while ( NULL != pRule )
			{
				std::string strRule = pRule->Attribute( "value" );
				if ( PcreRex::match( sValue, strRule ) )
				{
					return trace.SetRetResult( true );
				}
				pRule = pRule->NextSiblingElement();
			}
			
			// 
			pRule = NULL;
			pRule = new TiXmlElement( "rule" );
			if( pRule != NULL )
			{
				std::string sRexValue;
				sRexValue = sRexValue + "(.)*" + sValue + "(.)*";
				pRule->SetAttribute( "value", sRexValue.c_str() );
				pIncludes->InsertEndChild( *pRule );
				delete pRule;
				pRule = NULL;
			}
			else
			{
				return trace.SetRetResult( false );
			}
		}

		if (!doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
		{
			return trace.SetRetResult( false );
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}


bool CSqlConfig::UpdateExcludeRule( const char* sOldValue, const char* sValue, const char* sDescription )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:UpdateExcludeRule(%s,%s,%s)",sOldValue, sValue, sDescription );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRootElem )
		{
			return trace.SetRetResult( false );
		}

		TiXmlElement* pExcludes = NULL;
		pExcludes = pRulesElem->FirstChildElement("excludes");
		if ( NULL != pExcludes )
		{
			// sqlrules
			TiXmlElement* pSqlRules = NULL;
			pSqlRules = pExcludes->FirstChildElement("sqlrules");
			if ( NULL != pSqlRules )
			{
				TiXmlElement* pRule = NULL;
				pRule = pSqlRules->FirstChildElement("rule");
				while ( NULL != pRule )
				{
					std::string strUrlRule = pRule->Attribute( "value" );
					if ( PcreRex::match( sOldValue, strUrlRule ) )
					{
						// ޸
						std::string sRexValue;
						sRexValue = sRexValue + "(.)*" + sValue + "(.)*";
						pRule->SetAttribute( "value", sRexValue.c_str() );
						pRule->SetAttribute( "description", sDescription );
						if (doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
						{
							return trace.SetRetResult( true );
						}
					}
					pRule = pRule->NextSiblingElement();
				}
			}
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( false );
}

bool CSqlConfig::UpdateIncludeRule( const char* sOldValue, const char* sValue, const char* sDescription )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:UpdateIncludeRule(%s,%s,%s)",sOldValue, sValue, sDescription );

	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRootElem )
		{
			return trace.SetRetResult( false );
		}

		TiXmlElement* pIncludes = NULL;
		pIncludes = pRulesElem->FirstChildElement("includes");
		if ( NULL != pIncludes )
		{
			TiXmlElement* pRule = NULL;
			pRule = pIncludes->FirstChildElement("rule");
			while ( NULL != pRule )
			{
				std::string strRule = pRule->Attribute( "value" );
				if ( PcreRex::match( sOldValue, strRule ) )
				{
					// ޸
					std::string sRexValue;
					sRexValue = sRexValue + "(.)*" + sValue + "(.)*";
					pRule->SetAttribute( "value", sRexValue.c_str() );
					pRule->SetAttribute( "description", sDescription );
					if (doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
					{
						return trace.SetRetResult( true );
					}
				}
				pRule = pRule->NextSiblingElement();
			}
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( false );
}

bool CSqlConfig::DeleteExcludeRule( const char* sValue )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:DeleteExcludeRule(%s)", sValue );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRootElem )
		{
			return trace.SetRetResult( false );
		}

		TiXmlElement* pExcludes = NULL;
		pExcludes = pRulesElem->FirstChildElement("excludes");
		if ( NULL != pExcludes )
		{
			// sqlrules
			TiXmlElement* pSqlRules = NULL;
			pSqlRules = pExcludes->FirstChildElement("sqlrules");
			if ( NULL != pSqlRules )
			{
				TiXmlElement* pRule = NULL;
				pRule = pSqlRules->FirstChildElement("rule");
				while ( NULL != pRule )
				{
					std::string strRule = pRule->Attribute( "value" );
					if ( PcreRex::match( sValue, strRule ) )
					{
						pSqlRules->RemoveChild( pRule );
						if (doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
						{
							return trace.SetRetResult( true );
						}
						else
						{
							return trace.SetRetResult( false );
						}
					}
					pRule = pRule->NextSiblingElement();
				}
			}
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( false );
}

bool CSqlConfig::DeleteIncludeRule( const char* sValue )
{
	CGDTrace trace( LOG_L6, "CSqlConfig:DeleteIncludeRule(%s)", sValue );
	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRootElem )
		{
			return trace.SetRetResult( false );
		}

		TiXmlElement* pIncludes = NULL;
		pIncludes = pRulesElem->FirstChildElement("includes");
		if ( NULL != pIncludes )
		{
			TiXmlElement* pRule = NULL;
			pRule = pIncludes->FirstChildElement("rule");
			while ( NULL != pRule )
			{
				std::string strRule = pRule->Attribute( "value" );
				if ( PcreRex::match( sValue, strRule ) )
				{
					// ޸
					pIncludes->RemoveChild( pRule );
					if (doc.SaveFile( ( m_SqlConfigPath + S_PATHLASH + SQLRULES_NAME ).c_str() ) )
					{
						return trace.SetRetResult( true );
					}
				}
				pRule = pRule->NextSiblingElement();
			}
		}
	}
	catch ( ... )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( false );
}




