/***********************************************************************
*
* ļ    Validator.cpp
* ģĿģִļ֤
* ߼ڣ  wang_jin 2008-05-11
* 汾    1.0
* ȨϢ  CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning ( disable : 4251 4786 )

#include "SQLValidator.h"

#include "Base/MonitorDef.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/ThreadData.h"
#include "GDLog/TmpLog.h"
#include "TinyXml/tinyxml.h"

#include <stdio.h> // for sprintf

#ifndef NO_ERROR
#	define NO_ERROR 0
#endif


CSQLValidator::CSQLValidator():
	m_bInitialized(false)
{
	m_sqlRuleLastTime = 0;
	m_sqlReadCycle = 60;	// Ĭһ
	m_bUseCheck = true;
}

CSQLValidator::~CSQLValidator()
{
}

bool CSQLValidator::Initialize()
{
	CGDTrace trace( LOG_L6, "CValidator:Initialize()" );
	trace.SetRetResult( false );

	CThreadLock lock( m_mutex );
	
	if ( ! m_bInitialized )
	{
		// ʼʼΨһϲ߿ƣĿΪ˼ٳʼĵô
		CGDLog::WriteSysLog( "2043:CSQLValidator::Initialize() Begin" );

		// ʼ־ʼ־־ʼ
		// CGDLog::WriteErrLog( "[SQL]־" );

		// ȡϢ
		const char* pPath = GetInforGuardPath();
		if ( ! pPath || ! (*pPath) )
		{
			// ݴ
			CGDLog::WriteErrLog( "1085:GetInforGuardPath() failed" );
			GDPrint( ">>>>----GetInforGuardPath() fail----<<<<\n" );
			return trace.SetRetResult( false );
		}

		// option
		// ʼҳ
		char sCfgFileOption[ GD_MAX_PATH ] = {0}; 
		//жwindowsƽ̨ļ·sCfgFileMain
#ifdef _WIN32
		sprintf( sCfgFileOption, "%s\\cfg\\maoption.xml", pPath );
#else
		sprintf( sCfgFileOption, "%s/cfg/maoption.xml", pPath );
#endif
		try
		{
			if ( ! CFileOpt::IsExist( sCfgFileOption ) )
			{
				// ݴ
				CGDLog::WriteErrLog( "1086:ļ[%s]", sCfgFileOption );
				GDPrint( ">>>>----ļ[%s]----<<<<\n", sCfgFileOption );
				return trace.SetRetResult( false );
			}
		}
		catch ( CExceptionError & ex )
		{
			CGDLog::WriteErrLog( "1087:CSQLValidator:Initialize() catch IsExist throw:%s", ex.GetErrText().c_str() );
			return trace.SetRetResult( false );
		}
		catch ( ... )
		{
			CGDLog::WriteErrLog( "1088:CSQLValidator:Initialize() catch IsExist catch ..." );
			return trace.SetRetResult( false );
		}
		LoadErrCode( sCfgFileOption );

		m_SqlRulePath = "";
		m_SqlRulePath = m_SqlRulePath + pPath + S_PATHLASH + "cfg";
		//GDPrint( ">>>>----InforGuard Path=[%s]----<<<<\n", pPath );

		// ȡ
		if ( ReadRules( SQLRULES_NAME.c_str(), m_sqlRules ) )
		{
			m_sqlRuleLastTime = GetLastTime();	// ޸ʱ
			m_bInitialized = true;
		}
		else
		{
			GDPrint( "Read sqlrules.xml error.\n" );
			CGDLog::WriteErrLog( "1089:ȡSQLʧܣ" );
			return trace.SetRetResult( false );
		}

		// add by liu_yfeng 2009-01-05
		long nRet = m_msgQue.Init( KEY_MEM_MQUE_CHECKER, 512 );
		if ( nRet )
		{
			CGDLog::WriteErrLog( "1090:ʼϢʧ[%d] [%d]", nRet, KEY_MEM_MQUE_CHECKER);
			GDPrint( ">>>>----ʼϢʧ[%d] [%d]----<<<<\n", nRet, KEY_MEM_MQUE_CHECKER);
			trace.SetRetResult( false );
		}

		//GDPrint( ">>>>----CSQLValidator::Initialize() OK----<<<<\n" );
		CGDLog::WriteSysLog( "2044:CSQLValidator::Initialize() OK" );
	}
	
	return trace.SetRetResult( true ); 
}

bool CSQLValidator::LoadErrCode( const char* sCfgFile )
{
	CGDTrace trace( LOG_L6, "CSQLValidator:LoadErrCode(%s,)", sCfgFile );
	trace.SetRetResult( false );

	try
	{
		TiXmlDocument doc;
		if ( ! doc.LoadFile( sCfgFile ) )
		{
			// ݴ
			CGDLog::WriteErrLog( "1091:CValidator:LoadErrCode() ļ[%s]ʧ", sCfgFile );
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = hDoc.FirstChildElement("option").Element();
		if ( ! pRootElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1092:CValidator:LoadErrCode() ļȱʧ[%s]", "option" );
			return trace.SetRetResult( false );
		}

		TiXmlElement* pMonitorElem = NULL;
		pMonitorElem = pRootElem->FirstChildElement("monitor");
		if ( ! pMonitorElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1093:CValidator:LoadErrCode() ļȱʧ[%s]", "monitor" );
			return trace.SetRetResult( false );
		}
		TiXmlElement* pFileChecker = NULL;
		pFileChecker = pMonitorElem->FirstChildElement("filechecker");
		if ( ! pFileChecker )
		{
			// ݴ
			CGDLog::WriteErrLog( "1094:CValidator:LoadErrCode() ļȱʧ[%s]", "filechecker" );
			return trace.SetRetResult( false );
		}

		// Ϣ
		const char* pCodeMain = pFileChecker->Attribute( "errcode" );
		if ( pCodeMain && *pCodeMain )
		{
			m_nErrCode = pCodeMain;
		}
		
		pCodeMain = pFileChecker->Attribute( "errpage" );
		if ( pCodeMain && *pCodeMain )
		{
			m_sErrPage = pCodeMain; // ָĿ¼ʱӸĿ¼ʼ
		}
		pCodeMain = pFileChecker->Attribute( "errmessage" );
		if ( pCodeMain && *pCodeMain )
		{
			m_sErrMessage = pCodeMain; // ָʾϢ
		}
		else
		{
			m_sErrMessage = "<html><body><center><h1>кзǷַֹ!</h1></center></body></html>";
		}
	}
	catch ( ... )
	{
		// ݴ
		CGDLog::WriteErrLog( "1096:CValidator:LoadErrCode() catch Exception" );
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( true );
}

bool CSQLValidator::UnInitialize()
{
	CGDTrace trace( LOG_L6, "CSQLValidator:UnInitialize()" );
	return true;
}

bool CSQLValidator::Check( char cType, const char* sHost, const char* method, const char* url, char* pQueryString )
{
	CGDTrace trace( LOG_L6, "CSQLValidator:Check(%c,%s,%s,%s,%s)", cType, sHost, method, url, pQueryString );

	// Ĵ
	if ( NULL == pQueryString || '\0' == *pQueryString )
	{
		return trace.SetRetResult( true );
	}

	// ȡļ
	if ( IsRulesChange() )
	{
	    CThreadLock lock( m_mutex );
		if ( ReadRules( SQLRULES_NAME.c_str(), m_sqlRules ) )
		{
			m_sqlRuleLastTime = GetLastTime();
		}
	}

	if ( !m_bUseCheck )
	{
		return trace.SetRetResult( true );
	}

	vector<PcreRex*>::size_type exUrlLen = m_sqlRules.exUrls.size();
	for ( vector<PcreRex*>::size_type i=0; i<exUrlLen; i++ )
	{
		if ( url !=NULL && *url != '\0' && m_sqlRules.exUrls[i]->match( url ) )
		{
			return trace.SetRetResult( true );
		}
	}

	// ȥpQueryStringе\n
	string queryString(pQueryString);
	CGDString::ReplaceChar(queryString, '\n', ' ' );

	vector<PcreRex*>::size_type exRulesLen = m_sqlRules.exRules.size();
	for ( vector<PcreRex*>::size_type j=0; j<exRulesLen; j++ )
	{
		if ( !queryString.empty() && m_sqlRules.exRules[j]->match( queryString.c_str() ) )
		{
			if ( cType != NULL && sHost != NULL && method != NULL && url != NULL && pQueryString != NULL )
			{
				CGDLog::WriteSysLog( "CSQLValidator:Check(%c,%s,%s,%s,%s) Access(exclude)", cType, sHost, method, url, pQueryString );
			}
			return trace.SetRetResult( true );
		}
	}

	bool bRet = true;
	vector<PcreRex*>::size_type inRulesLen = m_sqlRules.inRules.size();
	for ( vector<PcreRex*>::size_type k=0; k<inRulesLen; k++ )
	{
		bool bCheck = false;
		try
		{
			if ( !queryString.empty() && NULL != m_sqlRules.inRules[k] )
			{
				bCheck = m_sqlRules.inRules[k]->match( queryString.c_str() );
			}
			else
			{
				CGDLog::WriteErrLog( "1097:CSQLValidator:Check()-match is NULL" );
				bCheck = true;
			}
		}
		catch ( PcreRexException ex )
		{
			CGDLog::WriteErrLog( "1098:CSQLValidator:Check()-match throw exception(%s)", ex.GetError().c_str() );
			bCheck = true;
		}
		catch ( ... )
		{
			// ¼־
			CGDLog::WriteErrLog( "1099:CSQLValidator:Check()-match throw exception(...)" );
			bCheck = true;
		}
		if ( bCheck )
		{
			EVENT_S event = {0};
			event.event_type = MONITOR_EVENT_SQLINJECT;
			strncpy( event.o_filepath, url, sizeof(event.o_filepath)-1 );

			int nLen = 0;
			int nSize = sizeof(event.n_filepath);
			strncpy( event.n_filepath, pQueryString, nSize - 1 );
			nLen += strlen( pQueryString );
			if ( nSize > nLen + 1 )
			{
				strcat( event.n_filepath, "|" );
				strncpy( event.n_filepath + nLen + 1, sHost, nSize - nLen - 1 );
			}
			nLen += strlen( sHost );
			if ( nSize > nLen + 1 )
			{
				strcat( event.n_filepath, "|" );
				strncpy( event.n_filepath + nLen + 2, method, nSize - nLen - 1 );
			}

			// ʼͨѶ
				long nErr = m_msgQue.PutMessage( ( void* )&event, sizeof(EVENT_S));
				
				if ( NO_ERROR != nErr )
				{
					// ¼־
					CGDLog::WriteErrLog( "1100:CSQLValidator:Check()-m_msgQue.PutMessage() fail [%d]", nErr );
				}
				
			// ¼ͼ־
			if ( cType != NULL && sHost != NULL && method != NULL && url != NULL && pQueryString != NULL )
			{
				CGDLog::WriteSecLog( "CSQLValidator:Check(%c,%s,%s,%s,%s) Deny Access", cType, sHost, method, url, pQueryString );
			}
			else
			{
				CGDLog::WriteSecLog( "CSQLValidator:Check(illegal request) Deny Access" );
			}
			
			return trace.SetRetResult( false );
		}
	}

	return trace.SetRetResult( true );
}

bool CSQLValidator::IsRulesChange()
{
	CGDTrace trace( LOG_L6, "CSQLValidator:IsRulesChange()" );
	// ȡǰʱ
	time_t curTime = time( NULL );
	static time_t futureTime = curTime;
	if ( curTime <= futureTime )			// ȡ
	{
		return trace.SetRetResult( false );
	}
	else	// ¶ȡʱ
	{
		futureTime = curTime + m_sqlReadCycle;
	}
	
	// ȡļ޸ʱ
	time_t lastTime = GetLastTime();
	if ( lastTime != m_sqlRuleLastTime )
	{
		return trace.SetRetResult( true );
	}
	else
	{
		return trace.SetRetResult( false );
	}
}

void CSQLValidator::ReleaseRules( SQLRules& rules )
{
	CGDTrace trace( LOG_L6, "CSQLValidator:ReleaseRules()" );

	vector<PcreRex*>::size_type exUrlLen = m_sqlRules.exUrls.size();
	for ( vector<PcreRex*>::size_type i=0; i<exUrlLen; i++ )
	{
		if ( NULL != m_sqlRules.exUrls[i] )
		{
			delete m_sqlRules.exUrls[i];
			m_sqlRules.exUrls[i] = NULL;
		}
	}
	m_sqlRules.exUrls.clear();

	vector<PcreRex*>::size_type exRulesLen = m_sqlRules.exRules.size();
	for ( vector<PcreRex*>::size_type j=0; j<exRulesLen; j++ )
	{
		if ( NULL != m_sqlRules.exRules[j] )
		{
			delete m_sqlRules.exRules[j];
			m_sqlRules.exRules[j] = NULL;
		}
	}
	m_sqlRules.exRules.clear();

	vector<PcreRex*>::size_type inRulesLen = m_sqlRules.inRules.size();
	for ( vector<PcreRex*>::size_type k=0; k<inRulesLen; k++ )
	{
		if ( NULL != m_sqlRules.inRules[k] )
		{
			delete m_sqlRules.inRules[k];
			m_sqlRules.inRules[k] = NULL;
		}
	}
	m_sqlRules.inRules.clear();
}

bool CSQLValidator::ReadRules( const char* name, SQLRules& rules )
{
	CGDTrace trace( LOG_L6, "CSQLValidator:ReadRules(%s)", name );
	trace.SetRetResult( false );

	// ڴ
	ReleaseRules( rules );

	try
	{
		TiXmlDocument doc;

		if (!doc.LoadFile(( m_SqlRulePath + S_PATHLASH + name ).c_str())) 
		{
			return trace.SetRetResult( false );
		}

		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = NULL;

		pRootElem = hDoc.FirstChildElement("sql").Element();

		string sCycle = pRootElem->Attribute( "cycle" );	// жļ
		if ( !sCycle.empty() )
		{
			m_sqlReadCycle = atol( sCycle.c_str() );
		}
		string sSqlUse = pRootElem->Attribute( "available" );	// жļ
		if ( "0" == sSqlUse )
		{
			m_bUseCheck = false;
		}
		else
		{
			m_bUseCheck = true;
		}

		// ȡ
		TiXmlElement* pRulesElem = NULL;
		pRulesElem = pRootElem->FirstChildElement("rules");
		if ( NULL == pRulesElem )
		{
			trace.SetRetResult( false );
		}
		
		// ų
		TiXmlElement* pExcludes = NULL;
		pExcludes = pRulesElem->FirstChildElement("excludes");
		if ( NULL != pExcludes )
		{
			// URL
			TiXmlElement* pUrls = NULL;
			pUrls = pExcludes->FirstChildElement("urls");
			if ( NULL != pUrls )
			{
				TiXmlElement* pUrl = NULL;
				pUrl = pUrls->FirstChildElement("url");
				while ( NULL != pUrl )
				{
					string strUrlRule = pUrl->Attribute( "value" );
					PcreRex* objUrlRule = new PcreRex( strUrlRule, PcreRex::RE_CASELESS );	//ַƥ䲻ִСд
					m_sqlRules.exUrls.push_back( objUrlRule );
					pUrl = pUrl->NextSiblingElement();
				}
			}

			// sqlrules
			TiXmlElement* pSqlRules = NULL;
			pSqlRules = pExcludes->FirstChildElement("sqlrules");
			if ( NULL != pSqlRules )
			{
				TiXmlElement* pRule = NULL;
				pRule = pSqlRules->FirstChildElement("rule");
				while ( NULL != pRule )
				{
					string strRule = pRule->Attribute( "value" );
					PcreRex* objRule = new PcreRex( strRule, PcreRex::RE_CASELESS );	//ַƥ䲻ִСд
					m_sqlRules.exRules.push_back( objRule );
					pRule = pRule->NextSiblingElement();
				}
			}
		}

		// 
		TiXmlElement* pIncludes = NULL;
		pIncludes = pRulesElem->FirstChildElement("includes");
		if ( NULL != pIncludes )
		{
			TiXmlElement* pRule = NULL;
			pRule = pIncludes->FirstChildElement("rule");
			while ( NULL != pRule )
			{
				string strRule = pRule->Attribute( "value" );
				PcreRex* objRule = new PcreRex( strRule, PcreRex::RE_CASELESS );	//ַƥ䲻ִСд
				m_sqlRules.inRules.push_back( objRule );
				pRule = pRule->NextSiblingElement();
			}
		}
	}
	catch ( ... )
	{
		trace.SetRetResult( false );
	}

	return trace.SetRetResult( true );
}

