/******************************************************************************
*
* ļ              SyncFile.cpp
* ģĿģ      ļ
* ߼ڣ        zhang_dpeng 2008-06-01
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
******************************************************************************/

#pragma warning( disable : 4786 4251)
#include "Common/GDTimer.h"
#include "Base/App.h"
#include "Base/AppConfig.h"
#include "Base/RunInfor.h"
#include "Base/SyncFile.h"
#include "Base/FileListEx.h"
#include "Base/TaskControl.h"
#include "Base/Toolbox.h"
#include "Base/Tool.h"
#include "FileOpt/FileTree.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "Groundwork/File.h"
#include "Groundwork/Path.h"
#include "Groundwork/String.h"
#include "MsgTran/MsgTranClient.h"
#include "WaterMark/WaterMarkDB.h"
#include <map>
#include <set>

extern char sa_ip[32];//ʹȫֱ
extern char sa_port[8];//ʹȫֱ

using std::string;
using namespace InforGuard::Groundwork;

unsigned long CSyncFile::m_nFileSerial = time(NULL) << 10; // Ʊظ(ֻҪƽ11024¼2^24ڲظԼ194)


CSyncFile::CSyncFile( long serial, enumMsgID totalSizeMid, enumMsgID finishMid, enumMsgID finishSizeMid, enumMsgID fileNameMid )
:CManageOperation(serial, totalSizeMid, finishMid, finishSizeMid, fileNameMid )
{}

CSyncFile::~CSyncFile()
{}

// ԶʱļкţԶMAһSAʱļ⣩
unsigned int CSyncFile::GetTempFileSerialNo()
{
	CGDTrace trace( LOG_L6, "CSyncFile:GetTempFileSerialNo()" );
	
	static CThreadMutex mutex;
	static unsigned int nSerialNo = time(NULL);
	static unsigned int nInc = 0;

	CThreadLock lock(mutex);
	unsigned int n = time(NULL);
	if ( n == nSerialNo )
	{
		n = (n<<10) + (nInc++); // Ʊظ(ֻҪƽ11024¼2^24ڲظԼ194)
	}
	else
	{
		n = ( (nSerialNo=n)<<10 ) + (nInc=0);
	}
	return trace.SetRetValue( n );
}

bool CSyncFile::IsTopPath(const std::string& websiteId, const string& srcPath)
{
	CGDTrace trace( LOG_L6, "CSyncFile:IsTopPath(%s, %s)", websiteId.c_str(), srcPath.c_str() );

	WebSite website;

	CAppConfig::Instance().GetSiteById(websiteId, website);

	std::vector<SiteDirectory>::iterator itDirectory;
	for (itDirectory = website.siteDirectorys.begin(); itDirectory != website.siteDirectorys.end(); ++itDirectory)
	{
		if ( icompare( srcPath, (*itDirectory).localPath ) == 0 )
		{
			return trace.SetRetResult( true );
		}
	}

	return trace.SetRetResult( false );
}

long CSyncFile::SyncFile(const std::string& websiteId, ESyncType syncType, bool isBackup )
{
	CGDTrace trace( LOG_L6, "CSyncFile:SyncFile(%s, %d)", websiteId.c_str(), syncType );

	WebSite website;
	std::vector<SiteDirectory> syncDir;

	string wid;
	string::size_type widLen = websiteId.find_first_of( "|", 0 );
	if ( widLen == string::npos )
	{
		wid = websiteId;
	}
	else
	{
		wid = websiteId.substr( 0, widLen );
	}

	if (!CAppConfig::Instance().GetSiteById(wid, website))
	{
		string errInfo;
		errInfo.append("ҲӦվid[");
		errInfo.append(websiteId);
		errInfo.append("]");
		GDPrint("%s\n", errInfo.c_str());
		SendFinish( "allfail", errInfo.c_str() );
		return trace.SetRetValue( 0 );
	}

	std::vector<SiteDirectory>::iterator itDirectory;
	for (itDirectory = website.siteDirectorys.begin(); itDirectory != website.siteDirectorys.end(); ++itDirectory)
	{
		syncDir.push_back((*itDirectory));
	}

	long nRet = DoSyncFile( websiteId, syncDir, syncType, isBackup );
	return trace.SetRetValue( nRet );
}

long CSyncFile::SyncFile(const std::string& websiteId, const InforGuard::ParamList& paths, ESyncType syncType, bool isBackup )
{
	CGDTrace trace( LOG_L6, "CSyncFile:SyncFile(%s, paths, %d)", websiteId.c_str(), syncType );
//modify by zhangtao Ŀ¼ļͬҲҪͬMA
	WebSite website;
	std::vector<SiteDirectory> syncDir;
	string wid;
	string::size_type widLen = websiteId.find_first_of( "|", 0 );
	if ( widLen == string::npos )
	{
		wid = websiteId;
	}
	else
	{
		wid = websiteId.substr( 0, widLen );
	}
	int nLen = paths.length();

	if (!CAppConfig::Instance().GetSiteById(wid, website))
	{
		string errInfo;
		errInfo.append("ҲӦվid[");
		errInfo.append(wid);
		errInfo.append("]");
		GDPrint("%s\n", errInfo.c_str());
		SendFinish( "allfail", errInfo.c_str() );
		return trace.SetRetValue( 0 );
	}

	for (int i = 1; i < nLen; ++i) // Ŀ¼б
	{
		std::string path = paths[i];

		std::vector<SiteDirectory>::iterator itDirectory;
		for (itDirectory = website.siteDirectorys.begin(); itDirectory != website.siteDirectorys.end(); ++itDirectory)
		{
			if ( icompare( path, (*itDirectory).localPath ) == 0 ) // ֱΪĿ¼
			{
				syncDir.push_back((*itDirectory));
				continue;
			}

			std::string tmpDir = (*itDirectory).localPath + Path::separator();
			if ( icompare( path.substr( 0, tmpDir.length() ), tmpDir ) == 0 ) // ǸlocalPathĿ¼ļ
			{
				SiteDirectory directory;
				std::string relativePath = path.substr( tmpDir.length(), path.length() ); // ȡ·

				directory = (*itDirectory); // Ƹdirectoryڵ
				directory.localPath = path; // localPathΪıĿ·

				std::vector<RemotePath>::iterator itRemotePath;
				for (itRemotePath = directory.remotePaths.begin(); itRemotePath != directory.remotePaths.end(); ++itRemotePath)
				{
					(*itRemotePath).path = (*itRemotePath).path + Path::separator() + relativePath; // remotePathΪԶĿ·
				}

				syncDir.push_back(directory);
			}
		}
	}
	long nRet = DoSyncFile( websiteId, syncDir, syncType, isBackup );

	return trace.SetRetValue( nRet );
}

// liu_yfeng	㽫ϳһ
long CSyncFile::DoSyncFile( const std::string& websiteId, 
						   std::vector<SiteDirectory>& syncDir, ESyncType syncType, bool isBackup )
{
	CGDTrace trace( LOG_L6, "CSyncFile:DoSyncFile(%s, syncDir)", websiteId.c_str() );
	//add at 2009.9.29
	char temp[32] = {0};
	MsgBlockStruct lmb;
	lmb.nMid = MID_MA_SA_START_BACKUP;	// MASAͬĿʼ־
	lmb.nLevel = 0;		// ͬ첽
	lmb.nSerial = 0;	// ˮ
	lmb.sSrc = CAppConfig::Instance().GetLocalIp() + ":" + CAppConfig::Instance().GetLocalPort();
#ifdef WIN32
	sprintf( temp, "%I64d", 0);
#else
	sprintf( temp, "%lld", 0 );
#endif
	lmb.pl.push_back( temp );

	long nRet = 0;
	// ȡб
	// ׼ͨѶϢ
	InforGuard::netIpPort host1, host2;
	host1.sIp = CORBA::string_dup( CAppConfig::Instance().GetLocalIp().c_str() );
	host1.sPort = CORBA::string_dup( CAppConfig::Instance().GetLocalPort().c_str() );
	//ȡվIDҪ
	string wid;
	string::size_type widLen = websiteId.find_first_of( "|", 0 );
	if ( widLen == string::npos )
	{
		wid = websiteId;
	}
	else
	{
		wid = websiteId.substr( 0, widLen );
	}
	//ȡҪͬбѡͬĳһ
	set<string> ipList;
	string::size_type wipStart = websiteId.find_first_of( "|", 0 );
	while ( wipStart != string::npos )
	{
		string::size_type wipEnd = websiteId.find_first_of( "|", wipStart + 1 );
		if ( wipEnd == string::npos )
		{
			wipEnd = websiteId.length() + 1;
		}
		ipList.insert( websiteId.substr(wipStart+1, wipEnd - wipStart - 1) );
		wipStart = websiteId.find_first_of( "|", wipEnd + 1 );
	}

	/*
	ֶļŻ
	1.Ŀ¼ͳƴʹ
	2.ѭ
	3.	Ŀ¼ѹݰݰ
	4.	Ŀ¼ˮӡ⣬ˮӡ
	5.
	*/

	// 1.1.Ŀ¼
	char saip[32]={0};
	char saport[8]={0};
	GDInt64 nTotalSize = 0;
 	std::list<FileList> listFileList;
	std::vector<SiteDirectory>::iterator itDirectory;
	std::map<std::string, FinishStateRecord> finishStatus; // ״¼

	for ( itDirectory = syncDir.begin(); itDirectory != syncDir.end(); ++itDirectory )
	{
		FileList fileList;
		CFileListEx fileListEx;
		try
		{
			nRet = fileListEx.CreateListEx( (*itDirectory).localPath.c_str(), wid.c_str(), fileList, CFileListEx::FILE_POLICY );
			if ( nRet )
			{
				CGDLog::WriteErrLog( "1035:CSyncFile:DoSyncFile(%s) return [%d]", (*itDirectory).localPath.c_str(), nRet );
				// ¼
				continue;
			}
			listFileList.push_back( fileList );
			// 1.2.ͳƴ
			GDInt64 nSimpleSize = CFileList::CalcList( fileList );
			std::vector<RemotePath>::iterator itRemotePath;
			for (itRemotePath = (*itDirectory).remotePaths.begin(); itRemotePath != (*itDirectory).remotePaths.end(); ++itRemotePath)
			{
				if ( ! ipList.empty() )
				{
					set<string>::iterator iter = ipList.find( (*itRemotePath).ip );
					if ( iter == ipList.end() )
					{
						continue; // ͬҲ򲻴
					}
				}
				//жǷ񱻽wu_bin
				if ((*itRemotePath).disable == 1 )
				{
					continue;
				}

				// ͳƴ
				nTotalSize += nSimpleSize;

				std::string key;
				key.append((*itRemotePath).ip);
				key.append("_");
				key.append((*itRemotePath).port);

				std::map<std::string, FinishStateRecord>::iterator iter;
				iter = finishStatus.find(key);
				if (iter == finishStatus.end()) // 
				{
					FinishStateRecord record;
					record.totalNum = 0;
					record.currentNum = 0;

					finishStatus.insert(make_pair(key, record));

					iter = finishStatus.find(key);
				}

				iter->second.totalNum += fileList.size(); // ۼ
				iter->second.currentNum = iter->second.totalNum;
			}
		}
		catch ( CExceptionError & ex )
		{
			// Ҫ־
			ex.AddErrText( "CSyncFile:DoSyncFile()" );
			CGDLog::WriteErrLog( "1036:CSyncFile:DoSyncFile(%s) catch ex", ex.GetErrText().c_str() );
		}
	}//for
	// жǷȡ
	if ( ! CheckValidTask() )
	{
		return trace.SetRetValue( -1 );
	}

	clock_t timeStart = clock();	// ڼʱ

	// ѭ-Ŀ¼
	GDInt64 nSendSize = 0;
	std::list<FileList>::iterator iterFileList;
	for ( itDirectory = syncDir.begin(), iterFileList = listFileList.begin(); itDirectory != syncDir.end(); ++itDirectory, ++iterFileList )
	{
		// ѭ-
		std::vector<RemotePath>::iterator itRemotePath;
		for ( itRemotePath = (*itDirectory).remotePaths.begin(); itRemotePath != (*itDirectory).remotePaths.end(); ++itRemotePath )
		{
			if( !ipList.empty() )
			{
				set<string>::iterator iter = ipList.find( (*itRemotePath).ip );
				if ( iter == ipList.end() )
					{
						continue; // ͬҲ򲻴
					}
			}
			//жǷ񱻽wu_bin
			if ((*itRemotePath).disable == 1 )
			{
				continue;
			}
			std::string sSrcPath = (*itDirectory).localPath;
			std::string sTopFile = (*itDirectory).localPath;
			std::string sDstPath = (*itRemotePath).path;
			std::string sIp = (*itRemotePath).ip;
			std::string sPort = (*itRemotePath).port;
			std::string sDstPathTemp = sDstPath + "==--_temp_temp_--==";

			std::string key;
			key.append(sIp);
			key.append("_");
			key.append(sPort);

			std::map<std::string, FinishStateRecord>::iterator iterFinishStatus;
			iterFinishStatus = finishStatus.find(key);
			if ( iterFinishStatus == finishStatus.end() ) // 
				continue;

            // ʼ
            CFileTranClient fileTranClient;
            CNetWaterMarkClient netWMClient;

            nRet = fileTranClient.Init( sIp.c_str(), sPort.c_str() );
			nRet = netWMClient.Init( sIp.c_str(), sPort.c_str() );

			// ȡԶʱĿ¼(ԶΪWindowsϵͳʱȨ޿ҪʹضʱĿ¼)
			std::string sTempPath;
			if ( '/' == sDstPath[0] ) // ԶΪWindows
			{
				sTempPath = fileTranClient.GetPeerTempPath();
				if ( sTempPath.empty() )
				{
					CGDLog::WriteErrLog( "1038:GetPeerTempPath() fail" );
					return trace.SetRetValue( -1 );
					// ׳쳣
				}
			}
			else // ԶΪWindowsϵͳ(ĬϹ)
			{
				sTempPath = CToolbox::GetGDTempPath( sDstPath.c_str() );
			}

            CGDTrace::GDTrace( LOG_DBG, "CSyncFile::DoSyncFile peer temp_path(%s)", sTempPath.c_str() );

            // װʱļ/Ŀ¼
            if( syncType == FULL_SYNC )
			{
                // ȫ, һʱĿ¼
                char sTmp[16] = {0};
                sprintf( sTmp, "%x", GetTempFileSerialNo() );
			    sTempPath += sTmp;
            }

			FileList::iterator iter;
			for ( iter = (*iterFileList).begin(); iter != (*iterFileList).end(); ++iter )
			{
				// add by zhangtao 2009.9.30
				if ( isBackup == 1 )//ǱݲŽķϢ
				{
					CGDTimer *m_cGDTimer = new CGDTimer(1*60*1000);//1ӷһ

					if ( m_cGDTimer->IsTimeout() )
					{
						lmb.sDst = sIp + ":" + sPort;
						host2.sIp = CORBA::string_dup( sIp.c_str() );
						host2.sPort = CORBA::string_dup( sPort.c_str() );
						InforGuard::HostChain hostChain;
						hostChain.length(2);
						hostChain[0] = host1;
						hostChain[1] = host2;

						try
						{ 
							nRet = CMsgTranClient::PushMessage( hostChain, lmb );
						}
						catch ( CExceptionError & ex )
						{
							ex.AddErrText( "CHandleFileTran:SendAllSize(%s)", "");
							throw ex;
						}

					}
				}
				//	add by zhangtao 2009.9.30
				if (!CheckValidTask())
				{
					GDPrint("=========ȡ!\r\n");
					return trace.SetRetValue( -1 );
				}

				string sSrcFile = (*iter).name;
				try
				{
					string sDstFile = sSrcFile;
					sDstFile.replace( 0, ::strlen(sSrcPath.c_str()), sDstPath );
                    // 08-11-12
                    CTool::FormatPath(sDstFile);

					string sTmpFile = sSrcFile;
					if( syncType == FULL_SYNC )
					{
						// ȫ
						sTmpFile.replace( 0, ::strlen(sTopFile.c_str()), sTempPath );
						// 08-11-12
						CTool::FormatPath(sTmpFile);
					}
					else
					{
						// 
						char sTmpNo[16] = {0};
						sprintf( sTmpNo, "%x", GetTempFileSerialNo() );
						sTmpFile = sTempPath + sTmpNo;
					}
					
					// жļĿ¼
					if ( (*iter).isfolder )
					{
						// 1.Ŀ¼
						if( syncType == FULL_SYNC ) // ʱĿ¼
						{
							nRet = fileTranClient.MakePath( sTmpFile.c_str(), true ); // Ŀ¼
						}
						else // ʵĿ¼
						{
							nRet = fileTranClient.MakePath( sDstFile.c_str(), false ); // Ŀ¼
						}
						iterFinishStatus->second.currentNum--; // ļδ-1
					}
					else // ļļ
					{
				//		CAppConfig::Instance().IsValidFile(sSrcFile);
						// õǰļ-ͬʱõǰϢ(һ)
						CApp::Instance().TaskControl().SetTaskProcess( m_fileNameMid, m_nSerial, sSrcFile, nSendSize, nTotalSize );

						char szWm[ WMARK_LEN ] = {0};
						// жǷͬͬҪжǷ䣬ֻдʱˮӡ
						bool bQuick = (syncType == QUICK_SYNC) && IsPushFile( fileTranClient, (*iter).size, sDstFile.c_str() );
						if ( (syncType != QUICK_SYNC) || bQuick )
						{
							// 1.ˮӡ
							nRet = CWaterMarkDB::BuildWaterMark( sSrcFile.c_str(), szWm );

							// 2.±ˮӡ
							if ( !isBackup )			// add by liu_yfeng 2008-11-27
							{
								nRet = CApp::Instance().WmDb().Set( sSrcFile.c_str(), szWm );
							}
							if( nRet == 2 )
							{
								CGDLog::WriteErrLog("ˮӡʱڴ治㣡");
								SendFinish( "allfail", "ˮӡʱڴ治㣡" );
								return trace.SetRetValue( nRet);
							}
						}
						// жǷͬͬҪжǷ䣬ֻдʱŴ
						bool bIncrease = (syncType == INCREASE_SYNC) && IsPushFile( netWMClient, sDstFile.c_str(), (*iter).size, szWm );
						if ( syncType == FULL_SYNC || bIncrease || bQuick )
						{
							// 3.ļ-˹Żѹ崦
							nRet = fileTranClient.PushFile( sSrcFile.c_str(), sTmpFile.c_str() );

							// ˮӡʱ״̬δʵ֣
							
							if ( syncType == FULL_SYNC )
							{
								std::string sDstFileTemp = sDstFile;
								sDstFileTemp.replace( 0, sDstPath.length(), sDstPathTemp );
								// 08-11-12
								CTool::FormatPath(sDstFileTemp);
								
								// 4.Զˮӡ
								if ( !isBackup )			// add by liu_yfeng 2008-11-27
								{
									nRet = netWMClient.Set( sDstFileTemp.c_str(), szWm );
								}
								if( nRet == 2 )
								{
									CGDLog::WriteErrLog("ˮӡʱڴ治㣡");
									SendFinish( "allfail", "ˮӡʱڴ治㣡" );
									return trace.SetRetValue( nRet);
								}
							}
							else
							{
								// ƶļ
								string sDustFile = sTmpFile;
								sDustFile.replace( sDustFile.find("Temporary", 0 ), strlen("Temporary"), "Dustbin" );
								char szTmp[16] = {0};
								sprintf(szTmp, "%d", m_nFileSerial++);
								sDustFile += szTmp;
								nRet = fileTranClient.MoveFileIn( sTmpFile.c_str(), sDstFile.c_str(), sDustFile.c_str(), false );
								
								// 4.Զˮӡ
								if ( !isBackup )			// add by liu_yfeng 2008-11-27
								{
									nRet = netWMClient.Set( sDstFile.c_str(), szWm );
								}
								if( nRet == 2 )
								{
									CGDLog::WriteErrLog("ˮӡʱڴ治㣡");
									SendFinish( "allfail", "ˮӡʱڴ治㣡" );
									return trace.SetRetValue( nRet);
								}
							}
						}

						iterFinishStatus->second.currentNum--; // ļδ-1
						nSendSize += (*iter).size;
					}//if(Ŀ¼)else(ļ)
				}
				catch ( CExceptionError & ex )
				{
					try
					{
						nSendSize += (*iter).size;
						// ʧϢ
						SendError( sSrcFile, sIp, ex );
						CGDLog::WriteErrLog( "2040:%s", ex.GetErrText().c_str() );
					}
					catch( CExceptionError& )
					{
						GDPrint("====MCͨѶ쳣====\n");
					}
				}
			}//for(ļ)

			if ( syncType == FULL_SYNC )
			{
				// װƳĿļ
				string sDustFile;
				if ( '/' == sDstPath[0] ) // ԶΪWindows
				{
					sDustFile = fileTranClient.GetPeerDustPath();
				}
				else // ԶΪWindowsϵͳ(ĬϹ)
				{
					sDustFile = CToolbox::GetGDDustPath(sDstPath.c_str());
				}

				char sTmp[16] = {0};
				sprintf( sTmp, "%x", GetTempFileSerialNo() );
				sDustFile += sTmp;

				string sDstFile = sTopFile;
				sDstFile.replace( 0, strlen(sSrcPath.c_str()), sDstPath.c_str() );
				// 08-11-12
				CTool::FormatPath(sDstFile);

				// Զļ
				// أԶͬ״̬²ƶأ򱸷ݣĿ¼
				bool bTopPath = IsTopPath(wid, sSrcPath.c_str());

				try
				{
					nRet = fileTranClient.MoveFileIn( sTempPath.c_str(), sDstFile.c_str(), sDustFile.c_str(), bTopPath );
					if ( 0 == nRet )
					{
						// ɾsDstPath
						if ( !isBackup )			// add by liu_yfeng 2008-11-27
						{
							nRet = netWMClient.Remove( sDstPath.c_str() );
							if ( 0 == nRet )
							{
								// Զˮӡ
								nRet = netWMClient.Rename( sDstPathTemp.c_str(), sDstPath.c_str() );
							}
						}
					}
				}
				catch ( CExceptionError & ex )
				{
					std::string sOptionName = GetOption( CApp::Instance().TaskControl().GetTaskTypeBySerial( m_nSerial ) );
					// CApp::Instance().RunInfor().SendToMc( m_nSerial, RUN_ERROR_LOG, sOptionName.c_str(), NULL, sDstPath.c_str() );
					CGDLog::WriteErrLog( "1041:ļƶʧ[%s, %s, %s]\n%s", sTempPath.c_str(), sDstFile.c_str(), sDustFile.c_str(), ex.GetErrText().c_str() );

					clock_t timeEnd = clock();
					GDPrint( "ļʧʱΪ:%d;\n", timeEnd - timeStart );
					try
					{
						// ļʧ
						// ʧϢ
						if ( ex.GetErrCode() != ENOENT )
						{
							SendError( sTempPath, sIp, ex );			// by liu_yfeng 2008-12-01
						}
						CGDLog::WriteErrLog( "3040:%s", ex.GetErrText().c_str() );
					}
					catch ( ... )
					{
						GDPrint("====MCͨѶ쳣====\n");
					}
				}
			}//if(ȫͬ)
		}//for()
	}//for(Ŀ¼)

	long totalFileNum = 0; // Ҫļ
	long currentFileNum = 0; // δļ

	std::map<std::string, FinishStateRecord>::iterator iterFinishStatus;
	for( iterFinishStatus = finishStatus.begin(); iterFinishStatus != finishStatus.end(); ++iterFinishStatus )
	{
		totalFileNum += iterFinishStatus->second.totalNum;
		currentFileNum += iterFinishStatus->second.currentNum;
	}

	clock_t timeEnd = clock();
	if ( timeEnd - timeStart < 70 )
	{
		CDateTime::Sleep( 70 ); // ǰ̨Ϣ̫
	}
	
	if ( currentFileNum == 0 ) // ȫ
	{
		// ʹ(ȫɹ)
		SendFinish( "success", "" );
	}	
	else if (totalFileNum == currentFileNum)// ȫʧ
	{
		CGDLog::WriteErrLog( "1042:ļʧ(ȫ)" );
		// ʹ(ȫʧ)
		SendFinish( "allfail", "ļȫʧ" );
	}
	else // ɣÿж
	{
		bool allSuccess = true;

		for( iterFinishStatus = finishStatus.begin(); iterFinishStatus != finishStatus.end(); ++iterFinishStatus )
		{
			// ȫʧ
			if (iterFinishStatus->second.currentNum == iterFinishStatus->second.totalNum)
			{
				GDPrint("***ļʧ(ĳȫʧ)***\r\n");

				// ʹ(ȫʧ)
				SendFinish( "allfail", "ļʧ(ĳȫʧ)" );
				return trace.SetRetValue( -1 ); // ???
			}
			// ʧ
			else
			{
				allSuccess = false;
			}
		}

		if (!allSuccess)
		{
			GDPrint("***ļʧ()***\r\n");

			// ʹ(ʧ)
			SendFinish( "partfail", "ļʧ()" );
		}
	}
	GDPrint( "ʱΪ:%d;\n", timeEnd - timeStart );
	return trace.SetRetValue( nRet);
}


bool CSyncFile::IsPushFile( CNetWaterMarkClient& netWMClient, const char* sFileName, long nFileSize, const char* sWm )
{
	CGDTrace trace( LOG_L6, "CSyncFile:IsPushFile(%s)", sFileName );
	// 3.֤Ƿ-֤
	long nRet = netWMClient.Verify( sFileName, nFileSize, sWm, false );
	if ( 403 == nRet || 404 == nRet )
	{
		return trace.SetRetResult( true );
	}
	else
	{
		return trace.SetRetResult( false );
	}
}

bool CSyncFile::IsPushFile ( CFileTranClient &fileTranClient, size_t fileSize, const char *sDstFile)
{
	CGDTrace trace( LOG_L6, "CSyncFile:IsPushFile(%d,%s)", fileSize, sDstFile );
	long nDstFileSize = 0;   //ڻȡԶ˵ļС
	long nRet = 9999;
	try 
	{
		nRet = fileTranClient.isFileExist(sDstFile, nDstFileSize);
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText("CSyncFile:IsPushFile()");
		throw ex;
	}
	
	if (nRet == 0 && fileSize == nDstFileSize)
		return trace.SetRetResult(false);
	return trace.SetRetResult(true);
}

std::string CSyncFile::GetOption( long msgId )
{
	switch ( msgId )
	{
	case MID_MC_SA_FILETRAN_WEBSITE_FULL:		// ȫͬ(SAش)(ļSAMA)
	case MID_MC_SA_FILETRAN_WEBSITE_PART:		// ͬ(SAش)(ԱΪ׼ͬ)
	case MID_MC_SA_FILETRAN_WEBSITEDIR_FULL:	// վ߼Ŀ¼ȫͬ
	case MID_MC_SA_FILETRAN_DIRFILE_FULL:		// Ŀ¼ļȫͬ
	case MID_MC_SA_FILETRAN_WEBSITEDIR_PART:	// վ߼Ŀ¼ͬ
	case MID_MC_SA_FILETRAN_DIRFILE_PART:		// Ŀ¼ļͬ
		return "ͬʧ";

	case MID_MC_MA_FILETRAN_WEBSITE_FULL:		// ȫ(MAش)(ļMASA)
	case MID_MC_MA_FILETRAN_WEBSITE_PART:		// (MAش)(ԱΪ׼ͬ)
	case MID_MC_MA_FILETRAN_DIRFILE_FULL:		// Ŀ¼ļȫ
	case MID_MC_MA_FILETRAN_WEBSITEDIR_PART:	// վ߼Ŀ¼
	case MID_MC_MA_FILETRAN_DIRFILE_PART:		// Ŀ¼ļ
		return "ʧ";
	default:
		return "ʧ";
	}
}
