// DirTreeCtrl.cpp : ʵļ
//

#include "stdafx.h"
#include "DBViewer.h"
#include "DirTreeCtrl.h"
#include ".\dirtreectrl.h"
#include "MainFrm.h"
#include ".\dbviewerview.h"

static UINT treeIcons[] =
{
	IDI_ICON_FOLDER
};

// CDirTreeCtrl
CDirTreeCtrl* CDirTreeCtrl::m_pDirTreeCtrl = NULL;

IMPLEMENT_DYNAMIC(CDirTreeCtrl, CTreeCtrl)
CDirTreeCtrl::CDirTreeCtrl()
{
	m_pDirTreeCtrl = this;
	m_pDb = NULL;
}

CDirTreeCtrl::~CDirTreeCtrl()
{
}


BEGIN_MESSAGE_MAP(CDirTreeCtrl, CTreeCtrl)
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
END_MESSAGE_MAP()



// CDirTreeCtrl Ϣ

void CDirTreeCtrl::FindAndAddNode(HTREEITEM hItem, const char* sPath)
{
	HTREEITEM hChildItem = NULL;
	HTREEITEM hNextItem = hItem;
	BOOL bFind = false;
	char dirPart[256] = "";
	char* sSlashPos = ::strstr(sPath, "\\");
	int nSlashPos = (sSlashPos == NULL) ? 0 : sSlashPos - sPath;
	const char* sSubPath = sPath + nSlashPos + 1;
	if (nSlashPos == 0)
	{
		::strcpy(dirPart, sPath);
		// ½ڵ
		m_pDirTreeCtrl->InsertItem(sPath, 0, 0, hItem);
	}
	else
	{
		::memcpy(dirPart, sPath, nSlashPos);
		dirPart[nSlashPos] = '\0';
	}

	while (hNextItem != NULL)
	{
		CString a = m_pDirTreeCtrl->GetItemText(hNextItem);
		if (m_pDirTreeCtrl->GetItemText(hNextItem).Compare(dirPart) == 0) // ǸĿ¼Ŀ¼
		{
			hChildItem = m_pDirTreeCtrl->GetChildItem(hNextItem);
			if (hChildItem == NULL || (hChildItem != NULL && !::strstr(sSubPath, "\\")))
                FindAndAddNode(hNextItem, sSubPath);
			else
				FindAndAddNode(hChildItem, sSubPath);

			return;
		}

		hNextItem = m_pDirTreeCtrl->GetNextItem(hNextItem, TVGN_NEXT);
	}
}

void CDirTreeCtrl::ShowDirCall(const char* sPath, const char* sWm)
{
	FindAndAddNode(m_pDirTreeCtrl->GetRootItem(), sPath);
	//m_pDirTreeCtrl->InsertItem(sPath);
}

void CDirTreeCtrl::ShowRootDir(void)
{
	CFileDialog filedlg(TRUE, _T("*"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NOCHANGEDIR, _T("*.dbݿļ|*.db|ļ (*.*)|*.*||"));
	if(filedlg.DoModal() != IDOK)
	{
		return;
	}

	CString strFileName = filedlg.GetFileName();
	CString strPath = filedlg.GetPathName();
	strPath.Replace("\\" + strFileName, "");

	if (m_pDb)
	{
		delete m_pDb;
		m_pDb = NULL;
	}

	DeleteAllItems();

	m_pDb = new CDB;
	long keydb = KEY_MEM_DB_TREE_MA;

	if (strFileName.CompareNoCase("ma.db") == 0)
		keydb = KEY_MEM_DB_TREE_SA;

	if (m_pDb->Initialize( strPath, strFileName, keydb, DB_TREE_SIZE, DB_TREE_SAVE_COUNT, DB_TREE_SAVE_SECONDS ))
	{
		::AfxMessageBox("ݿʼʧ!");
		return;
	}

	m_pDb->ShowData(CDirTreeCtrl::ShowDirCall);
	//m_pDb->ShowDirData("ROOT", CDirTreeCtrl::ShowRootDirCall);
}

CString CDirTreeCtrl::GetItemPath(HTREEITEM hItem)
{
	HTREEITEM hParentItem = hItem;
	CString strText = GetItemText(hItem);
	

	while((hParentItem = GetParentItem(hParentItem)) != NULL)
	{
		strText = GetItemText(hParentItem) + "\\" + strText;
	}

	return strText;
}

void CDirTreeCtrl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	// TODO: ڴӿؼ֪ͨ
	UINT ClickLocation;
    CPoint pt(::GetMessagePos());
    ScreenToClient(&pt);
    HitTest(pt, &ClickLocation);
    if (ClickLocation & TVHT_ONITEM)// ж˫ϢǷitem
    {
		CPoint point;
		
		GetCursorPos(&point);
		CPoint pointInTree = point;
		ScreenToClient(&pointInTree);
		
		HTREEITEM hItem;
		UINT flag = TVHT_ONITEM;
		hItem = HitTest(pointInTree, &flag);
		
		if(hItem != NULL)
		{
			CDBViewerView* pDbView=(CDBViewerView*)((CMainFrame*)AfxGetMainWnd())->m_wndSplitter.GetPane(0, 1);
    		pDbView->ShowDb(GetItemPath(hItem));
			
			SelectItem(hItem);
		}
		else
		{
			return;
		}
	}
	
	*pResult = 0;
}

void CDirTreeCtrl::InitTree(void)
{
	m_ilTreeIcons.Create(16, 16, ILC_MASK|ILC_COLOR32, 1, 1);
	for (int i  = 0; i < 1; i++)
	{
		HICON hIcon = AfxGetApp()->LoadIcon(treeIcons[i]);
		ASSERT(hIcon);

		m_ilTreeIcons.Add(hIcon);
	}

	SetImageList(&m_ilTreeIcons, TVSIL_NORMAL);

	SetItemHeight(18);
}
