/******************************************************************************
*
* ļ              Driver.cpp
* ģĿģ      ļж
* ߼ڣ        liu_yfeng 2008-6-19
* 汾                1.0
* ȨϢ            CVICSE Middleware
* ļ¼            
*
******************************************************************************/


#include "Driver.h" // use advapi32.lib
#include "GDLog/GDTrace.h"
#include "Common/ConvertString.h"


//const LPCTSTR INTERDICTION_NAME = "FileDriver";


CDriver::CDriver()
{
}

CDriver::~CDriver()
{
}

bool CDriver::InstallDriver( IN LPCTSTR DriverName, IN LPCTSTR ServiceExe )
{
	
	CGDTrace trace( LOG_L6, "CDriver:InstallDriver(%s,%s)", DriverName,ServiceExe );
	SC_HANDLE hSCManager;
	SC_HANDLE hService;

	// Remove any previous instance of the driver

	RemoveDriver( DriverName );

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

	if (hSCManager)
	{
		// Install the driver
		hService = CreateService( hSCManager,          // SCManager database
                                DriverName,           // name of service
                                DriverName,           // name to display
                                SERVICE_ALL_ACCESS,    // desired access
                                SERVICE_KERNEL_DRIVER, // service type
                                SERVICE_DEMAND_START,  // start type
                                SERVICE_ERROR_NORMAL,  // error control type
                                ServiceExe,            // service's binary
                                NULL,                  // no load ordering group
                                NULL,                  // no tag identifier
                                NULL,                  // no dependencies
                                NULL,                  // LocalSystem account
                                NULL                   // no password
                                );
		DWORD nn = GetLastError();

		CloseServiceHandle(hSCManager);

		if ( hService == NULL )
		{
			return trace.SetRetResult( false );
		}
	}
	else
	{
		return trace.SetRetResult( false );
	}

	CloseServiceHandle(hService);

	return trace.SetRetResult( true );
}

bool CDriver::RemoveDriver( IN LPCTSTR DriverName )
{
	CGDTrace trace( LOG_L6, "CDriver:RemoveDriver(%s)", DriverName);
	SC_HANDLE hSCManager;
	SC_HANDLE hService;
	bool bResult;

	StopDriver( DriverName );

	//CDateTime::Sleep( 100 );

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

	if (hSCManager)
	{
		hService = OpenService( hSCManager, DriverName, SERVICE_ALL_ACCESS );

		CloseServiceHandle(hSCManager);

		if (hService)
		{
			bResult = DeleteService( hService ) == 0 ? false : true;

			DWORD eeor = GetLastError();
      
			CloseServiceHandle(hService);
		}
		else
		{
			return trace.SetRetResult( false );
		}
  }
  else
  {
	  return trace.SetRetResult( false );
  }

  return trace.SetRetResult( bResult );
}

bool CDriver::StartDriver( IN LPCTSTR DriverName )
{
	CGDTrace trace( LOG_L6, "CDriver:StartDriver(%s)", DriverName);
	SC_HANDLE hSCManager;
	SC_HANDLE hService;
	BOOL bResult;

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

	if (hSCManager)
	{
		hService = OpenService( hSCManager, DriverName, SERVICE_ALL_ACCESS );
		DWORD nn = GetLastError();

		CloseServiceHandle(hSCManager);

		if (hService)
		{
			bResult = StartService( hService, 0, NULL );

			if ( !bResult )
			{
				DWORD dwErr = GetLastError();
				if ( dwErr == ERROR_SERVICE_ALREADY_RUNNING )
				{
					bResult = true;
				}
			}
			CloseServiceHandle(hService);
		}
		else
		{
			return trace.SetRetResult( false );
		}
	}
	else
	{
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( bResult?true:false );
}

bool CDriver::StopDriver( IN LPCTSTR DriverName )
{
	CGDTrace trace( LOG_L6, "CDriver:StopDriver(%s)", DriverName);
	SC_HANDLE hSCManager;
	SC_HANDLE hService;
	SERVICE_STATUS ServiceStatus;
	bool bResult;

	hSCManager = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS);

	if (hSCManager)
	{
		hService = OpenService( hSCManager, DriverName, SERVICE_ALL_ACCESS );

		CloseServiceHandle(hSCManager);

		if (hService)
		{
			bResult = ControlService( hService, SERVICE_CONTROL_STOP, &ServiceStatus ) == 0 ? false : true;

			DWORD error = GetLastError();

			CloseServiceHandle(hService);
		}
		else
		{
			return trace.SetRetResult( false );
		}
	}
	else
	{
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( bResult );
}



