/***********************************************************************
*
* ļ FileDiffer.cpp
* ģĿģ ļɨ װ
* ߼ڣ wu_bin 2009-08-1
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ wang_jin 2009-9-4
*
***********************************************************************/

#pragma warning( disable : 4251 4275 4786 )


#include "Differ.h"

#include "Common/ParamList.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "FileDiffer/FileDiffer.h"

using namespace std;
int backupFlag = 0;//ʱֹͣԶͬı־˴ֹͣ˲ʱ
int backupTimeout = 0;//ʱֹͣԶͬʱ

namespace InforGuard{
namespace FileScanner{


CFileDiffer::CFileDiffer() :
CMonitorInterface("FileScanner", SCANNER), 
	m_pDiffer(new CDiffer)
{
}


CFileDiffer::~CFileDiffer()
{
	if( m_pDiffer )
	{
		delete m_pDiffer;
		m_pDiffer = NULL;
	}
}


bool CFileDiffer::Initialize( const char * sParams )
{
	CGDTrace trace( LOG_L6, "CFileDiffer::Initialize()" );	
	bool ret=false;
	if( sParams )
	{
		ret = m_pDiffer->Initialize(sParams);
	}
	return ret;
}


bool CFileDiffer::Uninitialize()
{
	CGDTrace trace( LOG_L6, "CFileDiffer::Uninitialize()" );	
	bool ret = false;
	if( m_pDiffer )
	{
		ret = m_pDiffer->Uninitialize();
	}
	return ret;
}


bool CFileDiffer::WatchDirectory( CMonitorInformation& moniInfo )
{
	CGDTrace trace( LOG_L6, "CFileDiffer::WatchDirectory()" );	
	bool ret = false;
	if( m_pDiffer )
	{
		ret=m_pDiffer->WatchDirectory( moniInfo );
	}
	return ret;
}


bool CFileDiffer::UnwatchDirectory( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CFileDiffer::UnwatchDirectory()" );	
	bool ret = false;
	if( m_pDiffer )
	{
		ret=m_pDiffer->UnwatchDirectory( sDirId );
	}
	return ret;
}


bool CFileDiffer::IsWatched( const char * sDirId )
{
	CGDTrace trace( LOG_L6, "CFileDiffer::IsWatched()" );	
	bool ret = false;
	if( m_pDiffer )
	{
		ret = m_pDiffer->IsWatched( sDirId );
	}
	return ret;
}


bool CFileDiffer::IsWatchedByWebsiteId( const char * sWebsiteId )
{
	CGDTrace trace( LOG_L6, "CFileDiffer::IsWatchedByWebsiteId()" );	
	bool ret = false;
	if( m_pDiffer )
	{
		ret = m_pDiffer->IsWatchedByWebsiteId( sWebsiteId );
	}
	return ret;
}

bool CFileDiffer::ReadEvent( EVENT_S& event )
{
	//CGDTrace trace( LOG_L6, "CFileDiffer::ReadEvent()" );	
	bool ret = false;
	if( m_pDiffer )
	{
		ret=m_pDiffer->ReadEvent( event );
	}
	return ret;
}


}	// namespace FileDiffer
}	// namespace InforGuard
