/***********************************************************************
*
* ļ FileTreeSaver.cpp
* ģĿģ Ŀ¼ļб洢
* ߼ڣ wang_jin 2009-05-15
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ 
*
***********************************************************************/

#include "Common/Types.h"
#include "Common/Common.h"
#include "FileTreeSaver.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/RunLog.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"

#ifdef WIN32
#	include <windows.h>
#endif
#include <assert.h>
#include <time.h>

namespace InforGuard{
namespace FileScanner{

CFileTreeSaver::CFileTreeSaver( const char* sFileName )
:m_fp( NULL )
{
	assert( NULL != sFileName && '\0' != sFileName[0] );
	m_sFileName = sFileName;
}

CFileTreeSaver::~CFileTreeSaver()
{
	if ( m_fp)
	{
		fclose( m_fp );
		m_fp = NULL;
	}
}

int CFileTreeSaver::WriteFileItem( const FilePathItem * pFilePathItem )
{
	CGDTrace trace( LOG_L6, "CFileTreeSaver:WriteFileItem(%s)", pFilePathItem->sName.c_str() );

	if ( NULL == m_fp )
	{
		m_fp = fopen( m_sFileName.c_str(), "w" );
		fprintf( m_fp, "%08x%08x\n", time(NULL), 0 );
	}

	if ( m_fp)
	{
		char sBuf[ GD_MAX_PATH ] = {0};
		for ( int i=0; i<pFilePathItem->sName.length(); i++ )
		{
			sBuf[i] = pFilePathItem->sName[i]==' ' ? '>' : pFilePathItem->sName[i];
		}
		fprintf( m_fp, "%d %d %d %d %s\n", pFilePathItem->nDepth, pFilePathItem->nFileSize, pFilePathItem->nFileType, pFilePathItem->tLastTime, sBuf );//pFilePathItem->sName.c_str() );
		fflush(m_fp);
		return 0;
	}
	
	return GetLastError();
}

int CFileTreeSaver::WriteEnd()
{
	CGDTrace trace( LOG_L6, "CFileTreeSaver:WriteEnd()" );
	if ( m_fp )
	{
		long nSize = ftell( m_fp );
		fseek( m_fp, 0, SEEK_SET );
		unsigned int a = time(NULL);
		unsigned int b = ~a;
		fprintf( m_fp, "%08x%08x\n", a, b );
		fseek( m_fp, nSize, SEEK_SET );
		fclose( m_fp );
		m_fp = NULL;
		return true;
	}

	return false;
}

void CFileTreeSaver::Close()
{
	CGDTrace trace( LOG_L6, "CFileTreeSaver:Close()" );
	if ( m_fp)
	{
		fclose( m_fp );
		m_fp = NULL;
	}
}

bool CFileTreeSaver::IsReadable()
{
	CGDTrace trace( LOG_L6, "CFileTreeSaver:IsReadable()" );
	if ( NULL == m_fp )
	{
		m_fp = fopen( m_sFileName.c_str(), "r" );
		if ( m_fp )
		{
			unsigned int a = 0, b = 0;
			fscanf( m_fp, "%08x%08x", &a, &b );
			if ( ( a | b ) == 0xFFFFFFFF )
			{
				return true;
			}
		}
		else
		{
			ErrCode errCode = GetLastError();
			GDPrint( "CFileTreeSaver:IsReadable() fopen(%s) err=%d,%s\n", m_sFileName.c_str(), errCode, strerror(errCode) );
		}
	}
	if ( m_fp )
	{
		fclose( m_fp );
		m_fp = NULL;
	}
	return false;
}

FilePathItem * CFileTreeSaver::ReadNextFileItem()
{
	CGDTrace trace( LOG_L6, "CFileTreeSaver:ReadNextFileItem()" );
	if ( m_fp)
	{
		if ( ! feof( m_fp ) )
		{
			char sName[ GD_MAX_PATH ] = {0};
			fscanf( m_fp, "%d %d %d %d %s", &m_FilePathItem.nDepth, &m_FilePathItem.nFileSize, &m_FilePathItem.nFileType, &m_FilePathItem.tLastTime, sName );
			for ( int i=0; i<strlen(sName); i++ )
			{
				if ( sName[i] == '>' ) sName[i] = ' ';
			}

			if ( feof(m_fp) )
			{
				fclose( m_fp );
				m_fp = NULL;
				return NULL;
			}
			m_FilePathItem.sName = sName;
			return &m_FilePathItem;
		}
		else
		{
			return NULL;
		}
	}

	return NULL;
}


}	// namespace FileDiffer
}	// namespace InforGuard
