/***********************************************************************
*
* ļ FileTreeWalker.cpp
* ģĿģ Ŀ¼ļûص
* ߼ڣ wang_jin 2009-05-14
* 汾 1.0
* ȨϢ CVICSE Middleware
* ļ¼ 
*
***********************************************************************/

#include "FileTreeWalker.h"
#include "FileTreeComper.h"
#include "EventQueue.h"
#include "FileExclude/FileExclude.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/RunLog.h"
#include "GDLog/LogFile.h"
#include "GDLog/ThreadData.h"
#include "Common/DateTime.h"
#ifdef WIN32
#	include <windows.h>
#else
#	include <dirent.h>
#	include <errno.h>
#endif
#include <stdio.h> 
#include <time.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <algorithm>
#include <assert.h>

char s_sSavePath[256]={0};
extern int backupFlag;
extern int backupTimeout;

namespace InforGuard{
namespace FileScanner{


CFileTreeWalker::CFileTreeWalker( const char* sTopPath, const char *sSavePath )
{
	assert( NULL != sTopPath && '\0' != sTopPath[0] && NULL != sSavePath && '\0' != sSavePath[0] );
	m_sTopPath = sTopPath;
	strcpy( s_sSavePath, sSavePath );
}

CFileTreeWalker::~CFileTreeWalker()
{}

int CFileTreeWalker::FileTreeWalk( FileTreeWalkFunc * pFunc, void * pvoid )
{
	CGDTrace trace( LOG_L6, "CFileTreeWalker:FileTreeWalk()");
	int dirNum=0,fileNum=0;//	ͳļĿ¼

	deque< FilePathItem* > filePathDeque;
	map<string, FilePathItem*, FilePathItem_less> dirmap;
	map<string, FilePathItem*, FilePathItem_less> filemap;
	
	CFileExclude * pFileExclude = ((CFileTreeComper*)pvoid)->m_pFileExclude;
	assert(pFileExclude);
	FilePathItem * pFilePathRoot = new FilePathItem;
	pFilePathRoot->nDepth = 0;
	pFilePathRoot->nFileSize = 0;
	pFilePathRoot->nFileType = FILE_ATTRIBUTE_DIRECTORY;
	pFilePathRoot->sName = "";
	pFilePathRoot->tLastTime = 0;
	filePathDeque.push_back( pFilePathRoot );

	while ( !filePathDeque.empty() )
	{
		pFilePathRoot = filePathDeque.front();
		filePathDeque.pop_front();
		assert( pFilePathRoot );

		// Ŀ¼
		if ( pFilePathRoot->nDepth )
		{
			(*pFunc)(pFilePathRoot, pvoid); // ص
		}

		FilePathItem *pFilePathItem = NULL;
		char sCurrPath[ GD_MAX_PATH ] = {0};
#ifdef WIN32
		sprintf( sCurrPath, "%s%s\\*", m_sTopPath.c_str(), pFilePathRoot->sName.c_str() );
		// Ŀ¼
		WIN32_FIND_DATA fd = {0};
		HANDLE hFind = FindFirstFile( sCurrPath, &fd );
		if ( INVALID_HANDLE_VALUE == hFind )
		{
			DWORD dwErr = GetLastError();
			delete pFilePathRoot;
			pFilePathRoot = NULL;
			return dwErr;
		}
		do
		{
			//add at 2009.10.10
			int i=0;
			while(1)
			{
				if ( backupFlag == 1 )
				{
					CDateTime::Sleep(1*60*1000);//ÿ1Ӽһ	
					if( i > backupTimeout )//ʱļõ
					{
						backupFlag = 0;
						break;
					}
					i++;
					continue;
				}
				break;
			}
			//add by zhangtao 2009.10.10
			// жǷĿ¼
			if ( ( fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY ) == FILE_ATTRIBUTE_DIRECTORY )
			{
				// ...Ŀ¼ 
				if ( strcmp(fd.cFileName,".") == 0 || strcmp(fd.cFileName,"..") == 0 ) continue;

				trace.GDTrace(LOG_DBG, "%s", fd.cFileName);
				// Ŀ¼
				pFilePathItem = new FilePathItem;
				pFilePathItem->nDepth = pFilePathRoot->nDepth + 1;
			//	pFilePathItem->sName = m_sTopPath.c_str();
			//	pFilePathItem->sName.append( "\\" );
				pFilePathItem->sName.append( pFilePathRoot->sName );
				pFilePathItem->sName.append( "\\" );
				pFilePathItem->sName.append( fd.cFileName );
				pFilePathItem->nFileSize = fd.nFileSizeLow;
				ULONGLONG ll = *((ULONGLONG*)&fd.ftLastWriteTime);
				pFilePathItem->tLastTime = (time_t)( ( ll - 0x19DB1DED53E8000 ) / 10000000 );
				pFilePathItem->nFileType = FILE_ATTRIBUTE_DIRECTORY;
				if( pFileExclude->IsExcludeFile( ( m_sTopPath + pFilePathItem->sName ).c_str(), FILE_ATTRIBUTE_DIRECTORY ) )
				{
					trace.GDTrace(LOG_DBG, "IsExcludeDir[%s]", pFilePathItem->sName.c_str());
					continue;
				}
				dirNum++;
				dirmap.insert( make_pair( pFilePathItem->sName, pFilePathItem ) );
			}
			else
			{

				// ļ
				pFilePathItem = new FilePathItem;
				pFilePathItem->nDepth = pFilePathRoot->nDepth + 1;
				pFilePathItem->sName = pFilePathRoot->sName;
				pFilePathItem->sName.append( "\\" );
				pFilePathItem->sName.append( fd.cFileName );
				pFilePathItem->nFileSize = fd.nFileSizeLow;
				ULONGLONG ll = *((ULONGLONG*)&fd.ftLastWriteTime);
				pFilePathItem->tLastTime = (time_t)( ( ll - 0x19DB1DED53E8000 ) / 10000000 );
				pFilePathItem->nFileType = FILE_ATTRIBUTE_ARCHIVE;
				if( pFileExclude->IsExcludeFile( ( m_sTopPath + pFilePathItem->sName ).c_str(), FILE_ATTRIBUTE_ARCHIVE ) )
				{
					trace.GDTrace(LOG_DBG, "IsExcludeFile[%s]", pFilePathItem->sName.c_str());
					continue;
				}
				fileNum++;
				filemap.insert( make_pair( pFilePathItem->sName, pFilePathItem ) );
			}
		} while( FindNextFile( hFind, &fd ) );
		FindClose( hFind );
#else
		sprintf( sCurrPath, "%s%s", m_sTopPath.c_str(), pFilePathRoot->sName.c_str() );
		struct dirent * dir;
		DIR * dp = opendir( sCurrPath );
		
		if( NULL != dp)
		{

			char sSubPath[ GD_MAX_PATH ] = {0};
			while ( (dir = readdir(dp)) )
			{
				//add at 2009.10.10
				int i=0;
				while(1)
				{
					if ( backupFlag == 1 )
					{
						CDateTime::Sleep(1*60*1000);//ÿ1Ӽһ	
						if( i > backupTimeout )//ʱļõ
						{
							backupFlag = 0;
							break;
						}
						i++;
						continue;
					}
					break;
				}
				//add by zhangtao 2009.10.10
				if ( strcmp(dir->d_name,".") == 0 || strcmp(dir->d_name,"..") == 0 ) continue;
				
				sprintf( sSubPath, "%s/%s", sCurrPath, dir->d_name );
				struct stat buf = {0};
				stat( sSubPath, &buf );
				if ( S_ISDIR( buf.st_mode ) )
				{
					// Ŀ¼
					pFilePathItem = new FilePathItem;
					pFilePathItem->nDepth = pFilePathRoot->nDepth + 1;
					pFilePathItem->sName = pFilePathRoot->sName;
					pFilePathItem->sName.append( "/" );
					pFilePathItem->sName.append( dir->d_name );
					pFilePathItem->nFileSize = buf.st_size;
					pFilePathItem->tLastTime = buf.st_mtime;
					pFilePathItem->nFileType = FILE_ATTRIBUTE_DIRECTORY;
					if( pFileExclude->IsExcludeFile( ( m_sTopPath + pFilePathItem->sName ).c_str(), FILE_ATTRIBUTE_DIRECTORY ) )
					{
						trace.GDTrace( LOG_DBG, "IsExcludeDir[%s]", pFilePathItem->sName.c_str() );
						continue;
					}
					dirNum++;
					dirmap.insert( make_pair( pFilePathItem->sName, pFilePathItem ) );
				}
				else// if ( S_ISFILE( buf.st_mode) )
				{
					// ļ
					pFilePathItem = new FilePathItem;
					pFilePathItem->nDepth = pFilePathRoot->nDepth + 1;
//					pFilePathItem->sName = sSubPath;
					pFilePathItem->sName = pFilePathRoot->sName;
					pFilePathItem->sName.append( "/" );
					pFilePathItem->sName.append( dir->d_name );
					pFilePathItem->nFileSize = buf.st_size;
					pFilePathItem->tLastTime = buf.st_mtime;
					pFilePathItem->nFileType = FILE_ATTRIBUTE_ARCHIVE;
					if( pFileExclude->IsExcludeFile( ( m_sTopPath + pFilePathItem->sName ).c_str(), FILE_ATTRIBUTE_ARCHIVE ) )
					{
						trace.GDTrace(LOG_DBG, "IsExcludeFile[%s]", pFilePathItem->sName.c_str() );
						continue;
					}
					fileNum++;
					filemap.insert( make_pair( pFilePathItem->sName, pFilePathItem ) );
				}
			}
			closedir( dp );
		}
		else
		{
			int nErr = errno;
			delete pFilePathRoot;
			pFilePathRoot = NULL;
		 	//return nErr;
		}

#endif

		// mapdeque
		map<string, FilePathItem*,FilePathItem_less>::iterator itor;
		for ( itor=dirmap.begin(); itor!=dirmap.end(); ++itor )
		{
			filePathDeque.push_back( itor->second );
		}
		dirmap.clear();

		// mapļ
		//map<string, FilePathItem*,FilePathItem_less>::iterator itor;
		for ( itor=filemap.begin(); itor!=filemap.end(); itor++ )
		{
			(*pFunc)(itor->second, pvoid); // ص
			delete (FilePathItem*)(itor->second);
		}
		filemap.clear();

		// ͷŽ
		delete pFilePathRoot;
		pFilePathRoot = NULL;
	}
	CGDLog::WriteThreadState( "DIR=[%d],FILE=[%d]", dirNum, fileNum );
	return 0;
}


}	// namespace FileDiffer
}	// namespace InforGuard
