//
//////////////////////////////////////////////////////////////////////

#if !defined(IISSQLCOMMON_H)
#define IISSQLCOMMON_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CURL  
{
public:
	CString GetDomain();
	static CString FQDN(CString URL);
	static CString FQDNNoEndDot(CString URL);
	bool IsHTTPCompliantUrl();
	CString GetFragment();
	CString GetQuerystring();
	CString GetUrl();
	bool SetUrl(CString& URL);
	static bool IsValidScheme(CString& scheme);
	bool IsRFCCompliant();

	static CString URLEncodedToASCII(const char* str, bool convert_plus=true);
	static inline int HexToInt(const char char1, const char char2);
	static inline int HexToInt(const char* hex);
	
	CURL(CString strUrl = "");
	virtual ~CURL();

	CString RawUrl;
	CString Url;
	CString Querystring;
	CString Fragment;
	CString Domain;
	CString Scheme;

protected:
	inline void DeleteContents();
	bool IsRFC1808Compliant();
	bool IsRFC1738Compliant();
};

class CStringHelper
{
public:
	CStringHelper() {};
	~CStringHelper() {};

public:
	static CString ConvertBinaryData(BYTE* Data, DWORD Length, TCHAR ReplaceNullsWith);

};

#endif // !defined(IISSQLCOMMON_H)
