// Config_impl.cpp: implementation of the CConfig_impl class.

#include <STAR/CORBA.h>

#include "Base/App.h"
#include "Base/NetTran.h"
#include "Common/ExceptionError.h"
#include "GDLog/GDTrace.h"
#include "Exception.h"
#include "NetConfig/NetConfig_impl.h"


NetConfig_impl::NetConfig_impl()
{
}

NetConfig_impl::~NetConfig_impl()
{
}

//:			ṩͻ˼ݷ
//seqIpPort:	תIPPort
//cfgFile:		
//ֵ:		0Ϊɹ,Ϊʧ
CORBA::Long NetConfig_impl::Load(const InforGuard::HostChain& seqIpPort,
								 CORBA::String_out cfgFile)
								 throw(InforGuard::ExceptionError,CORBA::SystemException)
{
	CGDTrace trace( LOG_L6, "NetConfig_impl:Load()" );
	long nRet = 0;
	
	try
	{
		std::string configFileContent;
			
		nRet = CAppConfig::Instance().GetConfigFileContent(configFileContent);
			
		cfgFile = CORBA::string_dup(configFileContent.c_str());

		return nRet;
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CAppConfig:GetConfigFileContent()" );
		InforGuard::ExceptionError e;
		CNetTran::ConvertException( ex, e );
		e._raise();
		return -1;
	}
}
	

//:			ṩͻ˼ݷ
//seqIpPort:	תIPPort
//cfgFile:		
//ֵ:		0Ϊɹ,Ϊʧ
CORBA::Long NetConfig_impl::Save(const InforGuard::HostChain& seqIpPort,
								 const char* cfgFile)
								 throw(InforGuard::ExceptionError,CORBA::SystemException)
{
	CGDTrace trace( LOG_L6, "NetConfig_impl:Save(%s)", cfgFile );

	long nRet = 0;

	try
	{
		nRet = CAppConfig::Instance().Save(cfgFile);
	}
	catch ( CExceptionError & ex )
	{
		ex.AddErrText( "CAppConfig:Save()" );
		InforGuard::ExceptionError e;
		CNetTran::ConvertException( ex, e );
		e._raise();
	}

	return trace.SetRetValue( nRet );
}
