//---------------------------------------------------------------------------
#include <stdio.h>
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "MonOper.h"
#include "ListThr.h"
#include "Fpub.h"

#pragma package(smart_init)

//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall ListRefresh::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall ListThr::ListThr(bool CreateSuspended, TFrmMonOper *pFrm) : TThread(CreateSuspended)
{
        m_pFrm = pFrm;
}

//---------------------------------------------------------------------------
void ListThr::SetName()
{
        THREADNAME_INFO info;

        info.dwType = 0x1000;
        info.szName = "ListThr";
        info.dwThreadID = -1;
        info.dwFlags = 0;

        __try
        {
                 RaiseException( 0x406D1388, 0, sizeof(info)/sizeof(DWORD),(DWORD*)&info );
        }
        __except (EXCEPTION_CONTINUE_EXECUTION)
        {
        }
}

//---------------------------------------------------------------------------
void __fastcall ListThr::Execute()
{
        SetName();
        //---- Place thread code here ----

        // ʼ׽
        if( m_skt.Init(PKT_MAXSIZE, PKT_HEADFMT) != 1 )
        {
                ErrDlg("ʼʧ");
                Application->Terminate();
        }

        // 䱨ͷ
        m_skt.SetHeadN(TC_MON, 2);

        m_iHLen = m_skt.GetHeadLen();
        m_pInfo = m_skt.GetReply();

        // ѭˢ
        int  b;
        char szBuf[8] = {0};

        while( ! Terminated )
        {
                *m_pInfo = 0;
                *(m_pInfo + m_iHLen) = 0;

                try
                {
                // ׼
                Synchronize(PrepareReq);

                if( m_iRows > 0 )
                {
                        // 󣬲ȡӦ
                        b = SktComm(m_skt, m_pFrm->m_win_id, m_szBody, m_pFrm->StatusBar1, 1, 1);

                        if( b == R_OK )
                        {
                                // ʾ
                                Synchronize(ShowItem);
                        }
                        else if( b == R_DENY )
                        {
                                m_skt.GetHeadN(szBuf, 3);       // 

                                if( szBuf[0] == E_NOTRUN )
                                {
                                        // л״̬ƣɫ
                                        Synchronize(ShowRed);
                                }
                        }
                }
                } catch( Exception &E )
                {
                }

                for( int i = 0; i < 10 && ! Terminated; i++ )
                        Sleep(1000);
        }
}

//---------------------------------------------------------------------------
// ׼
void __fastcall ListThr::PrepareReq()
{
        // ɼ
        m_pFrm->m_show_rows = m_pFrm->ListView1->VisibleRowCount;
        if( (m_iRows = m_pFrm->m_show_rows) <= 0 ) return;

        // ʼ
        if( m_pFrm->m_start_no < 1 || m_pFrm->m_start_no > m_pFrm->m_total_rows )
        {
                m_pFrm->m_start_no = 1;
        }

        // ¼ϴʼšɼ
        m_pFrm->m_last_start_no  = m_pFrm->m_start_no;
        m_pFrm->m_last_show_rows = m_pFrm->m_show_rows;

        // ¼ǰѡеĿ
        m_pFrm->m_last_select = m_pFrm->ListView1->Items->IndexOf(m_pFrm->ListView1->Selected);

//---------------------------------------------------------------------------
        // ʽTLV(Tag(1)Length(4))
        char  szVal[64];
        char *pBody = m_szBody;

        // ʼ
        sprintf(szVal, "%d", m_pFrm->m_start_no);
        f_packTLV(&pBody, szVal, TAG_MONSTARTSEQ);

        // ɼ
        sprintf(szVal, "%d", m_pFrm->m_show_rows);
        f_packTLV(&pBody, szVal, TAG_MONSHOWROWS);

        // ɼ
        f_packTLV(&pBody, m_pFrm->m_filter_szDesc, TAG_DESCRIPTION);

        // ɼš
        f_packTLV(&pBody, m_pFrm->m_filter_szNo, TAG_NO);

        // Ƿ澯
        sprintf(szVal, "%d", m_pFrm->m_filter_warn);
        f_packTLV(&pBody, szVal, TAG_MONWARNNOT);

        // ״̬Ƿ
        sprintf(szVal, "%d", m_pFrm->m_filter_status);
        f_packTLV(&pBody, szVal, TAG_MONSTATOK);
        *pBody = 0;

        return;
}

//---------------------------------------------------------------------------
// ʾ
void __fastcall ListThr::ShowItem()
{
        // ʾ
        ListShow(m_pFrm, &m_skt);

        TShape *pShape;
        TLabel *pLbl;

        if( m_pFrm->m_win_id == 1 )
        {
                pShape = FrmMain->Shape1;
                pLbl   = FrmMain->LblNum1;
        }
        else
        {
                pShape = FrmMain->Shape2;
                pLbl   = FrmMain->LblNum2;
        }

        // ״ָ̬ʾƣɫ
        pShape->Brush->Color = clGreen;
        pShape->Tag = 1;

        // ʾܼĿ
        pLbl->Caption = String(m_pFrm->m_filter_rows) + "/" + m_pFrm->m_total_rows;

        // ѡϴѡеĿ
        try
        {
                m_pFrm->ListView1->Selected = m_pFrm->ListView1->Items->Item[m_pFrm->m_last_select];
        }
        catch (...)
        {
        }

        // Ҫť󣬲ԶѡϴѡеĿ
        m_pFrm->ListView1->SetFocus();
}

// ƽֹ̨ɫָʾ
void __fastcall ListThr::ShowRed()
{
        // 
        m_pFrm->ListView1->Items->Clear();

        TShape *pShape;
        TLabel *pLbl;

        if( m_pFrm->m_win_id == 1 )
        {
                pShape = FrmMain->Shape1;
                pLbl   = FrmMain->LblNum1;
        }
        else
        {
                pShape = FrmMain->Shape2;
                pLbl   = FrmMain->LblNum2;
        }

        // ״ָ̬ʾƣɫ
        pShape->Brush->Color = clRed;
        pShape->Tag = 2;

        // ʾܼĿ0
        m_pFrm->m_filter_rows = 0;
        m_pFrm->m_total_rows = 0;

        pLbl->Caption = "0/0";
}
