

#ifndef __SPICE_USB_ACL_HELPER_H__
#define __SPICE_USB_ACL_HELPER_H__

#include "spice-client.h"
#include <gio/gio.h>



G_BEGIN_DECLS

#define SPICE_TYPE_USB_ACL_HELPER            (spice_usb_acl_helper_get_type ())
#define SPICE_USB_ACL_HELPER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), SPICE_TYPE_USB_ACL_HELPER, SpiceUsbAclHelper))
#define SPICE_USB_ACL_HELPER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), SPICE_TYPE_USB_ACL_HELPER, SpiceUsbAclHelperClass))
#define SPICE_IS_USB_ACL_HELPER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SPICE_TYPE_USB_ACL_HELPER))
#define SPICE_IS_USB_ACL_HELPER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SPICE_TYPE_USB_ACL_HELPER))
#define SPICE_USB_ACL_HELPER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), SPICE_TYPE_USB_ACL_HELPER, SpiceUsbAclHelperClass))

typedef struct _SpiceUsbAclHelper SpiceUsbAclHelper;
typedef struct _SpiceUsbAclHelperClass SpiceUsbAclHelperClass;
typedef struct _SpiceUsbAclHelperPrivate SpiceUsbAclHelperPrivate;

struct _SpiceUsbAclHelper
{
    GObject parent;

    
    SpiceUsbAclHelperPrivate *priv;
    
};

struct _SpiceUsbAclHelperClass
{
    GObjectClass parent_class;
};

GType spice_usb_acl_helper_get_type(void);

SpiceUsbAclHelper *spice_usb_acl_helper_new(void);

void spice_usb_acl_helper_open_acl_async(SpiceUsbAclHelper *self,
                                         gint busnum, gint devnum,
                                         GCancellable *cancellable,
                                         GAsyncReadyCallback callback,
                                         gpointer user_data);
gboolean spice_usb_acl_helper_open_acl_finish(
    SpiceUsbAclHelper *self, GAsyncResult *res, GError **err);

void spice_usb_acl_helper_cancel(SpiceUsbAclHelper *self);

G_END_DECLS

#endif 

