/***********************************************************************
*
* ļ        Validator.cpp
* ģĿģִļ֤
* ߼ڣ  wang_jin 2008-05-11
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#pragma warning(disable:4786)

#include "Validator.h"

#include "Base/MonitorInterface.h"
#include "Common/DateTime.h"
#include "Common/ParamList.h"
#include "FileOpt/FileOpt.h"
#include "FileExclude/FileExclude.h"
#include "GDLog/GDLog.h"
#include "GDLog/GDTrace.h"
#include "GDLog/RunLog.h"
#include "GDLog/ThreadData.h"
#include "GDLog/TmpLog.h"
#include "UrlParse/UrlParse.h"
#include "Base/AppOption.h"

#include <stdarg.h> // for va_start
#include <stdio.h> // for sprintf

#ifndef NOT_USE_STD_LIB
#	include <sstream>
using namespace std;
#endif

#ifndef NO_ERROR
#	define NO_ERROR 0
#endif


const long DB_TREE_SIZE = 10240; // 10M


CValidator::CValidator():
m_nVersion(0),
m_bInitialized(false)
{
	m_mutex.Initialize( KEY_SEM_INITIALIZE_VERIFIER );
	m_fileTranOutTime = 0;
	m_nDBTreeSize = DB_TREE_SIZE;
	m_bUseDb = true;
}

CValidator::~CValidator()
{
}

bool CValidator::Initialize()
{
	CGDTrace trace( LOG_L6, "CValidator:Initialize()" );
	trace.SetRetResult( false );
	
	//sl 08-12-10
	CThreadLock thrLock(m_thrMutex);
	
	if ( ! m_bInitialized )
	{
		// ʼʼΨһϲ߿ƣĿΪ˼ٳʼĵô
		CGDLog::WriteSysLog( "2045:CValidator::Initialize() Begin" );
		
		// ȡϢ
		const char* pPath = GetInforGuardPath();
		if ( ! pPath || ! (*pPath) )
		{
			// ݴ
			CGDLog::WriteErrLog( "GetInforGuardPath() fail" );
			GDPrint( ">>>>----GetInforGuardPath() fail----<<<<\n" );
			return trace.SetRetResult( false );
		}
		
		// ʼ
		char sCfgFileMain[ GD_MAX_PATH ] = {0}; 
		// жwindowsƽ̨ļ·sCfgFile
		sprintf( sCfgFileMain, "%s%ccfg%cma.xml", pPath, C_PATHLASH, C_PATHLASH );
		try
		{
			if ( ! CFileOpt::IsExist( sCfgFileMain ) )
			{
				// ݴ
				CGDLog::WriteErrLog( "1113:ļ[%s]", sCfgFileMain );
				GDPrint( ">>>>----ļ[%s]----<<<<\n", sCfgFileMain );
				return trace.SetRetResult( false );
			}
		}
		catch ( CExceptionError & ex )
		{
			CGDLog::WriteErrLog( "1114:CValidator:Initialize() catch IsExist throw:%s", ex.GetErrText().c_str() );
			return trace.SetRetResult( false );
		}
		catch ( ... )
		{
			CGDLog::WriteErrLog( "1115:CValidator:Initialize() catch IsExist catch ..." );
			return trace.SetRetResult( false );
		}
		m_configFile = sCfgFileMain;
		
		// ʼҳ
		char sCfgFileOption[ GD_MAX_PATH ] = {0}; 
		//жwindowsƽ̨ļ·sCfgFileMain
		sprintf( sCfgFileOption, "%s%ccfg%cmaoption.xml", pPath, C_PATHLASH, C_PATHLASH );
		try
		{
			if ( ! CFileOpt::IsExist( sCfgFileOption ) )
			{
				// ݴ
				CGDLog::WriteErrLog( "1116:ļ[%s]", sCfgFileOption );
				GDPrint( ">>>>----ļ[%s]----<<<<\n", sCfgFileOption );
				return trace.SetRetResult( false );
			}
		}
		catch ( CExceptionError & ex )
		{
			CGDLog::WriteErrLog( "1117:CValidator:Initialize() catch IsExist throw:%s", ex.GetErrText().c_str() );
			return trace.SetRetResult( false );
		}
		catch ( ... )
		{
			CGDLog::WriteErrLog( "1118:CValidator:Initialize() catch IsExist catch ..." );
			return trace.SetRetResult( false );
		}
		LoadErrCode( sCfgFileOption );
		
		// ʼͨѶ
		long nRet = 0;
		{
			//sl 08-12-10
			CProcessLock lock( m_mutex );
			nRet = m_sharedBuffer.CreateBuffer( KEY_MEM_MONITOR_VERIFIER , 32 );  // 32K
			if ( NO_ERROR != nRet )
			{
				CGDLog::WriteErrLog( "1119:CreateBuffer(%x,32) ret=[%d]", KEY_MEM_MONITOR_VERIFIER, nRet );
				GDPrint( ">>>>----CreateBuffer() [%d]----<<<<\n", nRet ); 
				return trace.SetRetResult( false );
			}
			
			if (m_sharedBuffer.IsOwner())
			{
				if ( ! LoadFromDiskToExclude( sCfgFileMain, m_paths ) )
				{
					// ݴ
					CGDLog::WriteErrLog( "1120:ļ[%s]ʧ", sCfgFileMain );
					GDPrint( ">>>>----ļ[%s]ʧ----<<<<\n", sCfgFileMain );
					return trace.SetRetResult( false );
				}
				
				// ݽڴ
				SetSharedBuffer(m_paths);
			}
			else
			{
				// ӹڴȡ
				GetSharedBuffer(m_paths);
			}
		}
		
		// ʼˮӡ
		char sWmDbPath[ GD_MAX_PATH ] = {0};
		sprintf( sWmDbPath, "%s%cdbhome%cma", pPath, C_PATHLASH, C_PATHLASH );
		
		// by liu_yfeng 2009-03-11 ˮӡñ־
		nRet = m_db.Init( sWmDbPath, "wm.db", KEY_MEM_DB_TREE_MA, false, m_nDBTreeSize, m_bUseDb ); // falseʾд洢߳
		if ( nRet )
		{
			// ش
			CGDLog::WriteErrLog( "1121:ʼˮӡʧ[%d] [%s]", nRet, sWmDbPath);
			GDPrint( ">>>>----ʼˮӡʧ[%d] [%s]----<<<<\n", nRet, sWmDbPath);
			return trace.SetRetResult( false );
		}
		
		// add by liu_yfeng 2009-01-05
		nRet = m_msgQue.Init( KEY_MEM_MQUE_VERIFIER, 512 );
		if ( nRet )
		{
			CGDLog::WriteErrLog( "1122:ʼϢʧ[%d] [%d]", nRet, KEY_MEM_MQUE_CHECKER);
			GDPrint( ">>>>----ʼϢʧ[%d] [%d]----<<<<\n", nRet, KEY_MEM_MQUE_CHECKER);
			return trace.SetRetResult( false );
		}

		m_bInitialized = true;
		GDPrint( ">>>>----CValidator::Initialize() OK----<<<<\n" );
		CGDLog::WriteSysLog( "2048:CValidator:Initialize() OK" );
	}

	return trace.SetRetResult( true );
}

bool CValidator::Uninitialize()
{
	CGDTrace trace( LOG_L6, "CValidator:Uninitialize()" );
	return true;
}

bool CValidator::LoadErrCode( const char* sCfgFile )
{
	CGDTrace trace( LOG_L6, "CValidator:LoadErrCode(%s,)", sCfgFile );
	trace.SetRetResult( false );
	
	try
	{
		TiXmlDocument doc;
		if ( ! doc.LoadFile( sCfgFile ) )
		{
			// ݴ
			CGDLog::WriteErrLog( "1123:CValidator:LoadErrCode() ļ[%s]ʧ", sCfgFile );
			return trace.SetRetResult( false );	// by liu_yfeng 2008-12-22
		}
		
		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = hDoc.FirstChildElement("option").Element();
		if ( ! pRootElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1124:CValidator:LoadErrCode() ļȱʧ[%s]", "option" );
			trace.SetRetResult( false );
		}
		
		// ļмط۸Ļָʱ
		TiXmlElement* pFileTran = pRootElem->FirstChildElement("filetran");
		if ( ! pFileTran )
		{
			// ݴ
			CGDLog::WriteErrLog( "1125:CValidator:LoadErrCode() ļȱʧ[%s]", "filetran" );
			trace.SetRetResult( false );
		}
		const char* pOutTime = pFileTran->Attribute( "outtime" );
		if ( pOutTime &&  *pOutTime )
		{
			m_fileTranOutTime = atol( pOutTime );
		}
		else
		{
			m_fileTranOutTime = 5;
		}

		// ļмط۸֤ 2009-09-21
		TiXmlElement* pVerifierElem = pRootElem->FirstChildElement("verifier");
		if ( ! pVerifierElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1127:CValidator:LoadErrCode() ļȱʧ[%s]", "verifier" );
			trace.SetRetResult( false );
		}
		
		// by liu_yfeng 2009-03-11 ȡˮӡ
		const char* pSecLevel = pVerifierElem->Attribute( "seclevel" );
		if ( pSecLevel && *pSecLevel )
		{
			m_nSecLevel = atoi( pSecLevel );
		}
		const char* pTranLevel = pVerifierElem->Attribute( "tranlevel" );
		if ( pTranLevel && *pTranLevel )
		{
			m_nTranLevel = atoi( pTranLevel );
		}

		// ļмݿʹùڴĴС 2008-11-26
		TiXmlElement* pDatabaseElem = pRootElem->FirstChildElement("db");
		if ( ! pDatabaseElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1127:CValidator:LoadErrCode() ļȱʧ[%s]", "db" );
			trace.SetRetResult( false );
		}
		
		// by liu_yfeng 2009-03-11 ȡˮӡ
		const char* pDBTreeUse = pDatabaseElem->Attribute( "available" );
		if ( pDBTreeUse && *pDBTreeUse )
		{
#ifdef WIN32
			m_bUseDb = ( ( atoi( pDBTreeUse ) == 0 ) ? false:true );
			if ( !m_bUseDb )
			{
				CGDLog::WriteSysLog( "2047:CValidator::Initialize() m_bUseDb is false" );
				return trace.SetRetResult( false );
			}
#endif
		}
		const char* pDBTreeSize = pDatabaseElem->Attribute( "dbtreesize" );
		if ( pDBTreeSize && *pDBTreeSize )
		{
			m_nDBTreeSize = atoi( pDBTreeSize );
		}
		
		TiXmlElement* pMonitorElem = pRootElem->FirstChildElement("monitor");
		if ( ! pMonitorElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1128:CValidator:LoadErrCode() ļȱʧ[%s]", "monitor" );
			trace.SetRetResult( false );
		}
		TiXmlElement* pFileFilter = pMonitorElem->FirstChildElement("filefilter");
		if ( ! pFileFilter )
		{
			// ݴ
			CGDLog::WriteErrLog( "1129:CValidator:LoadErrCode() ļȱʧ[%s]", "filefilter" );
			trace.SetRetResult( false );
		}
		const char* pCodeMain = pFileFilter->Attribute( "errcode" );
		if ( pCodeMain && *pCodeMain )
		{
			m_sErrCode = pCodeMain;
			m_nErrCode = atoi(pCodeMain);
		}
		else
		{
			m_sErrCode = "403";
			m_nErrCode = 403;
		}
		pCodeMain = pFileFilter->Attribute( "errpage" );
		if ( pCodeMain && *pCodeMain )
		{
			m_sErrPage = pCodeMain; // ָĿ¼ʱӸĿ¼ʼ
		}
		else
		{
			m_sErrPage = "forbidden.html";
		}
		pCodeMain = pFileFilter->Attribute( "errmessage" );
		if ( pCodeMain && *pCodeMain )
		{
			m_sErrMessge = pCodeMain; // ָĿ¼ʱӸĿ¼ʼ
		}
		else
		{
			m_sErrMessge = "<html><head><title>404 Not Found</title></head><body><h1>Not Found</h1><p>The requested URL * was not found on this server.</p><hr><address>Web Server at localhost (IGWS Restoring...)</address></body></html>";
		}
	}
	catch ( ... )
	{
		// ݴ
		CGDLog::WriteErrLog( "1130:CValidator:LoadErrCode() catch Exception" );
		trace.SetRetResult( false );
	}

	return trace.SetRetResult( true );
}

bool CValidator::CheckPolicy()
{
	CGDTrace trace( LOG_L6, "CValidator::CheckPolicy()" );
	
	CProcessLock lock( m_mutex );
	
	bool bRet = CheckShmChange();
	
	if ( bRet ) // ڴˣӹڴز
	{
		bRet = GetSharedBuffer(m_paths);
	}
	
	return trace.SetRetResult( bRet );
}

bool CValidator::CheckShmChange()
{
	CGDTrace trace( LOG_L6, "CValidator::CheckShmChange()" );
	
	long nVersion = 0;
	char sVersion[11] = {0};
	long nLen = sizeof(sVersion);
	
	bool bRet = false;
	if ( m_sharedBuffer.GetData( (void*)sVersion, nLen ) < 0 )
	{
		return trace.SetRetResult( false );
	}
	
	sscanf(sVersion, "%d", &nVersion);
	
	if (nVersion > m_nVersion)
	{
		m_nVersion = nVersion;
		return trace.SetRetResult( true );
	}
	
	return trace.SetRetResult( false );
}

bool CValidator::LoadFromDiskToExclude( const char* sCfgFile, list<CFileExclude>& paths )
{
	CGDTrace trace( LOG_L6, "CValidator:LoadFromDiskToExclude(%s,)", sCfgFile );
	trace.SetRetResult( false );
	
	try
	{
		TiXmlDocument doc;
		if ( ! doc.LoadFile( sCfgFile ) )
		{
			// ݴ
			CGDLog::WriteErrLog( "1131:CValidator::LoadFromDiskToExclude() ļ[%s]ʧ", sCfgFile );
			return trace.SetRetResult( false );
		}
		
		TiXmlHandle hDoc(&doc);
		TiXmlElement* pRootElem = hDoc.FirstChildElement("app").Element();
		if ( ! pRootElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1132:CValidator::LoadFromDiskToExclude() ļȱʧ[%s]", "app" );
			trace.SetRetResult( false );
		}
		
		TiXmlElement* pWebSitesElem = pRootElem->FirstChildElement("websites");
		if ( ! pWebSitesElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1133:CValidator::LoadFromDiskToExclude() ļȱʧ[%s]", "websites" );
			return trace.SetRetResult( false );	// by liu_yfeng 2008-12-23 ûwebsitesĻĴcore
		}
		
		TiXmlPrinter printer;
		pWebSitesElem->Accept( &printer );
		m_websitesXml = printer.CStr();
		
		return ParseXmlPolicies(m_websitesXml, paths);
	}
	catch ( ... )
	{
		//cerr << exc.DisplayText() << endl;
		//throw exc;
		trace.SetRetResult( false );
	}
	
	return trace.SetRetResult( true );
}

void CValidator::ParseSplitInfo(const string& pathInfo, vector<string>& pathMuster)
{
	CGDTrace trace( LOG_L6, "CValidator:ParseSplitInfo(%s)", pathInfo.c_str() );
	CStringTokenizer tokenizer(pathInfo, "|");
	for (CStringTokenizer::Iterator it = tokenizer.begin(); it != tokenizer.end(); ++it)
	{
		pathMuster.push_back((*it));
	}
}

long CValidator::GetNumAttr(const TiXmlElement* pElement, const char* attrName, long defaultValue)
{
	CGDTrace trace( LOG_L6, "CValidator:GetNumAttr(%s,%d)", attrName, defaultValue );
	char* attrValue =  (char*)pElement->Attribute(attrName);
	
	if (attrValue == NULL)
	{
		//˴Ӧ¼ļ쳣־
#ifdef DEBUG
		//cout << ":ļȱ" << pElement->Value() << "" << attrName << endl;
#endif
		CGDLog::WriteSysLog( "2049:: ļȱ[%s][%s]", pElement->Value(), attrName );
	}
	
	// return (attrValue == NULL) ? defaultValue : NumberParser::parse(string(attrValue));
	return (attrValue == NULL) ? defaultValue : atol(string(attrValue).c_str());
}

bool CValidator::ParseXmlPolicies(const string& websites, list<CFileExclude>& paths)
{
	CGDTrace trace( LOG_L6, "CValidator:ParseXmlPolicies()" );
	trace.SetRetResult( false );
	
	paths.clear();
	
	try
	{
		TiXmlDocument doc;
		if ( ! doc.Parse(websites.c_str()) )
		{
			// ݴ
			CGDLog::WriteErrLog( "1134:CValidator::ParseXmlPolicies() doc.Parse() ʧ" );
			return trace.SetRetResult( false );
		}
		
		TiXmlHandle hDoc(&doc);
		TiXmlElement* pWebSitesElem = NULL;
		pWebSitesElem = hDoc.FirstChildElement("websites").Element();
		if ( ! pWebSitesElem )
		{
			// ݴ
			CGDLog::WriteErrLog( "1135:CValidator::ParseXmlPolicies() doc.Parse() ļȱʧ[%s]", "websites" );
			trace.SetRetResult( false );
		}
		
		// website
		for ( TiXmlElement* pWebSiteElem = pWebSitesElem->FirstChildElement("website"); pWebSiteElem; pWebSiteElem = pWebSiteElem->NextSiblingElement() )
		{
			TiXmlElement* pPolicyElem = NULL;
			const char* pAttr = NULL;
			const char* pDefaultHomepage = NULL;
			
			pAttr = pWebSiteElem->Attribute("monitorstate");
			if ( pAttr && *pAttr == '0' )
			{
				// δ
				continue;
			}
			
			// Ĭҳ
			pDefaultHomepage = pWebSiteElem->Attribute("defaulthomepage");
			
			// Policy
			pPolicyElem = pWebSiteElem->FirstChildElement("policy");
			if ( ! pPolicyElem )
			{
				// δò
				continue;
			}
			
			TiXmlElement* pMonitorPolicyElem = pPolicyElem->FirstChildElement("monitorpolicy");
			if ( ! pMonitorPolicyElem )
			{
				// δüز
				continue;
			}
			
			// monitorpolicy
			const char* pExcludePath = NULL;
			const char* pExcludeFile = NULL;
			const char* pExcludeType = NULL;
			const char* pExcludeBlur = NULL;
			long excludeChangeEvent = 0;
			long excludeCreateEvent = 0;
			long excludeDeleteEvent = 0;
			long excludeRenameEvent = 0;
			
			unsigned int nExcludeMask = 0;
			pAttr = pMonitorPolicyElem->Attribute("available");
			if ( pAttr && *pAttr == '1' )
			{
				pAttr = pMonitorPolicyElem->Attribute("excludepathavailable");
				if ( pAttr && *pAttr == '1' )
				{
					pExcludePath = pMonitorPolicyElem->Attribute("excludepath");
				}
				pAttr = pMonitorPolicyElem->Attribute("excludefileavailable");
				if ( pAttr && *pAttr == '1' )
				{
					pExcludeFile = pMonitorPolicyElem->Attribute("excludefile");
				}
				pAttr = pMonitorPolicyElem->Attribute("excludetypeavailable");
				if ( pAttr && *pAttr == '1' )
				{
					pExcludeType = pMonitorPolicyElem->Attribute("excludetype");
				}
				pAttr = pMonitorPolicyElem->Attribute("excludebluravailable");
				if ( pAttr && *pAttr == '1' )
				{
					pExcludeBlur = pMonitorPolicyElem->Attribute("excludeblur");
				}
				
				pAttr = pMonitorPolicyElem->Attribute("excludecreateevent");
				if ( pAttr && *pAttr == '1' )
				{
					nExcludeMask |= 0x01;
					excludeCreateEvent = GetNumAttr(pMonitorPolicyElem, "excludecreateevent");
				}
				pAttr = pMonitorPolicyElem->Attribute("excludedeleteevent");
				if ( pAttr && *pAttr == '1' )
				{
					nExcludeMask |= 0x02;
					excludeDeleteEvent = GetNumAttr(pMonitorPolicyElem, "excludedeleteevent");
				}
				pAttr = pMonitorPolicyElem->Attribute("excludechangeevent");
				if ( pAttr && *pAttr == '1' )
				{
					nExcludeMask |= 0x04;
					excludeChangeEvent = GetNumAttr(pMonitorPolicyElem, "excludechangeevent");
				}
				pAttr = pMonitorPolicyElem->Attribute("excluderenameevent");
				if ( pAttr && *pAttr == '1' )
				{
					nExcludeMask |= 0x08;
					excludeRenameEvent = GetNumAttr(pMonitorPolicyElem, "excluderenameevent");
				}
			}
			
			TiXmlElement* pDirectorysElem = pWebSiteElem->FirstChildElement("directorys");
			if ( ! pDirectorysElem )
			{
				// ݴ
				CGDLog::WriteErrLog( "1136:ļȱʧ[%s]", "directorys" );
				trace.SetRetResult( false );
			}
			
			// Directorys
			for ( TiXmlElement* pDirectoryElem = pDirectorysElem->FirstChildElement("directory"); pDirectoryElem; pDirectoryElem = pDirectoryElem->NextSiblingElement() )
			{
				const char* pMonitorPath = pDirectoryElem->Attribute("localpath");
				if ( pMonitorPath && *pMonitorPath )
				{
					CFileExclude exclude;
					CMonitorInformation moniInfo;
					
					moniInfo.m_monitorPath = pMonitorPath;

					ParseSplitInfo((pDefaultHomepage == NULL) ? "" : pDefaultHomepage, moniInfo.m_defaultHomepage);
					
					ParseSplitInfo((pExcludePath == NULL) ? "" : pExcludePath, moniInfo.m_excludePath);
					ParseSplitInfo((pExcludeFile == NULL) ? "" : pExcludeFile, moniInfo.m_excludeFile);
					ParseSplitInfo((pExcludeType == NULL) ? "" : pExcludeType, moniInfo.m_excludeType);
					ParseSplitInfo((pExcludeBlur == NULL) ? "" : pExcludeBlur, moniInfo.m_excludeBlur);
					
					moniInfo.m_excludeChangeEvent = excludeChangeEvent;
					moniInfo.m_excludeCreateEvent = excludeCreateEvent;
					moniInfo.m_excludeDeleteEvent = excludeDeleteEvent;
					moniInfo.m_excludeRenameEvent = excludeRenameEvent;

					exclude.SetRules( moniInfo );
					paths.push_back( exclude );
				}
			}
		}
	}
	catch ( ... )
	{
		//cerr << exc.DisplayText() << endl;
		CGDLog::WriteErrLog( "1137:CValidator::ParseXmlPolicies() catch exception" );
		return trace.SetRetResult( false );
	}

	return trace.SetRetResult( true );
}

bool CValidator::IsExclude( const char* pFile )
{
	CGDTrace trace( LOG_L6, "CValidator:IsExclude(%s)", pFile==NULL?"(null)":pFile );
	
	bool bRet = true;
	for ( list<CFileExclude>::iterator it = m_paths.begin(); it != m_paths.end(); ++ it )
	{
		if ( ! (*it).IsInMonitorPath( pFile ) ) 
		{
			continue;
		}
		// ֤ǰ֪¼֤֪ͣ?
		
		bRet = (*it).IsExcludeFile( pFile );
		break;
	}
	
	return trace.SetRetResult( bRet );
}

bool CValidator::IsExcludeEvent( eventType type, const char* pFile )
{
	CGDTrace trace( LOG_L6, "CValidator:IsExcludeEvent(%d,%s)", type, pFile==NULL?"(null)":pFile );
	
	bool bRet = true;
	for ( list<CFileExclude>::iterator it = m_paths.begin(); it != m_paths.end(); ++ it )
	{
		if ( ! (*it).IsInMonitorPath( pFile ) ) 
		{
			continue;
		}
		// ֤ǰ֪¼֤֪ͣ
		
		bRet = (*it).IsExcludeEvent( type, pFile );
		break;
	}
	
	return trace.SetRetResult( bRet );
}

void CValidator::GetDefaultHomepage(const char* pDir, vector<string>& defaultHomepages)
{
	CGDTrace trace( LOG_L6, "CValidator:GetDefaultHomepage(%s,)", pDir );
	
	for ( list<CFileExclude>::iterator it = m_paths.begin(); it != m_paths.end(); ++ it )
	{
		if ( ! (*it).IsInMonitorPath( pDir ) ) 
		{
			continue;
		}
		
		defaultHomepages = ((*it).GetInformation())->m_defaultHomepage;
		
		// <<Դ
		string homePages;
		for ( vector<string>::iterator iter = defaultHomepages.begin(); iter != defaultHomepages.end(); ++iter )
		{
			homePages += (*iter) + "|";
		}
		trace.SetOutParam( ",%s", homePages.c_str() );
		// >>
		
		return;
	}
}


// wu_binĿ¼
#if 1
// ʹapacheеĴ
#ifdef WIN32
#define IS_SLASH(s) ((s == '/') || (s == '\\'))
#else
#define IS_SLASH(s) (s == '/')
#endif
const char* CValidator::GetRealPath( char *name, int nPathSize, const char* input )
{
	if ( input == NULL || input[0] == '\0' )
	{
		return name;
	}
	strncpy( name, input, nPathSize );
	char *next;
	int l, w, first_dot;
	
	/* Four paseses, as per RFC 1808 */
	/* a) remove ./ path segments */
	for (next = name; *next && (*next != '.'); next++) {
	}
	
	l = w = first_dot = next - name;
	while (name[l] != '\0') {
		if (name[l] == '.' && IS_SLASH(name[l + 1])
			&& (l == 0 || IS_SLASH(name[l - 1])))
			l += 2;
		else
			name[w++] = name[l++];
	}
	
	/* b) remove trailing . path, segment */
	if (w == 1 && name[0] == '.')
		w--;
	else if (w > 1 && name[w - 1] == '.' && IS_SLASH(name[w - 2]))
		w--;
	name[w] = '\0';
	
	/* c) remove all xx/../ segments. (including leading ../ and /../) */
	l = first_dot;
	
	while (name[l] != '\0') {
		if (name[l] == '.' && name[l + 1] == '.' && IS_SLASH(name[l + 2])
			&& (l == 0 || IS_SLASH(name[l - 1]))) {
			register int m = l + 3, n;
			
			l = l - 2;
			if (l >= 0) {
				while (l >= 0 && !IS_SLASH(name[l]))
					l--;
				l++;
			}
			else
				l = 0;
			n = l;
			while ((name[n] = name[m]))
				(++n, ++m);
		}
		else
			++l;
	}
	
	/* d) remove trailing xx/.. segment. */
	if (l == 2 && name[0] == '.' && name[1] == '.')
		name[0] = '\0';
	else if (l > 2 && name[l - 1] == '.' && name[l - 2] == '.'
		&& IS_SLASH(name[l - 3])) {
		l = l - 4;
		if (l >= 0) {
			while (l >= 0 && !IS_SLASH(name[l]))
				l--;
			l++;
		}
		else
			l = 0;
		name[l] = '\0';
	}

	// ɾ\\Ĵ
	char nameTmp[GD_MAX_PATH] = {0};
	int i = 0;
	l = 0;
	nameTmp[i++] = name[l++];
	while( name[l]!= '\0' && i < GD_MAX_PATH )
	{
		if ( IS_SLASH(name[l-1]) && IS_SLASH(name[l]) )
		{
			l++;
		}
		else
		{
			nameTmp[i++] = name[l++];
		}
	}
	strcpy( name, nameTmp );
	return name;
}
#else
const char* GetRealPath( char *path, int nPathSize, const char* pathFile )
{
	// Ŀ¼е...  a\b\..\c	
	string tmp_path = pathFile;
	string::size_type pos1,pos2,pos3;
#ifdef WIN32
	//Windowsƽ̨"..\"ַ
	while(true)
	{
		pos2 =  tmp_path.find("..\\");                 //ҵһ"..\"
		if(pos2 == string::npos)                       //Ҳ"..\"ѭ
		{	
			break;
		}		
		pos3 = tmp_path.rfind("\\", pos2-2);           //..\һ
		tmp_path.erase(pos3,pos2+2-pos3);              //ɾ"\..\ַ֮
		
	}	
	//Windowsƽ̨".\"ַ
	while(true)
	{
		pos1 =  tmp_path.find(".\\");            
		if (pos1 == string::npos )
		{
			break;			
		}
		tmp_path.erase(pos1,2);                        //ɾ".\"
		
	}	
#else
	//ƽ̨LinuxUnix"../"ַ
	while(true)
	{
		pos2 =  tmp_path.find("../");                  //ҵһ"..\"
		if(pos2 == string::npos)                       //Ҳ"..\"ѭ
		{	
			break;
		}		
		pos3 = tmp_path.rfind("/", pos2-2);            //..\һ
		tmp_path.erase(pos3,pos2+2-pos3);              //ɾ"\..\ַ֮
		
	}
	
	//ƽ̨LinuxUnix"./"ַ
	while(true)
	{
		pos1 =  tmp_path.find("./");            
		if (pos1 == string::npos )
		{
			break;			
		}
		tmp_path.erase(pos1,2);                        //ɾ".\"		
	}
	
#endif
	
	strcpy(path,tmp_path.c_str());                     	
	return path;
	
}
#endif

int CValidator::Verify( int nType, const char* sFilePath, const char* sRootPath )
{
	CGDTrace trace( LOG_L6, "CValidator:Verify(%c,%s,%s)", nType, sFilePath, sRootPath );
	
	// жǷҪ²
	CheckPolicy(); 
	
	if ( !sFilePath ) return 403;
	
	if ( m_paths.size() == 0 )
	{
		trace.GDTrace( LOG_NOT, "No monitor path for [%s]", sFilePath );
		return trace.SetRetValue( 0 );
	}
	
	int nRet = 403;
	
	// ӶĿ¼ӵ֧
	char path[ GD_MAX_PATH ] = {0};
	const char* sFilePathReal = NULL;
	sFilePathReal = GetRealPath( path, sizeof(path), sFilePath );
	
	switch ( nType )
	{
	case 'A': // Apache
		nRet = VerifyApachePage( sFilePathReal, sRootPath );
		break;
	case 'I': // IIS
		nRet = VerifyIISPage( sFilePathReal, sRootPath );
		break;
	case 'J': // JEE
		nRet = VerifyJEEPage( sFilePathReal, sRootPath );
		break;
	default:
		break;
	}
	
	return trace.SetRetValue( nRet );
}

/*
Apacheص[2008-08-19]
Ĭҳ(/,C:/Program Files/Apache Group/Apache2/htdocs/index.htm)Ϊ(/,C:/Program Files/Apache Group/Apache2/htdocs/)
Ŀ¼ҳ(C:/Program Files/Apache Group/Apache2/htdocs/app/,C:/Program Files/Apache Group/Apache2/htdocs/)
Ĭҳ(/hi.html,C:/Program Files/Apache Group/Apache2/htdocs/index.htm)Ϊ(C:/Program Files/Apache Group/Apache2/htdocs/index.htm,C:/Program Files/Apache Group/Apache2/htdocs/)
Դļ(/app/images/body.jpg,C:/Program Files/Apache Group/Apache2/htdocs/app/images)Ϊ(C:/Program Files/Apache Group/Apache2/htdocs/app/images/body.jpg,C:/Program Files/Apache Group/Apache2/htdocs/)
ܽ᣺ǰĩΪ/ʱں(ǰ)֤Ĭҳֱ֤ǰ
˵֤̰ݹ(ֻincludefowardӦ÷)
*/
int CValidator::VerifyApachePage( const char* sFilePath, const char* sRootPath )
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyApachePage(%s,%s)", sFilePath, sRootPath );
	
	int nRet = 403;
	vector<string> allPath;
	
	if ( C_PATHLASH == sFilePath[ strlen( sFilePath ) - 1 ] ) // ĬҳĿ¼ҳ
	{
		// Ŀ¼ȡӦĬҳ
		vector<string> defaultHomepages;
		GetDefaultHomepage( sRootPath, defaultHomepages );
		
		for ( int i=0; i<defaultHomepages.size(); i++ )
		{
			string fullPath = sFilePath;
			fullPath += defaultHomepages[i];
			// ֤⴦һĬҳ
			const char* pFullPath = fullPath.c_str();
			if ( i == 0 )
			{
				nRet = VerifyApachePage( pFullPath, sRootPath ); // ݹ
			}
			else
			{
				VerifyApachePage( pFullPath, sRootPath ); // ֤¼
			}
		}
	}
	else if ( *sFilePath && *sRootPath ) // ָҳ
	{
		if ( CGDString::isEndOf( sFilePath, ".php" ) )
		{
			// ļ
			CUrlParse parser( sFilePath, sRootPath, CUrlParse::PHP_PAGE );
			parser.Parse();
			allPath = parser.GetFileList(); // ״ʹallPath
		}
		else if ( CGDString::isEndOf( sFilePath, ".shtml" ) ||
			CGDString::isEndOf( sFilePath, ".shtm" ) ||
			CGDString::isEndOf( sFilePath, ".stm" ) )
		{
			// ļ
			CUrlParse parser( sFilePath, sRootPath, CUrlParse::SHTML_PAGE );
			parser.Parse();
			allPath = parser.GetFileList(); // ״ʹallPath
		}
		else
		{
			allPath.push_back( sFilePath );
		}
		
		// һ֤
		nRet = VerifyList( allPath );
	}
	else
	{
		// none
	}
	
	return trace.SetRetValue( nRet );
}

/*
IISص[2008-08-19]
Ĭҳ()(c:\inetpub\wwwroot\,c:\inetpub\wwwroot\)(c:\inetpub\wwwroot\Default.htm,)ߴΪ(c:\inetpub\wwwroot\Default.htm,c:\inetpub\wwwroot\)
Ŀ¼ҳ()(c:\inetpub\wwwroot\tst\,c:\inetpub\wwwroot\)(c:\inetpub\wwwroot\tst\Default.htm,)ߴΪ(c:\inetpub\wwwroot\tst\Default.htm,c:\inetpub\wwwroot\)
Ĭҳ(һ)(c:\inetpub\wwwroot\index.htm,c:\inetpub\wwwroot\)
ܽ᣺ǰĩΪ/ʱں֤Ĭҳֱ֤ǰ
˵֤̰ݹ
*/
int CValidator::VerifyIISPage( const char* sFilePath, const char* sRootPath )
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyIISPage(%s,%s)", sFilePath, sRootPath );
	
	int nRet = 403;
	vector<string> allPath;
	
	if ( C_PATHLASH == sFilePath[ strlen( sFilePath ) - 1 ] ) // ĬҳĿ¼ҳ
	{
		trace.GDTrace( LOG_DBG, "Ĭҳ[%s][%s]", sFilePath, sRootPath );
		// Ŀ¼ȡӦĬҳ
		vector<string> defaultHomepages;
		GetDefaultHomepage( sRootPath, defaultHomepages );
		
		for ( int i=0; i<defaultHomepages.size(); i++ )
		{
			string fullPath = sFilePath;
			fullPath += defaultHomepages[i];
			// ֤⴦һĬҳ
			const char* pFullPath = fullPath.c_str();
			trace.GDTrace( LOG_DBG, "֤ҳ[%s][%s]", pFullPath, sRootPath );
			if ( i == 0 )
			{
				nRet = VerifyIISPage( pFullPath, sRootPath ); // ݹ
			}
			else
			{
				VerifyIISPage( pFullPath, sRootPath ); // ֤¼
			}
		}
	}
	else if ( *sFilePath ) // ָҳ
	{
		trace.GDTrace( LOG_DBG, "ָҳ[%s][%s]", sFilePath, sRootPath );
		if ( CGDString::isEndOf( sFilePath, ".asp" ) && *sRootPath )
		{
			// ļ
			CUrlParse parser( sFilePath, sRootPath, CUrlParse::ASP_PAGE );
			parser.Parse();
			allPath = parser.GetFileList(); // ״ʹallPath
		}
		else if ( CGDString::isEndOf( sFilePath, ".shtml" ) ||
			CGDString::isEndOf( sFilePath, ".shtm" )  ||
			CGDString::isEndOf( sFilePath, ".stm" )  )
		{
			// ļ
			CUrlParse parser( sFilePath, sRootPath, CUrlParse::SHTML_PAGE );
			parser.Parse();
			allPath = parser.GetFileList(); // ״ʹallPath
		}
		else
		{
			allPath.push_back( sFilePath );
		}
		
		// һ֤
		nRet = VerifyList( allPath );
	}
	else
	{
		// none
		trace.GDTrace( LOG_DBG, "none" );
	}
	
	return trace.SetRetValue( nRet );
}

/*
JEEص[2008-08-19]
Ĭҳ(/,E:\AppServer\apache-tomcat-6.0.18\webapps\ROOT\)
Ŀ¼ҳ(/tst/,E:\AppServer\apache-tomcat-6.0.18\webapps\ROOT\)
Ĭҳ(/he.html,E:\AppServer\apache-tomcat-6.0.18\webapps\ROOT\)
ܽ᣺Ϊ/ʱں֤Ĭҳֱ֤ǰ
˵֤̰ݹ
*/

int CValidator::VerifyJEEPage( const char* sFilePath, const char* sRootPath )
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyJEEPage(%s,%s)", sFilePath, sRootPath );
	
	int nRet = 0;
	vector<string> allPath;
	
	if ( C_PATHLASH == sFilePath[ strlen( sFilePath ) - 1 ] ) // ĬҳĿ¼ҳ
	{
		// Ŀ¼ȡӦĬҳ
		vector<string> defaultHomepages;
		GetDefaultHomepage( sRootPath, defaultHomepages );
		
		for ( int i=0; i<defaultHomepages.size(); i++ )
		{
			string fullPath = sRootPath;
			int len = fullPath.length();
			if( fullPath[len-1] != '/' )
			{
				fullPath += "/";
			}
			
			fullPath += sFilePath + 1; // '/'
			fullPath += defaultHomepages[i];
			// ֤⴦һĬҳ
			const char* pFullPath = fullPath.c_str();
			if ( i == 0 )
			{
				nRet = VerifyJEEPage( pFullPath, sRootPath ); // ݹ
			}
			else
			{
				VerifyJEEPage( pFullPath, sRootPath ); // ֤¼
			}
		}
	}
	else if ( *sFilePath && *sRootPath ) // ָҳ
	{
		string sFullFileName = sRootPath;
		int len = sFullFileName.length();
		if( sFullFileName[len-1] != '/' )
		{
			sFullFileName += "/";
		}
		
		sFullFileName += sFilePath + 1;
		
		if ( CGDString::isEndOf( sFilePath, ".jsp" ) )
		{
			// ļ
			CUrlParse parser( sFullFileName.c_str(), sRootPath, CUrlParse::JSP_PAGE );
			parser.Parse();
			allPath = parser.GetFileList(); // ״ʹallPath
		}
		else if ( CGDString::isEndOf( sFilePath, ".shtml" ) ||
			CGDString::isEndOf( sFilePath, ".shtm" )  ||
			CGDString::isEndOf( sFilePath, ".stm" )  )
		{
			// ļ
			CUrlParse parser( sFilePath, sRootPath, CUrlParse::SHTML_PAGE );
			parser.Parse();
			allPath = parser.GetFileList(); // ״ʹallPath
		}
		else
		{
			allPath.push_back( sFullFileName );
		}
		
		// һ֤
		nRet = VerifyList( allPath );
	}
	else
	{
		// ֤ѹļ
		allPath.push_back( sRootPath );
		// һ֤
		nRet = VerifyList( allPath );
	}
	
	return trace.SetRetValue( nRet );
}

#ifndef WIN32
void CValidator::ConvertSymbolLinkIfExist( string& path )
{
	CGDTrace trace( LOG_L6, "CValidator:ConvertSymbolLinkIfExist(%s)", path.c_str() );
	
	char sPath[ GD_MAX_PATH ] = {0};
	strcpy( sPath, path.c_str() );
	int nLen = strlen( sPath );
	struct stat st = {0};
	do
	{
		trace.GDTrace( LOG_DBG, "lstat(%s)", sPath );
		if ( lstat( sPath, &st ) == 0 && S_ISLNK(st.st_mode) )
		{
			int nTailIdx = nLen - 1; // -1ȡ'/'
			while ( nLen > 0 && sPath[ nLen - 1 ] != '/' ) nLen --;
			if ( nLen > 0 )
			{
				char sReal[ GD_MAX_PATH ] = {0};
				int nSize = readlink( sPath, sReal, sizeof(sReal) );
				trace.GDTrace( LOG_DBG, "readlink(%s) return [%d][%s]", sPath, nSize, sReal );
				if ( nSize > 0 )
				{
					sReal[ nSize ] = '\0'; // Ŀ¼
					sPath[ nLen ] = '\0'; // ĩβ'/'
					if ( sReal[0] == '/' )
					{
						strcpy( sPath, sReal ); // 
					}
					else
					{
						strcat( sPath, sReal ); // 
					}
					if ( sPath[ strlen(sPath) - 1 ] == '/' )
					{
						strcat( sPath, path.substr( nTailIdx + 1 ).c_str() );
					}
					else
					{
						strcat( sPath, path.substr( nTailIdx + 0 ).c_str() );
					}
					string tmpPath = GetRealPath( sPath, sizeof(sPath), sPath );

					ConvertSymbolLinkIfExist( tmpPath );
					path = tmpPath;
					trace.SetOutParam( "%s", path.c_str() );
					return; // õݹôڴεֻһ
				}
			}
		}
		while ( nLen > 0 && sPath[ nLen - 1 ] != '/' ) nLen --;
		if ( nLen > 0 ) sPath[ nLen - 1 ] = '\0';
	} while ( nLen > 1 ); // by wang_jin at 2009-02-28
}
#endif

int CValidator::VerifyList( vector<string>& allPath )
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyList(%d)", allPath.size() );
	
	// һ֤ļ
	int nRet = 0;
	vector<string>::iterator it;
	for (it = allPath.begin(); it != allPath.end(); ++it)
	{
#ifndef WIN32
		// ֤ʼ֮ǰҪ޷ӣԷӽת by wang_jin at 2008-10-1
		ConvertSymbolLinkIfExist( (*it) );
#endif

		// ȥ.././Լ//
		char path[ GD_MAX_PATH ] = {0};
		const char* pFile = NULL;
		pFile = GetRealPath( path, sizeof(path), (*it).c_str() );
		// Ӧòԣų
		if ( IsExclude( pFile ) )
		{
			CGDTrace::GDTrace( LOG_INF, "GDVerifier.Exclude(%s)", (*it).c_str() );
			continue;
		}
		
		// ֤
		int nTmp = VerifyAndAlert( pFile );
		if ( nTmp )
		{
			nRet = nTmp; // ֻҪһͨͽֹ
		}
	}
	
	return trace.SetRetValue( nRet );
}

int CValidator::VerifyAndAlert( const char* sFile )
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyAndAlert(%s)", sFile );
	
	EVENT_S event = {0};
	CDateTime::GetTime( event.evt_time );
	int nCode = 0;
	
	char sRealFile[ GD_MAX_PATH ] = {0};
	
	long nRet = Validate( sFile, sRealFile );

	switch ( nRet )
	{
	case CValidator::VALIDATOR_OK: // 
		break;
	case CValidator::VALIDATOR_NOT_MATCH: // Ƿ޸
		if ( IsExcludeEvent(MONITOR_EVENT_FILTER_CHANGE, sRealFile))
		{
			break;
		}
		else
		{
			if ( m_nSecLevel >= 1 )
			{
				nCode = m_nErrCode; // 040404ֵĬ403
			}
			if ( m_nTranLevel != 0 )
			{
				event.event_type = MONITOR_EVENT_FILTER_CHANGE;
				strcpy( event.o_filepath, sRealFile );		
			}
		}
		break;
	case CValidator::VALIDATOR_MARK_WITHOUT_FILE: // Ƿɾ
		if ( IsExcludeEvent(MONITOR_EVENT_FILTER_DELETE, sRealFile))
		{
			break;
		}
		else
		{
			if ( m_nSecLevel >= 1 )
			{
				nCode = m_nErrCode; // 040404ֵĬ403
			}
			if ( m_nTranLevel != 0 )
			{
				event.event_type = MONITOR_EVENT_FILTER_DELETE;
				strcpy( event.o_filepath, sRealFile );				
			}
		}
		break;
	case CValidator::VALIDATOR_FILE_WITHOUT_MARK: // Ƿ½
		if ( IsExcludeEvent(MONITOR_EVENT_FILTER_CREATE, sRealFile))
		{
			break;
		}
		else
		{
			if( m_nSecLevel >= 2 )//ȫ1Ϊ¼ΪǷ¼
			{
				nCode = m_nErrCode; // 040404ֵĬ403
				event.event_type = MONITOR_EVENT_FILTER_CREATE;
				strcpy( event.o_filepath, sRealFile );
			}
		}
		break;
	case VALIDATOR_WITHOUT_BOTH: // ˫
		nCode = 40404; // 40404 ʾļ
		if ( m_nTranLevel >= 2 )
		{
			event.event_type = MONITOR_EVENT_FILTER_NOBOTH;
			strcpy( event.o_filepath, sRealFile ); 
		}
		break;
	case VALIDATOR_WITHOUT_BOTH_DIR: // ˫ޡԻָ
		nCode = 40404;
		event.event_type = MONITOR_EVENT_FILTER_DELETE;
		event.attr_flag = FILE_ATTRIBUTE_DIRECTORY;
		strcpy( event.o_filepath, sRealFile );
		break;
	case CValidator::VALIDATOR_FILE_WITHOUT_DIR: // Ƿ½Ŀ¼
		nCode = m_nErrCode; // 040404ֵĬ403
		event.event_type = MONITOR_EVENT_FILTER_CREATE;
		event.attr_flag = FILE_ATTRIBUTE_DIRECTORY;
		strcpy( event.o_filepath, sRealFile );
		break;
	case CValidator::VALIDATOR_BOTH_ERROR: // ȫ
	case CValidator::VALIDATOR_MARK_ERROR:
		if( m_nSecLevel >= 3 )
		{
			nCode = 500; // 040404ֵĬ500
		}
		if ( m_nTranLevel >= 3 )
		{
			event.event_type = MONITOR_EVENT_FILTER_ERROR;
			strcpy( event.o_filepath, sRealFile ); 
		}
		break;
	 // ˮӡ
	case CValidator::VALIDATOR_FILE_ERROR: // ļ
		if( m_nSecLevel == 4)
		{
			nCode = 500;
		}
		if ( m_nTranLevel == 4 )
		{
			event.event_type = MONITOR_EVENT_FILTER_ERROR;
			strcpy( event.o_filepath, sRealFile ); 
		}
		break;
	case CValidator::VALIDATOR_FILE_TRANING:	// ļڴ
		if( m_nSecLevel != 0 )
		{
			nCode = m_nErrCode; // 040404ֵĬ403
		}
		break;
	default:
		assert( false );
	}
	
	// ͨϢзϢ 
	if ( event.event_type )
	{
		PutEvent(event);
		CGDTrace::GDTrace( LOG_NOT, "CValidator:VerifyAndAlert()-PutEvent(%d,%s)", event.event_type, event.o_filepath );
		// ¼۸־
		CGDLog::WriteSecLog( "CValidator:VerifyAndAlert(%s,%s,%s) Deny Access", event.GetEventType(), event.o_filepath, event.n_filepath );
	}
	
	return trace.SetRetValue( nCode );
}

long CValidator::VerifyWmState( const char* sFileName )	// ˮӡ״̬
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyWmState(%s)", sFileName );
	
	// liu_yfeng ˮӡжˮӡ״̬	2008-08-14ļش
	char sBakWm[ WMARK_LEN ] = {0};
	//CProcessLock lock( m_mutex );
	
	// ٴȡˮӡжˮӡ״̬Ƿ޸
	long nRet = m_db.Get( sFileName, sBakWm );
	
	time_t nCurTime = time( NULL );
	string sNewWm = "T" + CGDString::ltoa( nCurTime + m_fileTranOutTime );
	
	if ( sBakWm[0] != 'T' )
	{
		if ( 0 == strcmp( WMCHINGVALUE, sBakWm ) )		// ļ
		{
			nRet = 0;
		}
		else
		{
			nRet = m_db.Set( sFileName, sNewWm.c_str() );	// ˮӡ״̬Ϊļָ
			nRet = -1;
		}
	}
	else	// ָ
	{
		if ( nCurTime < atol( sBakWm + 1 ) )
		{
			nRet = 0;	// 
		}
		else	// ڣ»ָ
		{
			// ˮӡ
			nRet = m_db.Set( sFileName, sNewWm.c_str() );	// ˮӡ״̬
			nRet = -1;
		}
	}
	
	return trace.SetRetValue( nRet );
}


long CValidator::Validate( const char* sFileName, char* sRealFile )
{
	CGDTrace trace( LOG_L6, "CValidator:Validate(%s,)", sFileName );
	
	long nResult = VALIDATOR_OK;
	long nRet = 0;
	
	strcpy( sRealFile, sFileName );
	
	char sBakWm[ WMARK_LEN ] = {0};
	// жļĿ¼Ƿ
	bool bExit = false;		// 쳣ʱļ
	try
	{
		bExit = CFileOpt::IsExist( sFileName );
	}
	catch ( CExceptionError & ex )
	{
		CGDLog::WriteErrLog( "1139:CValidator:Validate() catch IsExist throw:%s", ex.GetErrText().c_str() );
	}
	catch ( ... )
	{
		CGDLog::WriteErrLog( "1140:CValidator:Validate() catch IsExist catch ..." );
	}
	
	if ( !bExit )
	{
		// ļһļͲ(ˮӡ)ļǷɾ(ˮӡ)
		// жˮӡ
		try
		{
			nRet = m_db.Get( sFileName, sBakWm );
		}
		catch( ... )
		{
			CGDLog::WriteErrLog( "1141:֤ļ[%s]ˮӡ쳣", sFileName );
			// Թ׳쳣ѽ
			return trace.SetRetValue( VALIDATOR_MARK_ERROR );
		}
		
		if ( nRet == 0 )
		{
			// ļˮӡǷɾָ
			
			long nState = VerifyWmState( sFileName );
			if ( 0 == nState )	// ڴ
			{
				CGDTrace::GDTrace( LOG_NOT, "ڴ[%s]", sFileName );
				return trace.SetRetValue( VALIDATOR_FILE_TRANING );
			}
			else if ( 1 == nState )	// ѻָ ??? by wang_jin at 2009-02-28
			{
				return trace.SetRetValue( VALIDATOR_OK );
			}
			
			// ȼ⸸Ŀ¼Ƿ
			char strLostFile[ GD_MAX_PATH ] = {0};
			if (GetLostFile(sFileName, strLostFile, sizeof(strLostFile)))
			{
				strcpy( sRealFile, strLostFile );
			}
			CGDTrace::GDTrace( LOG_NOT, "ļˮӡ[%s]", sFileName );
			return trace.SetRetValue( VALIDATOR_MARK_WITHOUT_FILE );
		}
		else if ( nRet == 40404 ) // 40404 ʾûˮӡ
		{
			// ļˮӡ
			CGDTrace::GDTrace( LOG_NOT, "ļˮӡ[%s]", sFileName );
			return trace.SetRetValue( VALIDATOR_WITHOUT_BOTH );
		}
		else if ( nRet == 50505 ) // 50505 ʾûĿ¼
		{
			// ļˮӡĿ¼Ǳɾķ by wang_jin at 2009-02-28
			CGDTrace::GDTrace( LOG_NOT, "ļĿ¼[%s]", sFileName );
			// ϼĿ¼Ƿ
			char strLostFile[ GD_MAX_PATH ] = {0};
			if (GetLostFile(sFileName, strLostFile, sizeof(strLostFile)))
			{
				strcpy( sRealFile, strLostFile );
			}
			CGDTrace::GDTrace( LOG_NOT, "ļĿ¼[%s]", sRealFile );
			return trace.SetRetValue( VALIDATOR_WITHOUT_BOTH_DIR );
		}
		else
		{
			// ļˮӡʧ
			CGDLog::WriteErrLog( "1142:ļˮӡ[%s]ʧ[%d]", sFileName, nRet );
			return trace.SetRetValue( VALIDATOR_MARK_ERROR );
		}
	}
	else
	{
		// ļ
		// ɵǰˮӡ
		char sNewWm[ WMARK_LEN ] = {0};
		try
		{
			nRet = CWaterMarkDB::BuildWaterMark( sFileName, sNewWm );
		}
		catch( ... )
		{
			return trace.SetRetValue( VALIDATOR_FILE_ERROR );
		}
		if ( nRet )
		{
			return trace.SetRetValue( VALIDATOR_FILE_ERROR );
		}
		
		// ȡԭʼˮӡ
		try
		{
			nRet = m_db.Get( sFileName, sBakWm );
		}
		catch( ... )
		{
			return trace.SetRetValue( VALIDATOR_MARK_ERROR );
		}
		
		if ( 0 == nRet )
		{
			// ļˮӡ
			// Ƚϵǰˮӡԭʼˮӡ
			if ( memcmp( sBakWm, sNewWm, WMARK_LEN ) == 0 )
			{
				// һ
				return trace.SetRetValue( VALIDATOR_OK );
			}
			else // һ
			{
				// ˮӡ״̬
				long nState = VerifyWmState( sFileName );
				if ( 0 == nState )	// ڴ
				{
					//CGDTrace::GDTrace( LOG_NOT, "ڴ[%s]", sFileName );
					return trace.SetRetValue( VALIDATOR_FILE_TRANING );
				}
				else if ( 1 == nState )	// ѻָ
				{
					return trace.SetRetValue( VALIDATOR_OK );
				}
				else	// ˮӡһ£ָش
				{
					return trace.SetRetValue( VALIDATOR_NOT_MATCH );
				}
			}
		}
		else if ( nRet == 40404 ) // 40404 ʾûˮӡ
		{
			// ļˮӡò
			CGDTrace::GDTrace( LOG_NOT, "ļˮӡ[%s]", sFileName );
			return trace.SetRetValue( VALIDATOR_FILE_WITHOUT_MARK );
		}
		else if ( nRet == 50505 ) // 50505 ʾûĿ¼
		{
			// ļˮӡĿ¼ǷǷ½Ŀ¼ by wang_jin at 2009-06-16
			CGDTrace::GDTrace( LOG_NOT, "ļĿ¼[%s]", sFileName );
			// ˮӡϼĿ¼Ƿ
			int nRealFileLen = atoi(sBakWm);
			if ( nRealFileLen > 0 )
			{
				strncpy( sRealFile, sFileName, nRealFileLen ); // ˮӡȱʧĿ¼ by wang_jin at 2009-06-19
				sRealFile[ nRealFileLen ] = '\0';
			}
			// (δʵ)
			return trace.SetRetValue( VALIDATOR_FILE_WITHOUT_DIR );
		}
		else
		{
			// ļˮӡʧ
			CGDLog::WriteErrLog( "1143:ļˮӡ[%s]ʧ[%d]", sFileName, nRet );
			return trace.SetRetValue( VALIDATOR_MARK_ERROR );
		}
	}
	
	return trace.SetRetValue( nResult );
}

bool CValidator::GetLostFile(const char* pFileFullPath, char* pLostFile, const unsigned int size)
{
	CGDTrace trace( LOG_L6, "CValidator:GetLostFile(%s,,%d)", pFileFullPath==NULL?"(null)":pFileFullPath, size );
	
	char tmpDir[GD_MAX_PATH] = { 0 };
	strncpy(tmpDir, pFileFullPath, sizeof(tmpDir) - 1);
	
	// File not exists, find its first ancestor dir that NOT exists
	for (int i = strlen(tmpDir) - 1; i >= 0; i--)
	{
		if (tmpDir[i] == C_PATHLASH)
		{
			// Get a ancestor dir
			char bak;
			if (i == 0)
			{
				bak = tmpDir[i+1];
				tmpDir[i+1] = '\0';
			}
			else
			{
				tmpDir[i] = '\0';
			}
			
			try
			{
				if ( CFileOpt::IsExist( tmpDir ) )
				{
					// Get the first nonexistence
					if (i == 0)
					{
						tmpDir[i+1] = bak;
					}
					else
					{
						tmpDir[i] = C_PATHLASH;
					}
					strncpy(pLostFile, tmpDir, size - 1);
					
					trace.SetOutParam( ",%s,", pLostFile );
					return trace.SetRetResult( true );
				}
			}
			catch ( CExceptionError & ex )
			{
				CGDLog::WriteErrLog( "1144:CValidator:GetLostFile() catch IsExist throw:%s", ex.GetErrText().c_str() );
			}
			catch ( ... )
			{
				CGDLog::WriteErrLog( "1145:CValidator:GetLostFile() catch IsExist catch ..." );
			}
		}
	}
	
	return trace.SetRetResult( false );
}

bool CValidator::SetSharedBuffer( list<CFileExclude> &m_monitorList )
{
	CGDTrace trace( LOG_L6, "CValidator:SetSharedBuffer()" );
	
	list<CFileExclude>::iterator iter;
#ifndef HPUX
	ostringstream oss;
	
	oss << (long)1 << endl;
	m_nVersion = 1;

	long num = m_monitorList.size();
	oss << num << endl;

	for ( iter = m_monitorList.begin(); iter != m_monitorList.end(); ++iter )
	{
		oss << *( (*iter).GetInformation() ) << endl;
	}
	
	string monitorString;
	monitorString = oss.str();
	CGDLog::WriteSysLog( "2050:Set Shared Buffer %s", monitorString.c_str() );
#else
	string monitorString;
	monitorString = CGDString::ltoa( 1 );
	monitorString = monitorString + " ";
	
	long num = m_monitorList.size();
	monitorString = monitorString + CGDString::ltoa( num );
	monitorString = monitorString + " ";
	
	for ( iter = m_monitorList.begin(); iter != m_monitorList.end(); ++iter )
	{
		string tmp;
		(*iter).GetInformation()->toString( tmp, *( (*iter).GetInformation() ) );
		monitorString += tmp;
	}
	CGDLog::WriteSysLog( "2051:HPUX Set Shared Buffer %s", monitorString.c_str() );
#endif
	
	//ͨCSharedBuffer,֪ͨverifier¼Ŀ¼
	if ( NO_ERROR != m_sharedBuffer.SetData( (void*)monitorString.c_str(), monitorString.length() + 1 ) )
	{
		return trace.SetRetResult( false );
	}
	return trace.SetRetResult( true );
}

bool CValidator::GetSharedBuffer( list<CFileExclude> &m_monitorList )
{
	CGDTrace trace( LOG_L6, "CValidator:GetSharedBuffer()" );
	
	m_monitorList.clear();
	long nSize = 0;
	
	// ȡݿС
	m_sharedBuffer.GetData( NULL, nSize );
	
	char* pBuff = new char[nSize + 1];
	
	if ( NO_ERROR != m_sharedBuffer.GetData( (void*)pBuff, nSize ) )
	{
		delete []pBuff;
		pBuff = NULL;
		return trace.SetRetResult( false );
	}
#ifndef HPUX
	istringstream iss(pBuff);
	if( !iss.good() )
	{
		CGDLog::WriteErrLog( "1146:Open buff stream failed" );
		return trace.SetRetResult( false );
	}
	
	//CGDLog::WriteSysLog( "Get Shared Buffer %s", iss.str() ); // by liu_yfeng 2009-04-03 Solaris core
	CGDLog::WriteSysLog( "2052:Get Shared Buffer %s", pBuff );

	iss >> m_nVersion;
	
	long num = 0;
	iss >> num;
	
	while( iss.good() && num > 0 )
	{
		CFileExclude fileExclude;
		iss >> *( fileExclude.GetInformation() );
		
		m_monitorList.push_back( fileExclude );
		
		num--;
	}
#else
	string monitorString(pBuff);
	if( monitorString.empty() )
	{
		CGDLog::WriteErrLog( "1147:monitorString is empty" );
		return trace.SetRetResult( false );
	}
	CGDLog::WriteSysLog( "2053:HPUX Get Shared Buffer %s", monitorString.c_str() );
	
	CGDString::StringHtrim( monitorString );
	string::size_type nCur = monitorString.find_first_of( " " );
	if ( nCur > 0 && nCur != string::npos )
	{
		m_nVersion = atol( monitorString.substr( 0, nCur ).c_str() );
		monitorString = monitorString.substr( nCur, monitorString.length() );
	}
	
	long num = 0;
	CGDString::StringHtrim( monitorString );
	nCur = monitorString.find_first_of( " " );
	if ( nCur > 0 && nCur != string::npos )
	{
		num = atol( monitorString.substr( 0, nCur ).c_str() );
		monitorString = monitorString.substr( nCur, monitorString.length() );
	}
	
	while( !monitorString.empty() && num > 0 )
	{
		CFileExclude fileExclude;
		monitorString = fileExclude.GetInformation()->fromString( monitorString, *( fileExclude.GetInformation() ) );
		
		m_monitorList.push_back( fileExclude );
		
		num--;
	}
#endif
	
	delete []pBuff;
	pBuff = NULL;
	return trace.SetRetResult( true );
}

bool CValidator::PutEvent(EVENT_S& event)
{
	CGDTrace trace( LOG_L6, "CValidator:PutEvent(%s)", event.toString().c_str() );

	// ʹ۸¼ϢMA
	if ( NO_ERROR != m_msgQue.PutMessage( (void*)&event, sizeof(EVENT_S) ) )
	{
		return trace.SetRetResult( false );
	}
	
	return trace.SetRetResult( true );
}

int CValidator::VerifyErrorPage( int sc, const char *chrRoot )
{
	CGDTrace trace( LOG_L6, "CValidator:VerifyErrorPage(%d,%s)", sc, chrRoot );
	
	if ( 0 == sc ) sc = m_nErrCode;
	
	int nRet = 500;
	map< int, string >::iterator iter;//ҳ棺ֵͶӦҳmap
	iter = m_errCodeMap.find( sc );   //mapвҴ洢scӦpairstring,iter
	if ( iter != m_errCodeMap.end() ) //ҵ
	{
		string file = chrRoot;
		file += iter->second;
		
		//֤scֵӦĴҳǷ񱻴۸
		if ( VerifyAndAlert( file.c_str() )  )
		{
			//"δ۸"򷵻scֵ
			nRet = sc;
		}//ִеelse˵scӦĴҳѱ۸
		else if ( m_nErrCode == sc )//жsc403ҳıʶֵǷȣ
		{	//ȣ˵403ҳ𻵣   
			CGDLog::WriteErrLog( "1148:Error Code [%d] No valid Error Page.", sc );
			nRet = 500;
		}
		else
		{
			nRet = VerifyErrorPage( m_nErrCode, chrRoot );
		}
	}
	else
	{
		CGDLog::WriteErrLog( "1149:Error Code [%d] Not config Error Page.", sc );
		nRet = sc; // by wang_jin at 2009-02-28
	}
	
	return trace.SetRetValue( nRet );
}
