/***********************************************************************
*
* ļ        Validator.h
* ģĿģִļ֤
* ߼ڣ  wang_jin 2008-05-11
* 汾          1.0
* ȨϢ      CVICSE Middleware
* ļ¼  
*
***********************************************************************/

#ifndef Validator_H
#define Validator_H


#include "FileExclude/FileExclude.h"
#include "GDLock/GDLock.h"
#include "GDQue/MessageQueue.h"
#include "GDQue/SharedBuffer.h"
#include "TinyXml/tinyxml.h"
#include "WaterMark/WaterMarkDB.h"

#include <map>
#include <list>

#ifndef NOT_USE_STD_LIB
	using namespace std;
#endif


class CValidator
{
public:
	enum 
	{
		VALIDATOR_OK				= 8000,	// 

		VALIDATOR_NOT_MATCH			,		// Ƿ޸
		VALIDATOR_FILE_WITHOUT_MARK ,		// Ƿ½ļˮӡ
		VALIDATOR_MARK_WITHOUT_FILE ,		// Ƿɾˮӡļ

		VALIDATOR_WITHOUT_BOTH		,		// ЧļˮӡûУ
		VALIDATOR_WITHOUT_BOTH_DIR	,		// ЧļˮӡĿ¼ûУ
		VALIDATOR_FILE_WITHOUT_DIR  ,		// Ƿ½Ŀ¼ļˮӡĿ¼

		VALIDATOR_FILE_ERROR		,		// ļ
		VALIDATOR_MARK_ERROR		,		// ˮӡ
		VALIDATOR_BOTH_ERROR		,		// ȫ

		VALIDATOR_FILE_TRANING				// ļڴ		// liu_yfeng	2008-08-14
	};

public:
	CValidator();
	~CValidator();

public:
	bool Initialize();
	bool Uninitialize();
	bool CheckPolicy();
	bool IsExclude( const char* pFile );
	bool IsExcludeEvent( eventType type, const char* pFile );
	long Validate( const char* pFile, char* sRealFile );
	bool GetLostFile(const char* pFileFullPath, char* pLostFile, const unsigned int size);
	bool PutEvent(EVENT_S& event);

	void GetDefaultHomepage(const char* pDir, vector<string>& defaultHomepages);
	int  VerifyErrorPage( int sc, const char *chrRoot );
	int Verify( int nType, const char* sFilePath, const char* sRootPath );
	int VerifyAndAlert( const char* sFile );
	
protected:
	long GetNumAttr(const TiXmlElement* pElement, const char* attrName, long defaultValue = 0);
	void ParseSplitInfo(const string& pathInfo, vector<string>& pathMuster);
	// Ӵ̶ȡ
	bool LoadFromDiskToExclude( const char* sCfgFile, list<CFileExclude>& paths );
	
	// xml
	bool ParseXmlPolicies(const string& websites, list<CFileExclude>& paths);
	// ⹲ڴǷ
	bool CheckShmChange();

	bool SetSharedBuffer( list<CFileExclude> &m_monitorList );
	// ӹڴȡ
	bool GetSharedBuffer( list<CFileExclude> &m_monitorList );

	// ļشҳϢ
	bool LoadErrCode( const char* sCfgFile );

private:
	// 0 ڻָ1ѻָ-1Ҫָ
	long VerifyWmState( const char* sFileName );	// liu_yfeng жļǷڴ	2008-08-14

	int VerifyApachePage( const char* sFilePath, const char* sRootPath );
	int VerifyIISPage( const char* sFilePath, const char* sRootPath );
	int VerifyJEEPage( const char* sFilePath, const char* sRootPath );
	int VerifyList( vector<string>& allPath );
	const char* GetRealPath( char *name, int nPathSize, const char* input );
#ifndef WIN32
	void ConvertSymbolLinkIfExist( string& path );
#endif

private:
	string m_websitesXml;
	string m_configFile;
	list<CFileExclude> m_paths;
	CSharedBuffer m_shBuf;
	long m_nVersion;
	bool m_bInitialized;
	CProcessMutex m_mutex;// Ϊ
	CThreadMutex m_thrMutex;
	CWaterMarkDB m_db;
	CSharedBuffer m_sharedBuffer;
	CMessageQueue m_msgQue;

	map< int, string > m_errCodeMap;
	long m_fileTranOutTime;	// ʱָشʱʱ䣨룩
    
    long m_nDBTreeSize; // ڴС(K)
	bool m_bUseDb;
	int m_nSecLevel;
	int m_nTranLevel;

public:
	int m_nErrCode;
	string m_sErrCode;
	string m_sErrPage;
	string m_sErrMessge;

};


#endif
