#include "coursepage.h"
#include <QDebug>

CoursePage* CoursePage::courseInstance = NULL;
CoursePage::CoursePage(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    articleList = ArticleListPage::getArticleListInstance();
    xzzs = XzzsPage::getXzzsInstance();
    jbbh = JbbhPage::getJbbhInstance();
    sfkt = SfktPage::getSfktInstance();
    szzb = SzzbPage::getSzzbInstance();
    ppbs = PpbsPage::getPpbsInstance();
    sxzf = SxzfPage::getSxzfInstance();
    query = QueryPage::getQueryInstance();
}

CoursePage* CoursePage::getCourseInstance()
{
    if (courseInstance == NULL) {
        courseInstance = new CoursePage();
    }

    return courseInstance;
}

void CoursePage::setWidget(QWidget *course, QStackedWidget *stack, QWidget *articleList, QWidget *xzzs,
                           QWidget *jbbh, QWidget *sfkt, QWidget *szzb, QWidget *ppbs, QWidget *sxzf, QWidget *query)
{
    stackWidget = stack;
    coursePage = course;
    articleListPage = articleList;
    xzzsPage = xzzs;
    jbbhPage = jbbh;
    sfktPage = sfkt;
    szzbPage = szzb;
    ppbsPage = ppbs;
    sxzfPage = sxzf;
    queryPage = query;

//    bgLabel = new QLabel(coursePage);
}

void CoursePage::setCoursePage()
{
    // 设置背景图片
    coursePage->setStyleSheet("QWidget#coursePage{image:url(:/shouye/bj_01.jpg)}");

    // 设置年级按钮
    setCourseButton();
}

void CoursePage::setCourseButton()
{
    QPixmap db1(":/shouye/sy_dbxz01.png");
    QPixmap db2(":/shouye/sy_dbxz02.png");
    QPixmap xb1(":/shouye/sy_xbxz01.png");
    QPixmap xb2(":/shouye/sy_xbxz02.png");

    btnDb = new ImageButton(coursePage);
    btnDb->setGeometry(538,173,190,151);
    btnDb->setMinimumSize(190,151);
    btnDb->setNormalImage(db1);
    btnDb->setPressImage(db2);
    btnDb->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnDb, SIGNAL(clicked()), this, SLOT(onDbClick()));

    btnXb = new ImageButton(coursePage);
    btnXb->setGeometry(278,173,190,151);
    btnXb->setMinimumSize(190,151);
    btnXb->setNormalImage(xb1);
    btnXb->setPressImage(xb2);
    btnXb->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnXb, SIGNAL(clicked()), this, SLOT(onXbClick()));


    // 查询
    btnQuery = new ImageButton(coursePage);
    btnQuery->setGeometry(838,188,135,127);
    QPixmap queryP1(":/shouye/sy_cx.png");
    QPixmap queryP2(":/shouye/sy_cx01.png");
    btnQuery->setNormalImage(queryP1);
    btnQuery->setPressImage(queryP2);
    btnQuery->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnQuery, SIGNAL(clicked()), this, SLOT(onQueryClick()));

    // 写字姿势
    btnXzzs = new ImageButton(coursePage);
    btnXzzs->setGeometry(193,394,166,48);
    QPixmap xzzsP1(":/shouye/sy_xzzs.png");
    QPixmap xzzsP2(":/shouye/sy_xzzs01.png");
    btnXzzs->setNormalImage(xzzsP1);
    btnXzzs->setPressImage(xzzsP2);
    btnXzzs->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnXzzs, SIGNAL(clicked()), this, SLOT(onXzzsClick()));

    // 基本笔画
    btnJbbh = new ImageButton(coursePage);
    btnJbbh->setGeometry(193,470,166,48);
    QPixmap jbbhP1(":/shouye/sy_jbbh.png");
    QPixmap jbbhP2(":/shouye/sy_jbbh01.png");
    btnJbbh->setNormalImage(jbbhP1);
    btnJbbh->setPressImage(jbbhP2);
    btnJbbh->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnJbbh, SIGNAL(clicked()), this, SLOT(onJbbhClick()));

    // 书法课堂
    btnMbkt = new ImageButton(coursePage);
    btnMbkt->setGeometry(405,394,204,72);
    QPixmap sfktP1(":/shouye/sy_mbkt.png");
    QPixmap sfktP2(":/shouye/sy_mbkt01.png");
    btnMbkt->setNormalImage(sfktP1);
    btnMbkt->setPressImage(sfktP2);
    btnMbkt->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnMbkt, SIGNAL(clicked()), this, SLOT(onMbktClick()));

    // 生字总表
    btnSzzb = new ImageButton(coursePage);
    btnSzzb->setGeometry(421,485,172,61);
//    btnSzzb->setFixedSize(172,61);
    QPixmap szzbP1(":/shouye/sy_szzb.png");
    QPixmap szzbP2(":/shouye/sy_szzb01.png");
    btnSzzb->setNormalImage(szzbP1);
    btnSzzb->setPressImage(szzbP2);
    btnSzzb->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnSzzb, SIGNAL(clicked()), this, SLOT(onSzzbClick()));

    // 偏旁部首
    btnPpbs = new ImageButton(coursePage);
    btnPpbs->setGeometry(645,394,166,48);
    QPixmap ppbsP1(":/shouye/sy_ppbs.png");
    QPixmap ppbsP2(":/shouye/sy_ppbs01.png");
    btnPpbs->setNormalImage(ppbsP1);
    btnPpbs->setPressImage(ppbsP2);
    btnPpbs->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnPpbs, SIGNAL(clicked()), this, SLOT(onPpbsClick()));

    // 书写章法
    btnSxzf = new ImageButton(coursePage);
    btnSxzf->setGeometry(645,470,166,48);
    QPixmap sxzfP1(":/shouye/sy_sxzf.png");
    QPixmap sxzfP2(":/shouye/sy_sxzf01.png");
    btnSxzf->setNormalImage(sxzfP1);
    btnSxzf->setPressImage(sxzfP2);
    btnSxzf->setCursor(QCursor(Qt::PointingHandCursor));
    QObject::connect(btnSxzf, SIGNAL(clicked()), this, SLOT(onSxzfClick()));
}


// slots
void CoursePage::onDbClick()
{
    qDebug() << "1年级上册 click";
    btnDb->blockSignals(true);

    stackWidget->setCurrentWidget(articleListPage);
    articleList->setArticleListPage(coursePage, "", "", btnDb, "dbxz");
}

void CoursePage::onXbClick()
{
    btnXb->blockSignals(true);

    stackWidget->setCurrentWidget(articleListPage);
    articleList->setArticleListPage(coursePage, "", "", btnXb, "xbxz");
}

void CoursePage::onQueryClick()
{
    qDebug() << "query click";
    btnQuery->blockSignals(true);

    stackWidget->setCurrentWidget(queryPage);
    query->setQueryPage(coursePage, btnQuery);
}

void CoursePage::onXzzsClick()
{
    btnXzzs->blockSignals(true);
    qDebug() << "xzzs click";

    stackWidget->setCurrentWidget(xzzsPage);
    xzzs->setXzzsPage(coursePage, btnXzzs);
}

void CoursePage::onJbbhClick()
{
    btnJbbh->blockSignals(true);
    qDebug() << "jbbh click";

    stackWidget->setCurrentWidget(jbbhPage);
    jbbh->setJbbhPage(coursePage, btnJbbh);
}

void CoursePage::onMbktClick()
{
    qDebug() << "mbkt click";
    btnMbkt->blockSignals(true);

    stackWidget->setCurrentWidget(articleListPage);
    articleList->setArticleListPage(coursePage, "", "", btnMbkt, "mbkt");
}

void CoursePage::onSzzbClick()
{
    qDebug() << "szzb click";
    btnSzzb->blockSignals(true);

    stackWidget->setCurrentWidget(szzbPage);
    szzb->setSzzbPage(coursePage, btnSzzb, "", "");
}

void CoursePage::onPpbsClick()
{
    qDebug() << "ppbs click";
    btnPpbs->blockSignals(true);

    stackWidget->setCurrentWidget(ppbsPage);
    ppbs->setPpbsPage(coursePage, btnPpbs);
}

void CoursePage::onSxzfClick()
{
    qDebug() << "sxzf click";
    btnSxzf->blockSignals(true);

    stackWidget->setCurrentWidget(sxzfPage);
    sxzf->setSxzfPage(coursePage, btnSxzf);
}
