#include "ppbspage.h"

PpbsPage* PpbsPage::ppbsInstance = NULL;
PpbsPage::PpbsPage(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    ppbuSubPage = PpbsSubPage::getPpbsSubInstance();
}

PpbsPage* PpbsPage::getPpbsInstance()
{
    if (ppbsInstance == NULL)
        ppbsInstance = new PpbsPage();

    return ppbsInstance;
}

void PpbsPage::setWidget(QWidget *ppbs, QStackedWidget *stack, QWidget *next)
{
    ppbsPage = ppbs;
    nextPage = next;
    stackWidget = stack;

    // 页面元素初始化
    topImageLabel = new QLabel(ppbsPage);
    btnZitou = new ImageButton(ppbsPage);
    btnZidi = new ImageButton(ppbsPage);
    btnZpp = new ImageButton(ppbsPage);
    btnYpp = new ImageButton(ppbsPage);
    btnBaowei = new ImageButton(ppbsPage);
    btnBack = new ImageButton(ppbsPage);

    QObject::connect(btnZitou, SIGNAL(clicked()), this, SLOT(onZitouClick()));
    QObject::connect(btnZpp, SIGNAL(clicked()), this, SLOT(onZppClick()));
    QObject::connect(btnBaowei, SIGNAL(clicked()), this, SLOT(onBaoweiClick()));
    QObject::connect(btnZidi, SIGNAL(clicked()), this, SLOT(onZidiClick()));
    QObject::connect(btnYpp, SIGNAL(clicked()), this, SLOT(onYppClick()));
    QObject::connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
}

void PpbsPage::setPpbsPage(QWidget *parent, ImageButton *btnP)
{
    parentPage = parent;
    btnParent = btnP;

    setBackGround();
    setButtons();
}

void PpbsPage::setBackGround()
{
    ppbsPage->setStyleSheet("image:url(:/ppbs/bj_08.jpg)");

    topImageLabel->setGeometry(334,27,331,104);
    topImageLabel->setStyleSheet("image:url(:ppbs/pb_bt.png)");
}

void PpbsPage::setButtons()
{
    // 字头
    btnZitou->setGeometry(259,187,216,62);
    QPixmap zitouP1(":/ppbs/pp_zt01.png");
    QPixmap zitouP2(":/ppbs/pp_zt02.png");
    btnZitou->setNormalImage(zitouP1);
    btnZitou->setPressImage(zitouP2);
    btnZitou->setCursor(QCursor(Qt::PointingHandCursor));

    // 左偏旁
    btnZpp->setGeometry(259,277,216,62);
    QPixmap zppP1(":/ppbs/pp_zpp01.png");
    QPixmap zppP2(":/ppbs/pp_zpp02.png");
    btnZpp->setNormalImage(zppP1);
    btnZpp->setPressImage(zppP2);
    btnZpp->setCursor(QCursor(Qt::PointingHandCursor));

    // 包围
    btnBaowei->setGeometry(259,367,216,62);
    QPixmap baoweiP1(":/ppbs/pp_bw01.png");
    QPixmap baoweiP2(":/ppbs/pp_bw02.png");
    btnBaowei->setNormalImage(baoweiP1);
    btnBaowei->setPressImage(baoweiP2);
    btnBaowei->setCursor(QCursor(Qt::PointingHandCursor));

    // 字底
    btnZidi->setGeometry(556,187,216,62);
    QPixmap zidiP1(":/ppbs/pp_zd01.png");
    QPixmap zidiP2(":/ppbs/pp_zd02.png");
    btnZidi->setNormalImage(zidiP1);
    btnZidi->setPressImage(zidiP2);
    btnZidi->setCursor(QCursor(Qt::PointingHandCursor));

    // 右偏旁
    btnYpp->setGeometry(556,277,216,62);
    QPixmap yppP1(":/ppbs/pp_ypp01.png");
    QPixmap yppP2(":/ppbs/pp_ypp02.png");
    btnYpp->setNormalImage(yppP1);
    btnYpp->setPressImage(yppP2);
    btnYpp->setCursor(QCursor(Qt::PointingHandCursor));

    // 返回按钮
    btnBack->setGeometry(624,446,248,208);
    QPixmap backP1(":/jbbh/fh_05.png");
    QPixmap backP2(":/jbbh/fh_06.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));
}

void PpbsPage::onZitouClick()
{
    btnZitou->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    ppbuSubPage->setPpbsSubPage(ppbsPage, btnZitou, "zt");
}

void PpbsPage::onZidiClick()
{
    btnZidi->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    ppbuSubPage->setPpbsSubPage(ppbsPage, btnZidi, "zd");
}

void PpbsPage::onZppClick()
{
    btnZpp->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    ppbuSubPage->setPpbsSubPage(ppbsPage, btnZpp, "zpp");
}

void PpbsPage::onYppClick()
{
    btnYpp->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    ppbuSubPage->setPpbsSubPage(ppbsPage, btnYpp, "ypp");
}

void PpbsPage::onBaoweiClick()
{
    btnBaowei->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    ppbuSubPage->setPpbsSubPage(ppbsPage, btnBaowei, "bw");
}

void PpbsPage::onBackClick()
{
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
}
