#include "ppbssubpage.h"
#include <QDebug>
#include <QScrollBar>
#include <windows.h>

PpbsSubPage* PpbsSubPage::ppbsSubInstance = NULL;

PpbsSubPage::PpbsSubPage(QObject *parent) : QObject(parent)
{
    middle = Middle::getMiddleInstance();
    video = VideoPage::getVideoPageInstance();
}

PpbsSubPage* PpbsSubPage::getPpbsSubInstance()
{
    if (ppbsSubInstance == NULL)
        ppbsSubInstance = new PpbsSubPage();

    return ppbsSubInstance;
}

void PpbsSubPage::setWidget(QWidget *ppbsSub, QStackedWidget *stack, QWidget *next, QWidget *videoP)
{
    ppbsSubPage = ppbsSub;
    nextPage = next;
    stackWidget = stack;
    videoPage = videoP;

    topImageLabel = new QLabel(ppbsSubPage);
    btnBack = new ImageButton(ppbsSubPage);
    listWidget = new QListWidget(ppbsSubPage);
    listWidget->hide();

    connect(listWidget,SIGNAL(clicked(QModelIndex)),this,SLOT(itemClicked(QModelIndex)));
    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
}

void PpbsSubPage::setPpbsSubPage(QWidget *parent, ImageButton *btnP, QString code)
{
    parentPage = parent;
    btnParent = btnP;
    stop = false;

    setBackGround(code);
    setButtons();
    setList(code);
}

void PpbsSubPage::setBackGround(QString code)
{
    ppbsSubPage->setStyleSheet("image:url(:/ppbs/erji/bj_08.jpg)");
    if (code == "zt") {
        topImageLabel->setGeometry(400,67,168,91);
        topImageLabel->setStyleSheet("image:url(:/ppbs/erji/pp_bt04.png)");
    } else if (code == "zd") {
        topImageLabel->setGeometry(400,67,168,91);
        topImageLabel->setStyleSheet("image:url(:/ppbs/erji/pp_bt05.png)");
    } else if (code == "zpp") {
        topImageLabel->setGeometry(370,67,256,97);
        topImageLabel->setStyleSheet("image:url(:/ppbs/erji/pp_bt01.png)");
    } else if (code == "ypp") {
        topImageLabel->setGeometry(370,67,256,97);
        topImageLabel->setStyleSheet("image:url(:/ppbs/erji/pp_bt02.png)");
    } else if (code =="bw") {
        topImageLabel->setGeometry(400,67,168,91);
        topImageLabel->setStyleSheet("image:url(:/ppbs/erji/pp_bt03.png)");
    }
}

void PpbsSubPage::setList(QString code)
{
    QList<QVariant> itemList;

    itemList = middle->getRadical(code);

    // 设置表格样式
    listWidget->clear();
    listWidget->setGeometry(180,200,630,360);
    listWidget->show();
    //设置QListWidget的显示模式
    listWidget->setViewMode(QListView::IconMode);
    //设置QListWidget中单元项的图片大小
    listWidget->setIconSize(QSize(70,70));
    //设置QListWidget中单元项的间距
    listWidget->setSpacing(15);
    //设置自动适应布局调整（Adjust适应，Fixed不适应），默认不适应
    listWidget->setResizeMode(QListWidget::Adjust);
    //设置不能移动
    listWidget->setMovement(QListWidget::Static);
    //去掉边框
    listWidget->setFrameStyle(0);
    //设置鼠标样式
    listWidget->setCursor(QCursor(Qt::PointingHandCursor));
    // 去掉滚动条
    listWidget->verticalScrollBar()->setStyleSheet("QScrollBar:vertical{width:6px;background:transparent;background-color:rgb(248, 248, 248);margin:0px,0px,0px,0px;padding-top:10px;padding-bottom:10px;}"
                       "QScrollBar::handle:vertical{width:6px;background:lightgray ;border-radius:5px;min-height:20px;}"
                       "QScrollBar::handle:vertical:hover{width:6px;background:gray;border-radius:5px;min-height:20px;}"
                       "QScrollBar::add-line:vertical{height:10px;width:10px;border-image:url(:/button/images/button/down.png);subcontrol-position:bottom;}"
                       "QScrollBar::sub-line:vertical{height:10px;width:10px;border-image:url(:/button/images/button/up.png);subcontrol-position:top;}"
                       "QScrollBar::add-line:vertical:hover{height:10px;width:10px;border-image:url(:/button/images/button/down_mouseDown.png);subcontrol-position:bottom;}"
                       "QScrollBar::sub-line:vertical:hover{height:10px;width:10px;border-image:url(:/button/images/button/up_mouseDown.png);subcontrol-position:top;}"
                       "QScrollBar::add-page:vertical,QScrollBar::sub-page:vertical{background:transparent;border-radius:5px;}");
//    listWidget->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
//    listWidget->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    //去掉选中的背景框
    listWidget->setSelectionMode(QAbstractItemView::NoSelection);
    listWidget->setStyleSheet("QListWidget{background-color:transparent}");

    //填充表格内容
    listWidget->blockSignals(true);
    foreach (QVariant item, itemList) {
        if (stop)
            return;
        //定义QListWidgetItem对象
        QListWidgetItem *imageItem = new QListWidgetItem;
        //为单元项设置属性
        QPixmap image;
//        bool ret = image.loadFromData(middle->getImageData(item.toMap()["img_url"].toString()));
//        if (!ret) {
//            Sleep(1000);
//            image.loadFromData(middle->getImageData(item.toMap()["img_url"].toString()));
//        }
        QString imageFile = middle->getImageFile(item.toMap()["img_url"].toString(), "/bushou/" + code +"/");
        if (imageFile.length() > 0)
            image.load(imageFile);
        else
            image.loadFromData(middle->getImageData(item.toMap()["img_url"].toString()));
        image = image.scaled(QSize(70,70),Qt::KeepAspectRatio);
        imageItem->setIcon(QIcon(image));
        imageItem->setData(Qt::WhatsThisRole, item.toMap()["video_url"].toString() + "," + item.toMap()["video_size"].toString());
        //重新设置单元项图片的宽度和高度
        imageItem->setSizeHint(QSize(70,70));
        //将单元项添加到QListWidget中
        listWidget->addItem(imageItem);
    }
    listWidget->blockSignals(false);
}

void PpbsSubPage::setButtons()
{
    // 返回按钮
    btnBack->setGeometry(803,542,141,95);
    QPixmap backP1(":/jbbh/fh_07.png");
    QPixmap backP2(":/jbbh/fh_08.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));
}

void PpbsSubPage::itemClicked(QModelIndex index)
{
//    listWidget->blockSignals(true);
    QString data = index.data(Qt::WhatsThisRole).toString();
    QStringList list = data.split(",");
    QString videoUrl = list[0];
    int videoSize = list[1].toInt();

    qDebug() << "ppbs"  << __FUNCTION__ << videoUrl;

    video->setVideoPage("image:url(:jbbh/bj_18.jpg)", "",
                            "", "",
                            videoUrl, videoSize, NULL, ppbsSubPage, "ggxz");

    stackWidget->addWidget(videoPage);
    stackWidget->setCurrentWidget(videoPage);
}

void PpbsSubPage::onBackClick()
{
    stop = true;
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
    listWidget->clear();
}
