#include "sfktpage.h"

SfktPage* SfktPage::sfktInstance = NULL;

SfktPage::SfktPage(QObject *parent) : QObject(parent)
{
    sfkt2 = Sfkt2Page::getSfkt2Instance();
}

SfktPage* SfktPage::getSfktInstance()
{
    if (sfktInstance == NULL)
        sfktInstance = new SfktPage();

    return sfktInstance;
}

void SfktPage::setWidget(QWidget *sfkt, QStackedWidget *stack, QWidget *next)
{
    sfktPage = sfkt;
    nextPage = next;
    stackWidget = stack;

    // 窗口组件初始化
    nj1Image = new QLabel(sfktPage);
    nj2Image = new QLabel(sfktPage);
    nj3Image = new QLabel(sfktPage);
    nj4Image = new QLabel(sfktPage);
    nj5Image = new QLabel(sfktPage);
    nj6Image = new QLabel(sfktPage);

    btn1S = new ImageButton(sfktPage);
    btn1X = new ImageButton(sfktPage);
    btn2S = new ImageButton(sfktPage);
    btn2X = new ImageButton(sfktPage);
    btn3S = new ImageButton(sfktPage);
    btn3X = new ImageButton(sfktPage);
    btn4S = new ImageButton(sfktPage);
    btn4X = new ImageButton(sfktPage);
    btn5S = new ImageButton(sfktPage);
    btn5X = new ImageButton(sfktPage);
    btn6S = new ImageButton(sfktPage);
    btn6X = new ImageButton(sfktPage);
    btnBack = new ImageButton(sfktPage);

    connect(btn1S, SIGNAL(clicked()), this, SLOT(on1SClick()));
    connect(btn1X, SIGNAL(clicked()), this, SLOT(on1XClick()));
    connect(btn2S, SIGNAL(clicked()), this, SLOT(on2SClick()));
    connect(btn2X, SIGNAL(clicked()), this, SLOT(on2XClick()));
    connect(btn3S, SIGNAL(clicked()), this, SLOT(on3SClick()));
    connect(btn3X, SIGNAL(clicked()), this, SLOT(on3XClick()));
    connect(btn4S, SIGNAL(clicked()), this, SLOT(on4SClick()));
    connect(btn4X, SIGNAL(clicked()), this, SLOT(on4XClick()));
    connect(btn5S, SIGNAL(clicked()), this, SLOT(on5SClick()));
    connect(btn5X, SIGNAL(clicked()), this, SLOT(on5XClick()));
    connect(btn6S, SIGNAL(clicked()), this, SLOT(on6SClick()));
    connect(btn6X, SIGNAL(clicked()), this, SLOT(on6XClick()));
    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
}

void SfktPage::setSfktPage(QWidget *parent, ImageButton *btnP)
{
    parentPage = parent;
    btnParent = btnP;

    setBackGround();
    setButtons();
}

void SfktPage::setBackGround()
{
    sfktPage->setStyleSheet("QWidget#sfktPage{image:url(:/sfkt/bj_14.jpg)}");

    nj1Image->setGeometry(158,235,159,53);
    nj1Image->setStyleSheet("image:url(:/sfkt/sfkt_1nj.png)");
    nj2Image->setGeometry(158,308,159,53);
    nj2Image->setStyleSheet("image:url(:/sfkt/sfkt_2nj.png)");
    nj3Image->setGeometry(158,382,159,53);
    nj3Image->setStyleSheet("image:url(:/sfkt/sfkt_3nj.png)");
    nj4Image->setGeometry(545,235,159,53);
    nj4Image->setStyleSheet("image:url(:/sfkt/sfkt_4nj.png)");
    nj5Image->setGeometry(545,308,159,53);
    nj5Image->setStyleSheet("image:url(:/sfkt/sfkt_5nj.png)");
    nj6Image->setGeometry(545,382,159,53);
    nj6Image->setStyleSheet("image:url(:/sfkt/sfkt_6nj.png)");
}

void SfktPage::setButtons()
{
    // 上下册按钮
    QPixmap sP1(":/sfkt/sfkt_njs01.png");
    QPixmap sP2(":/sfkt/sfkt_njs02.png");
    QPixmap xP1(":/sfkt/sfkt_njx01.png");
    QPixmap xP2(":/sfkt/sfkt_njx02.png");

    btn1S->setGeometry(333,235,53,53);
    btn1S->setNormalImage(sP1);
    btn1S->setPressImage(sP2);
    btn1S->setCursor(QCursor(Qt::PointingHandCursor));

    btn1X->setGeometry(400,235,53,53);
    btn1X->setNormalImage(xP1);
    btn1X->setPressImage(xP2);
    btn1X->setCursor(QCursor(Qt::PointingHandCursor));

    btn2S->setGeometry(333,308,53,53);
    btn2S->setNormalImage(sP1);
    btn2S->setPressImage(sP2);
    btn2S->setCursor(QCursor(Qt::PointingHandCursor));

    btn2X->setGeometry(400,308,53,53);
    btn2X->setNormalImage(xP1);
    btn2X->setPressImage(xP2);
    btn2X->setCursor(QCursor(Qt::PointingHandCursor));

    btn3S->setGeometry(333,382,53,53);
    btn3S->setNormalImage(sP1);
    btn3S->setPressImage(sP2);
    btn3S->setCursor(QCursor(Qt::PointingHandCursor));

    btn3X->setGeometry(400,382,53,53);
    btn3X->setNormalImage(xP1);
    btn3X->setPressImage(xP2);
    btn3X->setCursor(QCursor(Qt::PointingHandCursor));

    btn4S->setGeometry(722,235,53,53);
    btn4S->setNormalImage(sP1);
    btn4S->setPressImage(sP2);
    btn4S->setCursor(QCursor(Qt::PointingHandCursor));

    btn4X->setGeometry(790,235,53,53);
    btn4X->setNormalImage(xP1);
    btn4X->setPressImage(xP2);
    btn4X->setCursor(QCursor(Qt::PointingHandCursor));

    btn5S->setGeometry(722,308,53,53);
    btn5S->setNormalImage(sP1);
    btn5S->setPressImage(sP2);
    btn5S->setCursor(QCursor(Qt::PointingHandCursor));

    btn5X->setGeometry(790,308,53,53);
    btn5X->setNormalImage(xP1);
    btn5X->setPressImage(xP2);
    btn5X->setCursor(QCursor(Qt::PointingHandCursor));

    btn6S->setGeometry(722,382,53,53);
    btn6S->setNormalImage(sP1);
    btn6S->setPressImage(sP2);
    btn6S->setCursor(QCursor(Qt::PointingHandCursor));

    btn6X->setGeometry(790,382,53,53);
    btn6X->setNormalImage(xP1);
    btn6X->setPressImage(xP2);
    btn6X->setCursor(QCursor(Qt::PointingHandCursor));

    // 返回
    btnBack->setGeometry(837,503,109,110);
    QPixmap backP1(":/sfkt/fh_10.png");
    QPixmap backP2(":/sfkt/fh_10.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));
}

void SfktPage::on1SClick()
{
    btn1S->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "1", "一年级", "1", "上学期", btn1S);
}

void SfktPage::on1XClick()
{
    btn1X->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "1", "一年级", "2", "下学期", btn1X);
}

void SfktPage::on2SClick()
{
    btn2S->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "2", "二年级", "1", "上学期", btn2S);
}

void SfktPage::on2XClick()
{
    btn2X->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "2", "二年级", "2", "下学期", btn2X);
}

void SfktPage::on3SClick()
{
    btn3S->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "3", "三年级", "1", "上学期", btn3S);
}

void SfktPage::on3XClick()
{
    btn3X->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "3", "三年级", "2", "下学期", btn3X);
}

void SfktPage::on4SClick()
{
    btn4S->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "4", "四年级", "1", "上学期", btn4S);
}

void SfktPage::on4XClick()
{
    btn4X->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "4", "四年级", "2", "下学期", btn4X);
}

void SfktPage::on5SClick()
{
    btn5S->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "5", "五年级", "1", "上学期", btn5S);
}

void SfktPage::on5XClick()
{
    btn5X->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "5", "五年级", "2", "下学期", btn5X);
}

void SfktPage::on6SClick()
{
    btn6S->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "6", "六年级", "1", "上学期", btn6S);
}

void SfktPage::on6XClick()
{
    btn6X->blockSignals(true);

    stackWidget->setCurrentWidget(nextPage);
    sfkt2->setSfkt2Page(sfktPage, "6", "六年级", "2", "下学期", btn6X);
}

void SfktPage::onBackClick()
{
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
}
