#ifndef SFKTVIDEOPAGE_H
#define SFKTVIDEOPAGE_H

#include <QWidget>
#include <QStackedWidget>
#include "video.h"
#include "imagebutton.h"
#include "mylabel.h"
#include "middle.h"
#include <QLabel>
#include <QListView>
#include <QSlider>
#include <QTimer>
#include <QListWidget>
#include "common.h"

class SfktVideoPage : public QWidget
{
    Q_OBJECT
public:
    explicit SfktVideoPage(QWidget *parent = 0);
    static SfktVideoPage* getSfktVideoInstance();

    void setWidget(QWidget *sfktVideo, QStackedWidget *stack, QWidget *root, MyLabel *video,
                   QSlider *slider, QLabel *timeLabel, QLabel *lenLabel, QSlider *_volSlider,
                   ImageButton *play, ImageButton *vol, ImageButton *full, QLabel *ctlRect);
    void setVideoPage(QWidget *parent, QListView *listViewP, QString videoUrl, int videoSize, int num, QString code);
    void setBackButton();
    bool eventFilter(QObject *obj, QEvent *event);
    void initVideoCtl();
    void showVideoCtl();
    void setVideoCtl();
    void initVolCtl();
    void setViewList(int num, QString code);
    void setView(QList<QVariant> list);
    void setPlayIcon();
    void setPauseIcon();

signals:
    void fullScreen();
    void showNormal();

public slots:
    void onBackClick();
    void onVideoDoubleClick();
    void onVideoClick();
    void changePosition(int pos);
    void updateInfo();
    void onPressed();
    void resizeVideo();
    //    void updateVideoCtl();
    void onMouseMove();

    void onVideoEndReached();
    void hideVideoCtl();
    void onVolClick();
    void onVolSliderMoved(int pos);
    void itemClicked(QModelIndex index);
private:
    static SfktVideoPage* sfktVideoInstance;
    Middle *middle = NULL;
    bool stop;
    bool videoStop;

    QWidget *sfktVideoPage = NULL;
    QStackedWidget *stackWidget = NULL;
    QWidget *parentPage = NULL;
    QWidget *rootWidget = NULL;

    Video *video = NULL;
    MyLabel *videoLabel = NULL;
    QListView *listViewParent = NULL;
    bool isFullScreen;

    QTimer *timer;
    QTimer *videoCtlTimer;
    QSlider *posSlider = NULL;
    QLabel *curTimeLabel = NULL;
    QLabel *lengthLabel = NULL;

    QLabel *BgLabel = NULL;
    ImageButton *btnBack = NULL;

    QLabel *videoBgLabel = NULL;
    QSlider *volSlider = NULL;
    ImageButton *btnPlay = NULL;
    ImageButton *btnVol = NULL;
    ImageButton *btnFull = NULL;
    QLabel *videoCtlRect = NULL;

    QListWidget *imageList = NULL;
};

#endif // SFKTVIDEOPAGE_H
