#ifndef SWJZPAGE_H
#define SWJZPAGE_H

#include <QWidget>
#include <QStackedWidget>
#include <QLabel>
#include <QFont>
#include <QPixmap>
#include <QScrollArea>
#include <QAxObject>
#include <phonon/audiooutput.h>
#include <phonon/mediaobject.h>
#include <QAxWidget>
#include "imagebutton.h"
#include "middle.h"
#include "mylabel.h"
#include "swjzimage.h"

class SwjzPage : public QWidget
{
    Q_OBJECT
public:
    explicit SwjzPage(QWidget *parent = 0);
    static SwjzPage* getSwjzInstance();
    void setWidget(QWidget *swjz, QStackedWidget *stack, QWidget *next);
    void setSwjzPage(QWidget *parent, QString word, ImageButton *btnP,
                     MyLabel *videoLabel, QLabel *videoBgLabel, bool show_, QAxWidget *flash, bool play_);
    void setBackGround();
    void setButtons();
    void setItems(QString word);
    void setWord(QString pinyin, QString word);
    void setImages(QString zs, QString ls, QString ks, QString xs, QString cs, QString ms);
    void setDescription(QString description);
    QString encodeUrl(QString url);

signals:

public slots:
    void onBackClick();
    void onPlayClick();
    void onZsClick();
    void onLsClick();
    void onKsClick();
    void onXsClick();
    void onCsClick();
    void stateChanged(Phonon::State newstate, Phonon::State oldstate);
    void finished();

private:
    static SwjzPage* swjzInstance;
    Middle *middle = NULL;
    SwjzImage* swjzImage = NULL;

    QWidget *swjzPage = NULL;
    QWidget *parentPage = NULL;
    QWidget *nextPage = NULL;
    QStackedWidget *stackWidget = NULL;
    ImageButton *btnParent = NULL;
    MyLabel *parentVideoLabel = NULL;
    QLabel *parentVideoBgLabel = NULL;

    // 页面元素
    QLabel *bgLabel = NULL;
    QLabel *topImageLabel = NULL;
    QLabel *pinyinLabel = NULL;
    QLabel *ziLabel = NULL;

    QLabel *zsText = NULL;
    MyLabel *zsImage = NULL;
    QLabel *lsText = NULL;
    MyLabel *lsImage = NULL;
    QLabel *ksText = NULL;
    MyLabel *ksImage = NULL;
    QLabel *xsText = NULL;
    MyLabel *xsImage = NULL;
    QLabel *csText = NULL;
    MyLabel *csImage = NULL;
    QLabel *descriptionText = NULL;
    MyLabel *descriptionImage = NULL;
    QLabel *zhushi = NULL;
    ImageButton *btnPlay = NULL;

    ImageButton *btnBack = NULL;

    QString zsUrl, lsUrl, ksUrl, xsUrl, cSurl, msUrl;
    bool show, play;
    QString audioUrl;
    QAxWidget *flashP = NULL;

private:
    Phonon::MediaObject *moo = NULL;
    Phonon::AudioOutput *device =NULL;

};

#endif // SWJZPAGE_H
