#ifndef SXZFVIDEOPAGE_H
#define SXZFVIDEOPAGE_H

#include <QObject>
#include <QLabel>
#include <QStackedWidget>
#include <QPixmap>
#include <QSlider>
#include <QTimer>
#include "video.h"
#include "imagebutton.h"
#include "middle.h"
#include "mylabel.h"
#include "common.h"

class SxzfVideoPage : public QObject
{
    Q_OBJECT
public:
    explicit SxzfVideoPage(QObject *parent = 0);
    static SxzfVideoPage* getSxzfVideoInstance();
    void setWidget(QWidget *sxzfVideo, QStackedWidget *stack, QWidget *root, QWidget *next,
                   MyLabel *video, QSlider *slider, QLabel *timeLabel, QLabel *lenLabel, QSlider *_volSlider,
                   ImageButton *play, ImageButton *vol, ImageButton *full, QLabel *ctlRect);
    void setSxzfVideoPage(QWidget *parent, ImageButton *btnP, QString videoUrl, int videoSize,
                          QString leftImageUrl, QString bottomImageUrl, QRect videoRect);
    void setBackGround(QString leftImageUrl, QString bottomImageUrl);
    void setVideo(QString videoUrl, int videoSize, QRect rect);
    void setButtons();
    bool eventFilter(QObject *obj, QEvent *event);
    void initVideoCtl();
    void showVideoCtl();
    void setVideoCtl();
    void initVolCtl();
    void setPlayIcon();
    void setPauseIcon();

signals:
    void fullScreen();
    void showNormal();

public slots:
    void onBackClick();
    void onVideoDoubleClick();
    void onVideoClick();
    void changePosition(int pos);
    void updateInfo();
    void onPressed();
    void resizeVideo();
//    void updateVideoCtl();
    void onMouseMove();

    void onVideoEndReached();
    void hideVideoCtl();
    void onVolClick();
    void onVolSliderMoved(int pos);

private:
    static SxzfVideoPage* sxzfVideoInstance;
    Middle *middle = NULL;
    Video *video = NULL;
    bool isFullScreen;
    QRect videoRect;
    bool videoStop;

    QTimer *timer;
    QTimer *videoCtlTimer;
    QSlider *posSlider = NULL;
    QLabel *curTimeLabel = NULL;
    QLabel *lengthLabel = NULL;

    QWidget *sxzfVideoPage = NULL;
    QWidget *rootWidget = NULL;
    QWidget *nextPage = NULL;
    QStackedWidget *stackWidget = NULL;
    QWidget *parentPage = NULL;
    ImageButton *btnParent = NULL;
    MyLabel *videoLabel = NULL;

    // 页面元素
    QLabel *bottomImageLabel = NULL;
    QLabel *leftImageLabel = NULL;
    ImageButton *btnBack = NULL;

    QLabel *videoBgLabel = NULL;
    QSlider *volSlider = NULL;
    ImageButton *btnPlay = NULL;
    ImageButton *btnVol = NULL;
    ImageButton *btnFull = NULL;
    QLabel *videoCtlRect = NULL;
};

#endif // SXZFVIDEOPAGE_H
