#include "sztxsubpage.h"
#include <QDebug>
#include <QMessageBox>
#include <QTextCodec>

SztxSubPage* SztxSubPage::sztxSubInstance = NULL;

SztxSubPage::SztxSubPage(QWidget *parent) : QWidget(parent)
{
    middle = Middle::getMiddleInstance();
    video = VideoPage::getVideoPageInstance();
    moo = new Phonon::MediaObject;
    device = new Phonon::AudioOutput;
    flash = FlashPage::getFlashPageInstance();

    Phonon::createPath(moo, device);
}

SztxSubPage* SztxSubPage::getSztxSubInstance()
{
    if (sztxSubInstance == NULL)
        sztxSubInstance = new SztxSubPage();

    return sztxSubInstance;
}

void SztxSubPage::setWidget(QWidget *sztxSub, QStackedWidget *stack, QWidget *next, QWidget *videoP)
{
    sztxSubPage = sztxSub;
    nextPage = next;
    stackWidget = stack;
    videoPage = videoP;

//    bgLabel = new QLabel(sztxSubPage);
    titleText = new QLabel(sztxSubPage);
    countText2 = new QLabel(sztxSubPage);
    countText1 = new QLabel(sztxSubPage);
    txBgLabel = new QLabel(sztxSubPage);
    btnBack = new ImageButton(sztxSubPage);
    qwfdButton = new ImageButton(sztxSubPage);
    qwgdButton = new ImageButton(sztxSubPage);
    qwydButton = new ImageButton(sztxSubPage);
    btnPre = new ImageButton(sztxSubPage);
    btnAudio = new ImageButton(sztxSubPage);
    btnNext = new ImageButton(sztxSubPage);

//    Phonon::VolumeSlider *volumeSlider = new Phonon::VolumeSlider(sztxSubPage);
//    volumeSlider->setAudioOutput(device);
//    volumeSlider->setGeometry(166,540,120,70);

    connect(btnBack, SIGNAL(clicked()), this, SLOT(onBackClick()));
    connect(qwfdButton, SIGNAL(clicked()), this, SLOT(qwfdClicked()));
    connect(qwgdButton, SIGNAL(clicked()), this, SLOT(qwgdClicked()));
    connect(qwydButton, SIGNAL(clicked()), this, SLOT(qwydClicked()));
    connect(btnPre, SIGNAL(clicked()), this, SLOT(onPreClick()));
    connect(btnAudio, SIGNAL(clicked()), this, SLOT(onAudioClick()));
    connect(btnNext, SIGNAL(clicked()), this, SLOT(onNextClick()));
    connect(moo, SIGNAL(metaDataChanged()), this, SLOT(updateInfo()));
    connect(moo, SIGNAL(stateChanged(Phonon::State,Phonon::State)), this, SLOT(stateChanged(Phonon::State,Phonon::State)));
    connect(moo, SIGNAL(finished()), SLOT(finished()));
}

void SztxSubPage::setSztxPage(QWidget *parent, QString title, QList<QString> videoInfo,
                              QList<QString> listenUrl, ImageButton *btnP, QWidget *flashP)
{
    parentPage = parent;
    btnParent = btnP;
    flashPage = flashP;

    qwfd_video = videoInfo[1];
    qwgd_video = videoInfo[2];
    qwyd_video = videoInfo[3];
    qwfd_video_size = videoInfo[4].toInt();
    qwgd_video_size = videoInfo[5].toInt();
    qwyd_video_size = videoInfo[6].toInt();

    setBackGround(title);
    setButtons();
    setAudio(listenUrl);
}

void SztxSubPage::setBackGround(QString title)
{
    QFont font;
    QPalette pa;

    pa.setColor(QPalette::WindowText,QColor(251,151,5));
    font.setFamily("黑体");
    font.setPixelSize(40);
    font.setLetterSpacing(QFont::AbsoluteSpacing,1);
    font.setBold(true);

    sztxSubPage->setStyleSheet("QWidget#sztxSubPage{image:url(:/nianji/yiji/bj_03.jpg)}");
//    bgLabel->setGeometry(0,0,1000,700);
//    bgLabel->lower();
//    QPixmap pix;
//    pix.loadFromData(middle->getImageData2("http://www.cguoguo.org.cn/jfx-web/attachment/aggxz/bjpic/bj_03.jpg"));
//    bgLabel->setPixmap(pix);

    titleText->setText(title);
    titleText->setAlignment(Qt::AlignCenter);
    titleText->setFont(font);
//    titleText->setPalette(pa);
    titleText->setGeometry(0,35,1000,50);

    txBgLabel->setGeometry(166,412,663,120);
    txBgLabel->setStyleSheet("image:url(:/nianji/tingxie/bft_bj.png)");
}

void SztxSubPage::setAudio(QList<QString> listenUrl)
{

    QFont font;
    font.setFamily("黑体");
    font.setPixelSize(40);
    font.setLetterSpacing(QFont::AbsoluteSpacing,1);
    font.setBold(true);

    countText1->setAlignment(Qt::AlignRight);
    countText1->setFont(font);
    countText1->setGeometry(280,318,200,50);

    countText2->setAlignment(Qt::AlignLeft);
    countText2->setFont(font);
    countText2->setGeometry(481,318,200,50);

    /*
    videoList.clear();
    // del
    QString baseUrl = middle->getBaseUrlOld();

    for (int i=0; i<words.count(); i++) {
        QList<QVariant> wordInfo = middle->getWordInfo(words[i]);
        if (wordInfo.count() == 0)
            continue;
        QString url = wordInfo[0].toMap()["listen"].toString();
        url = baseUrl + url;
        url = encodeUrl(url);
        videoList.append(url);
    }
    */

    videoList.clear();
    for (int i=0; i<listenUrl.count();i++) {
        QString url = listenUrl[i];
        url = encodeUrl(url);
        videoList.append(url);
    }

    total = videoList.count();
    QString text = "/" + QString::number(total, 10);
    countText2->setText(text);

    moo->setQueue(videoList);
    moo->play();
}

QString SztxSubPage::encodeUrl(QString url)
{
    QStringList list = url.split("/");
    QString name = list[list.length()-1];

    QTextCodec *code = QTextCodec::codecForName("utf-8");//解决中文路径问题
    QByteArray byte = code->fromUnicode(name);
    byte = byte.toPercentEncoding();

    url = url.replace(name, byte);

    qDebug() << __FUNCTION__  << "url" << url;
    return url;
}

void SztxSubPage::setButtons()
{
    // 全文泛读
    qwfdButton->setGeometry(150,165,193,62);
    QPixmap qwfdP1(":/nianji/yiji/nj_qwfd01.png");
    QPixmap qwfdP2(":/nianji/yiji/nj_qwfd02.png");
    qwfdButton->setNormalImage(qwfdP1);
    qwfdButton->setPressImage(qwfdP2);
    qwfdButton->setCursor(QCursor(Qt::PointingHandCursor));

    // 全文跟读
    qwgdButton->setGeometry(405,165,193,62);
    QPixmap qwgdP1(":/nianji/yiji/nj_qwgd01.png");
    QPixmap qwgdP2(":/nianji/yiji/nj_qwgd02.png");
    qwgdButton->setNormalImage(qwgdP1);
    qwgdButton->setPressImage(qwgdP2);
    qwgdButton->setCursor(QCursor(Qt::PointingHandCursor));

    // 全文阅读
    qwydButton->setGeometry(655,165,193,62);
    QPixmap qwydP1(":/nianji/yiji/nj_qwyd01.png");
    QPixmap qwydP2(":/nianji/yiji/nj_qwyd02.png");
    qwydButton->setNormalImage(qwydP1);
    qwydButton->setPressImage(qwydP2);
    qwydButton->setCursor(QCursor(Qt::PointingHandCursor));

    // 上一个
    btnPre->setGeometry(282,422,99,99);
    QPixmap preP1(":/nianji/tingxie/sztx_syg.png");
    QPixmap preP2(":/nianji/tingxie/sztx_syg.png");
    btnPre->setNormalImage(preP1);
    btnPre->setPressImage(preP2);
    btnPre->setCursor(QCursor(Qt::PointingHandCursor));

    // 暂停
    btnAudio->setGeometry(438,422,99,99);
    QPixmap pauseP1(":/nianji/tingxie/sztx_zt.png");
    QPixmap pauseP2(":/nianji/tingxie/sztx_zt.png");
    btnAudio->setNormalImage(pauseP1);
    btnAudio->setPressImage(pauseP2);
    btnAudio->setCursor(QCursor(Qt::PointingHandCursor));

    // 下一个
    btnNext->setGeometry(597,422,99,99);
    QPixmap nextP1(":/nianji/tingxie/sztx_xyg.png");
    QPixmap nextP2(":/nianji/tingxie/sztx_xyg.png");
    btnNext->setNormalImage(nextP1);
    btnNext->setPressImage(nextP2);
    btnNext->setCursor(QCursor(Qt::PointingHandCursor));

    // 返回
    btnBack->setGeometry(855,540,109,101);
    QPixmap backP1(":/nianji/yiji/fh_03.png");
    QPixmap backP2(":/nianji/yiji/fh_04.png");
    btnBack->setNormalImage(backP1);
    btnBack->setPressImage(backP2);
    btnBack->setCursor(QCursor(Qt::PointingHandCursor));
}

void SztxSubPage::onBackClick()
{
    moo->stop();
    moo->clearQueue();
    btnParent->blockSignals(false);
    stackWidget->setCurrentWidget(parentPage);
    titleText->clear();
    countText1->clear();
    countText2->clear();
}

void SztxSubPage::qwfdClicked()
{
    moo->pause();
    qwfdButton->blockSignals(true);
//    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "", "", "",qwfd_video, qwfd_video_size, qwfdButton, sztxSubPage);
//    stackWidget->addWidget(videoPage);
//    stackWidget->setCurrentWidget(videoPage);
    flash->setFlashPage("image:url(:/xzzs/bj_11.jpg)", qwfd_video, qwfd_video_size, qwfdButton, sztxSubPage, NULL);
    stackWidget->setCurrentWidget(flashPage);
}

void SztxSubPage::qwgdClicked()
{
    moo->pause();
    qwgdButton->blockSignals(true);
//    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "", "", "",qwgd_video, qwgd_video_size, qwgdButton, sztxSubPage);
//    stackWidget->addWidget(videoPage);
//    stackWidget->setCurrentWidget(videoPage);
    flash->setFlashPage("image:url(:/xzzs/bj_11.jpg)", qwgd_video, qwgd_video_size, qwgdButton, sztxSubPage, NULL);
    stackWidget->setCurrentWidget(flashPage);
}

void SztxSubPage::qwydClicked()
{
    moo->pause();
    qwydButton->blockSignals(true);
//    video->setVideoPage("image:url(:/xzzs/bj_11.jpg)", "", "", "",qwyd_video,qwyd_video_size, qwydButton, sztxSubPage);
//    stackWidget->addWidget(videoPage);
//    stackWidget->setCurrentWidget(videoPage);
    flash->setFlashPage("image:url(:/xzzs/bj_11.jpg)", qwyd_video, qwyd_video_size, qwydButton, sztxSubPage, NULL);
    stackWidget->setCurrentWidget(flashPage);
}

void SztxSubPage::onPreClick()
{
    QList<QUrl> tmp;
    QList<Phonon::MediaSource> queue = moo->queue();

    if (queue.size() >= total -1)
        return;

    tmp = videoList.mid(total-queue.size()-2, -1);
    moo->setQueue(tmp);

    queue = moo->queue();
    Phonon::State state = moo->state();
    if (queue.size() > 0) {
        moo->setCurrentSource(queue[0]);
        if (state == Phonon::PlayingState)
            moo->play();
        else
            moo->pause();
    }
}

void SztxSubPage::onAudioClick()
{
    if (moo->state() == Phonon::PlayingState) {
        moo->pause();
    } else {
        moo->play();
    }
}

void SztxSubPage::onNextClick()
{
    QList<Phonon::MediaSource> queue = moo->queue();
    qDebug() << __FUNCTION__  << "size:" << queue.size();
    Phonon::State state = moo->state();
    if (queue.size() > 0) {
        moo->setCurrentSource(queue[0]);
        if (state == Phonon::PlayingState)
            moo->play();
        else
            moo->pause();
    }
}

void SztxSubPage::updateInfo()
{
    qDebug() << __FUNCTION__  << "update ";
    QList<Phonon::MediaSource> queue = moo->queue();
    countText1->setText(QString::number((total-queue.size()), 10));
}

void SztxSubPage::stateChanged(Phonon::State newstate, Phonon::State oldstate)
{
    Q_UNUSED(oldstate);
    QPixmap P1(":/nianji/tingxie/sztx_bf.png");
    QPixmap P2(":/nianji/tingxie/sztx_zt.png");

    switch (newstate) {
        case Phonon::ErrorState:
            QMessageBox::warning(this, "播放异常", moo->errorString(), QMessageBox::Close);
            break;

        case Phonon::StoppedState:
            qDebug() << __FUNCTION__  << "stopped";
            break;
        case Phonon::PlayingState:
            btnAudio->setNormalImage(P2);
            btnAudio->setPressImage(P2);
            btnAudio->repaint();
            break;
        case Phonon::PausedState:
            btnAudio->setNormalImage(P1);
            btnAudio->setPressImage(P1);
            btnAudio->repaint();
            break;
        case Phonon::BufferingState:
            break;
        case Phonon::LoadingState:
            break;
    }
}

void SztxSubPage::finished()
{
    qDebug() << __FUNCTION__  << "finished ";
    moo->setQueue(videoList);
}
